CREATE TABLE `wp__wsd_plugin_alerts` (  `alertId` int(10) unsigned NOT NULL AUTO_INCREMENT,  `alertType` tinyint(4) NOT NULL DEFAULT '0',  `alertSeverity` int(11) NOT NULL DEFAULT '0',  `alertActionName` varchar(255) NOT NULL,  `alertTitle` varchar(255) NOT NULL,  `alertDescription` text NOT NULL,  `alertSolution` text NOT NULL,  `alertDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `alertFirstSeen` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  PRIMARY KEY (`alertId`),  UNIQUE KEY `alertId_UNIQUE` (`alertId`)) ENGINE=MyISAM AUTO_INCREMENT=26 DEFAULT CHARSET=utf8;
INSERT INTO `wp__wsd_plugin_alerts` VALUES('1', '0', '3', 'fix_wp_version_hidden', 'WordPress version is displayed for all users', '<p>Displaying your WordPress version on frontend and in the backend\'s footer to all visitors\r\n                        and users of your website is a security risk because if a hacker knows which version of WordPress a website is running, it can make it easier for him to target a known WordPress security issue.</p>', '<p>This plugin can automatically hide your WordPress version from frontend, backend and rss feeds if the option <strong>\"Hide WordPress version for all users but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('2', '0', '3', 'fix_wp_generators_frontend', 'WordPress meta tags are displayed on frontend to all users', '<p>By default, WordPress creates a few meta tags, among which is the currently installed version, that give a hacker the knowledge about your WordPress installation. At the moment, these meta tags are available for anyone to see, which is a potentially security risk.</p>', '<p>This plugin can automatically hide your WordPress\'s default meta tags if the option <strong>\"Remove various meta tags generators from the blog\'s head tag for non-administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('3', '0', '0', 'fix_wp_rsd_frontend', 'WordPress Really Simple Discovery tag is displayed on frontend to all users', '<p>By default, WordPress creates the <strong>rsd meta tag</strong> to allow bloggers to consume services like Flickr using the <a href=\"http://en.wikipedia.org/wiki/XML-RPC\" target=\"_blank\">XML-RPC</a> protocol.\r\n                            If you don\'t use such services it is recommended to hide this meta tag.</p>', '<p>This plugin can automatically hide the rsd meta tag if the option <strong>\"Remove Really Simple Discovery meta tags from front-end\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('4', '0', '2', 'fix_wp_wlw_frontend', 'WordPress Windows Live Writer tag is displayed on frontend for all users', '<p>By default, WordPress creates the wlw meta tag to allow bloggers to publish their articles using the <strong>\"Windows Live Writer\"</strong> application.\r\n                        It is recommended to hide this meta tag from all visitors. If the option <strong>\"Remove Windows Live Writer meta tags from front-end\"</strong> is checked on the plugin\'s settings page, this meta tag\r\n                        will still be available for administrator users to use the <strong>\"Windows Live Writer\"</strong> application to publish their blog posts.</p>', '<p>This plugin can automatically hide the wlw meta tag if the option <strong>\"Remove Windows Live Writer meta tags from front-end\"\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('5', '0', '3', 'fix_wp_error_reporting', 'The check for PHP and database error reporting is disabled', '<p>By default, WordPress hides database errors, but there are times when a plugin might enable them thus it is very important to have this type of errors turned off\r\n                            so if there is an error during a connection to the database the user will not get access to the error message generated during that request.</p>\r\n                            <p>As regarding the PHP errors, with the <strong>display_error</strong> PHP configuration directive enabled, untrusted sources can see detailed web application environment\r\n                            error messages which include sensitive information that can be used to craft further attacks.</p>\r\n                            <p>Attackers will do anything to collect information in order to design their attack in a more sophisticated way to eventually hack your website or web application, and causing\r\n                            errors to display is a common starting point. Website errors can always occur, but they should be suppressed from being displayed back to the public.</p>\r\n                            <p>Therefore we highly recommend you to have the <strong>\"Disable error reporting (php + db) for all but administrators\"</strong> option checked on the plugin\'s settings page to ensure PHP and\r\n                            database errors will be hidden from all users. For more information, please check the following <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/php-security-directive-your-website-is-showing-php-errors/\" target=\"_blank\">article</a>.</p>', '<p>This plugin can do this automatically if the option <strong>\"Disable error reporting (php + db) for all but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('6', '0', '3', 'fix_wp_core_update_notif', 'Core update notifications are displayed to all users', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the website was updated or needs an update.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove core update notifications from back-end for all but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('7', '0', '2', 'fix_wp_plugins_update_notif', 'Plugins update notifications are displayed to all users', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                        needs to be informed about an available update for a plugin.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove plug-ins update notifications from back-end\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('8', '0', '0', 'fix_wp_themes_update_notif', 'Themes update notifications are displayed to all users.', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                        needs to be informed about an available update for a theme.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove themes update notifications from back-end\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('9', '0', '2', 'fix_wp_login_errors', 'WordPress login errors are displayed.', '<p>Every time a failed login is encountered, the WordPress platform generates an error message that is displayed to the user.\r\n                        This is a potential security risk because it let\'s the user know of his mistake (be it a wrong user name or password) thus making your\r\n                        WordPress website more vulnerable to attacks.</p>\r\n                    <p>We strongly recommend you to hide these login error messages from all users to ensure a better security of your blog.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove login error notifications from front-end\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('10', '0', '2', 'fix_wp_admin_notices', 'WordPress admin notifications are displayed to all users.', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                       needs to be informed about an event that has occurred inside WordPress, it could be about an available update for the\r\n                       WordPress platform, a plugin or a theme that was updated or needs an update or to be configured, etc.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Hide admin notifications for non admins\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('11', '0', '2', 'fix_wp_dir_listing', 'Directory listing check is disabled. This option should be enabled.', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory.\r\n                    The specific risks and consequences vary depending on which files are listed and accessible.\r\n                    Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '<p>This plugin can automatically create an empty <strong>index.php</strong> file in the following directories: wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads if\r\n                    the option <strong>\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('12', '0', '3', 'fix_remove_wp_version_links', 'WordPress version is displayed in links for all users', '<p>By default, WordPress will display the current version in links to javascript scripts or stylesheets.\r\n                    Therefore, if anyone has access to this information it might be a security risk because if a hacker knows which version of WordPress a website is running,\r\n                    it can make it easier for him to target a known WordPress security issue.</p>', '<p>This plugin can automatically hide the WordPress version from links if the option <strong>\"Remove the version parameter from urls\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('13', '0', '2', 'fix_empty_root_readme_file', 'Clearing the content of the <strong>\"readme.html\"</strong> file from the <strong>\"root\"</strong> directory is disabled.', '<p>A default WordPress installation contains a readme.html file. This file is a simple html file that does not contain executable content that can be exploited by hackers or malicious users.\r\n                        Still, this file can provide hackers the version of your WordPress installation, therefore it is important to either delete this file or make it inaccessible for your visitors.</p>', '<p>This plugin can automatically delete its content (assuming the file exists) if the option <strong>\"Empty the content of the readme.html file from the root directory\"</strong> is checked on the plugin\'s settings page.\r\n                    You can also delete this file manually by connecting to your website through an FTP connection.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('14', '0', '3', 'check_table_prefix', 'The default WordPress database prefix (<strong>wp_</strong>) is used', '<p>The majority of reported WordPress database security attacks were performed by exploiting SQL Injection vulnerabilities.\r\n                        By renaming the WordPress database table prefixes you are securing your WordPress blog and website from zero day SQL injections attacks.</p>\r\n                    <p>Therefore by renaming the WordPress database table prefixes, you are automatically enforcing your WordPress database security against such dangerous attacks\r\n                        because the attacker would not be able to guess the table names.</p>\r\n                    <p>We recommend to use difficult to guess prefixes, like long random strings which include both letters and numbers.</p>', '<p>This plugin can automatically <a href=\"admin.php?page=wsd_database\">do this</a> for you, but if you want to do it manually then please read this <a href=\"http://www.websitedefender.com/wordpress-security/change-wordpress-database-prefix/\" target=\"_blank\">article</a> first.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('15', '0', '0', 'check_wp_current_version', 'You have the latest version of WordPress installed', '<p>The latest WordPress version is usually more stable and secure, and is only released to include new features or fix technical and WordPress security bugs;\r\n                            making it an important part of your website administration to keep up to date since some fixes might resolve security issues.<p>\r\n                        <p>Running an older WordPress version could put your blog security at risk, allowing a hacker to exploit known vulnerabilities for your specific version and take full control over your web server.</p>', '', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('16', '0', '0', 'check_index_wp_content', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('17', '0', '0', 'check_index_wp_plugins', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content/plugins\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('18', '0', '0', 'check_index_wp_themes', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content/themes\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('19', '0', '2', 'check_index_wp_uploads', 'The <strong>\"index.php\"</strong> file was not found in the <strong>\"/wp-content/uploads\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                        <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '<p>This plugin can automatically create an empty <strong>\"index.php\"</strong> file in the following directories: wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads if the\r\n                        option <strong>\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\"</strong> is checked on the plugin\'s settings page.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('20', '0', '2', 'check_htaccess_wp_admin', 'The <strong>\".htaccess\"</strong> file was not found in the <strong>\"wp-admin\"</strong> directory', '<p>An .htaccess file is a configuration file which provides the ability to specify configuration settings for a specific directory in a website.\r\n                    The .htaccess file can include one or more configuration settings which apply only for the directory in which the .htaccess file has been placed.\r\n                    So while web servers have their own main configuration settings file, the .htaccess file can be used to override their main configuration settings.</p>', '<p>Please refer to this <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/what-is-an-htaccess-file/\" target=\"_blank\">article</a> for more information on how to create an .htaccess file.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('21', '0', '2', 'check_readme_wp_root', 'The <strong>readme.html</strong> file was found in the root directory', '<p>A default WordPress installation contains a readme.html file.\r\n                                This file is a simple html file that does not contain executable content that can be exploited by hackers or malicious users.\r\n                                Still, this file can provide hackers the version of your WordPress installation, therefore it is important to either delete this file or make it inaccessible for your visitors.</p>', '<p>This plugin can automatically delete its content if the option <strong>\"Empty the content of the readme.html file from the root directory.\"</strong> is checked on the plugin\'s settings page.\r\n                                You can also delete this file manually by connecting to your website through an FTP connection.</p>', '2013-12-17 10:56:27', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('22', '0', '0', 'check_username_admin ', 'User <strong>\"admin\"</strong> (with administrative rights) was not found', '<p>One well known and dangerous WordPress security vulnerability is User Enumeration, in which a\r\n                            malicious user is able to enumerate a valid WordPress user account to launch a brute force attack against it.\r\n                            In order to help deter this type of attack, it is important not to have the default <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/default-wordpress-administrator-account/\" target=\"_blank\">WordPress administrator</a>\r\n                            username enabled on your blog.</p>', '', '2013-12-17 10:31:25', '2013-11-11 15:51:42');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('23', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 15:59:19', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('24', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:02:05', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('25', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:04:11', '2013-11-11 15:59:19');
CREATE TABLE `wp__wsd_plugin_live_traffic` (  `entryId` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `entryTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `entryIp` text,  `entryReferrer` text,  `entryUA` text,  `entryRequestedUrl` text,  PRIMARY KEY (`entryId`)) ENGINE=MyISAM AUTO_INCREMENT=42473 DEFAULT CHARSET=utf8;
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42377', '2013-12-16 15:39:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42376', '2013-12-16 15:39:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42375', '2013-12-16 15:39:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42374', '2013-12-16 15:38:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42373', '2013-12-16 15:38:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42370', '2013-12-16 15:38:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42371', '2013-12-16 15:38:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42372', '2013-12-16 15:38:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42368', '2013-12-16 15:38:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42369', '2013-12-16 15:38:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42367', '2013-12-16 15:38:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42366', '2013-12-16 15:38:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42365', '2013-12-16 15:38:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42364', '2013-12-16 15:38:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42363', '2013-12-16 15:38:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42362', '2013-12-16 15:38:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42361', '2013-12-16 15:38:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42360', '2013-12-16 15:38:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42359', '2013-12-16 15:37:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42358', '2013-12-16 15:37:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42357', '2013-12-16 15:37:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42356', '2013-12-16 15:37:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42355', '2013-12-16 15:37:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42354', '2013-12-16 15:37:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42353', '2013-12-16 15:37:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42352', '2013-12-16 15:37:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42351', '2013-12-16 15:37:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42350', '2013-12-16 15:37:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42349', '2013-12-16 15:37:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42348', '2013-12-16 15:37:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42347', '2013-12-16 15:37:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42346', '2013-12-16 15:37:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42345', '2013-12-16 15:37:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42344', '2013-12-16 15:36:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42343', '2013-12-16 15:36:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42342', '2013-12-16 15:36:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42341', '2013-12-16 15:36:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42340', '2013-12-16 15:36:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42339', '2013-12-16 15:36:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42338', '2013-12-16 15:36:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42337', '2013-12-16 15:36:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42336', '2013-12-16 15:36:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42335', '2013-12-16 15:36:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42334', '2013-12-16 15:36:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42333', '2013-12-16 15:36:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42332', '2013-12-16 15:36:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42331', '2013-12-16 15:36:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42330', '2013-12-16 15:36:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42329', '2013-12-16 15:35:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42328', '2013-12-16 15:35:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42327', '2013-12-16 15:35:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42326', '2013-12-16 15:35:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42325', '2013-12-16 15:35:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42324', '2013-12-16 15:35:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42323', '2013-12-16 15:35:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42322', '2013-12-16 15:35:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42321', '2013-12-16 15:35:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42320', '2013-12-16 15:35:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42319', '2013-12-16 15:35:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42318', '2013-12-16 15:35:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42317', '2013-12-16 15:35:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42316', '2013-12-16 15:35:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42315', '2013-12-16 15:35:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42314', '2013-12-16 15:34:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42313', '2013-12-16 15:34:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42312', '2013-12-16 15:34:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42311', '2013-12-16 15:34:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42310', '2013-12-16 15:34:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42309', '2013-12-16 15:34:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42308', '2013-12-16 15:34:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42307', '2013-12-16 15:34:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42306', '2013-12-16 15:34:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42305', '2013-12-16 15:34:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42304', '2013-12-16 15:34:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42303', '2013-12-16 15:34:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42302', '2013-12-16 15:34:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42301', '2013-12-16 15:34:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42300', '2013-12-16 15:34:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42299', '2013-12-16 15:33:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42298', '2013-12-16 15:33:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42297', '2013-12-16 15:33:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42296', '2013-12-16 15:33:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42295', '2013-12-16 15:33:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42294', '2013-12-16 15:33:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42293', '2013-12-16 15:33:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42292', '2013-12-16 15:33:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42291', '2013-12-16 15:33:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42290', '2013-12-16 15:33:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42289', '2013-12-16 15:33:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42288', '2013-12-16 15:33:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42287', '2013-12-16 15:33:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42286', '2013-12-16 15:33:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42285', '2013-12-16 15:33:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42284', '2013-12-16 15:32:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42283', '2013-12-16 15:32:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42282', '2013-12-16 15:32:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42281', '2013-12-16 15:32:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42280', '2013-12-16 15:32:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42279', '2013-12-16 15:32:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42278', '2013-12-16 15:32:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42277', '2013-12-16 15:32:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42276', '2013-12-16 15:32:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42275', '2013-12-16 15:32:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42274', '2013-12-16 15:32:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42273', '2013-12-16 15:32:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42272', '2013-12-16 15:32:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42271', '2013-12-16 15:32:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42270', '2013-12-16 15:32:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42269', '2013-12-16 15:31:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42268', '2013-12-16 15:31:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42267', '2013-12-16 15:31:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42266', '2013-12-16 15:31:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42265', '2013-12-16 15:31:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42264', '2013-12-16 15:31:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42263', '2013-12-16 15:31:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42262', '2013-12-16 15:31:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42261', '2013-12-16 15:31:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42260', '2013-12-16 15:31:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42259', '2013-12-16 15:31:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42258', '2013-12-16 15:31:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42257', '2013-12-16 15:31:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42256', '2013-12-16 15:31:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42255', '2013-12-16 15:31:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42254', '2013-12-16 15:30:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42253', '2013-12-16 15:30:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42252', '2013-12-16 15:30:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42251', '2013-12-16 15:30:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42250', '2013-12-16 15:30:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42249', '2013-12-16 15:30:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42248', '2013-12-16 15:30:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42247', '2013-12-16 15:30:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42246', '2013-12-16 15:30:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42245', '2013-12-16 15:30:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42244', '2013-12-16 15:30:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42243', '2013-12-16 15:30:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42242', '2013-12-16 15:30:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42241', '2013-12-16 15:30:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42240', '2013-12-16 15:30:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42239', '2013-12-16 15:29:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42238', '2013-12-16 15:29:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42237', '2013-12-16 15:29:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42236', '2013-12-16 15:29:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42235', '2013-12-16 15:29:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42234', '2013-12-16 15:29:38', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42233', '2013-12-16 15:29:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42232', '2013-12-16 15:29:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42231', '2013-12-16 15:29:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42230', '2013-12-16 15:29:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42229', '2013-12-16 15:29:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42228', '2013-12-16 15:29:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42227', '2013-12-16 15:29:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42226', '2013-12-16 15:29:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42225', '2013-12-16 15:29:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42224', '2013-12-16 15:28:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42223', '2013-12-16 15:28:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42222', '2013-12-16 15:28:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42221', '2013-12-16 15:28:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42220', '2013-12-16 15:28:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42219', '2013-12-16 15:28:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42218', '2013-12-16 15:28:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42217', '2013-12-16 15:28:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42216', '2013-12-16 15:28:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42215', '2013-12-16 15:28:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42214', '2013-12-16 15:28:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42213', '2013-12-16 15:28:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42212', '2013-12-16 15:28:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42211', '2013-12-16 15:28:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42210', '2013-12-16 15:28:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42209', '2013-12-16 15:27:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42208', '2013-12-16 15:27:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42207', '2013-12-16 15:27:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42206', '2013-12-16 15:27:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42205', '2013-12-16 15:27:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42204', '2013-12-16 15:27:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42203', '2013-12-16 15:27:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42202', '2013-12-16 15:27:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42201', '2013-12-16 15:27:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42200', '2013-12-16 15:27:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42199', '2013-12-16 15:27:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42198', '2013-12-16 15:27:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42197', '2013-12-16 15:27:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42196', '2013-12-16 15:27:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42195', '2013-12-16 15:27:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42194', '2013-12-16 15:26:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42193', '2013-12-16 15:26:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42192', '2013-12-16 15:26:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42191', '2013-12-16 15:26:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42190', '2013-12-16 15:26:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42189', '2013-12-16 15:26:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42188', '2013-12-16 15:26:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42187', '2013-12-16 15:26:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42186', '2013-12-16 15:26:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42185', '2013-12-16 15:26:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42184', '2013-12-16 15:26:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42183', '2013-12-16 15:26:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42182', '2013-12-16 15:26:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42181', '2013-12-16 15:26:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42180', '2013-12-16 15:26:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42179', '2013-12-16 15:25:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42178', '2013-12-16 15:25:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42177', '2013-12-16 15:25:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42176', '2013-12-16 15:25:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42175', '2013-12-16 15:25:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42174', '2013-12-16 15:25:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42173', '2013-12-16 15:25:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42172', '2013-12-16 15:25:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42171', '2013-12-16 15:25:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42170', '2013-12-16 15:25:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42169', '2013-12-16 15:25:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42168', '2013-12-16 15:25:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42167', '2013-12-16 15:25:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42166', '2013-12-16 15:25:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42165', '2013-12-16 15:25:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42164', '2013-12-16 15:24:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42163', '2013-12-16 15:24:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42162', '2013-12-16 15:24:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42161', '2013-12-16 15:24:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42160', '2013-12-16 15:24:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42159', '2013-12-16 15:24:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42158', '2013-12-16 15:24:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42157', '2013-12-16 15:24:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42156', '2013-12-16 15:24:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42155', '2013-12-16 15:24:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42154', '2013-12-16 15:24:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42153', '2013-12-16 15:24:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42152', '2013-12-16 15:24:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42151', '2013-12-16 15:24:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42150', '2013-12-16 15:24:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42149', '2013-12-16 15:23:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42148', '2013-12-16 15:23:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42147', '2013-12-16 15:23:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42146', '2013-12-16 15:23:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42145', '2013-12-16 15:23:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42144', '2013-12-16 15:23:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42143', '2013-12-16 15:23:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42142', '2013-12-16 15:23:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42141', '2013-12-16 15:23:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42140', '2013-12-16 15:23:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42139', '2013-12-16 15:23:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42138', '2013-12-16 15:23:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42137', '2013-12-16 15:23:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42136', '2013-12-16 15:23:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42135', '2013-12-16 15:23:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42134', '2013-12-16 15:22:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42133', '2013-12-16 15:22:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42132', '2013-12-16 15:22:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42131', '2013-12-16 15:22:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42130', '2013-12-16 15:22:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42129', '2013-12-16 15:22:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42128', '2013-12-16 15:22:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42127', '2013-12-16 15:22:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42126', '2013-12-16 15:22:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42125', '2013-12-16 15:22:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42124', '2013-12-16 15:22:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42123', '2013-12-16 15:22:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42122', '2013-12-16 15:22:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42121', '2013-12-16 15:22:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42120', '2013-12-16 15:22:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42119', '2013-12-16 15:21:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42118', '2013-12-16 15:21:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42117', '2013-12-16 15:21:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42116', '2013-12-16 15:21:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42115', '2013-12-16 15:21:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42114', '2013-12-16 15:21:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42113', '2013-12-16 15:21:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42112', '2013-12-16 15:21:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42111', '2013-12-16 15:21:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42110', '2013-12-16 15:21:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42109', '2013-12-16 15:21:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42108', '2013-12-16 15:21:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42107', '2013-12-16 15:21:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42106', '2013-12-16 15:21:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42105', '2013-12-16 15:21:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42104', '2013-12-16 15:20:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42103', '2013-12-16 15:20:54', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42102', '2013-12-16 15:20:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42101', '2013-12-16 15:20:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42100', '2013-12-16 15:20:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42099', '2013-12-16 15:20:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42098', '2013-12-16 15:20:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42097', '2013-12-16 15:20:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42096', '2013-12-16 15:20:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42095', '2013-12-16 15:20:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42094', '2013-12-16 15:20:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42093', '2013-12-16 15:20:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42092', '2013-12-16 15:20:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42091', '2013-12-16 15:20:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42090', '2013-12-16 15:20:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42089', '2013-12-16 15:19:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42088', '2013-12-16 15:19:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42087', '2013-12-16 15:19:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42086', '2013-12-16 15:19:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42085', '2013-12-16 15:19:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42084', '2013-12-16 15:19:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42083', '2013-12-16 15:19:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42082', '2013-12-16 15:19:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42081', '2013-12-16 15:19:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42080', '2013-12-16 15:19:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42079', '2013-12-16 15:19:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42078', '2013-12-16 15:19:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42077', '2013-12-16 15:19:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42076', '2013-12-16 15:19:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42075', '2013-12-16 15:19:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42074', '2013-12-16 15:18:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42073', '2013-12-16 15:18:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42072', '2013-12-16 15:18:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42071', '2013-12-16 15:18:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42070', '2013-12-16 15:18:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42069', '2013-12-16 15:18:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42068', '2013-12-16 15:18:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42067', '2013-12-16 15:18:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42066', '2013-12-16 15:18:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42065', '2013-12-16 15:18:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42064', '2013-12-16 15:18:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42063', '2013-12-16 15:18:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42062', '2013-12-16 15:18:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42061', '2013-12-16 15:18:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42060', '2013-12-16 15:18:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42057', '2013-12-16 15:17:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42059', '2013-12-16 15:17:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42058', '2013-12-16 15:17:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42056', '2013-12-16 15:17:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42055', '2013-12-16 15:17:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42054', '2013-12-16 15:17:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42053', '2013-12-16 15:17:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42052', '2013-12-16 15:17:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42051', '2013-12-16 15:17:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42050', '2013-12-16 15:17:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42049', '2013-12-16 15:17:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42048', '2013-12-16 15:17:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42047', '2013-12-16 15:17:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42046', '2013-12-16 15:17:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42045', '2013-12-16 15:17:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42044', '2013-12-16 15:16:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42043', '2013-12-16 15:16:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42042', '2013-12-16 15:16:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42041', '2013-12-16 15:16:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42040', '2013-12-16 15:16:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42039', '2013-12-16 15:16:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42038', '2013-12-16 15:16:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42037', '2013-12-16 15:16:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42036', '2013-12-16 15:16:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42035', '2013-12-16 15:16:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42034', '2013-12-16 15:16:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42033', '2013-12-16 15:16:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42032', '2013-12-16 15:16:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42031', '2013-12-16 15:16:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42030', '2013-12-16 15:16:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42029', '2013-12-16 15:15:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42028', '2013-12-16 15:15:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42027', '2013-12-16 15:15:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42026', '2013-12-16 15:15:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42025', '2013-12-16 15:15:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42024', '2013-12-16 15:15:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42023', '2013-12-16 15:15:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42022', '2013-12-16 15:15:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42021', '2013-12-16 15:15:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42020', '2013-12-16 15:15:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42019', '2013-12-16 15:15:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42018', '2013-12-16 15:15:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42017', '2013-12-16 15:15:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42016', '2013-12-16 15:15:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42015', '2013-12-16 15:15:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42014', '2013-12-16 15:14:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42013', '2013-12-16 15:14:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42012', '2013-12-16 15:14:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42011', '2013-12-16 15:14:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42010', '2013-12-16 15:14:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42009', '2013-12-16 15:14:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42008', '2013-12-16 15:14:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42007', '2013-12-16 15:14:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42006', '2013-12-16 15:14:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42005', '2013-12-16 15:14:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42004', '2013-12-16 15:14:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42003', '2013-12-16 15:14:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42002', '2013-12-16 15:14:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42001', '2013-12-16 15:14:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42000', '2013-12-16 15:14:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41999', '2013-12-16 15:13:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41998', '2013-12-16 15:13:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41997', '2013-12-16 15:13:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41996', '2013-12-16 15:13:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41995', '2013-12-16 15:13:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41994', '2013-12-16 15:13:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41993', '2013-12-16 15:13:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41992', '2013-12-16 15:13:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41991', '2013-12-16 15:13:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41990', '2013-12-16 15:13:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41989', '2013-12-16 15:13:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41988', '2013-12-16 15:13:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41987', '2013-12-16 15:13:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41986', '2013-12-16 15:13:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41985', '2013-12-16 15:13:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41984', '2013-12-16 15:12:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41983', '2013-12-16 15:12:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41982', '2013-12-16 15:12:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41981', '2013-12-16 15:12:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41980', '2013-12-16 15:12:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41979', '2013-12-16 15:12:37', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41978', '2013-12-16 15:12:33', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41977', '2013-12-16 15:12:29', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41976', '2013-12-16 15:12:25', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41975', '2013-12-16 15:12:21', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41974', '2013-12-16 15:12:17', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41973', '2013-12-16 15:12:13', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41972', '2013-12-16 15:12:09', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41971', '2013-12-16 15:12:05', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41970', '2013-12-16 15:12:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41969', '2013-12-16 15:11:57', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41968', '2013-12-16 15:11:53', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41967', '2013-12-16 15:11:49', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41966', '2013-12-16 15:11:45', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('41965', '2013-12-16 15:11:41', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42472', '2013-12-17 10:56:04', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42471', '2013-12-17 10:55:58', '151.226.138.173', 'http://www.plrblogs.com/magic/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42470', '2013-12-17 10:54:16', '151.226.138.173', 'http://www.plrblogs.com/magic/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42469', '2013-12-17 10:53:45', '151.226.138.173', 'http://www.plrblogs.com/magic/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42468', '2013-12-17 10:53:02', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42467', '2013-12-17 10:52:41', '151.226.138.173', 'http://www.plrblogs.com/magic/magic-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42466', '2013-12-17 10:52:34', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42465', '2013-12-17 10:52:25', '151.226.138.173', 'http://www.plrblogs.com/magic/magic-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42452', '2013-12-17 10:31:25', '94.7.244.240', '', 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42453', '2013-12-17 10:46:10', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42454', '2013-12-17 10:46:28', '151.226.138.173', 'http://www.plrblogs.com/magic/wp-login.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42455', '2013-12-17 10:46:48', '151.226.138.173', 'http://www.plrblogs.com/magic/wp-admin/?sucuriscan_lastlogin_message=1', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42456', '2013-12-17 10:47:07', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42457', '2013-12-17 10:47:36', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-admin/[aff1banner3]');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42458', '2013-12-17 10:47:51', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-admin/[aff1banner3]');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42459', '2013-12-17 10:48:06', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-admin/[aff1banner3]');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42460', '2013-12-17 10:48:34', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-admin/[aff1banner3]');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42461', '2013-12-17 10:49:01', '151.226.138.173', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42462', '2013-12-17 10:50:39', '151.226.138.173', 'http://www.plrblogs.com/magic/wp-admin/users.php?update=add&amp;id=28', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-login.php?action=logout&amp;_wpnonce=6864255cdc');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42451', '2013-12-17 06:38:21', '96.54.140.221', '', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; Trident/6.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; Tablet PC 2.0; .NET4.0C; .NET4.0E)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42447', '2013-12-17 02:29:50', '99.5.252.179', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42446', '2013-12-17 02:29:48', '99.5.252.179', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42445', '2013-12-17 02:29:44', '99.5.252.179', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-shops');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42444', '2013-12-17 02:29:42', '99.5.252.179', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42443', '2013-12-17 02:29:21', '99.5.252.179', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42441', '2013-12-17 02:24:08', '222.77.202.32', '', 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42442', '2013-12-17 02:29:14', '99.5.252.179', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42440', '2013-12-17 02:22:31', '144.132.17.6', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42439', '2013-12-17 01:41:04', '183.31.198.178', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42438', '2013-12-17 01:09:28', '50.65.158.168', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-shops');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42437', '2013-12-17 01:09:26', '50.65.158.168', 'http://www.plrblogs.com/magic/contact', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42436', '2013-12-17 01:08:45', '50.65.158.168', 'http://www.plrblogs.com/magic/contact', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/privacy-policy');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42435', '2013-12-17 01:08:43', '50.65.158.168', 'http://www.plrblogs.com/magic/category/magic-trickery', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/contact');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42434', '2013-12-17 01:08:39', '50.65.158.168', 'http://www.plrblogs.com/magic/category/tips-on-performing-magic', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/category/magic-trickery');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42432', '2013-12-17 01:07:10', '50.65.158.168', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42433', '2013-12-17 01:08:09', '50.65.158.168', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/category/tips-on-performing-magic');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42448', '2013-12-17 02:34:28', '144.132.17.6', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42425', '2013-12-17 00:07:02', '178.84.166.152', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42426', '2013-12-17 00:14:47', '97.112.47.154', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42427', '2013-12-17 00:15:57', '97.112.47.154', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/category/tips-on-performing-magic');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42428', '2013-12-17 00:16:01', '97.112.47.154', 'http://www.plrblogs.com/magic/category/tips-on-performing-magic', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42429', '2013-12-17 00:17:00', '97.112.47.154', 'http://www.plrblogs.com/magic/magic-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/contact');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42430', '2013-12-17 00:17:04', '97.112.47.154', 'http://www.plrblogs.com/magic/contact', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/about');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42431', '2013-12-17 00:17:09', '97.112.47.154', 'http://www.plrblogs.com/magic/about', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42422', '2013-12-16 22:51:49', '142.68.13.72', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42423', '2013-12-16 23:12:17', '74.197.61.75', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42424', '2013-12-17 00:06:54', '178.84.166.152', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42449', '2013-12-17 02:34:29', '144.132.17.6', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42450', '2013-12-17 06:38:20', '96.54.140.221', '', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; Trident/6.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; Tablet PC 2.0; .NET4.0C; .NET4.0E)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42463', '2013-12-17 10:50:40', '151.226.138.173', 'http://www.plrblogs.com/magic/wp-admin/users.php?update=add&amp;id=28', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-login.php?loggedout=true');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42464', '2013-12-17 10:50:55', '151.226.138.173', 'http://www.plrblogs.com/magic/wp-login.php?loggedout=true', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42421', '2013-12-16 22:41:18', '181.135.155.43', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42420', '2013-12-16 22:04:26', '198.148.26.1', '', 'ContextAd Bot 1.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42419', '2013-12-16 21:57:44', '172.4.180.183', 'http://www.plrblogs.com/magic/magic-trickery/coin-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42418', '2013-12-16 21:54:13', '172.4.180.183', 'http://www.plrblogs.com/magic/magic-trickery/cool-card-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/coin-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42417', '2013-12-16 21:52:17', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/easy-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/cool-card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42416', '2013-12-16 21:52:17', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/easy-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/cool-card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42404', '2013-12-16 21:30:45', '54.196.52.236', '', 'Mozilla/5.0 (compatible; proximic; +http://www.proximic.com/info/spider.php)', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42403', '2013-12-16 21:30:36', '172.4.180.183', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42401', '2013-12-16 21:26:16', '172.4.180.183', '', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42402', '2013-12-16 21:30:35', '172.4.180.183', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42398', '2013-12-16 20:47:24', '68.51.112.37', '', 'Mozilla/5.0 (MSIE 9.0; Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42399', '2013-12-16 20:47:29', '68.51.112.37', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (MSIE 9.0; Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42400', '2013-12-16 20:48:20', '68.51.112.37', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (MSIE 9.0; Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', 'http://www.plrblogs.com/magic/magic-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42405', '2013-12-16 21:32:18', '23.22.251.115', '', 'A6-Indexer/1.0 (http://www.a6corp.com/a6-web-scraping-policy/)', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42406', '2013-12-16 21:34:19', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-shops');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42396', '2013-12-16 19:31:09', '24.31.172.218', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42397', '2013-12-16 19:47:15', '66.249.73.49', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/magic/the-art-of-magic/card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42407', '2013-12-16 21:37:06', '172.4.180.183', 'http://www.plrblogs.com/magic/magic-trickery/magic-shops', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42408', '2013-12-16 21:40:03', '172.4.180.183', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42392', '2013-12-16 17:54:12', '151.226.138.173', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42393', '2013-12-16 18:13:18', '97.116.3.226', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42394', '2013-12-16 18:14:54', '121.73.118.101', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42395', '2013-12-16 18:16:16', '121.73.118.101', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42409', '2013-12-16 21:43:26', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/free-card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42410', '2013-12-16 21:45:59', '172.4.180.183', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42411', '2013-12-16 21:46:02', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/magic-illusions');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42412', '2013-12-16 21:46:51', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/free-card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42413', '2013-12-16 21:46:54', '172.4.180.183', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/the-art-of-magic/free-card-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42388', '2013-12-16 17:06:47', '50.178.48.213', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42389', '2013-12-16 17:07:36', '50.178.48.213', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.2; WOW64; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42390', '2013-12-16 17:13:12', '24.234.252.65', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42391', '2013-12-16 17:13:17', '89.145.95.42', '', 'Mozilla/5.0 (compatible; GrapeshotCrawler/2.0; +http://www.grapeshot.co.uk/crawler.php)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42414', '2013-12-16 21:48:13', '172.4.180.183', 'http://www.plrblogs.com/magic/the-art-of-magic/free-card-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/free-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42415', '2013-12-16 21:50:39', '172.4.180.183', 'http://www.plrblogs.com/magic/the-art-of-magic/free-card-tricks', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/easy-magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42387', '2013-12-16 16:37:49', '54.196.43.11', '', 'A6-Indexer/1.0 (http://www.a6corp.com/a6-web-scraping-policy/)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42385', '2013-12-16 16:36:06', '172.4.180.183', '', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42386', '2013-12-16 16:36:30', '54.234.49.103', '', 'Mozilla/5.0 (compatible; proximic; +http://www.proximic.com/info/spider.php)', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42384', '2013-12-16 16:33:31', '172.4.180.183', '', 'Mozilla/5.0 (Windows NT 5.1; rv:25.0) Gecko/20100101 Firefox/25.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42383', '2013-12-16 16:29:55', '72.199.189.235', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42382', '2013-12-16 16:29:53', '72.199.189.235', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/tips-on-performing-magic/magic-shows');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42381', '2013-12-16 16:29:31', '72.199.189.235', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:26.0) Gecko/20100101 Firefox/26.0', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42380', '2013-12-16 16:13:28', '96.54.140.221', 'http://www.plrblogs.com/magic/', 'Mozilla/5.0 (Windows NT 6.1; rv:24.0) Gecko/20100101 Firefox/24.0 AlexaToolbar/alxf-2.19', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42379', '2013-12-16 16:13:07', '96.54.140.221', 'http://www.plrblogs.com/demo29/demoblogs29.html', 'Mozilla/5.0 (Windows NT 6.1; rv:24.0) Gecko/20100101 Firefox/24.0 AlexaToolbar/alxf-2.19', 'http://www.plrblogs.com/magic/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('42378', '2013-12-16 16:02:07', '151.226.138.173', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/32.0.1700.41 Safari/537.36', 'http://www.plrblogs.com/magic/');
CREATE TABLE `wp_bad_behavior` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `ip` text NOT NULL,  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `request_method` text NOT NULL,  `request_uri` text NOT NULL,  `server_protocol` text NOT NULL,  `http_headers` text NOT NULL,  `user_agent` text NOT NULL,  `request_entity` text NOT NULL,  `key` text NOT NULL,  PRIMARY KEY (`id`),  KEY `ip` (`ip`(15)),  KEY `user_agent` (`user_agent`(10))) ENGINE=MyISAM AUTO_INCREMENT=56 DEFAULT CHARSET=latin1;
INSERT INTO `wp_bad_behavior` VALUES('52', '195.162.36.5', '2013-12-16 03:53:17', 'POST', '/magic/trackback/', 'HTTP/1.1', 'POST /magic/trackback/ HTTP/1.1\nAccept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, */*\nConnection: Keep-Alive\nHost: www.plrblogs.com\nReferer: http://www.plrblogs.com/magic/\nUser-Agent: Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)\nVia: 1.1 ASOOWIFI\n', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)', 'title: aQthblYJ\nurl: http://www.a3d446z3Wr82SASrQwj1N9.com/\nexcerpt: The Art Of Magic |\nblog_name: aQthblYJ\n', 'f0dcb3fd');
INSERT INTO `wp_bad_behavior` VALUES('51', '192.35.222.163', '2013-12-16 03:29:40', 'GET', '/magic/', 'HTTP/1.0', 'GET /magic/ HTTP/1.0\nAccept-Encoding: x-gzip, gzip, deflate\nAccept-Language: en-us,en-gb,en;q=0.7,*;q=0.3\nHost: www.plrblogs.com\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3\n', 'Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3', '', '17566707');
INSERT INTO `wp_bad_behavior` VALUES('53', '108.163.146.25', '2013-12-16 21:36:53', 'GET', '/magic/', 'HTTP/1.1', 'GET /magic/ HTTP/1.1\nConnection: Keep-Alive\nHost: www.plrblogs.com\nUser-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0\n', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0', '', '17566707');
INSERT INTO `wp_bad_behavior` VALUES('54', '198.72.120.51', '2013-12-17 02:26:56', 'GET', '/magic/magic-trickery/magic-tricks', 'HTTP/1.1', 'GET /magic/magic-trickery/magic-tricks HTTP/1.1\nConnection: Keep-Alive\nHost: www.plrblogs.com\nUser-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0\n', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0', '', '17566707');
INSERT INTO `wp_bad_behavior` VALUES('55', '108.163.146.25', '2013-12-17 02:26:56', 'GET', '/magic/magic-trickery/magic-tricks', 'HTTP/1.1', 'GET /magic/magic-trickery/magic-tricks HTTP/1.1\nConnection: Keep-Alive\nHost: www.plrblogs.com\nUser-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0\n', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:11.0) Gecko/20100101 Firefox/11.0', '', '17566707');
CREATE TABLE `wp_commentmeta` (  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`meta_id`),  KEY `comment_id` (`comment_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_comments` (  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',  `comment_author` tinytext NOT NULL,  `comment_author_email` varchar(100) NOT NULL DEFAULT '',  `comment_author_url` varchar(200) NOT NULL DEFAULT '',  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `comment_content` text NOT NULL,  `comment_karma` int(11) NOT NULL DEFAULT '0',  `comment_approved` varchar(20) NOT NULL DEFAULT '1',  `comment_agent` varchar(255) NOT NULL DEFAULT '',  `comment_type` varchar(20) NOT NULL DEFAULT '',  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `vp_campaign_id` int(11) DEFAULT NULL,  PRIMARY KEY (`comment_ID`),  KEY `comment_post_ID` (`comment_post_ID`),  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),  KEY `comment_date_gmt` (`comment_date_gmt`),  KEY `comment_parent` (`comment_parent`),  KEY `vp_campaign_id` (`vp_campaign_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_links` (  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `link_url` varchar(255) NOT NULL DEFAULT '',  `link_name` varchar(255) NOT NULL DEFAULT '',  `link_image` varchar(255) NOT NULL DEFAULT '',  `link_target` varchar(25) NOT NULL DEFAULT '',  `link_description` varchar(255) NOT NULL DEFAULT '',  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',  `link_rating` int(11) NOT NULL DEFAULT '0',  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `link_rel` varchar(255) NOT NULL DEFAULT '',  `link_notes` mediumtext NOT NULL,  `link_rss` varchar(255) NOT NULL DEFAULT '',  PRIMARY KEY (`link_id`),  KEY `link_visible` (`link_visible`)) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
INSERT INTO `wp_links` VALUES('1', 'http://codex.wordpress.org/', 'Documentation', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('2', 'http://wordpress.org/news/', 'WordPress Blog', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', 'http://wordpress.org/news/feed/');
INSERT INTO `wp_links` VALUES('3', 'http://wordpress.org/extend/ideas/', 'Suggest Ideas', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('4', 'http://wordpress.org/support/', 'Support Forum', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('5', 'http://wordpress.org/extend/plugins/', 'Plugins', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('6', 'http://wordpress.org/extend/themes/', 'Themes', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('7', 'http://planet.wordpress.org/', 'WordPress Planet', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
CREATE TABLE `wp_lockdowns` (  `lockdown_ID` bigint(20) NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) NOT NULL,  `lockdown_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `release_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `lockdown_IP` varchar(100) NOT NULL DEFAULT '',  PRIMARY KEY (`lockdown_ID`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE `wp_login_fails` (  `login_attempt_ID` bigint(20) NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) NOT NULL,  `login_attempt_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `login_attempt_IP` varchar(100) NOT NULL DEFAULT '',  PRIMARY KEY (`login_attempt_ID`)) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=latin1;
INSERT INTO `wp_login_fails` VALUES('1', '18', '2012-04-21 20:57:29', '2.218.148.45');
INSERT INTO `wp_login_fails` VALUES('2', '24', '2012-11-01 11:36:50', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('3', '26', '2013-06-04 19:45:00', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('4', '26', '2013-06-04 19:45:11', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('5', '26', '2013-08-08 12:38:44', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('6', '26', '2013-11-11 15:44:00', '151.226.138.173');
INSERT INTO `wp_login_fails` VALUES('7', '26', '2013-12-15 23:10:36', '151.226.138.173');
CREATE TABLE `wp_options` (  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `option_name` varchar(64) NOT NULL DEFAULT '',  `option_value` longtext NOT NULL,  `autoload` varchar(20) NOT NULL DEFAULT 'yes',  PRIMARY KEY (`option_id`),  UNIQUE KEY `option_name` (`option_name`)) ENGINE=MyISAM AUTO_INCREMENT=5645 DEFAULT CHARSET=utf8;
INSERT INTO `wp_options` VALUES('1', 'siteurl', 'http://www.plrblogs.com/magic', 'yes');
INSERT INTO `wp_options` VALUES('2', 'blogname', 'The Art Of Magic', 'yes');
INSERT INTO `wp_options` VALUES('3', 'blogdescription', '', 'yes');
INSERT INTO `wp_options` VALUES('4', 'users_can_register', '0', 'yes');
INSERT INTO `wp_options` VALUES('5', 'admin_email', 'youremail@youremail.com', 'yes');
INSERT INTO `wp_options` VALUES('6', 'start_of_week', '1', 'yes');
INSERT INTO `wp_options` VALUES('7', 'use_balanceTags', '0', 'yes');
INSERT INTO `wp_options` VALUES('8', 'use_smilies', '1', 'yes');
INSERT INTO `wp_options` VALUES('9', 'require_name_email', '1', 'yes');
INSERT INTO `wp_options` VALUES('10', 'comments_notify', '1', 'yes');
INSERT INTO `wp_options` VALUES('11', 'posts_per_rss', '10', 'yes');
INSERT INTO `wp_options` VALUES('12', 'rss_use_excerpt', '0', 'yes');
INSERT INTO `wp_options` VALUES('13', 'mailserver_url', 'mail.example.com', 'yes');
INSERT INTO `wp_options` VALUES('14', 'mailserver_login', 'login@example.com', 'yes');
INSERT INTO `wp_options` VALUES('15', 'mailserver_pass', 'password', 'yes');
INSERT INTO `wp_options` VALUES('16', 'mailserver_port', '110', 'yes');
INSERT INTO `wp_options` VALUES('17', 'default_category', '1', 'yes');
INSERT INTO `wp_options` VALUES('18', 'default_comment_status', 'open', 'yes');
INSERT INTO `wp_options` VALUES('19', 'default_ping_status', 'open', 'yes');
INSERT INTO `wp_options` VALUES('20', 'default_pingback_flag', '0', 'yes');
INSERT INTO `wp_options` VALUES('22', 'posts_per_page', '10', 'yes');
INSERT INTO `wp_options` VALUES('23', 'date_format', 'F j, Y', 'yes');
INSERT INTO `wp_options` VALUES('24', 'time_format', 'g:i a', 'yes');
INSERT INTO `wp_options` VALUES('25', 'links_updated_date_format', 'F j, Y g:i a', 'yes');
INSERT INTO `wp_options` VALUES('26', 'links_recently_updated_prepend', '<em>', 'yes');
INSERT INTO `wp_options` VALUES('27', 'links_recently_updated_append', '</em>', 'yes');
INSERT INTO `wp_options` VALUES('28', 'links_recently_updated_time', '120', 'yes');
INSERT INTO `wp_options` VALUES('29', 'comment_moderation', '0', 'yes');
INSERT INTO `wp_options` VALUES('30', 'moderation_notify', '1', 'yes');
INSERT INTO `wp_options` VALUES('31', 'permalink_structure', '/%category%/%postname%', 'yes');
INSERT INTO `wp_options` VALUES('32', 'gzipcompression', '0', 'yes');
INSERT INTO `wp_options` VALUES('33', 'hack_file', '0', 'yes');
INSERT INTO `wp_options` VALUES('34', 'blog_charset', 'UTF-8', 'yes');
INSERT INTO `wp_options` VALUES('35', 'moderation_keys', '', 'no');
INSERT INTO `wp_options` VALUES('36', 'active_plugins', 'a:24:{i:0;s:35:\"ad-codez-widget/ad-codes-widget.php\";i:1;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:2;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:3;s:27:\"backupbuddy/backupbuddy.php\";i:4;s:39:\"bad-behavior/bad-behavior-wordpress.php\";i:5;s:36:\"contact-form-7/wp-contact-form-7.php\";i:6;s:46:\"custom-post-template/custom-post-templates.php\";i:7;s:23:\"digg-digg/digg-digg.php\";i:8;s:43:\"easy-privacy-policy/easy-privacy-policy.php\";i:9;s:36:\"google-sitemap-generator/sitemap.php\";i:10;s:32:\"login-lockdown/loginlockdown.php\";i:11;s:22:\"obox-mobile/mobile.php\";i:12;s:27:\"pretty-link/pretty-link.php\";i:13;s:26:\"secure-wordpress/index.php\";i:14;s:35:\"simply-show-ids/simply-show-ids.php\";i:15;s:39:\"sitemap-generator/sitemap-generator.php\";i:16;s:23:\"slideshow/slideshow.php\";i:17;s:30:\"smart-youtube/smartyoutube.php\";i:18;s:25:\"sucuri-scanner/sucuri.php\";i:19;s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";i:21;s:25:\"wp-cumulus/wp-cumulus.php\";i:22;s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";i:23;s:27:\"wp-pagenavi/wp-pagenavi.php\";i:24;s:31:\"youtube-embed/youtube-embed.php\";}', 'yes');
INSERT INTO `wp_options` VALUES('37', 'home', 'http://www.plrblogs.com/magic', 'yes');
INSERT INTO `wp_options` VALUES('38', 'category_base', '', 'yes');
INSERT INTO `wp_options` VALUES('39', 'ping_sites', 'http://rpc.pingomatic.com/', 'yes');
INSERT INTO `wp_options` VALUES('40', 'advanced_edit', '0', 'yes');
INSERT INTO `wp_options` VALUES('41', 'comment_max_links', '2', 'yes');
INSERT INTO `wp_options` VALUES('42', 'gmt_offset', '0', 'yes');
INSERT INTO `wp_options` VALUES('43', 'default_email_category', '1', 'yes');
INSERT INTO `wp_options` VALUES('44', 'recently_edited', 'a:5:{i:0;s:71:\"/home/scplrb10/public_html/magic/wp-content/plugins/akismet/akismet.php\";i:1;s:79:\"/home/scplrb10/public_html/magic/wp-content/themes/headlines_enhanced/index.php\";i:2;s:79:\"/home/scplrb10/public_html/magic/wp-content/themes/headlines_enhanced/style.css\";i:3;s:86:\"/home/scplrb10/public_html/magic/wp-content/themes/headlines_enhanced_v3/functions.php\";i:4;s:82:\"/home/scplrb10/public_html/magic/wp-content/themes/headlines_enhanced_v3/style.css\";}', 'no');
INSERT INTO `wp_options` VALUES('45', 'template', 'headlines_enhanced', 'yes');
INSERT INTO `wp_options` VALUES('46', 'stylesheet', 'headlines_enhanced', 'yes');
INSERT INTO `wp_options` VALUES('47', 'comment_whitelist', '1', 'yes');
INSERT INTO `wp_options` VALUES('48', 'blacklist_keys', '', 'no');
INSERT INTO `wp_options` VALUES('49', 'comment_registration', '0', 'yes');
INSERT INTO `wp_options` VALUES('51', 'html_type', 'text/html', 'yes');
INSERT INTO `wp_options` VALUES('52', 'use_trackback', '0', 'yes');
INSERT INTO `wp_options` VALUES('53', 'default_role', 'subscriber', 'yes');
INSERT INTO `wp_options` VALUES('54', 'db_version', '26691', 'yes');
INSERT INTO `wp_options` VALUES('55', 'uploads_use_yearmonth_folders', '1', 'yes');
INSERT INTO `wp_options` VALUES('56', 'upload_path', '', 'yes');
INSERT INTO `wp_options` VALUES('57', 'blog_public', '1', 'yes');
INSERT INTO `wp_options` VALUES('58', 'default_link_category', '2', 'yes');
INSERT INTO `wp_options` VALUES('59', 'show_on_front', 'posts', 'yes');
INSERT INTO `wp_options` VALUES('60', 'tag_base', '', 'yes');
INSERT INTO `wp_options` VALUES('61', 'show_avatars', '1', 'yes');
INSERT INTO `wp_options` VALUES('62', 'avatar_rating', 'G', 'yes');
INSERT INTO `wp_options` VALUES('63', 'upload_url_path', '', 'yes');
INSERT INTO `wp_options` VALUES('64', 'thumbnail_size_w', '150', 'yes');
INSERT INTO `wp_options` VALUES('65', 'thumbnail_size_h', '150', 'yes');
INSERT INTO `wp_options` VALUES('66', 'thumbnail_crop', '1', 'yes');
INSERT INTO `wp_options` VALUES('67', 'medium_size_w', '300', 'yes');
INSERT INTO `wp_options` VALUES('68', 'medium_size_h', '300', 'yes');
INSERT INTO `wp_options` VALUES('69', 'avatar_default', 'mystery', 'yes');
INSERT INTO `wp_options` VALUES('5461', 'rewrite_rules', 'a:72:{s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:31:\".+?/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\".+?/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\".+?/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:26:\"(.+?)/([^/]+)/trackback/?$\";s:57:\"index.php?category_name=$matches[1]&name=$matches[2]&tb=1\";s:46:\"(.+?)/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:41:\"(.+?)/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:34:\"(.+?)/([^/]+)/page/?([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&paged=$matches[3]\";s:41:\"(.+?)/([^/]+)/comment-page-([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&cpage=$matches[3]\";s:26:\"(.+?)/([^/]+)(/[0-9]+)?/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&page=$matches[3]\";s:20:\".+?/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:30:\".+?/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:50:\".+?/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:38:\"(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:33:\"(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:26:\"(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:33:\"(.+?)/comment-page-([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&cpage=$matches[2]\";s:8:\"(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";}', 'yes');
INSERT INTO `wp_options` VALUES('72', 'large_size_w', '1024', 'yes');
INSERT INTO `wp_options` VALUES('73', 'large_size_h', '1024', 'yes');
INSERT INTO `wp_options` VALUES('74', 'image_default_link_type', 'file', 'yes');
INSERT INTO `wp_options` VALUES('75', 'image_default_size', '', 'yes');
INSERT INTO `wp_options` VALUES('76', 'image_default_align', '', 'yes');
INSERT INTO `wp_options` VALUES('77', 'close_comments_for_old_posts', '0', 'yes');
INSERT INTO `wp_options` VALUES('78', 'close_comments_days_old', '14', 'yes');
INSERT INTO `wp_options` VALUES('79', 'thread_comments', '1', 'yes');
INSERT INTO `wp_options` VALUES('80', 'thread_comments_depth', '5', 'yes');
INSERT INTO `wp_options` VALUES('81', 'page_comments', '0', 'yes');
INSERT INTO `wp_options` VALUES('82', 'comments_per_page', '50', 'yes');
INSERT INTO `wp_options` VALUES('83', 'default_comments_page', 'newest', 'yes');
INSERT INTO `wp_options` VALUES('84', 'comment_order', 'asc', 'yes');
INSERT INTO `wp_options` VALUES('85', 'sticky_posts', 'a:5:{i:0;i:881;i:1;i:878;i:2;i:875;i:3;i:874;i:4;i:877;}', 'yes');
INSERT INTO `wp_options` VALUES('86', 'widget_categories', 'a:3:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}i:3;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('87', 'widget_text', 'a:5:{i:2;a:0:{}i:3;a:3:{s:5:\"title\";s:14:\"Amazon Example\";s:4:\"text\";s:210:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/magic/wp-content/uploads/2011/12/banner-example.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}i:4;a:3:{s:5:\"title\";s:17:\"Product X Example\";s:4:\"text\";s:211:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/magic/wp-content/uploads/2011/12/banner-example2.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}i:5;a:3:{s:5:\"title\";s:17:\"Product Z Example\";s:4:\"text\";s:211:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/magic/wp-content/uploads/2011/12/banner-example3.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('88', 'widget_rss', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('89', 'timezone_string', '', 'yes');
INSERT INTO `wp_options` VALUES('91', 'embed_size_w', '', 'yes');
INSERT INTO `wp_options` VALUES('92', 'embed_size_h', '600', 'yes');
INSERT INTO `wp_options` VALUES('93', 'page_for_posts', '0', 'yes');
INSERT INTO `wp_options` VALUES('95', 'default_post_format', '0', 'yes');
INSERT INTO `wp_options` VALUES('96', 'wp_user_roles', 'a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:64:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:8:\"exec_php\";b:1;s:15:\"edit_others_php\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}', 'yes');
INSERT INTO `wp_options` VALUES('97', 'widget_search', 'a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('98', 'widget_recent-posts', 'a:4:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}i:3;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:10;}i:4;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('99', 'widget_recent-comments', 'a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('100', 'widget_archives', 'a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('101', 'widget_meta', 'a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('102', 'sidebars_widgets', 'a:9:{s:19:\"wp_inactive_widgets\";a:20:{i:0;s:14:\"woo_adwidget-2\";i:1;s:10:\"woo_tabs-2\";i:2;s:13:\"woo_twitter-2\";i:3;s:7:\"pages-2\";i:4;s:10:\"calendar-2\";i:5;s:7:\"links-2\";i:6;s:6:\"text-2\";i:7;s:5:\"rss-2\";i:8;s:11:\"tag_cloud-2\";i:9;s:10:\"nav_menu-2\";i:10;s:21:\"ws_widget__ad_codes-2\";i:11;s:23:\"ws_widget__ad_squares-2\";i:12;s:23:\"pluginbuddy_slideshow-2\";i:13;s:22:\"youtube_embed_widget-2\";i:14;s:15:\"smart-youtube-2\";i:15;s:14:\"recent-posts-2\";i:16;s:17:\"recent-comments-2\";i:17;s:10:\"archives-2\";i:18;s:12:\"categories-2\";i:19;s:6:\"meta-2\";}s:9:\"sidebar-1\";a:5:{i:0;s:21:\"ws_widget__ad_codes-3\";i:1;s:23:\"ws_widget__ad_squares-3\";i:2;s:14:\"recent-posts-3\";i:3;s:10:\"wp-cumulus\";i:4;s:21:\"ws_widget__ad_codes-4\";}s:8:\"footer-1\";a:1:{i:0;s:14:\"recent-posts-4\";}s:8:\"footer-2\";a:1:{i:0;s:7:\"pages-3\";}s:8:\"footer-3\";a:1:{i:0;s:12:\"categories-3\";}s:18:\"left-column-widget\";a:1:{i:0;s:6:\"text-3\";}s:20:\"center-column-widget\";a:1:{i:0;s:6:\"text-4\";}s:19:\"right-column-widget\";a:1:{i:0;s:6:\"text-5\";}s:13:\"array_version\";i:3;}', 'yes');
INSERT INTO `wp_options` VALUES('103', 'cron', 'a:9:{i:1387297153;a:3:{s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1387299101;a:1:{s:25:\"swpa_cleanup_live_traffic\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1387304548;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1387307220;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1387313501;a:1:{s:21:\"swpa_check_user_admin\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:2:\"8h\";s:4:\"args\";a:0:{}s:8:\"interval\";i:28800;}}}i:1387317386;a:1:{s:42:\"pluginbuddy_backupbuddy-cron_final_cleanup\";a:1:{s:32:\"d11c17a4eebd2b6f042231dfbc6ad22c\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;s:10:\"adzdi0gc9f\";}}}}i:1387323427;a:1:{s:24:\"akismet_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1387340364;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}', 'yes');
INSERT INTO `wp_options` VALUES('5609', '_transient_timeout_vye_video_e6497e6403201e48785439f505894f71', '1387298827', 'no');
INSERT INTO `wp_options` VALUES('5610', '_transient_vye_video_e6497e6403201e48785439f505894f71', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ClA1lUeXMTc?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5544', '_transient_timeout_vye_type_ClA1lUeXMTc', '1387331249', 'no');
INSERT INTO `wp_options` VALUES('5545', '_transient_vye_type_ClA1lUeXMTc', 'v', 'no');
INSERT INTO `wp_options` VALUES('5546', '_transient_timeout_vye_title_ClA1lUeXMTc', '1387331249', 'no');
INSERT INTO `wp_options` VALUES('5547', '_transient_vye_title_ClA1lUeXMTc', 'Police Officer Career Information : Police Officer Qualifications', 'no');
INSERT INTO `wp_options` VALUES('5589', '_transient_timeout_online_users', '1387297255', 'no');
INSERT INTO `wp_options` VALUES('5590', '_transient_online_users', 'a:1:{i:0;a:6:{s:7:\"user_id\";i:28;s:10:\"user_login\";s:5:\"admin\";s:10:\"user_email\";s:23:\"youremail@youremail.com\";s:15:\"user_registered\";s:19:\"2013-12-17 15:50:31\";s:13:\"last_activity\";i:1387295455;s:11:\"remote_addr\";s:15:\"151.226.138.173\";}}', 'no');
INSERT INTO `wp_options` VALUES('1919', 'woo_disable_posts_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1920', 'woo_disable_cats_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1921', 'woo_disable_search_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('988', 'initial_db_version', '18226', 'yes');
INSERT INTO `wp_options` VALUES('110', '_transient_random_seed', 'bea4dd1779893da76c99df6fa8018be6', 'yes');
INSERT INTO `wp_options` VALUES('111', 'auth_salt', 'f!*e4!@T$;$WZV^uMI#|4X@xlA1w&o(N7DIW(N$:g0.s;sS em/2jB=Z0xJ{ek+h', 'yes');
INSERT INTO `wp_options` VALUES('112', 'logged_in_salt', '~#+o4Q>Np{iE?VV;h9AD>{*z]ReG#{ 0HhgW-9(1B6nq?``:H;lAt,m}0 Fc*;}i', 'yes');
INSERT INTO `wp_options` VALUES('113', 'widget_pages', 'a:3:{i:2;a:0:{}i:3;a:3:{s:5:\"title\";s:0:\"\";s:6:\"sortby\";s:10:\"post_title\";s:7:\"exclude\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('114', 'widget_calendar', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('115', 'widget_links', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('116', 'widget_tag_cloud', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('117', 'widget_nav_menu', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('118', 'widget_widget_twentyeleven_ephemera', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('121', 'dashboard_widget_options', 'a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:29:\"http://www.plrblogs.com/magic\";s:4:\"link\";s:105:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://www.plrblogs.com/magic/\";s:3:\"url\";s:138:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://www.plrblogs.com/magic/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}', 'yes');
INSERT INTO `wp_options` VALUES('122', 'nonce_salt', ']u]lpAQC~0BfO##Sc/B>FXOG/ bp.:<rPBd-h11LeSh~DOT<h*YY.I_mjmH<[2+N', 'yes');
INSERT INTO `wp_options` VALUES('1917', 'akismet_spam_count', '4', 'yes');
INSERT INTO `wp_options` VALUES('1893', 'woo_custom_bg', '#edeadd', 'yes');
INSERT INTO `wp_options` VALUES('1562', '_transient_ye_video_NGUxMmQwNjZlMTkzZjc0MzQ3ZGZhNjI4OTMxMjhjNmZj', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;fs=0&amp;rel=0&amp;title=Natural+Remedies+%26amp%3B+Cleanses+%3A+How+to+Naturally+Reduce+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1561', '_transient_timeout_ye_video_NGUxMmQwNjZlMTkzZjc0MzQ3ZGZhNjI4OTMx', '1328815661', 'no');
INSERT INTO `wp_options` VALUES('1555', '_transient_timeout_ye_video_Zjk0NmQ0Y2ZjYzNjNDFhMWRiZjQwMzJlMTAy', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1556', '_transient_ye_video_Zjk0NmQ0Y2ZjYzNjNDFhMWRiZjQwMzJlMTAyMGM1ZmM0', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;fs=0&amp;rel=0&amp;title=Alternative+Medicines+for+Common+Ailments+%3A+How+to+Use+Herbs+to+Lower+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3940', '_transient_plugins_delete_result_26', '1', 'yes');
INSERT INTO `wp_options` VALUES('1535', '_transient_timeout_ye_video_YTk4Mjk1OTNhODNlODlkNmI5NmUyYjkyOWUz', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1536', '_transient_ye_video_YTk4Mjk1OTNhODNlODlkNmI5NmUyYjkyOWUzYmE5ZWYx', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/nrfj4LM5qj8?version=3&amp;fs=0&amp;rel=0&amp;title=High+Blood+Pressure+Tips+%26amp%3B+Treatments+%3A+Potassium+Rich+Food+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1520', '_transient_plugins_delete_result_18', '1', 'yes');
INSERT INTO `wp_options` VALUES('1541', '_transient_timeout_ye_video_ZWU3YjUzNWVkZmI3MTg1NTVhOGRhODczODcw', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1542', '_transient_ye_video_ZWU3YjUzNWVkZmI3MTg1NTVhOGRhODczODcwOWU1NzNi', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;fs=0&amp;rel=0&amp;title=High+Blood+Pressure+Tips+%26amp%3B+Treatments+%3A+Exercise+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1549', '_transient_timeout_ye_video_YzkyYjQ5OTRkYzJmMzEwNDllY2IwNzlhNDMx', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1550', '_transient_ye_video_YzkyYjQ5OTRkYzJmMzEwNDllY2IwNzlhNDMxNzA2MGJj', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;fs=0&amp;rel=0&amp;title=Nutrition+Tips+%3A+About+Sesame+Oil+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1362', 'theme_mods_headlines_enhanced', 'a:1:{i:0;b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('1363', 'theme_switched', '', 'yes');
INSERT INTO `wp_options` VALUES('989', 'db_upgraded', '', 'yes');
INSERT INTO `wp_options` VALUES('1452', 'woo_page_nav_disable', '18,19,388', 'yes');
INSERT INTO `wp_options` VALUES('3516', 'youtube_embed_editor_sc', 'youtube', 'yes');
INSERT INTO `wp_options` VALUES('2113', 'woo_custom_footer_disclaimer', 'Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.', 'yes');
INSERT INTO `wp_options` VALUES('2115', 'woo_disclaimer_color', '#244676', 'yes');
INSERT INTO `wp_options` VALUES('2117', 'woo_disclaimer_fontsize', '14', 'yes');
INSERT INTO `wp_options` VALUES('2139', 'woo_show_dislcaimer_footer', 'true', 'yes');
INSERT INTO `wp_options` VALUES('3695', '_transient_plugins_delete_result_24', '1', 'yes');
INSERT INTO `wp_options` VALUES('3143', '_transient_aye_video_NjFmMjdjMDg2YzBiNGEzOWQ0MjJmYTBiMzJkZTAyOTM', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/CrvBApGYEYw?fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Do+Homemade+Scar+Removal&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3393', '_transient_plugins_delete_result_23', '1', 'yes');
INSERT INTO `wp_options` VALUES('288', 'pluginbuddy_plugins', 'a:4:{s:23:\"pluginbuddy_backupbuddy\";O:8:\"stdClass\":9:{s:3:\"url\";s:68:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/backupbuddy\";s:4:\"slug\";s:23:\"pluginbuddy_backupbuddy\";s:7:\"package\";s:0:\"\";s:11:\"new_version\";s:6:\"2.2.33\";s:11:\"last_update\";i:1387295195;s:2:\"id\";s:1:\"0\";s:3:\"key\";s:0:\"\";s:10:\"key_status\";s:7:\"invalid\";s:4:\"guid\";s:13:\"4ee047c895644\";}s:21:\"pluginbuddy_slideshow\";O:8:\"stdClass\":9:{s:3:\"url\";s:66:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/slideshow\";s:4:\"slug\";s:21:\"pluginbuddy_slideshow\";s:7:\"package\";s:0:\"\";s:11:\"new_version\";s:6:\"1.0.45\";s:11:\"last_update\";i:1387295190;s:2:\"id\";s:1:\"0\";s:3:\"key\";s:0:\"\";s:10:\"key_status\";s:7:\"invalid\";s:4:\"guid\";s:13:\"4ee047c9d04d9\";}s:8:\"userhash\";s:0:\"\";s:8:\"username\";s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('280', 'akismet_available_servers', 'a:4:{s:12:\"72.233.69.88\";b:1;s:12:\"72.233.69.89\";b:1;s:12:\"66.135.58.61\";b:1;s:12:\"66.135.58.62\";b:1;}', 'yes');
INSERT INTO `wp_options` VALUES('281', 'akismet_connectivity_time', '1339887644', 'yes');
INSERT INTO `wp_options` VALUES('282', 'wordpress_api_key', '3dad46be7226', 'yes');
INSERT INTO `wp_options` VALUES('283', 'akismet_discard_month', 'true', 'yes');
INSERT INTO `wp_options` VALUES('284', 'akismet_show_user_comments_approved', 'true', 'yes');
INSERT INTO `wp_options` VALUES('286', '_transient_update_plugins', '', 'yes');
INSERT INTO `wp_options` VALUES('159', 'recently_activated', 'a:1:{s:37:\"wp-content-magic/wp-content-magic.php\";i:1384315482;}', 'yes');
INSERT INTO `wp_options` VALUES('160', 'ws_widget__ad_codes_configured', '0', 'yes');
INSERT INTO `wp_options` VALUES('161', 'ws_widget__ad_codes_notices', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('162', 'ws_widget__ad_codes_options', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('163', 'ws_widget__ad_squares_configured', '0', 'yes');
INSERT INTO `wp_options` VALUES('164', 'ws_widget__ad_squares_notices', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('165', 'ws_widget__ad_squares_options', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('166', 'aioseop_options', 'a:57:{s:9:\"aiosp_can\";s:2:\"on\";s:12:\"aiosp_donate\";s:0:\"\";s:16:\"aiosp_home_title\";s:0:\"\";s:22:\"aiosp_home_description\";s:0:\"\";s:19:\"aiosp_home_keywords\";s:0:\"\";s:23:\"aiosp_max_words_excerpt\";s:0:\"\";s:20:\"aiosp_rewrite_titles\";s:1:\"1\";s:23:\"aiosp_post_title_format\";s:27:\"%post_title% | %blog_title%\";s:23:\"aiosp_page_title_format\";s:27:\"%page_title% | %blog_title%\";s:27:\"aiosp_category_title_format\";s:31:\"%category_title% | %blog_title%\";s:26:\"aiosp_archive_title_format\";s:21:\"%date% | %blog_title%\";s:22:\"aiosp_tag_title_format\";s:20:\"%tag% | %blog_title%\";s:25:\"aiosp_search_title_format\";s:23:\"%search% | %blog_title%\";s:24:\"aiosp_description_format\";s:13:\"%description%\";s:22:\"aiosp_404_title_format\";s:33:\"Nothing found for %request_words%\";s:18:\"aiosp_paged_format\";s:14:\" - Part %page%\";s:20:\"aiosp_use_categories\";s:0:\"\";s:32:\"aiosp_dynamic_postspage_keywords\";s:2:\"on\";s:22:\"aiosp_category_noindex\";s:2:\"on\";s:18:\"aiosp_tags_noindex\";s:0:\"\";s:14:\"aiosp_cap_cats\";s:2:\"on\";s:27:\"aiosp_generate_descriptions\";s:0:\"\";s:16:\"aiosp_debug_info\";s:0:\"\";s:20:\"aiosp_post_meta_tags\";s:0:\"\";s:20:\"aiosp_page_meta_tags\";s:0:\"\";s:20:\"aiosp_home_meta_tags\";s:0:\"\";s:13:\"aiosp_enabled\";s:1:\"1\";s:17:\"aiosp_enablecpost\";s:1:\"0\";s:26:\"aiosp_use_tags_as_keywords\";s:2:\"on\";s:16:\"aiosp_seopostcol\";s:0:\"\";s:18:\"aiosp_seocustptcol\";s:0:\"\";s:21:\"aiosp_posttypecolumns\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:12:\"aiosp_do_log\";s:0:\"\";s:25:\"aiosp_google_analytics_id\";s:0:\"\";s:29:\"aiosp_ga_track_outbound_links\";s:0:\"\";s:14:\"aiosp_ex_pages\";s:0:\"\";s:22:\"aiosp_google_publisher\";s:0:\"\";s:15:\"aiosp_ga_domain\";s:0:\"\";s:21:\"aiosp_front_meta_tags\";s:0:\"\";s:21:\"aiosp_ga_multi_domain\";s:0:\"\";s:20:\"aiosp_togglekeywords\";s:1:\"0\";s:20:\"aiosp_force_rewrites\";s:1:\"1\";s:24:\"aiosp_use_original_title\";s:1:\"0\";s:16:\"aiosp_cap_titles\";s:2:\"on\";s:19:\"aiosp_cpostadvanced\";s:1:\"0\";s:17:\"aiosp_cpostactive\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:17:\"aiosp_cposttitles\";s:0:\"\";s:15:\"aiosp_admin_bar\";s:2:\"on\";s:23:\"aiosp_custom_menu_order\";s:2:\"on\";s:19:\"aiosp_google_verify\";s:0:\"\";s:17:\"aiosp_bing_verify\";s:0:\"\";s:22:\"aiosp_pinterest_verify\";s:0:\"\";s:20:\"aiosp_unprotect_meta\";s:0:\"\";s:37:\"aiosp_wpcf7_contact_form_title_format\";s:27:\"%post_title% | %blog_title%\";s:31:\"aiosp_wooframework_title_format\";s:27:\"%post_title% | %blog_title%\";s:28:\"aiosp_archive_author_noindex\";s:2:\"on\";s:26:\"aiosp_archive_date_noindex\";s:2:\"on\";}', 'yes');
INSERT INTO `wp_options` VALUES('167', 'pluginbuddy_backupbuddy', 'a:36:{s:12:\"data_version\";s:1:\"2\";s:15:\"import_password\";s:0:\"\";s:16:\"backup_reminders\";i:1;s:16:\"edits_since_last\";i:0;s:11:\"last_backup\";i:1387295786;s:18:\"last_backup_serial\";s:10:\"adzdi0gc9f\";s:11:\"compression\";i:1;s:19:\"force_compatibility\";i:0;s:18:\"skip_database_dump\";i:0;s:19:\"backup_nonwp_tables\";i:0;s:14:\"include_tables\";a:0:{}s:14:\"exclude_tables\";a:0:{}s:15:\"integrity_check\";i:1;s:9:\"schedules\";a:0:{}s:9:\"log_level\";s:1:\"1\";s:8:\"excludes\";s:0:\"\";s:13:\"high_security\";i:0;s:19:\"next_schedule_index\";i:100;s:13:\"archive_limit\";i:0;s:18:\"archive_limit_size\";i:0;s:22:\"email_notify_scheduled\";s:0:\"\";s:19:\"email_notify_manual\";s:0:\"\";s:18:\"email_notify_error\";s:0:\"\";s:7:\"backups\";a:1:{s:10:\"adzdi0gc9f\";a:14:{s:6:\"serial\";s:10:\"adzdi0gc9f\";s:11:\"backup_mode\";s:1:\"2\";s:4:\"type\";s:4:\"full\";s:10:\"start_time\";i:1387295786;s:12:\"updated_time\";i:1387295786;s:6:\"status\";a:0:{}s:14:\"schedule_title\";s:0:\"\";s:16:\"backup_directory\";s:72:\"/home/scplrb10/public_html/magic/wp-content/uploads/backupbuddy_backups/\";s:12:\"archive_file\";s:127:\"/home/scplrb10/public_html/magic/wp-content/uploads/backupbuddy_backups/backup-www_plrblogs_com_magic-2013_12_17-adzdi0gc9f.zip\";s:7:\"trigger\";s:6:\"manual\";s:19:\"force_compatibility\";b:0;s:5:\"steps\";a:2:{i:0;a:2:{s:8:\"function\";s:16:\"backup_zip_files\";s:4:\"args\";a:0:{}}i:1;a:2:{s:8:\"function\";s:11:\"post_backup\";s:4:\"args\";a:0:{}}}s:14:\"temp_directory\";s:80:\"/home/scplrb10/public_html/magic/wp-content/uploads/backupbuddy_temp/adzdi0gc9f/\";s:23:\"temporary_zip_directory\";s:92:\"/home/scplrb10/public_html/magic/wp-content/uploads/backupbuddy_backups/temp_zip_adzdi0gc9f/\";}}s:19:\"remote_destinations\";a:0:{}s:21:\"backup_file_integrity\";a:0:{}s:11:\"role_access\";s:13:\"administrator\";s:16:\"dropboxtemptoken\";s:0:\"\";s:11:\"backup_mode\";s:1:\"2\";s:16:\"multisite_export\";s:1:\"1\";s:16:\"backup_directory\";s:72:\"/home/scplrb10/public_html/magic/wp-content/uploads/backupbuddy_backups/\";s:20:\"repairbuddy_password\";s:0:\"\";s:10:\"log_serial\";s:10:\"29mdgqe92p\";s:17:\"temporary_options\";a:1:{s:16:\"experimental_zip\";s:1:\"0\";}i:0;b:0;s:7:\"updater\";a:2:{s:10:\"last_check\";i:1323321447;s:13:\"last_response\";a:6:{s:6:\"status\";s:2:\"ok\";s:10:\"key_status\";s:2:\"ok\";s:12:\"download_url\";s:201:\"http://updater.ithemes.com/?product=backupbuddy&action=download&siteurl=http://www.plrblogs.com/magic&guid=4ee047c895644&key=4EEX4861EF6DEX76722179&expires=1323407847&v=8a6f6ed83df765269a91a510f7c8be0b\";s:11:\"new_version\";b:1;s:14:\"latest_version\";s:6:\"2.2.31\";s:13:\"latest_update\";s:20:\"2011-11-17 12:16:06\n\";}}}', 'no');
INSERT INTO `wp_options` VALUES('5552', '_transient_timeout_vye_title_NnPobSrR3zM', '1387331249', 'no');
INSERT INTO `wp_options` VALUES('5553', '_transient_vye_title_NnPobSrR3zM', 'Police Officer Career Information : How to Become a Police Officer', 'no');
INSERT INTO `wp_options` VALUES('5462', 'can_compress_scripts', '1', 'yes');
INSERT INTO `wp_options` VALUES('5486', '_site_transient_timeout_browser_2a45585bf6fbca9e24972054edb9a714', '1387771870', 'yes');
INSERT INTO `wp_options` VALUES('5487', '_site_transient_browser_2a45585bf6fbca9e24972054edb9a714', 'a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:12:\"31.0.1650.63\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('5591', '_site_transient_timeout__prli_messages', '1387296991', 'yes');
INSERT INTO `wp_options` VALUES('5592', '_site_transient__prli_messages', 'a:1:{i:0;s:568:\"If you like Pretty Link and want to generate income from your WordPress website then you\'ll love our new plugin:<br/><a class=\"prli_message_image\" href=\"http://www.memberpress.com/supercleanse/payments-728\"><img src=\"http://www.memberpress.com/wp-content/uploads/2013/01/banner5.png\" /></a><script>jQuery(\'.prli_message_image\').parent().removeClass(\'updated\');jQuery(\'.prli_message_image\').parent().parent().css(\'border-color\',\'transparent\').css(\'background-color\',\'transparent\');jQuery(\'.prli_message_image img\').css(\'width\',\'100%\').css(\'max-width\',\'728px\');</script>\";}', 'yes');
INSERT INTO `wp_options` VALUES('1724', 'woo_disable_date_posts', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1725', 'woo_disable_date_cats', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1726', 'woo_disable_date_search', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1732', '_transient_timeout_ye_video_YThkMjc0ZTYzZDJhYmEzOGVkMjI2Y2FmMmZi', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1733', '_transient_ye_video_YThkMjc0ZTYzZDJhYmEzOGVkMjI2Y2FmMmZiY2RhNWMz', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eIRmCGwurmE?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Hanging+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('168', 'pluginbuddy_backupbuddy-updater-guid', '4ee047c895644', 'yes');
INSERT INTO `wp_options` VALUES('169', 'wpcf7', 'a:1:{s:7:\"version\";s:3:\"3.6\";}', 'yes');
INSERT INTO `wp_options` VALUES('170', 'ddsg_language', 'English', 'yes');
INSERT INTO `wp_options` VALUES('171', 'ddsg_items_per_page', '50', 'yes');
INSERT INTO `wp_options` VALUES('172', 'ddsg_sm_name', '', 'yes');
INSERT INTO `wp_options` VALUES('173', 'ddsg_what_to_show', 'both', 'yes');
INSERT INTO `wp_options` VALUES('174', 'ddsg_which_first', 'posts', 'yes');
INSERT INTO `wp_options` VALUES('175', 'ddsg_post_sort_order', 'title', 'yes');
INSERT INTO `wp_options` VALUES('176', 'ddsg_page_sort_order', 'title', 'yes');
INSERT INTO `wp_options` VALUES('177', 'ddsg_comments_on_posts', '', 'yes');
INSERT INTO `wp_options` VALUES('178', 'ddsg_comments_on_pages', '', 'yes');
INSERT INTO `wp_options` VALUES('179', 'ddsg_show_zero_comments', '', 'yes');
INSERT INTO `wp_options` VALUES('180', 'ddsg_hide_future', '', 'yes');
INSERT INTO `wp_options` VALUES('181', 'ddsg_new_window', '', 'yes');
INSERT INTO `wp_options` VALUES('182', 'ddsg_show_post_date', '', 'yes');
INSERT INTO `wp_options` VALUES('183', 'ddsg_show_page_date', '', 'yes');
INSERT INTO `wp_options` VALUES('184', 'ddsg_date_format', 'F jS, Y', 'yes');
INSERT INTO `wp_options` VALUES('185', 'ddsg_hide_protected', '1', 'yes');
INSERT INTO `wp_options` VALUES('186', 'ddsg_excluded_cats', '', 'yes');
INSERT INTO `wp_options` VALUES('187', 'ddsg_excluded_pages', '', 'yes');
INSERT INTO `wp_options` VALUES('188', 'ddsg_page_nav', '1', 'yes');
INSERT INTO `wp_options` VALUES('189', 'ddsg_page_nav_where', 'top', 'yes');
INSERT INTO `wp_options` VALUES('190', 'ddsg_xml_path', '', 'yes');
INSERT INTO `wp_options` VALUES('191', 'ddsg_xml_where', 'last', 'yes');
INSERT INTO `wp_options` VALUES('192', 'easy_privacy_sitename', '', 'yes');
INSERT INTO `wp_options` VALUES('193', 'easy_privacy_email', '', 'yes');
INSERT INTO `wp_options` VALUES('194', 'easy_privacy_pageurl', 'privacy-policy', 'yes');
INSERT INTO `wp_options` VALUES('195', 'easy_privacy_acknowlegement', '', 'yes');
INSERT INTO `wp_options` VALUES('196', 'easy_privacy_lastupdated', '', 'yes');
INSERT INTO `wp_options` VALUES('197', 'easy_privacy_pagetitle', 'Privacy Policy', 'yes');
INSERT INTO `wp_options` VALUES('198', 'easy_privacy_section_one_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('199', 'easy_privacy_section_one_title', 'Your Privacy', 'yes');
INSERT INTO `wp_options` VALUES('200', 'easy_privacy_section_one', 'Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.', 'yes');
INSERT INTO `wp_options` VALUES('201', 'easy_privacy_section_two_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('202', 'easy_privacy_section_two_title', 'Google Adsense and the DoubleClick DART Cookie', 'yes');
INSERT INTO `wp_options` VALUES('203', 'easy_privacy_section_two', 'Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url http://www.google.com/privacy_ads.html Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies, @blogname has no access or control over these cookies that may be used by third party advertisers.', 'yes');
INSERT INTO `wp_options` VALUES('204', 'easy_privacy_section_three_selected', '', 'yes');
INSERT INTO `wp_options` VALUES('205', 'easy_privacy_section_three_title', 'Our Commitment To Childrens Privacy', 'yes');
INSERT INTO `wp_options` VALUES('206', 'easy_privacy_section_three', 'Protecting the privacy of the very young is especially important. For that reason, @blogname will never collect or maintain information at our website from those we actually know are under 18, and no part of our website is structured to attract anyone under 18.\r\nUnder our Terms of Service, children under 18 are not allowed to access our service.', 'yes');
INSERT INTO `wp_options` VALUES('207', 'easy_privacy_section_four_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('208', 'easy_privacy_section_four_title', 'Collection of Personal Information', 'yes');
INSERT INTO `wp_options` VALUES('209', 'easy_privacy_section_four', 'When visiting @blogname, the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n', 'yes');
INSERT INTO `wp_options` VALUES('210', 'easy_privacy_section_five_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('211', 'easy_privacy_section_five_title', 'Links to third party Websites', 'yes');
INSERT INTO `wp_options` VALUES('212', 'easy_privacy_section_five', 'We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n', 'yes');
INSERT INTO `wp_options` VALUES('213', 'easy_privacy_section_six_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('214', 'easy_privacy_section_six_title', 'Changes to this Privacy Statement', 'yes');
INSERT INTO `wp_options` VALUES('215', 'easy_privacy_section_six', 'The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of @blogname then you may contact us at @email', 'yes');
INSERT INTO `wp_options` VALUES('216', 'loginlockdownAdminOptions', 'a:5:{s:17:\"max_login_retries\";i:3;s:14:\"retries_within\";i:5;s:14:\"lockout_length\";i:60;s:25:\"lockout_invalid_usernames\";s:2:\"no\";s:17:\"mask_login_errors\";s:2:\"no\";}', 'yes');
INSERT INTO `wp_options` VALUES('217', 'loginlockdown_db1_version', '', 'yes');
INSERT INTO `wp_options` VALUES('218', 'loginlockdown_db2_version', '', 'yes');
INSERT INTO `wp_options` VALUES('4213', 'mobile_custom_footer', '<a href=\"ADD-YOUR-URL\">ADD YOUR LINK TEXT</a>', 'yes');
INSERT INTO `wp_options` VALUES('4214', 'mobile_force', 'no', 'yes');
INSERT INTO `wp_options` VALUES('221', 'mobile_custom_logo', '', 'yes');
INSERT INTO `wp_options` VALUES('222', 'mobile_custom_background', '', 'yes');
INSERT INTO `wp_options` VALUES('223', 'mobile_app_icon', 'http://www.plrblogs.com/magic/wp-content/plugins/obox-mobile//admin/images/iphone_ico.png', 'yes');
INSERT INTO `wp_options` VALUES('224', 'mobile_license_key', '', 'yes');
INSERT INTO `wp_options` VALUES('225', 'prli_options', 'a:24:{s:16:\"prli_exclude_ips\";s:0:\"\";s:13:\"whitelist_ips\";s:0:\"\";s:13:\"filter_robots\";i:0;s:17:\"extended_tracking\";s:6:\"normal\";s:19:\"prettybar_image_url\";s:97:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/pretty-link/images/pretty-link-48x48.png\";s:30:\"prettybar_background_image_url\";s:94:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/pretty-link/images/bar_background.png\";s:15:\"prettybar_color\";s:0:\"\";s:20:\"prettybar_text_color\";s:6:\"000000\";s:20:\"prettybar_link_color\";s:6:\"0000ee\";s:21:\"prettybar_hover_color\";s:6:\"ababab\";s:23:\"prettybar_visited_color\";s:6:\"551a8b\";s:20:\"prettybar_show_title\";s:1:\"1\";s:26:\"prettybar_show_description\";s:1:\"1\";s:26:\"prettybar_show_share_links\";s:1:\"1\";s:30:\"prettybar_show_target_url_link\";s:1:\"1\";s:21:\"prettybar_title_limit\";s:2:\"25\";s:20:\"prettybar_desc_limit\";s:2:\"30\";s:20:\"prettybar_link_limit\";s:2:\"30\";s:18:\"link_redirect_type\";s:3:\"307\";s:20:\"link_redirect_action\";s:4:\"init\";s:11:\"link_prefix\";i:0;s:13:\"link_track_me\";s:1:\"1\";s:13:\"link_nofollow\";s:1:\"0\";s:16:\"bookmarklet_auth\";s:32:\"8be94e368ec807ef700a3b7754fc1c67\";}', 'yes');
INSERT INTO `wp_options` VALUES('226', 'prli_db_version', '12', 'yes');
INSERT INTO `wp_options` VALUES('227', 'AdsDisp', '3', 'yes');
INSERT INTO `wp_options` VALUES('228', 'BegnAds', '1', 'yes');
INSERT INTO `wp_options` VALUES('229', 'BegnRnd', '1', 'yes');
INSERT INTO `wp_options` VALUES('230', 'EndiAds', '1', 'yes');
INSERT INTO `wp_options` VALUES('231', 'EndiRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('232', 'MiddRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('233', 'MoreRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('234', 'Par1Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('235', 'Par1Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('236', 'Par2Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('237', 'Par2Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('238', 'Par3Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('239', 'Par3Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('240', 'Img1Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('241', 'Img1Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('242', 'AppPost', '1', 'yes');
INSERT INTO `wp_options` VALUES('243', 'AppPage', '1', 'yes');
INSERT INTO `wp_options` VALUES('244', 'QckTags', '1', 'yes');
INSERT INTO `wp_options` VALUES('245', 'AdsMargin1', '10', 'yes');
INSERT INTO `wp_options` VALUES('246', 'AdsAlign1', '2', 'yes');
INSERT INTO `wp_options` VALUES('247', 'AdsMargin2', '10', 'yes');
INSERT INTO `wp_options` VALUES('248', 'AdsAlign2', '2', 'yes');
INSERT INTO `wp_options` VALUES('249', 'AdsMargin3', '10', 'yes');
INSERT INTO `wp_options` VALUES('250', 'AdsAlign3', '2', 'yes');
INSERT INTO `wp_options` VALUES('251', 'AdsMargin4', '10', 'yes');
INSERT INTO `wp_options` VALUES('252', 'AdsAlign4', '2', 'yes');
INSERT INTO `wp_options` VALUES('253', 'AdsMargin5', '10', 'yes');
INSERT INTO `wp_options` VALUES('254', 'AdsAlign5', '2', 'yes');
INSERT INTO `wp_options` VALUES('255', 'AdsMargin6', '10', 'yes');
INSERT INTO `wp_options` VALUES('256', 'AdsAlign6', '2', 'yes');
INSERT INTO `wp_options` VALUES('257', 'AdsMargin7', '10', 'yes');
INSERT INTO `wp_options` VALUES('258', 'AdsAlign7', '2', 'yes');
INSERT INTO `wp_options` VALUES('259', 'AdsMargin8', '10', 'yes');
INSERT INTO `wp_options` VALUES('260', 'AdsAlign8', '2', 'yes');
INSERT INTO `wp_options` VALUES('261', 'AdsMargin9', '10', 'yes');
INSERT INTO `wp_options` VALUES('262', 'AdsAlign9', '2', 'yes');
INSERT INTO `wp_options` VALUES('263', 'AdsMargin10', '10', 'yes');
INSERT INTO `wp_options` VALUES('264', 'AdsAlign10', '2', 'yes');
INSERT INTO `wp_options` VALUES('265', 'secure-wp', 'a:11:{s:15:\"secure_wp_error\";s:0:\"\";s:17:\"secure_wp_version\";s:1:\"1\";s:23:\"secure_wp_admin_version\";s:1:\"1\";s:15:\"secure_wp_index\";s:1:\"1\";s:13:\"secure_wp_rsd\";s:1:\"1\";s:13:\"secure_wp_wlw\";s:0:\"\";s:13:\"secure_wp_rcu\";s:1:\"1\";s:13:\"secure_wp_rpu\";s:1:\"1\";s:13:\"secure_wp_rtu\";s:1:\"1\";s:13:\"secure_wp_wps\";s:0:\"\";s:16:\"secure_wp_amurlr\";s:1:\"1\";}', 'yes');
INSERT INTO `wp_options` VALUES('266', 'pluginbuddy_slideshow', 'a:4:{s:6:\"groups\";a:1:{i:0;a:37:{s:5:\"title\";s:16:\"The Art Of Magic\";s:6:\"images\";a:2:{i:0;i:896;i:1;i:903;}s:6:\"layout\";s:7:\"default\";s:4:\"type\";s:6:\"slider\";s:16:\"enable_css_files\";s:4:\"true\";s:11:\"image_width\";s:3:\"580\";s:12:\"image_height\";s:3:\"300\";s:17:\"thumb_image_width\";s:2:\"85\";s:18:\"thumb_image_height\";s:2:\"65\";s:12:\"slider-align\";s:6:\"center\";s:13:\"slider-effect\";s:4:\"fold\";s:13:\"slider-slices\";s:2:\"15\";s:16:\"slider-animSpeed\";s:3:\"600\";s:16:\"slider-pauseTime\";s:4:\"4000\";s:19:\"slider-directionNav\";s:4:\"true\";s:23:\"slider-directionNavHide\";s:4:\"true\";s:17:\"slider-controlNav\";s:5:\"false\";s:23:\"slider-controlNavThumbs\";s:5:\"false\";s:18:\"slider-keyboardNav\";s:5:\"false\";s:19:\"slider-pauseOnHover\";s:4:\"true\";s:21:\"slider-captionOpacity\";s:3:\"0.8\";s:14:\"slider-shadows\";s:5:\"false\";s:11:\"cycle-align\";s:6:\"center\";s:8:\"cycle-fx\";s:4:\"fade\";s:13:\"cycle-timeout\";s:4:\"4000\";s:16:\"cycle-continuous\";s:1:\"0\";s:11:\"cycle-speed\";s:4:\"1000\";s:13:\"cycle-speedIn\";s:1:\"0\";s:14:\"cycle-speedOut\";s:1:\"0\";s:10:\"cycle-sync\";s:1:\"1\";s:12:\"cycle-random\";s:1:\"0\";s:11:\"cycle-pause\";s:1:\"1\";s:14:\"cycle-autostop\";s:1:\"0\";s:19:\"cycle-autostopCount\";s:1:\"3\";s:11:\"cycle-delay\";s:1:\"0\";s:22:\"cycle-randomizeEffects\";s:1:\"1\";s:14:\"cycle-pb_pager\";s:1:\"0\";}}s:6:\"access\";s:16:\"activate_plugins\";i:0;b:0;s:7:\"updater\";a:2:{s:10:\"last_check\";i:1323381001;s:13:\"last_response\";a:6:{s:6:\"status\";s:2:\"ok\";s:10:\"key_status\";s:2:\"ok\";s:12:\"download_url\";s:199:\"http://updater.ithemes.com/?product=slideshow&action=download&siteurl=http://www.plrblogs.com/magic&guid=4ee047c9d04d9&key=4EEX488D93E27431939277&expires=1323467401&v=16e82f643b17a0c6cae90e5fb2647ab2\";s:11:\"new_version\";b:1;s:14:\"latest_version\";s:6:\"1.0.36\";s:13:\"latest_update\";s:20:\"2011-12-08 11:33:04\n\";}}}', 'no');
INSERT INTO `wp_options` VALUES('267', 'pluginbuddy_slideshow-updater-guid', '4ee047c9d04d9', 'yes');
INSERT INTO `wp_options` VALUES('268', 'smart_youtube_pro', 'a:36:{s:5:\"posts\";s:2:\"on\";s:8:\"comments\";s:3:\"off\";s:3:\"img\";s:3:\"off\";s:5:\"width\";i:425;s:6:\"height\";i:344;s:7:\"widthhq\";i:480;s:8:\"heighthq\";i:295;s:9:\"widthside\";i:200;s:10:\"heightside\";i:167;s:3:\"rel\";s:1:\"1\";s:4:\"link\";s:2:\"on\";s:5:\"valid\";s:3:\"off\";s:6:\"search\";s:3:\"off\";s:4:\"info\";s:2:\"on\";s:3:\"ann\";s:2:\"on\";s:8:\"template\";s:7:\"{video}\";s:8:\"autoplay\";i:0;s:14:\"autoplay_first\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:6:\"iframe\";s:2:\"on\";s:4:\"http\";s:3:\"off\";s:3:\"www\";s:3:\"off\";s:4:\"loop\";i:0;s:5:\"thumb\";s:3:\"off\";s:8:\"colorbox\";s:3:\"off\";s:14:\"colorbox_theme\";i:1;s:7:\"excerpt\";s:3:\"not\";s:13:\"excerpt_thumb\";s:4:\"left\";s:8:\"logoless\";s:2:\"on\";s:7:\"wiziapp\";s:3:\"off\";s:6:\"teheme\";s:4:\"dark\";s:13:\"excerpt_align\";s:4:\"left\";s:5:\"theme\";s:4:\"dark\";}', 'yes');
INSERT INTO `wp_options` VALUES('269', 'wpcumulus_options', 'a:13:{s:5:\"width\";s:3:\"550\";s:6:\"height\";s:3:\"375\";s:6:\"tcolor\";s:6:\"ffffff\";s:7:\"tcolor2\";s:6:\"ffffff\";s:7:\"hicolor\";s:6:\"ffffff\";s:7:\"bgcolor\";s:6:\"333333\";s:5:\"speed\";s:3:\"100\";s:5:\"trans\";s:5:\"false\";s:5:\"distr\";s:4:\"true\";s:4:\"args\";s:0:\"\";s:8:\"compmode\";s:5:\"false\";s:10:\"showwptags\";s:4:\"true\";s:4:\"mode\";s:4:\"tags\";}', 'yes');
INSERT INTO `wp_options` VALUES('270', 'wpcumulus_widget', 'a:14:{s:5:\"width\";s:3:\"280\";s:6:\"height\";s:3:\"220\";s:6:\"tcolor\";s:6:\"333333\";s:7:\"tcolor2\";s:6:\"333333\";s:7:\"hicolor\";s:6:\"000000\";s:7:\"bgcolor\";s:6:\"ffffff\";s:5:\"speed\";s:3:\"100\";s:5:\"trans\";s:0:\"\";s:5:\"distr\";s:4:\"true\";s:4:\"args\";s:0:\"\";s:8:\"compmode\";s:5:\"false\";s:10:\"showwptags\";s:4:\"true\";s:4:\"mode\";s:4:\"tags\";s:5:\"title\";s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('271', 'widget_ws_widget__ad_codes', 'a:4:{i:2;a:0:{}i:3;a:2:{s:5:\"title\";s:16:\"Learn Easy Magic\";s:4:\"code\";s:146:\"<a href=\"[aff1link]\" title=\"[aff1tag]\"  target=\"_blank\"><img src=\"[aff1banner1]\" alt=\"[aff1tag]\" title=\"[aff1tag]\" width=\"300\" height=\"250\" /></a>\";}i:4;a:2:{s:5:\"title\";s:33:\"Professional Magic Tricks Exposed\";s:4:\"code\";s:129:\"<a href=\"[aff2link]\" title=\"[aff2tag]\"><img src=\"[aff2banner1]\" alt=\"[aff2tag]\" title=\"[aff2tag]\" width=\"300\" height=\"250\" /></a>\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('272', 'widget_ws_widget__ad_squares', 'a:3:{i:2;a:0:{}i:3;a:12:{s:5:\"title\";s:21:\"Magic Tricks Products\";s:7:\"squares\";s:1:\"2\";s:7:\"padding\";s:2:\"15\";s:7:\"shuffle\";s:1:\"0\";s:6:\"code_1\";s:146:\"<a href=\"[aff1link]\" title=\"[aff1tag]\"  target=\"_blank\"><img src=\"[aff1banner2]\" alt=\"[aff1tag]\" title=\"[aff1tag]\" width=\"125\" height=\"125\" /></a>\";s:6:\"code_2\";s:129:\"<a href=\"[aff2link]\" title=\"[aff2tag]\"><img src=\"[aff2banner2]\" alt=\"[aff2tag]\" title=\"[aff2tag]\" width=\"125\" height=\"125\" /></a>\";s:6:\"code_3\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_4\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_5\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_6\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_7\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_8\";s:162:\"<img src=\"http://www.plrblogs.com/magic/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('2029', '_transient_timeout_ye_video_MjY5ZGMzNWVjNGNkYTg4MDc3ZGY5ODZjNjZi', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2030', '_transient_ye_video_MjY5ZGMzNWVjNGNkYTg4MDc3ZGY5ODZjNjZiNTMwMjU0', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/CrvBApGYEYw?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Do+Homemade+Scar+Removal%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2035', '_transient_timeout_ye_video_NjJhNTdkYWViZGI5NzFkNmI2NTc4OTA4NDE1', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2036', '_transient_ye_video_NjJhNTdkYWViZGI5NzFkNmI2NTc4OTA4NDE1OGI3MjNl', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/qiIZJJ9l5ZU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Make+Scars+Go+Away%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('273', 'widget_pluginbuddy_slideshow', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('274', 'widget_youtube_embed_widget', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('275', 'widget_smart-youtube', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('276', 'exec-php', 'a:2:{s:7:\"version\";s:3:\"4.9\";s:14:\"widget_support\";b:1;}', 'yes');
INSERT INTO `wp_options` VALUES('277', 'youtube_embed_general', 'a:29:{s:13:\"editor_button\";s:1:\"1\";s:9:\"admin_bar\";s:1:\"1\";s:10:\"profile_no\";s:1:\"5\";s:7:\"list_no\";s:1:\"5\";s:11:\"embed_cache\";s:1:\"1\";s:10:\"info_cache\";s:2:\"24\";s:16:\"transcript_cache\";s:2:\"24\";s:11:\"fetch_title\";N;s:11:\"alt_profile\";s:1:\"0\";s:12:\"alt_profile2\";s:1:\"0\";s:7:\"bracket\";N;s:3:\"alt\";N;s:13:\"other_profile\";s:1:\"0\";s:11:\"url_profile\";s:1:\"0\";s:8:\"comments\";N;s:16:\"comments_profile\";s:1:\"0\";s:8:\"metadata\";s:1:\"1\";s:4:\"feed\";s:1:\"b\";s:3:\"api\";s:1:\"1\";s:13:\"error_message\";s:83:\"&lt;p&gt;The video cannot be shown at the moment. Please try again later.&lt;/p&gt;\";s:9:\"thumbnail\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.1\";s:11:\"frameborder\";i:1;s:7:\"donated\";s:0:\"\";s:7:\"privacy\";i:0;s:7:\"widgets\";i:0;s:14:\"profile_access\";s:14:\"delete_plugins\";s:11:\"list_access\";s:14:\"delete_plugins\";s:11:\"menu_access\";s:10:\"list_users\";}', 'yes');
INSERT INTO `wp_options` VALUES('285', '_transient_plugins_delete_result_1', '1', 'yes');
INSERT INTO `wp_options` VALUES('582', 'WPContentMagic_Options', 'a:25:{s:9:\"post_type\";s:4:\"post\";s:11:\"post_status\";s:7:\"publish\";s:15:\"post_title_from\";s:4:\"file\";s:16:\"auto_tag_article\";s:1:\"0\";s:30:\"keywords_typed_for_tag_article\";N;s:13:\"post_category\";s:3:\"317\";s:21:\"auto_posting_schedule\";s:6:\"custom\";s:20:\"custom_schedule_date\";s:16:\"10/02/2013 09:48\";s:21:\"schedule_number_begin\";s:1:\"2\";s:19:\"schedule_unit_begin\";s:4:\"days\";s:19:\"schedule_number_end\";s:1:\"5\";s:17:\"schedule_unit_end\";s:4:\"days\";s:27:\"seo_options_bold_decoration\";i:0;s:28:\"seo_options_bold_per_article\";s:1:\"1\";s:32:\"seo_options_underline_decoration\";i:0;s:33:\"seo_options_underline_per_article\";s:1:\"1\";s:32:\"seo_options_italicize_decoration\";i:0;s:33:\"seo_options_italicize_per_article\";s:1:\"1\";s:14:\"add_hyperlinks\";s:1:\"0\";s:30:\"in_content_hyperlinks_quantity\";N;s:15:\"csv_keyword_url\";N;s:11:\"cloak_links\";s:1:\"0\";s:11:\"track_links\";s:1:\"0\";s:27:\"outbound_links_add_nofollow\";i:0;s:30:\"outbound_links_open_new_window\";i:0;}', 'yes');
INSERT INTO `wp_options` VALUES('289', 'youtube_embed_url', '', 'yes');
INSERT INTO `wp_options` VALUES('290', 'youtube_embed_shortcode', 'a:2:{i:1;s:13:\"youtube_video\";i:2;s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('808', 'theme_mods_twentyeleven', 'a:1:{i:0;b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('1361', 'current_theme', 'Headlines Enhanced', 'yes');
INSERT INTO `wp_options` VALUES('294', 'theme_mods_headlines_enhanced_v3', 'a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1326082259;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:20:{i:0;s:14:\"woo_adwidget-2\";i:1;s:10:\"woo_tabs-2\";i:2;s:13:\"woo_twitter-2\";i:3;s:7:\"pages-2\";i:4;s:10:\"calendar-2\";i:5;s:7:\"links-2\";i:6;s:6:\"text-2\";i:7;s:5:\"rss-2\";i:8;s:11:\"tag_cloud-2\";i:9;s:10:\"nav_menu-2\";i:10;s:21:\"ws_widget__ad_codes-2\";i:11;s:23:\"ws_widget__ad_squares-2\";i:12;s:23:\"pluginbuddy_slideshow-2\";i:13;s:22:\"youtube_embed_widget-2\";i:14;s:15:\"smart-youtube-2\";i:15;s:14:\"recent-posts-2\";i:16;s:17:\"recent-comments-2\";i:17;s:10:\"archives-2\";i:18;s:12:\"categories-2\";i:19;s:6:\"meta-2\";}s:18:\"left-column-widget\";a:1:{i:0;s:6:\"text-3\";}s:20:\"center-column-widget\";a:1:{i:0;s:6:\"text-4\";}s:19:\"right-column-widget\";a:1:{i:0;s:6:\"text-5\";}s:9:\"sidebar-1\";a:4:{i:0;s:21:\"ws_widget__ad_codes-3\";i:1;s:23:\"ws_widget__ad_squares-3\";i:2;s:14:\"recent-posts-3\";i:3;s:10:\"wp-cumulus\";}s:8:\"footer-1\";a:1:{i:0;s:14:\"recent-posts-4\";}s:8:\"footer-2\";a:1:{i:0;s:7:\"pages-3\";}s:8:\"footer-3\";a:1:{i:0;s:12:\"categories-3\";}}}}', 'yes');
INSERT INTO `wp_options` VALUES('295', 'woo_timthumb_update', '', 'yes');
INSERT INTO `wp_options` VALUES('296', 'widget_woo_adwidget', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('297', 'widget_woo_tabs', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('298', 'widget_woo_twitter', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('299', 'woo_framework_version', '4.7.2', 'yes');
INSERT INTO `wp_options` VALUES('300', 'woo_custom_seo_template', 'a:3:{i:0;a:5:{s:4:\"name\";s:10:\"seo_info_1\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:4:\"SEO \";s:4:\"type\";s:4:\"info\";s:4:\"desc\";s:195:\"Additional SEO custom fields available: <strong>Custom Page Titles</strong>. Go to <a href=\"http://www.plrblogs.com/magic/wp-admin/admin.php?page=woothemes_seo\">SEO Settings</a> page to activate.\";}i:1;a:5:{s:4:\"name\";s:10:\"seo_follow\";s:3:\"std\";s:5:\"false\";s:5:\"label\";s:16:\"SEO - Set follow\";s:4:\"type\";s:8:\"checkbox\";s:4:\"desc\";s:77:\"Make links from this post/page <strong>followable</strong> by search engines.\";}i:2;a:5:{s:4:\"name\";s:11:\"seo_noindex\";s:3:\"std\";s:5:\"false\";s:5:\"label\";s:13:\"SEO - Noindex\";s:4:\"type\";s:8:\"checkbox\";s:4:\"desc\";s:56:\"Set the Page/Post to not be indexed by a search engines.\";}}', 'yes');
INSERT INTO `wp_options` VALUES('301', 'woo_options', 'a:117:{s:18:\"woo_alt_stylesheet\";s:12:\"skylight.css\";s:8:\"woo_logo\";s:0:\"\";s:13:\"woo_texttitle\";s:4:\"true\";s:19:\"woo_font_site_title\";a:5:{s:4:\"size\";s:2:\"52\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Yanone Kaffeesatz\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}s:16:\"woo_font_tagline\";a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Arial, sans-serif\";s:5:\"style\";s:6:\"normal\";s:5:\"color\";s:7:\"#bbbbbb\";}s:18:\"woo_custom_favicon\";s:0:\"\";s:20:\"woo_google_analytics\";s:0:\"\";s:18:\"woo_feedburner_url\";s:0:\"\";s:17:\"woo_feedburner_id\";s:0:\"\";s:21:\"woo_contactform_email\";s:0:\"\";s:14:\"woo_custom_css\";s:0:\"\";s:15:\"woo_custom_link\";s:7:\"#1079c9\";s:13:\"woo_custom_bg\";s:7:\"#edeadd\";s:20:\"woo_page_nav_disable\";s:9:\"18,19,388\";s:18:\"woo_search_disable\";s:5:\"false\";s:22:\"woo_disable_posts_date\";s:5:\"false\";s:21:\"woo_disable_cats_date\";s:5:\"false\";s:23:\"woo_disable_search_date\";s:5:\"false\";s:25:\"woo_disable_comments_date\";s:5:\"false\";s:23:\"woo_show_number_results\";s:5:\"false\";s:19:\"woo_featured_slider\";s:4:\"true\";s:22:\"woo_featured_shortcode\";s:24:\"[pb_slideshow group=\"0\"]\";s:18:\"woo_featured_video\";s:5:\"false\";s:29:\"woo_featured_video_embed_code\";s:196:\"<iframe src=\"http://player.vimeo.com/video/27299211?title=0&amp;byline=0&amp;portrait=0\" width=\"580\" height=\"300\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>\";s:21:\"woo_sticky_posts_only\";s:4:\"true\";s:22:\"woo_sticky_posts_count\";s:1:\"5\";s:15:\"woo_top_widgets\";s:5:\"false\";s:24:\"woo_top_widgets_allposts\";s:5:\"false\";s:26:\"woo_top_widgets_bypost_ids\";s:0:\"\";s:24:\"woo_top_widgets_allpages\";s:5:\"false\";s:26:\"woo_top_widgets_bypage_ids\";s:0:\"\";s:25:\"woo_custom_l_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_l_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_l_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_l_star_image\";s:4:\"true\";s:21:\"woo_stars_left_ribbon\";s:7:\"5-stars\";s:25:\"woo_custom_c_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_c_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_c_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_c_star_image\";s:4:\"true\";s:23:\"woo_stars_center_ribbon\";s:7:\"4-stars\";s:25:\"woo_custom_r_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_r_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_r_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_r_star_image\";s:4:\"true\";s:22:\"woo_stars_right_ribbon\";s:7:\"3-stars\";s:9:\"woo_cufon\";s:4:\"true\";s:16:\"woo_home_content\";s:5:\"false\";s:19:\"woo_archive_content\";s:5:\"false\";s:23:\"woo_disable_post_author\";s:4:\"true\";s:23:\"woo_sp_noheadfoot_width\";s:3:\"950\";s:26:\"woo_sp_noheadfoot_fontsize\";s:2:\"14\";s:20:\"woo_sp_noheadfoot_bg\";s:0:\"\";s:24:\"woo_sp_noheadfoot_border\";s:0:\"\";s:28:\"woo_sp_noheadfoot_bordersize\";s:0:\"\";s:29:\"woo_sp_noheadfoot_borderstyle\";s:5:\"solid\";s:30:\"woo_sp_noheadfoot_borderradius\";s:2:\"30\";s:14:\"woo_padd_right\";s:3:\"150\";s:13:\"woo_padd_left\";s:3:\"150\";s:12:\"woo_padd_top\";s:2:\"20\";s:15:\"woo_padd_bottom\";s:2:\"20\";s:18:\"woo_show_sp_footer\";s:5:\"false\";s:21:\"woo_show_sp_footer_id\";s:0:\"\";s:22:\"woo_show_custom_footer\";s:5:\"false\";s:27:\"woo_show_custom_footer_code\";s:267:\"Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>\";s:28:\"woo_custom_footer_font_color\";s:0:\"\";s:27:\"woo_custom_footer_underline\";s:4:\"true\";s:0:\"\";b:0;s:11:\"woo_blank_1\";s:10:\"wizardmar4\";s:11:\"woo_blank_2\";s:9:\"magicsi25\";s:13:\"woo_aff1_link\";s:52:\"http://d0ebcjt2wae7-d7jjjbqhbok8u.hop.clickbank.net/\";s:18:\"woo_aff1_title_tag\";s:16:\"Learn Easy Magic\";s:21:\"woo_aff1_banner_url_1\";s:85:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/learn-easy-magic-300x250.jpg\";s:21:\"woo_aff1_banner_url_2\";s:85:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/learn-easy-magic-300x250.jpg\";s:21:\"woo_aff1_banner_url_3\";s:67:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/468x60.jpg\";s:13:\"woo_aff2_link\";s:52:\"http://20387gp7s3ne9c1ce1o3-a832g.hop.clickbank.net/\";s:18:\"woo_aff2_title_tag\";s:33:\"Professional Magic Tricks Exposed\";s:21:\"woo_aff2_banner_url_1\";s:94:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/professional-magic-tricks-300x250.jpg\";s:21:\"woo_aff2_banner_url_2\";s:82:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/125x125-Mind-Blowing2.jpg\";s:21:\"woo_aff2_banner_url_3\";s:47:\"Put your 468x60 (on Video Page) Banner URL here\";s:10:\"woo_ad_top\";s:4:\"true\";s:16:\"woo_ad_top_image\";s:67:\"http://www.plrblogs.com/magic/wp-content/uploads/2013/11/468x60.jpg\";s:14:\"woo_ad_top_url\";s:52:\"http://d0ebcjt2wae7-d7jjjbqhbok8u.hop.clickbank.net/\";s:18:\"woo_ad_top_adsense\";s:0:\"\";s:26:\"woo_show_dislcaimer_footer\";s:4:\"true\";s:28:\"woo_custom_footer_disclaimer\";s:368:\"Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.\";s:23:\"woo_disclaimer_fontsize\";s:2:\"14\";s:20:\"woo_disclaimer_color\";s:7:\"#244676\";s:22:\"woo_post_image_support\";s:4:\"true\";s:14:\"woo_pis_resize\";s:4:\"true\";s:17:\"woo_pis_hard_crop\";s:4:\"true\";s:10:\"woo_resize\";s:4:\"true\";s:12:\"woo_auto_img\";s:5:\"false\";s:13:\"woo_rss_thumb\";s:5:\"false\";s:9:\"woo_align\";s:9:\"alignleft\";s:15:\"woo_thumb_width\";s:3:\"150\";s:16:\"woo_thumb_height\";s:3:\"150\";s:16:\"woo_image_single\";s:5:\"false\";s:16:\"woo_single_width\";s:3:\"200\";s:17:\"woo_single_height\";s:3:\"200\";s:14:\"woo_ad_content\";s:5:\"false\";s:22:\"woo_ad_content_adsense\";s:0:\"\";s:20:\"woo_ad_content_image\";s:15:\"Enter Image URL\";s:18:\"woo_ad_content_url\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ads_rotate\";s:4:\"true\";s:14:\"woo_ad_image_1\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_1\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_2\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_2\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_3\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_3\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_4\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_4\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_5\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_5\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_6\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_6\";s:24:\"http://www.woothemes.com\";}', 'yes');
INSERT INTO `wp_options` VALUES('302', 'woo_template', 'a:126:{i:0;a:3:{s:4:\"name\";s:16:\"General Settings\";s:4:\"icon\";s:7:\"general\";s:4:\"type\";s:7:\"heading\";}i:1;a:6:{s:4:\"name\";s:16:\"Theme Stylesheet\";s:4:\"desc\";s:44:\"Select your themes alternative color scheme.\";s:2:\"id\";s:18:\"woo_alt_stylesheet\";s:3:\"std\";s:11:\"default.css\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:21:{i:0;s:14:\"purplehaze.css\";i:1;s:14:\"tequilasun.css\";i:2;s:12:\"redslate.css\";i:3;s:14:\"greyorange.css\";i:4;s:9:\"berry.css\";i:5;s:13:\"blueberry.css\";i:6;s:14:\"springtime.css\";i:7;s:11:\"default.css\";i:8;s:11:\"redrock.css\";i:9;s:15:\"pomegranate.css\";i:10;s:14:\"chocoberry.css\";i:11;s:21:\"redhotchilipepper.css\";i:12;s:15:\"countryside.css\";i:13;s:12:\"skylight.css\";i:14;s:13:\"greenline.css\";i:15;s:13:\"fruitella.css\";i:16;s:14:\"orangeline.css\";i:17;s:12:\"blueline.css\";i:18;s:15:\"cottoncandy.css\";i:19;s:12:\"orangina.css\";i:20;s:9:\"salsa.css\";}}i:2;a:5:{s:4:\"name\";s:11:\"Custom Logo\";s:4:\"desc\";s:63:\"Upload a logo for your theme, or specify an image URL directly.\";s:2:\"id\";s:8:\"woo_logo\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:3;a:6:{s:4:\"name\";s:10:\"Text Title\";s:4:\"desc\";s:85:\"Enable text-based Site Title and Tagline. Setup title & tagline in Settings->General.\";s:2:\"id\";s:13:\"woo_texttitle\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:4;a:6:{s:4:\"name\";s:10:\"Site Title\";s:4:\"desc\";s:62:\"Change the site title (must have \'Text Title\' option enabled).\";s:2:\"id\";s:19:\"woo_font_site_title\";s:3:\"std\";a:5:{s:4:\"size\";s:2:\"36\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:5:\"Arial\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:10:\"typography\";}i:5;a:6:{s:4:\"name\";s:16:\"Site Description\";s:4:\"desc\";s:68:\"Change the site description (must have \'Text Title\' option enabled).\";s:2:\"id\";s:16:\"woo_font_tagline\";s:3:\"std\";a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:5:\"Arial\";s:5:\"style\";s:0:\"\";s:5:\"color\";s:7:\"#bbbbbb\";}s:5:\"class\";s:11:\"hidden last\";s:4:\"type\";s:10:\"typography\";}i:6;a:5:{s:4:\"name\";s:14:\"Custom Favicon\";s:4:\"desc\";s:113:\"Upload a 16px x 16px <a href=\'http://www.faviconr.com/\'>ico image</a> that will represent your website\'s favicon.\";s:2:\"id\";s:18:\"woo_custom_favicon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:7;a:5:{s:4:\"name\";s:13:\"Tracking Code\";s:4:\"desc\";s:117:\"Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.\";s:2:\"id\";s:20:\"woo_google_analytics\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:8;a:5:{s:4:\"name\";s:7:\"RSS URL\";s:4:\"desc\";s:51:\"Enter your preferred RSS URL. (Feedburner or other)\";s:2:\"id\";s:18:\"woo_feedburner_url\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:9;a:5:{s:4:\"name\";s:10:\"E-Mail URL\";s:4:\"desc\";s:67:\"Enter your preferred E-mail subscription URL. (Feedburner or other)\";s:2:\"id\";s:17:\"woo_feedburner_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:10;a:5:{s:4:\"name\";s:19:\"Contact Form E-Mail\";s:4:\"desc\";s:67:\"Enter your E-mail address to use on the Contact Form Page Template.\";s:2:\"id\";s:21:\"woo_contactform_email\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:11;a:5:{s:4:\"name\";s:10:\"Custom CSS\";s:4:\"desc\";s:62:\"Quickly add some CSS to your theme by adding it to this block.\";s:2:\"id\";s:14:\"woo_custom_css\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:12;a:3:{s:4:\"name\";s:15:\"Styling Options\";s:4:\"type\";s:7:\"heading\";s:4:\"icon\";s:7:\"styling\";}i:13;a:5:{s:4:\"name\";s:17:\"Custom Link Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the links in your site e.g. #697e09\";s:2:\"id\";s:15:\"woo_custom_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:14;a:5:{s:4:\"name\";s:23:\"Custom Background Color\";s:4:\"desc\";s:54:\"Add a custom hex color for the background e.g. #697e09\";s:2:\"id\";s:13:\"woo_custom_bg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:15;a:3:{s:4:\"name\";s:18:\"Navigation Options\";s:4:\"icon\";s:3:\"nav\";s:4:\"type\";s:7:\"heading\";}i:16;a:5:{s:4:\"name\";s:35:\"Exclude Pages In Top Navigation Bar\";s:4:\"desc\";s:35:\"Comma separate Page IDs, e.g. 18,19\";s:2:\"id\";s:20:\"woo_page_nav_disable\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:17;a:5:{s:4:\"name\";s:20:\"Disable Search Field\";s:4:\"desc\";s:83:\"Remove the Search Field in the right side of nav, to make room for more categories.\";s:2:\"id\";s:18:\"woo_search_disable\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:18;a:5:{s:4:\"name\";s:52:\"Disable Date &amp; Comments Count (by line) On Posts\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:22:\"woo_disable_posts_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:19;a:5:{s:4:\"name\";s:57:\"Disable Date &amp; Comments Count (by line) On Categories\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:21:\"woo_disable_cats_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:20;a:5:{s:4:\"name\";s:69:\"Disable Date &amp; Comments Count (by line) On The Search Result Page\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:23:\"woo_disable_search_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:21;a:5:{s:4:\"name\";s:35:\"Disable Date &amp; Time On Comments\";s:4:\"desc\";s:38:\"Remove Date and Time from on comments.\";s:2:\"id\";s:25:\"woo_disable_comments_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:22;a:5:{s:4:\"name\";s:50:\"Show Page Navigation At The Bottom Of The Homepage\";s:4:\"desc\";s:63:\"You must have more posts than what shows on Settings >> Reading\";s:2:\"id\";s:23:\"woo_show_number_results\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:23;a:3:{s:4:\"name\";s:16:\"Homepage Options\";s:4:\"icon\";s:8:\"featured\";s:4:\"type\";s:7:\"heading\";}i:24;a:6:{s:4:\"name\";s:25:\"Enable Slider On Homepage\";s:4:\"desc\";s:37:\"Show the slider on the homepage page.\";s:2:\"id\";s:19:\"woo_featured_slider\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:25;a:6:{s:4:\"name\";s:28:\"Slideshow Homepage Shortcode\";s:4:\"desc\";s:68:\"By default, this will display the first Slideshow shortcode created!\";s:2:\"id\";s:22:\"woo_featured_shortcode\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"hidden last\";s:3:\"std\";s:24:\"[pb_slideshow group=\"0\"]\";}i:26;a:6:{s:4:\"name\";s:49:\"Enable Video On Homepage <u>Instead Of</u> Slider\";s:4:\"desc\";s:47:\"Show video, e.g. YouTube, on the homepage page.\";s:2:\"id\";s:18:\"woo_featured_video\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:27;a:6:{s:4:\"name\";s:61:\"Video Embed Code - <i>Video Size Should Be 580px by 300px</i>\";s:4:\"desc\";s:61:\"Please note the ideal size of video should be 580px by 300px!\";s:2:\"id\";s:29:\"woo_featured_video_embed_code\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:11:\"hidden last\";s:3:\"std\";s:65:\"Paste Your Video Code Here. Size of video must be 580px by 300px!\";}i:28;a:5:{s:4:\"name\";s:49:\"Display Sticky Posts <u>Only</u> On The Homepage?\";s:4:\"desc\";s:34:\"Show only sticky posts on homepage\";s:2:\"id\";s:21:\"woo_sticky_posts_only\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:29;a:5:{s:4:\"name\";s:41:\"Number of Sticky Posts (Only) On Homepage\";s:4:\"desc\";s:36:\"Enter number of sticky posts to show\";s:2:\"id\";s:22:\"woo_sticky_posts_count\";s:4:\"type\";s:4:\"text\";s:3:\"std\";s:1:\"5\";}i:30;a:3:{s:4:\"name\";s:20:\"Homepage Top Sidebar\";s:4:\"icon\";s:10:\"topsidebar\";s:4:\"type\";s:7:\"heading\";}i:31;a:5:{s:4:\"name\";s:30:\"Display 3 Widgets On Homepage?\";s:4:\"desc\";s:53:\"Show 3 widgets below header &amp; above posts/sidebar\";s:2:\"id\";s:15:\"woo_top_widgets\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:32;a:5:{s:4:\"name\";s:18:\"Show On All Posts?\";s:4:\"desc\";s:61:\"Tick the box if you want to show the top sidebar on all Posts\";s:2:\"id\";s:24:\"woo_top_widgets_allposts\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:33;a:5:{s:4:\"name\";s:104:\"Show Top Sidebar By Post IDs Only <span style=\'color:#e82f0b;font-size:12px;\'>(Untick Box Above!)</span>\";s:4:\"desc\";s:42:\"Enter the Post IDs to show the top sidebar\";s:2:\"id\";s:26:\"woo_top_widgets_bypost_ids\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:34;a:5:{s:4:\"name\";s:18:\"Show on All Pages?\";s:4:\"desc\";s:61:\"Tick the box if you want to show the top sidebar on all Pages\";s:2:\"id\";s:24:\"woo_top_widgets_allpages\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:35;a:5:{s:4:\"name\";s:104:\"Show Top Sidebar By Page IDs Only <span style=\'color:#e82f0b;font-size:12px;\'>(Untick Box Above!)</span>\";s:4:\"desc\";s:42:\"Enter the Page IDs to show the top sidebar\";s:2:\"id\";s:26:\"woo_top_widgets_bypage_ids\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:36;a:5:{s:4:\"name\";s:24:\"Custom Left Ribbon Color\";s:4:\"desc\";s:61:\"Add a custom hex color for the left ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_l_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:37;a:5:{s:4:\"name\";s:29:\"Custom Left Ribbon Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_l_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:38;a:5:{s:4:\"name\";s:31:\"Custom Left Ribbon Border Color\";s:4:\"desc\";s:68:\"Add a custom hex color for the left ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_l_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:39;a:5:{s:4:\"name\";s:31:\"Add Star Rating To Left Ribbon?\";s:4:\"desc\";s:65:\"Tick the box if you want to show a star rating on the left ribbon\";s:2:\"id\";s:20:\"woo_add_l_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:40;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:21:\"woo_stars_left_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:41;a:5:{s:4:\"name\";s:26:\"Custom Center Ribbon Color\";s:4:\"desc\";s:63:\"Add a custom hex color for the center ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_c_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:42;a:5:{s:4:\"name\";s:31:\"Custom Center Ribbon Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_c_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:43;a:5:{s:4:\"name\";s:33:\"Custom Center Ribbon Border Color\";s:4:\"desc\";s:70:\"Add a custom hex color for the center ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_c_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:44;a:5:{s:4:\"name\";s:33:\"Add Star Rating To Center Ribbon?\";s:4:\"desc\";s:67:\"Tick the box if you want to show a star rating on the center ribbon\";s:2:\"id\";s:20:\"woo_add_c_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:45;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:23:\"woo_stars_center_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:46;a:5:{s:4:\"name\";s:25:\"Custom Right Ribbon Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the right ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_r_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:47;a:5:{s:4:\"name\";s:30:\"Custom Right Ribbon Font Color\";s:4:\"desc\";s:67:\"Add a custom hex color for the right ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_r_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:48;a:5:{s:4:\"name\";s:32:\"Custom Right Ribbon Border Color\";s:4:\"desc\";s:69:\"Add a custom hex color for the right ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_r_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:49;a:5:{s:4:\"name\";s:32:\"Add Star Rating To Right Ribbon?\";s:4:\"desc\";s:66:\"Tick the box if you want to show a star rating on the right ribbon\";s:2:\"id\";s:20:\"woo_add_r_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:50;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:22:\"woo_stars_right_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:51;a:3:{s:4:\"name\";s:14:\"Layout Options\";s:4:\"icon\";s:6:\"layout\";s:4:\"type\";s:7:\"heading\";}i:52;a:5:{s:4:\"name\";s:17:\"Enable Cufon font\";s:4:\"desc\";s:187:\"Enable <a href=\"http://cufon.shoqolate.com/generate/\">Cufon</a> font replacement. Replaces Headers to <a href=\"http://www.fontsquirrel.com/fonts/Liberation-Sans\">Liberation Sans</a> font.\";s:2:\"id\";s:9:\"woo_cufon\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:53;a:5:{s:4:\"name\";s:17:\"Full Content Home\";s:4:\"desc\";s:66:\"Show the full content in posts on homepage instead of the excerpt.\";s:2:\"id\";s:16:\"woo_home_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:54;a:5:{s:4:\"name\";s:20:\"Full Content Archive\";s:4:\"desc\";s:71:\"Show the full content in posts on archive pages instead of the excerpt.\";s:2:\"id\";s:19:\"woo_archive_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:55;a:5:{s:4:\"name\";s:19:\"Disable Post Author\";s:4:\"desc\";s:31:\"Disable post author below post?\";s:2:\"id\";s:23:\"woo_disable_post_author\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:56;a:3:{s:4:\"name\";s:18:\"Sales Page Options\";s:4:\"icon\";s:4:\"post\";s:4:\"type\";s:7:\"heading\";}i:57;a:5:{s:4:\"name\";s:58:\"Width For Page Template - \"Sales Page No Header No Footer\"\";s:4:\"desc\";s:30:\"Enter Width - Default is 960px\";s:2:\"id\";s:23:\"woo_sp_noheadfoot_width\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:58;a:5:{s:4:\"name\";s:9:\"Font Size\";s:4:\"desc\";s:38:\"Enter size of font in pixels e.g. 14px\";s:2:\"id\";s:26:\"woo_sp_noheadfoot_fontsize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:59;a:5:{s:4:\"name\";s:23:\"Custom Background Color\";s:4:\"desc\";s:61:\"Add a custom hex color for the background color, e.g. #697e09\";s:2:\"id\";s:20:\"woo_sp_noheadfoot_bg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:60;a:5:{s:4:\"name\";s:19:\"Custom Border Color\";s:4:\"desc\";s:51:\"Add a custom hex color for the border, e.g. #697e09\";s:2:\"id\";s:24:\"woo_sp_noheadfoot_border\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:61;a:5:{s:4:\"name\";s:18:\"Custom Border Size\";s:4:\"desc\";s:27:\"Enter size - default is 1px\";s:2:\"id\";s:28:\"woo_sp_noheadfoot_bordersize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:62;a:6:{s:4:\"name\";s:19:\"Custom Border Style\";s:4:\"desc\";s:22:\"Select style of border\";s:2:\"id\";s:29:\"woo_sp_noheadfoot_borderstyle\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:3:{s:5:\"solid\";s:5:\"Solid\";s:6:\"dashed\";s:6:\"Dashed\";s:6:\"dotted\";s:6:\"Dotted\";}}i:63;a:5:{s:4:\"name\";s:20:\"Custom Border Radius\";s:4:\"desc\";s:49:\"Enter radius size, for example 10 (do not add px)\";s:2:\"id\";s:30:\"woo_sp_noheadfoot_borderradius\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:64;a:5:{s:4:\"name\";s:28:\"Add Padding Inside Page Area\";s:4:\"desc\";s:68:\"Enter an integer value i.e. 20 for the image size. Max width is 576.\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:4:{i:0;a:4:{s:2:\"id\";s:14:\"woo_padd_right\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:50;s:4:\"meta\";s:5:\"Right\";}i:1;a:4:{s:2:\"id\";s:13:\"woo_padd_left\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:50;s:4:\"meta\";s:4:\"Left\";}i:2;a:4:{s:2:\"id\";s:12:\"woo_padd_top\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:20;s:4:\"meta\";s:3:\"Top\";}i:3;a:4:{s:2:\"id\";s:15:\"woo_padd_bottom\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:20;s:4:\"meta\";s:6:\"Bottom\";}}}i:65;a:5:{s:4:\"name\";s:50:\"Show <u>Blog</u> Footer On <u>All</u> Sales Pages?\";s:4:\"desc\";s:55:\"Tick the box if you want to show the main blog\'s footer\";s:2:\"id\";s:18:\"woo_show_sp_footer\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:66;a:5:{s:4:\"name\";s:154:\"Show <u>Blog</u> Footer By Page IDs Only <span style=\'color:#e82f0b;font-size:12px;\'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>\";s:4:\"desc\";s:37:\"Enter the Page IDs to show the footer\";s:2:\"id\";s:21:\"woo_show_sp_footer_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:67;a:6:{s:4:\"name\";s:155:\"Show <u>Custom</u> Footer On Sales Pages? <span style=\'color:#e82f0b;font-size:12px;\'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>\";s:4:\"desc\";s:52:\"Tick the box if you want to show custom footer links\";s:2:\"id\";s:22:\"woo_show_custom_footer\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:68;a:6:{s:4:\"name\";s:27:\"Enter HTML Links Code below\";s:4:\"desc\";s:26:\"Enter your HTML Links Code\";s:2:\"id\";s:27:\"woo_show_custom_footer_code\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:6:\"hidden\";s:3:\"std\";s:267:\"Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>\";}i:69;a:6:{s:4:\"name\";s:24:\"Custom Footer Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:28:\"woo_custom_footer_font_color\";s:3:\"std\";s:0:\"\";s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:5:\"color\";}i:70;a:6:{s:4:\"name\";s:30:\"Underline Custom Footer Links?\";s:4:\"desc\";s:47:\"Choose whether or not to underline footer links\";s:2:\"id\";s:27:\"woo_custom_footer_underline\";s:5:\"class\";s:6:\"hidden\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:71;a:3:{s:4:\"name\";s:22:\"Replace Affiliate URLs\";s:4:\"icon\";s:4:\"ads2\";s:4:\"type\";s:7:\"heading\";}i:72;a:3:{s:4:\"name\";s:219:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Replace Affiliate URLs - Instructions</span>\";s:4:\"type\";s:4:\"para\";s:4:\"desc\";s:1421:\"<span style=\'font-weight:bold; color:#e82f0b;\'>Step 1)</span> - If using Clickbank, Click the Clickbank Hoplink Encoding URL below. It will open in a new window.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 2)</span> - On the Clickbank Hoplink Encoding webpage, add your Clickbank ID (aka Affiliate Nickname) and one of the Clickbank Vendor IDs below in Step 2.<br /><br />** Repeat Step 2 twice until you have BOTH your <strong>unique</strong> Affiliate URLs.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Steps 3 &amp; 4)</span> - Add Your Affiliate URLs (Clickbank, etc.), Title/Alt Tags, Banner URLs </strong>.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 5)</span> - Tick the box in <strong>Step 5</strong> to enable the 468px by 60px banner in the <strong>header area</strong>. Enter your Affiliate URL (Clickbank, etc.) that you created earlier that relates to the banner/product. You can replace the banner with Adsense if you prefer.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 6)</span> - Click the <strong>Save All Changes</strong> button at the bottom.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 7)</span> - Now go to your site and hover your mouse over each banner to make sure the correct Affiliate Links/Alt Tags/Banners are appearing!<br /><br /><br /><br />\r\n								\";}i:73;a:3:{s:4:\"name\";s:379:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 1 - Click The Link Below To Create Your Encoded Hoplinks</span> <br /><br /><a href=\'https://www.clickbank.com/hoplink_encoding.htm\' target=\'_blank\'>https://www.clickbank.com/hoplink_encoding.htm</a>\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";}i:74;a:5:{s:4:\"name\";s:254:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 2 - Clickbank Vendor IDs To Encode Your Hoplinks From The URL Above</span>\";s:4:\"desc\";s:0:\"\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:11:\"woo_blank_1\";s:3:\"std\";s:11:\"vendor id 1\";s:4:\"meta\";s:22:\"Clickbank Vendor ID #1\";s:4:\"type\";s:4:\"text\";}i:1;a:4:{s:2:\"id\";s:11:\"woo_blank_2\";s:3:\"std\";s:11:\"vendor id 2\";s:4:\"meta\";s:22:\"Clickbank Vendor ID #2\";s:4:\"type\";s:4:\"text\";}}}i:75;a:5:{s:4:\"name\";s:222:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 3 - Add Your Affiliate URL #1 Below</span>\";s:4:\"desc\";s:107:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1link]</strong></span>\";s:2:\"id\";s:13:\"woo_aff1_link\";s:3:\"std\";s:30:\"Put your Affiliate URL #1 here\";s:4:\"type\";s:4:\"text\";}i:76;a:5:{s:4:\"name\";s:112:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Banner Title/Alt Tags For Affiliate URL #1</span>\";s:4:\"desc\";s:106:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1tag]</strong></span>\";s:2:\"id\";s:18:\"woo_aff1_title_tag\";s:3:\"std\";s:28:\"Put your Title/Alt info here\";s:4:\"type\";s:4:\"text\";}i:77;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 300x250 Banner Link For Affiliate URL #1</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner1]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_1\";s:3:\"std\";s:32:\"Put your 300x250 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:78;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 125x125 Banner Link For Affiliate URL #1</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner2]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_2\";s:3:\"std\";s:32:\"Put your 125x125 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:79;a:5:{s:4:\"name\";s:131:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Banner Link For Affiliate URL #1</span> (if applicable)\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner3]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_3\";s:3:\"std\";s:31:\"Put your 468x60 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:80;a:5:{s:4:\"name\";s:222:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 4 - Add Your Affiliate URL #2 Below</span>\";s:4:\"desc\";s:98:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2link]</span>\";s:2:\"id\";s:13:\"woo_aff2_link\";s:3:\"std\";s:30:\"Put your Affiliate URL #2 here\";s:4:\"type\";s:4:\"text\";}i:81;a:5:{s:4:\"name\";s:112:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Banner Title/Alt Tags For Affiliate URL #2</span>\";s:4:\"desc\";s:106:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2tag]</strong></span>\";s:2:\"id\";s:18:\"woo_aff2_title_tag\";s:3:\"std\";s:28:\"Put your Title/Alt info here\";s:4:\"type\";s:4:\"text\";}i:82;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 300x250 Banner Link For Affiliate URL #2</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner1]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_1\";s:3:\"std\";s:32:\"Put your 300x250 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:83;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 125x125 Banner Link For Affiliate URL #2</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner2]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_2\";s:3:\"std\";s:32:\"Put your 125x125 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:84;a:5:{s:4:\"name\";s:131:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Banner Link For Affiliate URL #2</span> (if applicable)\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner3]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_3\";s:3:\"std\";s:47:\"Put your 468x60 (on Video Page) Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:85;a:5:{s:4:\"name\";s:218:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 5 - Enable 468x60 Header Banner</span>\";s:4:\"desc\";s:29:\"Enable 468x60 banner ad space\";s:2:\"id\";s:10:\"woo_ad_top\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:86;a:5:{s:4:\"name\";s:100:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Header Banner URL</span>\";s:4:\"desc\";s:46:\"Enter the URL to the banner ad image location.\";s:2:\"id\";s:16:\"woo_ad_top_image\";s:3:\"std\";s:40:\"http://www.woothemes.com/ads/468x60b.jpg\";s:4:\"type\";s:6:\"upload\";}i:87;a:5:{s:4:\"name\";s:110:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Header Banner Affiliate URL</span>\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:14:\"woo_ad_top_url\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:88;a:5:{s:4:\"name\";s:72:\"Adsense code (optional) - if you prefer Adsense over an affiliate banner\";s:4:\"desc\";s:56:\"Enter your adsense code (or other ad network code) here.\";s:2:\"id\";s:18:\"woo_ad_top_adsense\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:89;a:3:{s:4:\"name\";s:17:\"Footer Disclaimer\";s:4:\"icon\";s:4:\"post\";s:4:\"type\";s:7:\"heading\";}i:90;a:5:{s:4:\"name\";s:23:\"Show Footer Disclaimer?\";s:4:\"desc\";s:73:\"Tick the box if you want to show a disclaimer in the footer (recommended)\";s:2:\"id\";s:26:\"woo_show_dislcaimer_footer\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:91;a:5:{s:4:\"name\";s:44:\"Type In Your Disclaimer Or Use The One Below\";s:4:\"desc\";s:24:\"Type or Paste Disclaimer\";s:2:\"id\";s:28:\"woo_custom_footer_disclaimer\";s:3:\"std\";s:368:\"Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.\";s:4:\"type\";s:8:\"textarea\";}i:92;a:5:{s:4:\"name\";s:59:\"Disclaimer Font Size - Just Type The Number, Don\'t Add \'px\'\";s:4:\"desc\";s:41:\"Enter font size e.g. type 14 to mean 14px\";s:2:\"id\";s:23:\"woo_disclaimer_fontsize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:93;a:5:{s:4:\"name\";s:17:\"Custom Link Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the links in your site e.g. #697e09\";s:2:\"id\";s:20:\"woo_disclaimer_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:94;a:3:{s:4:\"name\";s:13:\"Backlink Tips\";s:4:\"icon\";s:10:\"linkseeker\";s:4:\"type\";s:7:\"heading\";}i:95;a:3:{s:4:\"name\";s:262:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Find .edu, .gov, and other URLs to \"drop your links\" - <u><i>Don\'t Spam!</i></u></span>\";s:4:\"type\";s:4:\"para\";s:4:\"desc\";s:1162:\"Click The Link Below To Search For Sites To Leave Well-Constructed Comments! <br /><br /><a href=\'http://dropmylink.com/\' target=\'_blank\'>Drop My Link</a><br /><br />\r\n							   <span style=\'font-weight:bold; color:#e82f0b;\'>Please Note:</span> While most links may be considered \"good\", don\'t fall for the <i>\".edu or .org links will skyrocket your site to the top of Google!\".</i> Mix up your backlink strategy for best results!<br /><br />\r\n							   ** Consider these other options:<br /><br />\r\n							   - Article directories like those listed below:<br /><br />\r\n								<ol>\r\n									<li><a href=\'http://www.ezinearticles.com\' target=\'_blank\'>EzineArticles.com</a></li>\r\n									<li><a href=\'http://www.goarticles.com\' target=\'_blank\'>GoArticles.com</a></li>\r\n									<li><a href=\'http://www.articlesbase.com\' target=\'_blank\'>ArticlesBase.com</a></li>\r\n								</ol><br />\r\n							   - Outsource link building, press releases etc. <br /><br />\r\n								<ol>\r\n									<li>Try the <a href=\'http://www.warriorforum.com/warriors-hire/\' target=\'_blank\'>Warrior\'s For Hire</a> section</li>\r\n								</ol><br />\r\n							   - And so on.<br /><br />\r\n								\";}i:96;a:3:{s:4:\"name\";s:14:\"Dynamic Images\";s:4:\"type\";s:7:\"heading\";s:4:\"icon\";s:5:\"image\";}i:97;a:6:{s:4:\"name\";s:39:\"Enable WordPress Post Thumbnail Support\";s:4:\"desc\";s:64:\"Use WordPress post thumbnail support to assign a post thumbnail.\";s:2:\"id\";s:22:\"woo_post_image_support\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:98;a:6:{s:4:\"name\";s:33:\"Dynamically Resize Post Thumbnail\";s:4:\"desc\";s:113:\"The post thumbnail will be dynamically resized using native WP resize functionality. <em>(Requires PHP 5.2+)</em>\";s:2:\"id\";s:14:\"woo_pis_resize\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:8:\"checkbox\";}i:99;a:6:{s:4:\"name\";s:24:\"Hard Crop Post Thumbnail\";s:4:\"desc\";s:59:\"The image will be cropped to match the target aspect ratio.\";s:2:\"id\";s:17:\"woo_pis_hard_crop\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:11:\"hidden last\";s:4:\"type\";s:8:\"checkbox\";}i:100;a:5:{s:4:\"name\";s:28:\"Enable Dynamic Image Resizer\";s:4:\"desc\";s:84:\"This will enable the thumb.php script which dynamically resizes images on your site.\";s:2:\"id\";s:10:\"woo_resize\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:101;a:5:{s:4:\"name\";s:22:\"Automatic Image Thumbs\";s:4:\"desc\";s:96:\"If no image is specified in the \'image\' custom field then the first uploaded post image is used.\";s:2:\"id\";s:12:\"woo_auto_img\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:102;a:5:{s:4:\"name\";s:22:\"Show Image in RSS feed\";s:4:\"desc\";s:69:\"Will show the image uploaded to \'image\' custom field in the RSS feed.\";s:2:\"id\";s:13:\"woo_rss_thumb\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:103;a:6:{s:4:\"name\";s:15:\"Image alignment\";s:4:\"desc\";s:69:\"Select how to align your images with posts (front page and archives).\";s:2:\"id\";s:9:\"woo_align\";s:3:\"std\";s:9:\"alignleft\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:3:{s:9:\"alignleft\";s:4:\"Left\";s:10:\"alignright\";s:5:\"Right\";s:11:\"aligncenter\";s:6:\"Center\";}}i:104;a:5:{s:4:\"name\";s:16:\"Image Dimensions\";s:4:\"desc\";s:69:\"Enter an integer value i.e. 250 for the image size. Max width is 576.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:15:\"woo_thumb_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:16:\"woo_thumb_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:6:\"Height\";}}}i:105;a:5:{s:4:\"name\";s:20:\"Show in Single Posts\";s:4:\"desc\";s:100:\"Show the attached image in the single post page. <strong>Note:</strong> You must disable content ad.\";s:2:\"id\";s:16:\"woo_image_single\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:106;a:5:{s:4:\"name\";s:23:\"Single Image Dimensions\";s:4:\"desc\";s:69:\"Enter an integer value i.e. 250 for the image size. Max width is 576.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:16:\"woo_single_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:17:\"woo_single_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:6:\"Height\";}}}i:107;a:3:{s:4:\"name\";s:22:\"Content Ad (200x200px)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:108;a:5:{s:4:\"name\";s:9:\"Enable Ad\";s:4:\"desc\";s:19:\"Enable the ad space\";s:2:\"id\";s:14:\"woo_ad_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:109;a:5:{s:4:\"name\";s:12:\"Adsense code\";s:4:\"desc\";s:56:\"Enter your adsense code (or other ad network code) here.\";s:2:\"id\";s:22:\"woo_ad_content_adsense\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:110;a:5:{s:4:\"name\";s:14:\"Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:20:\"woo_ad_content_image\";s:3:\"std\";s:15:\"Enter Image URL\";s:4:\"type\";s:6:\"upload\";}i:111;a:5:{s:4:\"name\";s:15:\"Destination URL\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:18:\"woo_ad_content_url\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:112;a:3:{s:4:\"name\";s:20:\"Widget Ads (125x125)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:113;a:5:{s:4:\"name\";s:15:\"Rotate banners?\";s:4:\"desc\";s:45:\"Check this to randomly rotate the banner ads.\";s:2:\"id\";s:14:\"woo_ads_rotate\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:114;a:5:{s:4:\"name\";s:29:\"Banner Ad #1 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_1\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:115;a:5:{s:4:\"name\";s:26:\"Banner Ad #1 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_1\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:116;a:5:{s:4:\"name\";s:29:\"Banner Ad #2 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_2\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:117;a:5:{s:4:\"name\";s:26:\"Banner Ad #2 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_2\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:118;a:5:{s:4:\"name\";s:29:\"Banner Ad #3 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_3\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:119;a:5:{s:4:\"name\";s:26:\"Banner Ad #3 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_3\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:120;a:5:{s:4:\"name\";s:29:\"Banner Ad #4 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_4\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:121;a:5:{s:4:\"name\";s:26:\"Banner Ad #4 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_4\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:122;a:5:{s:4:\"name\";s:29:\"Banner Ad #5 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_5\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:123;a:5:{s:4:\"name\";s:26:\"Banner Ad #5 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_5\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:124;a:5:{s:4:\"name\";s:29:\"Banner Ad #6 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_6\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:125;a:5:{s:4:\"name\";s:26:\"Banner Ad #6 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_6\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}}', 'yes');
INSERT INTO `wp_options` VALUES('303', 'woo_themename', 'Headlines Enhanced', 'yes');
INSERT INTO `wp_options` VALUES('304', 'woo_shortname', 'woo', 'yes');
INSERT INTO `wp_options` VALUES('305', 'woo_manual', 'http://www.woothemes.com/support/theme-documentation/headlines', 'yes');
INSERT INTO `wp_options` VALUES('306', 'woo_custom_template', 'a:2:{s:5:\"image\";a:5:{s:4:\"name\";s:5:\"image\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:22:\"Custom Thumbnail Image\";s:4:\"type\";s:6:\"upload\";s:4:\"desc\";s:39:\"Upload an image to show with your post.\";}s:5:\"embed\";a:5:{s:4:\"name\";s:5:\"embed\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:10:\"Embed Code\";s:4:\"type\";s:8:\"textarea\";s:4:\"desc\";s:69:\"Enter the video embed code for your video (YouTube, Vimeo or similar)\";}}', 'yes');
INSERT INTO `wp_options` VALUES('4972', 'category_children', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('731', '_transient_timeout_ye_video_MGE3YjI3ZjdiNjVkMDU5YmI0OGJhNDk3OTc0', '1323459904', 'no');
INSERT INTO `wp_options` VALUES('4207', 'mobile_category_exclude', '0', 'yes');
INSERT INTO `wp_options` VALUES('4208', 'mobile_home_page', '0', 'yes');
INSERT INTO `wp_options` VALUES('4209', 'mobile_auto_excerpt', 'yes', 'yes');
INSERT INTO `wp_options` VALUES('4210', 'mobile_thumbnail_usage', 'image', 'yes');
INSERT INTO `wp_options` VALUES('354', 'mobile_thumbnail_custom', '', 'yes');
INSERT INTO `wp_options` VALUES('4211', 'mobile_slider_category', '0', 'yes');
INSERT INTO `wp_options` VALUES('4212', 'mobile_slider_count', '3', 'yes');
INSERT INTO `wp_options` VALUES('4215', 'update_ocmx', 'general_site_options, 1', 'yes');
INSERT INTO `wp_options` VALUES('360', 'woo_alt_stylesheet', 'skylight.css', 'yes');
INSERT INTO `wp_options` VALUES('361', 'woo_logo', '', 'yes');
INSERT INTO `wp_options` VALUES('362', 'woo_texttitle', 'true', 'yes');
INSERT INTO `wp_options` VALUES('363', 'woo_font_site_title', 'a:5:{s:4:\"size\";s:2:\"52\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Yanone Kaffeesatz\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}', 'yes');
INSERT INTO `wp_options` VALUES('364', 'woo_font_tagline', 'a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Arial, sans-serif\";s:5:\"style\";s:6:\"normal\";s:5:\"color\";s:7:\"#bbbbbb\";}', 'yes');
INSERT INTO `wp_options` VALUES('365', 'woo_custom_favicon', '', 'yes');
INSERT INTO `wp_options` VALUES('366', 'woo_google_analytics', '', 'yes');
INSERT INTO `wp_options` VALUES('367', 'woo_feedburner_url', '', 'yes');
INSERT INTO `wp_options` VALUES('368', 'woo_feedburner_id', '', 'yes');
INSERT INTO `wp_options` VALUES('369', 'woo_contactform_email', '', 'yes');
INSERT INTO `wp_options` VALUES('370', 'woo_custom_css', '', 'yes');
INSERT INTO `wp_options` VALUES('371', 'woo_custom_link', '#1079c9', 'yes');
INSERT INTO `wp_options` VALUES('372', 'woo_search_disable', 'false', 'yes');
INSERT INTO `wp_options` VALUES('373', 'woo_featured_slider', 'true', 'yes');
INSERT INTO `wp_options` VALUES('374', 'woo_featured_shortcode', '[pb_slideshow group=\"0\"]', 'yes');
INSERT INTO `wp_options` VALUES('375', 'woo_featured_video', 'false', 'yes');
INSERT INTO `wp_options` VALUES('376', 'woo_featured_video_embed_code', '<iframe src=\"http://player.vimeo.com/video/27299211?title=0&amp;byline=0&amp;portrait=0\" width=\"580\" height=\"300\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>', 'yes');
INSERT INTO `wp_options` VALUES('377', 'woo_sticky_posts_only', 'true', 'yes');
INSERT INTO `wp_options` VALUES('378', 'woo_sticky_posts_count', '5', 'yes');
INSERT INTO `wp_options` VALUES('379', 'woo_top_widgets', 'false', 'yes');
INSERT INTO `wp_options` VALUES('380', 'woo_top_widgets_allposts', 'false', 'yes');
INSERT INTO `wp_options` VALUES('381', 'woo_top_widgets_bypost_ids', '', 'yes');
INSERT INTO `wp_options` VALUES('382', 'woo_top_widgets_allpages', 'false', 'yes');
INSERT INTO `wp_options` VALUES('383', 'woo_top_widgets_bypage_ids', '', 'yes');
INSERT INTO `wp_options` VALUES('384', 'woo_custom_l_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('385', 'woo_custom_l_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('386', 'woo_custom_l_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('387', 'woo_add_l_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('388', 'woo_stars_left_ribbon', '5-stars', 'yes');
INSERT INTO `wp_options` VALUES('389', 'woo_custom_c_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('390', 'woo_custom_c_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('391', 'woo_custom_c_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('392', 'woo_add_c_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('393', 'woo_stars_center_ribbon', '4-stars', 'yes');
INSERT INTO `wp_options` VALUES('394', 'woo_custom_r_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('395', 'woo_custom_r_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('396', 'woo_custom_r_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('397', 'woo_add_r_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('398', 'woo_stars_right_ribbon', '3-stars', 'yes');
INSERT INTO `wp_options` VALUES('399', 'woo_cufon', 'true', 'yes');
INSERT INTO `wp_options` VALUES('400', 'woo_home_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('401', 'woo_archive_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('402', 'woo_disable_post_author', 'true', 'yes');
INSERT INTO `wp_options` VALUES('403', 'woo_sp_noheadfoot_width', '950', 'yes');
INSERT INTO `wp_options` VALUES('404', 'woo_sp_noheadfoot_fontsize', '14', 'yes');
INSERT INTO `wp_options` VALUES('405', 'woo_sp_noheadfoot_bg', '', 'yes');
INSERT INTO `wp_options` VALUES('406', 'woo_sp_noheadfoot_border', '', 'yes');
INSERT INTO `wp_options` VALUES('407', 'woo_sp_noheadfoot_bordersize', '', 'yes');
INSERT INTO `wp_options` VALUES('408', 'woo_sp_noheadfoot_borderstyle', 'solid', 'yes');
INSERT INTO `wp_options` VALUES('409', 'woo_sp_noheadfoot_borderradius', '30', 'yes');
INSERT INTO `wp_options` VALUES('410', 'woo_padd_right', '150', 'yes');
INSERT INTO `wp_options` VALUES('411', 'woo_padd_left', '150', 'yes');
INSERT INTO `wp_options` VALUES('412', 'woo_padd_top', '20', 'yes');
INSERT INTO `wp_options` VALUES('413', 'woo_padd_bottom', '20', 'yes');
INSERT INTO `wp_options` VALUES('414', 'woo_show_sp_footer', 'false', 'yes');
INSERT INTO `wp_options` VALUES('415', 'woo_show_sp_footer_id', '', 'yes');
INSERT INTO `wp_options` VALUES('416', 'woo_show_custom_footer', 'false', 'yes');
INSERT INTO `wp_options` VALUES('417', 'woo_show_custom_footer_code', 'Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>', 'yes');
INSERT INTO `wp_options` VALUES('418', 'woo_custom_footer_font_color', '', 'yes');
INSERT INTO `wp_options` VALUES('419', 'woo_custom_footer_underline', 'true', 'yes');
INSERT INTO `wp_options` VALUES('420', 'woo_show_custom_footer_id', '', 'yes');
INSERT INTO `wp_options` VALUES('421', 'woo_blank_1', 'wizardmar4', 'yes');
INSERT INTO `wp_options` VALUES('422', 'woo_blank_2', 'magicsi25', 'yes');
INSERT INTO `wp_options` VALUES('423', 'woo_aff1_link', 'http://d0ebcjt2wae7-d7jjjbqhbok8u.hop.clickbank.net/', 'yes');
INSERT INTO `wp_options` VALUES('424', 'woo_aff1_title_tag', 'Learn Easy Magic', 'yes');
INSERT INTO `wp_options` VALUES('425', 'woo_aff1_banner_url_1', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/learn-easy-magic-300x250.jpg', 'yes');
INSERT INTO `wp_options` VALUES('426', 'woo_aff1_banner_url_2', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/learn-easy-magic-300x250.jpg', 'yes');
INSERT INTO `wp_options` VALUES('427', 'woo_aff1_banner_url_3', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/468x60.jpg', 'yes');
INSERT INTO `wp_options` VALUES('2041', '_transient_timeout_ye_video_ODhhMzlhZDYwNWMyNjhhNjBjNTA2YjAxOTQ3', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('428', 'woo_aff2_link', 'http://20387gp7s3ne9c1ce1o3-a832g.hop.clickbank.net/', 'yes');
INSERT INTO `wp_options` VALUES('429', 'woo_aff2_title_tag', 'Professional Magic Tricks Exposed', 'yes');
INSERT INTO `wp_options` VALUES('430', 'woo_aff2_banner_url_1', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/professional-magic-tricks-300x250.jpg', 'yes');
INSERT INTO `wp_options` VALUES('431', 'woo_aff2_banner_url_2', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/125x125-Mind-Blowing2.jpg', 'yes');
INSERT INTO `wp_options` VALUES('432', 'woo_aff2_banner_url_3', 'Put your 468x60 (on Video Page) Banner URL here', 'yes');
INSERT INTO `wp_options` VALUES('433', 'woo_ad_top', 'true', 'yes');
INSERT INTO `wp_options` VALUES('434', 'woo_ad_top_image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/468x60.jpg', 'yes');
INSERT INTO `wp_options` VALUES('435', 'woo_ad_top_url', 'http://d0ebcjt2wae7-d7jjjbqhbok8u.hop.clickbank.net/', 'yes');
INSERT INTO `wp_options` VALUES('436', 'woo_ad_top_adsense', '', 'yes');
INSERT INTO `wp_options` VALUES('437', 'woo_post_image_support', 'true', 'yes');
INSERT INTO `wp_options` VALUES('438', 'woo_pis_resize', 'true', 'yes');
INSERT INTO `wp_options` VALUES('439', 'woo_pis_hard_crop', 'true', 'yes');
INSERT INTO `wp_options` VALUES('440', 'woo_resize', 'true', 'yes');
INSERT INTO `wp_options` VALUES('441', 'woo_auto_img', 'false', 'yes');
INSERT INTO `wp_options` VALUES('442', 'woo_rss_thumb', 'false', 'yes');
INSERT INTO `wp_options` VALUES('443', 'woo_align', 'alignleft', 'yes');
INSERT INTO `wp_options` VALUES('444', 'woo_thumb_width', '150', 'yes');
INSERT INTO `wp_options` VALUES('445', 'woo_thumb_height', '150', 'yes');
INSERT INTO `wp_options` VALUES('446', 'woo_image_single', 'false', 'yes');
INSERT INTO `wp_options` VALUES('447', 'woo_single_width', '200', 'yes');
INSERT INTO `wp_options` VALUES('448', 'woo_single_height', '200', 'yes');
INSERT INTO `wp_options` VALUES('449', 'woo_ad_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('450', 'woo_ad_content_adsense', '', 'yes');
INSERT INTO `wp_options` VALUES('451', 'woo_ad_content_image', 'Enter Image URL', 'yes');
INSERT INTO `wp_options` VALUES('452', 'woo_ad_content_url', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('453', 'woo_ads_rotate', 'true', 'yes');
INSERT INTO `wp_options` VALUES('454', 'woo_ad_image_1', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('455', 'woo_ad_url_1', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('456', 'woo_ad_image_2', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('457', 'woo_ad_url_2', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('458', 'woo_ad_image_3', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('459', 'woo_ad_url_3', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('460', 'woo_ad_image_4', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('461', 'woo_ad_url_4', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('462', 'woo_ad_image_5', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('463', 'woo_ad_url_5', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('464', 'woo_ad_image_6', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('465', 'woo_ad_url_6', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('468', 'sm_options', 'a:57:{s:18:\"sm_b_prio_provider\";s:41:\"GoogleSitemapGeneratorPrioByCountProvider\";s:13:\"sm_b_filename\";s:11:\"sitemap.xml\";s:10:\"sm_b_debug\";b:1;s:8:\"sm_b_xml\";b:1;s:9:\"sm_b_gzip\";b:1;s:9:\"sm_b_ping\";b:1;s:12:\"sm_b_pingask\";b:1;s:12:\"sm_b_pingmsn\";b:1;s:19:\"sm_b_manual_enabled\";b:0;s:17:\"sm_b_auto_enabled\";b:1;s:15:\"sm_b_auto_delay\";b:1;s:15:\"sm_b_manual_key\";s:32:\"7b7054b80023e44631c65e466f53e88d\";s:11:\"sm_b_memory\";s:0:\"\";s:9:\"sm_b_time\";i:-1;s:14:\"sm_b_max_posts\";i:-1;s:13:\"sm_b_safemode\";b:0;s:18:\"sm_b_style_default\";b:1;s:10:\"sm_b_style\";s:0:\"\";s:11:\"sm_b_robots\";b:1;s:12:\"sm_b_exclude\";a:0:{}s:17:\"sm_b_exclude_cats\";a:0:{}s:18:\"sm_b_location_mode\";s:4:\"auto\";s:20:\"sm_b_filename_manual\";s:0:\"\";s:19:\"sm_b_fileurl_manual\";s:0:\"\";s:10:\"sm_in_home\";b:1;s:11:\"sm_in_posts\";b:1;s:15:\"sm_in_posts_sub\";b:0;s:11:\"sm_in_pages\";b:1;s:10:\"sm_in_cats\";b:0;s:10:\"sm_in_arch\";b:0;s:10:\"sm_in_auth\";b:0;s:10:\"sm_in_tags\";b:0;s:9:\"sm_in_tax\";a:0:{}s:17:\"sm_in_customtypes\";a:0:{}s:13:\"sm_in_lastmod\";b:1;s:10:\"sm_cf_home\";s:5:\"daily\";s:11:\"sm_cf_posts\";s:7:\"monthly\";s:11:\"sm_cf_pages\";s:6:\"weekly\";s:10:\"sm_cf_cats\";s:6:\"weekly\";s:10:\"sm_cf_auth\";s:6:\"weekly\";s:15:\"sm_cf_arch_curr\";s:5:\"daily\";s:14:\"sm_cf_arch_old\";s:6:\"yearly\";s:10:\"sm_cf_tags\";s:6:\"weekly\";s:10:\"sm_pr_home\";d:1;s:11:\"sm_pr_posts\";d:0.59999999999999997779553950749686919152736663818359375;s:15:\"sm_pr_posts_min\";d:0.200000000000000011102230246251565404236316680908203125;s:11:\"sm_pr_pages\";d:0.59999999999999997779553950749686919152736663818359375;s:10:\"sm_pr_cats\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_arch\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_auth\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_tags\";d:0.299999999999999988897769753748434595763683319091796875;s:12:\"sm_i_donated\";b:0;s:17:\"sm_i_hide_donated\";b:0;s:17:\"sm_i_install_date\";i:1323379239;s:14:\"sm_i_hide_note\";b:0;s:15:\"sm_i_hide_works\";b:0;s:16:\"sm_i_hide_donors\";b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('471', 'sm_status', 'O:28:\"GoogleSitemapGeneratorStatus\":24:{s:10:\"_startTime\";d:1387295341.26216602325439453125;s:8:\"_endTime\";d:1387295345.7025840282440185546875;s:11:\"_hasChanged\";b:1;s:12:\"_memoryUsage\";i:26214400;s:9:\"_lastPost\";i:16;s:9:\"_lastTime\";d:1387295341.3469998836517333984375;s:8:\"_usedXml\";b:1;s:11:\"_xmlSuccess\";b:1;s:8:\"_xmlPath\";s:44:\"/home/scplrb10/public_html/magic/sitemap.xml\";s:7:\"_xmlUrl\";s:41:\"http://www.plrblogs.com/magic/sitemap.xml\";s:8:\"_usedZip\";b:1;s:11:\"_zipSuccess\";b:1;s:8:\"_zipPath\";s:47:\"/home/scplrb10/public_html/magic/sitemap.xml.gz\";s:7:\"_zipUrl\";s:44:\"http://www.plrblogs.com/magic/sitemap.xml.gz\";s:11:\"_usedGoogle\";b:1;s:10:\"_googleUrl\";s:109:\"http://www.google.com/webmasters/sitemaps/ping?sitemap=http%3A%2F%2Fwww.plrblogs.com%2Fmagic%2Fsitemap.xml.gz\";s:15:\"_gooogleSuccess\";b:1;s:16:\"_googleStartTime\";d:1387295341.371097087860107421875;s:14:\"_googleEndTime\";d:1387295341.452104091644287109375;s:8:\"_usedMsn\";b:1;s:7:\"_msnUrl\";s:102:\"http://www.bing.com/webmaster/ping.aspx?siteMap=http%3A%2F%2Fwww.plrblogs.com%2Fmagic%2Fsitemap.xml.gz\";s:11:\"_msnSuccess\";b:1;s:13:\"_msnStartTime\";d:1387295341.4531040191650390625;s:11:\"_msnEndTime\";d:1387295345.70162296295166015625;}', 'no');
INSERT INTO `wp_options` VALUES('5618', '_transient_timeout_vye_type_eQU7p52El4k', '1387381741', 'no');
INSERT INTO `wp_options` VALUES('5460', '_site_transient_update_core', 'O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:39:\"https://wordpress.org/wordpress-3.8.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:39:\"https://wordpress.org/wordpress-3.8.zip\";s:10:\"no_content\";s:50:\"https://wordpress.org/wordpress-3.8-no-content.zip\";s:11:\"new_bundled\";s:51:\"https://wordpress.org/wordpress-3.8-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:3:\"3.8\";s:7:\"version\";s:3:\"3.8\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1387264952;s:15:\"version_checked\";s:3:\"3.8\";s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('5595', '_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1387338395', 'no');
INSERT INTO `wp_options` VALUES('5596', '_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1387295195', 'no');
INSERT INTO `wp_options` VALUES('469', 'woo_custom_upload_tracking', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('569', '_transient_timeout_ye_video_ZDE0NTFiYmY3YzczOWViNTFlNTczMTRjOTg1', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('476', 'easy_privacy_CreatePageId', '18', 'yes');
INSERT INTO `wp_options` VALUES('483', 'youtube_embed_profile0', 'a:36:{s:5:\"width\";i:560;s:6:\"height\";d:315;s:10:\"fullscreen\";s:0:\"\";s:8:\"template\";s:7:\"%video%\";s:8:\"autoplay\";s:0:\"\";s:5:\"start\";s:1:\"0\";s:4:\"loop\";s:0:\"\";s:2:\"cc\";s:0:\"\";s:10:\"annotation\";s:1:\"1\";s:7:\"related\";s:0:\"\";s:4:\"info\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"react\";s:1:\"1\";s:4:\"stop\";s:1:\"0\";s:9:\"sweetspot\";s:1:\"1\";s:4:\"type\";s:1:\"v\";s:9:\"disablekb\";s:0:\"\";s:8:\"autohide\";s:1:\"2\";s:8:\"controls\";s:1:\"1\";s:8:\"playlist\";s:1:\"v\";s:8:\"fallback\";s:1:\"v\";s:5:\"wmode\";s:6:\"opaque\";s:6:\"shadow\";s:1:\"0\";s:5:\"audio\";s:0:\"\";s:2:\"hd\";s:1:\"1\";s:5:\"style\";s:0:\"\";s:5:\"color\";s:3:\"red\";s:5:\"theme\";s:4:\"dark\";s:5:\"https\";s:1:\"0\";s:4:\"name\";s:7:\"Default\";s:6:\"modest\";i:1;s:7:\"dynamic\";s:0:\"\";s:5:\"fixed\";s:0:\"\";s:8:\"download\";s:0:\"\";s:14:\"download_style\";s:0:\"\";s:13:\"download_text\";s:32:\"Click here to download the video\";}', 'yes');
INSERT INTO `wp_options` VALUES('488', '_transient_timeout_ye_video_Yzk2NGI3OWYyYzdkZjYyZTJkMTg5ZmM2OTA4', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('489', '_transient_ye_video_Yzk2NGI3OWYyYzdkZjYyZTJkMTg5ZmM2OTA4MjM3ZTQ1', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/J2C_7QLwsnc?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('498', '_transient_timeout_ye_video_MjA1ZjY4YTQwOWNlMjA3Mzc4NzNhNGQ5NTg1', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('499', '_transient_ye_video_MjA1ZjY4YTQwOWNlMjA3Mzc4NzNhNGQ5NTg1NTRlY2Vi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/I3BxvHhz4XQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('504', '_transient_timeout_ye_video_MzRmZDI4YjdkNjE1OGI0OGU1OTdhMWEzYmRj', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('505', '_transient_ye_video_MzRmZDI4YjdkNjE1OGI0OGU1OTdhMWEzYmRjYmFlZTg2', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/h_FZMRZ1_Xg?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('510', '_transient_timeout_ye_video_MGRhZjg2ZTA0N2YzNDkyZjg4ZTk5MDg5NzQx', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('511', '_transient_ye_video_MGRhZjg2ZTA0N2YzNDkyZjg4ZTk5MDg5NzQxNjAwZmFl', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/UFSc3rrAYLQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('732', '_transient_ye_video_MGE3YjI3ZjdiNjVkMDU5YmI0OGJhNDk3OTc0NjZjNTI1', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/5LOcUkm8m9w?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('562', '_transient_timeout_ye_video_NGE2MWFiOTNjMTk2NWZmYzIwYzU1MDBiZmFi', '1323384353', 'no');
INSERT INTO `wp_options` VALUES('517', '_transient_timeout_ye_video_NWQ2M2FhZThiMWFkNTIyMjZjMTdlNDA1ZTVj', '1326512800', 'no');
INSERT INTO `wp_options` VALUES('518', '_transient_ye_video_NWQ2M2FhZThiMWFkNTIyMjZjMTdlNDA1ZTVjNmNiMjRk', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/nrfj4LM5qj8?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('523', '_transient_timeout_ye_video_YmRjNzhhNTU3NzBhMzZjZWRiN2Q2NDVkOGFh', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('524', '_transient_ye_video_YmRjNzhhNTU3NzBhMzZjZWRiN2Q2NDVkOGFhNmRiMTdl', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('529', '_transient_timeout_ye_video_YTVjZTdkNzU1NjFlMzViMWRjMGZhZDRhNThh', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('530', '_transient_ye_video_YTVjZTdkNzU1NjFlMzViMWRjMGZhZDRhNThhNmNjNTYy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('535', '_transient_timeout_ye_video_MTlkYzY4M2Y4NzQ3ZTg2ZDk5ZjNlZWQxMDBj', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('536', '_transient_ye_video_MTlkYzY4M2Y4NzQ3ZTg2ZDk5ZjNlZWQxMDBjOGQxMTEy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('541', '_transient_timeout_ye_video_ZTY2MWRiZjRlYzkxNGQ5ZmZkOTUyZGYxZDQ4', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('542', '_transient_ye_video_ZTY2MWRiZjRlYzkxNGQ5ZmZkOTUyZGYxZDQ4OGNiMTMy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('544', '_transient_timeout_ye_video_NWQ1OTkxNWIwN2M4N2FkZWMwYjEwMTRlMmQ1', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('545', '_transient_ye_video_NWQ1OTkxNWIwN2M4N2FkZWMwYjEwMTRlMmQ1NTQ1M2Nm', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('546', '_transient_timeout_ye_video_NjQwMWI3ZGFiYjRmZDRhNDM5ODI1NjM5NTdk', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('547', '_transient_ye_video_NjQwMWI3ZGFiYjRmZDRhNDM5ODI1NjM5NTdkMmU2ZDky', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('548', '_transient_timeout_ye_video_OTQxZjNjZjYzYmE3NmQxODI3NGE4ZjFkNjA2', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('549', '_transient_ye_video_OTQxZjNjZjYzYmE3NmQxODI3NGE4ZjFkNjA2NmE2ODc4', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('550', '_transient_timeout_ye_video_NTAwYjhiMThiZmQ3Njc5MzM4YmVjMmY4ZTg2', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('551', '_transient_ye_video_NTAwYjhiMThiZmQ3Njc5MzM4YmVjMmY4ZTg2YjVhMzM0', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('553', '_transient_timeout_ye_video_NjVmYjczOGYyNmI0OWEwYjhkYjYzZDIxMWFl', '1323383282', 'no');
INSERT INTO `wp_options` VALUES('554', '_transient_ye_video_NjVmYjczOGYyNmI0OWEwYjhkYjYzZDIxMWFlYjU1NTJh', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('555', '_transient_timeout_ye_video_M2Q1ZDZlMzhhMGMyY2NhZmJhNDFmYjkyMTYw', '1323383282', 'no');
INSERT INTO `wp_options` VALUES('556', '_transient_ye_video_M2Q1ZDZlMzhhMGMyY2NhZmJhNDFmYjkyMTYwMzVlMzRk', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('557', '_transient_timeout_ye_video_OTdmNGY4NTUyNzU0YzdlOTRkOGJjMWI3NTA4', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('558', '_transient_ye_video_OTdmNGY4NTUyNzU0YzdlOTRkOGJjMWI3NTA4N2VmMGYw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('559', '_transient_timeout_ye_video_NWM3M2RmMjdiZmZlMjZjYmQ0OGM5ZmM2ZmVk', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('560', '_transient_ye_video_NWM3M2RmMjdiZmZlMjZjYmQ0OGM5ZmM2ZmVkZDBkNDAw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('563', '_transient_ye_video_NGE2MWFiOTNjMTk2NWZmYzIwYzU1MDBiZmFiN2JhOTBi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"200\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('564', '_transient_timeout_ye_video_NTA0YjYzM2FkZGUzMjMyMjY2ZmZjNzBiZTU3', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('565', '_transient_ye_video_NTA0YjYzM2FkZGUzMjMyMjY2ZmZjNzBiZTU3ZjkzMTdi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"200\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('570', '_transient_ye_video_ZDE0NTFiYmY3YzczOWViNTFlNTczMTRjOTg1ZTA4NjY5', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('571', '_transient_timeout_ye_video_MWU2ODJkMTEzYWJlNjNmNWM3NjYzZjVlMzNm', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('572', '_transient_ye_video_MWU2ODJkMTEzYWJlNjNmNWM3NjYzZjVlMzNmNmEzZDYw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('573', '_transient_timeout_ye_video_ZDgxNWM4MDhmMzJlODk5NjFhMjc3ZDNjYjhm', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('574', '_transient_ye_video_ZDgxNWM4MDhmMzJlODk5NjFhMjc3ZDNjYjhmYmYwNjI4', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('575', '_transient_timeout_ye_video_OTgyODQyNmVjMmJmNDQwNTE2MTViMDhiZTU3', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('576', '_transient_ye_video_OTgyODQyNmVjMmJmNDQwNTE2MTViMDhiZTU3MDlkYjEw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('583', 'WPContentMagic_StopWords', 'a,about,above,across,after,again,against,all,almost,alone,along,already,also,although,always,among,an,and,another,any,anybody,anyone,anything,anywhere,are,area,areas,around,as,ask,asked,asking,asks,at,away,b,back,backed,backing,backs,be,became,because,become,becomes,been,before,began,behind,being,beings,best,better,between,big,both,but,by,c,came,can,cannot,case,cases,certain,certainly,clear,clearly,come,could,d,did,differ,different,differently,do,does,done,down,down,downed,downing,downs,during,e,each,early,either,end,ended,ending,ends,enough,even,evenly,ever,every,everybody,everyone,everything,everywhere,f,face,faces,fact,facts,far,felt,few,find,finds,first,for,four,from,full,fully,further,furthered,furthering,furthers,g,gave,general,generally,get,gets,give,given,gives,go,going,good,goods,got,great,greater,greatest,group,grouped,grouping,groups,h,had,has,have,having,he,her,here,herself,high,high,high,higher,highest,him,himself,his,how,however,i,if,important,in,interest,interested,interesting,interests,into,is,it,its,itself,j,just,k,keep,keeps,kind,knew,know,known,knows,l,large,largely,last,later,latest,least,less,let,lets,like,likely,long,longer,longest,m,made,make,making,man,many,may,me,member,members,men,might,more,most,mostly,mr,mrs,much,must,my,myself,n,necessary,need,needed,needing,needs,never,new,new,newer,newest,next,no,nobody,non,noone,not,nothing,now,nowhere,number,numbers,o,of,off,often,old,older,oldest,on,once,one,only,open,opened,opening,opens,or,order,ordered,ordering,orders,other,others,our,out,over,p,part,parted,parting,parts,per,perhaps,place,places,point,pointed,pointing,points,possible,present,presented,presenting,presents,problem,problems,put,puts,q,quite,r,rather,really,right,right,room,rooms,s,said,same,saw,say,says,second,seconds,see,seem,seemed,seeming,seems,sees,several,shall,she,should,show,showed,showing,shows,side,sides,since,small,smaller,smallest,so,some,somebody,someone,something,somewhere,state,states,still,still,such,sure,t,take,taken,than,that,the,their,them,then,there,therefore,these,they,thing,things,think,thinks,this,those,though,thought,thoughts,three,through,thus,to,today,together,too,took,toward,turn,turned,turning,turns,two,u,under,until,up,upon,us,use,used,uses,v,very,w,want,wanted,wanting,wants,was,way,ways,we,well,wells,went,were,what,when,where,whether,which,while,who,whole,whose,why,will,with,within,without,work,worked,working,works,would,x,y,year,years,yet,you,young,younger,youngest,your,yours,z', 'yes');
INSERT INTO `wp_options` VALUES('734', '_transient_timeout_ye_video_NGMwMGM3NjEwMzJiNThkZGU2OTQzNjRjZmQz', '1323465249', 'no');
INSERT INTO `wp_options` VALUES('4940', 'SWPA_PLUGIN_ENTRIES_LIVE_TRAFFIC', '508', 'yes');
INSERT INTO `wp_options` VALUES('735', '_transient_ye_video_NGMwMGM3NjEwMzJiNThkZGU2OTQzNjRjZmQzYTg1NGY5', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/5LOcUkm8m9w?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('772', '_transient_timeout_ye_video_YTkxZjRkMmRkNjYxNTRlNGFjYmIxMmM5MWNk', '1323465594', 'no');
INSERT INTO `wp_options` VALUES('773', '_transient_ye_video_YTkxZjRkMmRkNjYxNTRlNGFjYmIxMmM5MWNkOThlYmUw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/GRmDGvdkg8E?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('779', '_transient_timeout_ye_video_MjRkMjBlYTM4YTRkMDQ0MjZkZTY4MTRmYjc4', '1323925660', 'no');
INSERT INTO `wp_options` VALUES('780', '_transient_ye_video_MjRkMjBlYTM4YTRkMDQ0MjZkZTY4MTRmYjc4YjgyMjUy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/2jYJV9zHy04?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3042', 'page_on_front', '0', 'yes');
INSERT INTO `wp_options` VALUES('1628', '_transient_timeout_ye_video_ZmE3ZWZjOGU4NTZiN2ZhY2E5MTBlMGY0OTMx', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1629', '_transient_ye_video_ZmE3ZWZjOGU4NTZiN2ZhY2E5MTBlMGY0OTMxN2QwNjg1', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eIRmCGwurmE?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Hanging+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('4941', 'cg_tvs_data', 'a:8:{s:21:\"script_latest_version\";s:6:\"2.8.11\";s:19:\"script_safe_version\";s:5:\"2.8.2\";s:18:\"last_version_check\";i:1387295189;s:16:\"script_instances\";a:2:{i:0;a:2:{s:4:\"path\";s:101:\"/home/scplrb10/public_html/magic/wp-content/plugins/obox-mobile/themes/default/functions/timthumb.php\";s:7:\"version\";s:6:\"2.8.11\";}i:1;a:2:{s:4:\"path\";s:89:\"/home/scplrb10/public_html/magic/wp-content/themes/headlines_enhanced/functions/thumb.php\";s:7:\"version\";s:6:\"2.8.11\";}}s:16:\"suspicious_files\";N;s:9:\"last_scan\";i:1384203159;s:10:\"scan_daily\";b:1;s:12:\"scan_summary\";a:3:{s:10:\"Vulnerable\";i:0;s:8:\"Outdated\";i:0;s:10:\"Up to Date\";i:2;}}', 'yes');
INSERT INTO `wp_options` VALUES('5593', '_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1387338395', 'no');
INSERT INTO `wp_options` VALUES('5594', '_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 22:14:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/?v=3.9-alpha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://wordpress.org/news/2013/12/parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/parker/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2765\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:354:\"Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:18020:\"<p>Version 3.8 of WordPress, named “Parker” in honor of <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>, bebop innovator, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id=\"v-6wORgoGb-1\" class=\"video-player\"><embed id=\"v-6wORgoGb-1-video\" src=\"http://s0.videopress.com/player.swf?v=1.03&amp;guid=6wORgoGb&amp;isDynamicSeeking=true\" type=\"application/x-shockwave-flash\" width=\"692\" height=\"388\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\"></embed></div>\n<h2 class=\"aligncenter\">Introducing a modern new design</h2>\n<p><img class=\"wp-image-2951 aligncenter\" alt=\"overview\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193\" data-recalc-dims=\"1\" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class=\"aligncenter  wp-image-2856\" style=\"margin-left: 0;margin-right: 0\" alt=\"about-modern-wordpress\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151\" data-recalc-dims=\"1\" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class=\"aligncenter\">WordPress on every device</h2>\n<p><img class=\"alignright  wp-image-2984\" alt=\"responsive\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255\" data-recalc-dims=\"1\" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class=\"aligncenter\">Admin color schemes to match your personality</h2>\n<p><img class=\"aligncenter  wp-image-2954\" alt=\"colors\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339\" data-recalc-dims=\"1\" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class=\"aligncenter\">Refined theme management</h2>\n<p><img class=\"alignright  wp-image-2967\" alt=\"themes\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344\" data-recalc-dims=\"1\" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class=\"aligncenter\">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class=\"aligncenter size-large wp-image-2789\" alt=\"The new Twenty Fourteen theme displayed on a laptop. tablet and phone\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275\" data-recalc-dims=\"1\" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title=\"Make WordPress Core\" href=\"http://make.wordpress.org/core/\" target=\"_blank\">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/admiralthrawn\">admiralthrawn</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aralbald\">Andrey Kabakchiev</a>, <a href=\"http://profiles.wordpress.org/apeatling\">Andy Peatling</a>, <a href=\"http://profiles.wordpress.org/ankitgadertcampcom\">Ankit Gade</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/fliespl\">Arkadiusz Rzadkowolski</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/binarymoon\">binarymoon</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/calin\">Calin Don</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/chrisbliss18\">Chris Jean</a>, <a href=\"http://profiles.wordpress.org/iblamefish\">Clinton Montague</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/dbernar1\">Dan Bernardic</a>, <a href=\"http://profiles.wordpress.org/danieldudzic\">Daniel Dudzic</a>, <a href=\"http://profiles.wordpress.org/datafeedrcom\">datafeedrcom</a>, <a href=\"http://profiles.wordpress.org/drw158\">Dave Whitley</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/dziudek\">dziudek</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gnarf37\">gnarf37</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/isaackeyet\">Isaac Keyet</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"http://profiles.wordpress.org/janhenckens\">janhenckens</a>, <a href=\"http://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"http://profiles.wordpress.org/jeffr0\">Jeff Chandler</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jeherve\">Jeremy Herve</a>, <a href=\"http://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jhned\">jhned</a>, <a href=\"http://profiles.wordpress.org/jim912\">jim912</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/koki4a\">Konstantin Dankov</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/lite3\">lite3</a>, <a href=\"http://profiles.wordpress.org/littlethingsstudio\">littlethingsstudio</a>, <a href=\"http://profiles.wordpress.org/lucp\">LucP</a>, <a href=\"http://profiles.wordpress.org/latz\">Lutz Schroer</a>, <a href=\"http://profiles.wordpress.org/mako09\">Mako</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/megane9988\">megane9988</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/micahwave\">micahwave</a>, <a href=\"http://profiles.wordpress.org/cainm\">Michael Cain</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel</a>, <a href=\"http://profiles.wordpress.org/chellycat\">Michelle Langston</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mt8biz\">moto hachi</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/neil_pie\">neil_pie</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/ninio\">ninio</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"http://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/bamadesigner\">Rachel Carden</a>, <a href=\"http://profiles.wordpress.org/radices\">Radices</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/defries\">Remkus de Vries</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/wet\">Robert Wetzlmayr, PHP-Programmierer</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sanchothefat\">sanchothefat</a>, <a href=\"http://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"http://profiles.wordpress.org/scottbasgaard\">Scott Basgaard</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">shaunandrews</a>, <a href=\"http://profiles.wordpress.org/designsimply\">Sheri Bigelow (designsimply)</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirbrillig\">sirbrillig</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/thomasguillot\">Thomas Guillot</a>, <a href=\"http://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"http://profiles.wordpress.org/tillkruess\">Till Kruss</a>, <a href=\"http://profiles.wordpress.org/tlamedia\">TLA Media</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tommcfarlin\">tommcfarlin</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/trishasalas\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/mbmufffin\">Tyler Smith</a>, <a href=\"http://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"http://profiles.wordpress.org/l10n\">Vladimir</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yonasy\">yonasy</a>, and <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>. Also thanks to <a href=\"http://benmorrison.org/\">Ben Morrison</a> and <a href=\"http://christineswebb.com/\">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://wordpress.org/news/2013/12/parker/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"3.8 RC2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"http://wordpress.org/news/2013/12/3-8-rc2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://wordpress.org/news/2013/12/3-8-rc2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 01:08:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2805\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:343:\"Release candidate 2 of WordPress 3.8 is now available for download. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday. This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1180:\"<p>Release candidate 2 of WordPress 3.8 is <a href=\"http://wordpress.org/wordpress-3.8-RC2.zip\">now available for download</a>. This is the last pre-release, and we expect it to be effectively identical to what&#8217;s officially released to the public on Thursday.</p>\n<p>This means if you are a plugin or theme developer, start your engines! (If they&#8217;re not going already.) Lots of admin code has changed so it&#8217;s especially important to see if your plugin works well within the new admin design and layout, and update <a href=\"http://wordpress.org/plugins/about/readme.txt\">the &#8220;Tested up to:&#8221; part of your plugin readme.txt</a>.</p>\n<p>If there is something in your plugin that you&#8217;re unable to fix, or if you think you&#8217;ve found a bug, join us <a href=\"http://codex.wordpress.org/IRC\">in #wordpress-dev in IRC</a>, especially if you&#8217;re able to join during the dev chat on Wednesday, or post in the <a href=\"http://wordpress.org/support/forum/alphabeta\">alpha/beta forum</a>. The developers and designers who worked on this release are happy to help anyone update their code before the 3.8 release.</p>\n<p>Happy hacking, everybody!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/news/2013/12/3-8-rc2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"WordPress 3.8 RC1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/12/3-8-almost/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/news/2013/12/3-8-almost/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Dec 2013 09:54:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2760\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:345:\"We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, which includes a number of exciting enhancements, so the focus [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1873:\"<p>We&#8217;re entering the quiet but busy part of a release, whittling down issues to bring you all of the new features you&#8217;re excited about with the stability you expect from WordPress. There are just a few days from the &#8220;code freeze&#8221; for our 3.8 release, <a href=\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/\">which includes a number of exciting enhancements</a>, so the focus is on identifying any major issues and resolving them as soon as possible.</p>\n<p>If you&#8217;ve ever wondered about how to contribute to WordPress, here&#8217;s a time you can: download this release candidate and use it in as many ways as you can imagine. Try to break it, and if you do, let us know how you did it so we can make sure it never happens again. If you work for a web host, this is the release you should test as much as possible and start getting your automatic upgrade systems and 1-click installers ready.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.8-RC1.zip\">Download WordPress 3.8 RC1</a> (zip) or use the <a href=\"http://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p>If you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8\">everything we’ve fixed</a> so far.</p>\n<p><em>We&#8217;re so close to the</em><br />\n<em>finish line, jump in and help</em><br />\n<em>good karma is yours.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/12/3-8-almost/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.8 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 21 Nov 2013 05:21:56 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2754\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:307:\"The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th. 3.8 brings together several of the features as plugins projects and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2236:\"<p>The first beta of the 3.8 is now available, and the next dates to watch out for are code freeze on December 5th and a final release on December 12th.</p>\n<p>3.8 brings together <a href=\"http://make.wordpress.org/core/features-as-plugins/\">several of the features as plugins projects</a> and while this isn&#8217;t our first rodeo, expect this to be more beta than usual. The headline things to test out in this release are:</p>\n<ul>\n<li>The new admin design, especially the responsive aspect of it. Try it out on different devices and browsers, see how it goes, especially the more complex pages like widgets or seldom-looked-at-places like Press This. Color schemes, which you can change on your profile, have also been spruced up.</li>\n<li>The dashboard homepage has been refreshed, poke and prod it.</li>\n<li>Choosing themes under Appearance is completely different, try to break it however possible.</li>\n<li>There&#8217;s a new default theme, Twenty Fourteen.</li>\n<li>Over 250 issues closed already.</li>\n</ul>\n<p>Given how many things in the admin have changed it&#8217;s extra super duper important to test as many plugins and themes with admin pages against the new stuff. Also if you&#8217;re a developer consider how you can make your admin interface fit the MP6 aesthetic better.</p>\n<p>As always, if you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.8\">everything we’ve fixed</a> so far.</p>\n<p><a href=\"http://wordpress.org/wordpress-3.8-beta-1.zip\">Download WordPress 3.8 Beta 1</a> (zip) or use the <a href=\"http://wordpress.org/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;).</p>\n<p><em>Alphabet soup of</em><br />\n<em>Plugins as features galore</em><br />\n<em>The future is here</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/11/wordpress-3-8-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.7.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 29 Oct 2013 21:04:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2745\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:371:\"WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including: Images with captions no longer appear broken in the visual editor. Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org. Avoid fatal errors with certain plugins that were incorrectly calling some [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1594:\"<p>WordPress 3.7.1 is now available! This maintenance release addresses 11 bugs in WordPress 3.7, including:</p>\n<ul>\n<li>Images with captions no longer appear broken in the visual editor.</li>\n<li>Allow some sites running on old or poorly configured servers to continue to check for updates from WordPress.org.</li>\n<li>Avoid fatal errors with certain plugins that were incorrectly calling some WordPress functions too early.</li>\n<li>Fix hierarchical sorting in get_pages(), exclusions in wp_list_categories(), and in_category() when called with empty values.</li>\n<li>Fix a warning that may occur in certain setups while performing a search, and a few other notices.</li>\n</ul>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.7.1\">list of tickets</a> and <a href=\"http://core.trac.wordpress.org/log/branches/3.7?stop_rev=25914&amp;rev=25986\">the changelog</a>.</p>\n<p>If you are one of the <a href=\"http://wordpress.org/download/counter/\">nearly two million</a> already running WordPress 3.7, we will start rolling out the all-new <a href=\"http://wordpress.org/news/2013/10/basie/\">automatic background updates</a> for WordPress 3.7.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.7.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p><em>Just a few fixes<br />\nYour new update attitude:<br />\nZero clicks given</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/wordpress-3-7-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.7 “Basie”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2013/10/basie/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2013/10/basie/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 24 Oct 2013 22:35:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2736\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of Count Basie, is available for download or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones: Updates while you sleep: With WordPress 3.7, you don&#8217;t have to lift a finger to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:17229:\"<p>Version 3.7 of WordPress, named &#8220;Basie&#8221; in honor of <a href=\"http://en.wikipedia.org/wiki/Count_basie\">Count Basie</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features some of the most important architectural updates we&#8217;ve made to date. Here are the big ones:</p>\n<ul>\n<li><strong>Updates while you sleep</strong>: With WordPress 3.7, you don&#8217;t have to lift a finger to apply maintenance and security updates. Most sites are now able to automatically apply these updates in the background. The update process also has been made even more reliable and secure, with dozens of new checks and safeguards.</li>\n<li><strong>Stronger password recommendations</strong>: Your password is your site&#8217;s first line of defense. It&#8217;s best to create passwords that are complex, long, and unique. To that end, our password meter has been updated in WordPress 3.7 to recognize common mistakes that can weaken your password: dates, names, keyboard patterns (123456789), and even pop culture references.</li>\n<li><strong>Better global support</strong>: Localized versions of WordPress will receive faster and more complete translations. WordPress 3.7 adds support for automatically installing the right language files and keeping them up to date, a boon for the many millions who use WordPress in a language other than English.</li>\n</ul>\n<p>For developers there are lots of options around how to control the new updates feature, including allowing it to handle major upgrades as well as minor ones, more sophisticated date query support, and multisite improvements. As always, if you&#8217;re hungry for more <a href=\"http://codex.wordpress.org/Version_3.7\">dive into the Codex</a> or browse the <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=resolution&amp;milestone=3.7\">over 400 closed tickets on Trac</a>.</p>\n<h3>A New Wave</h3>\n<p>This release was led by Andrew Nacin, backed up by Dion Hulse and Jon Cave. This is our first release using the new plugin-first development process, with a much shorter timeframe than in the past. (3.6 was released in August.) The 3.8 release, due in December, will continue this plugin-led development cycle that gives much more autonomy to plugin leads and allows us to decouple feature development from a release. You can follow this grand experiment, and what we&#8217;re learning from it, <a href=\"http://make.wordpress.org/core/\">on the make/core blog</a>. There are 211 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/technosailor\">Aaron Brazell</a>, <a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/viper007bond\">Alex Mills (Viper007Bond)</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/andg\">andg</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/andrewspittle\">Andrew Spittle</a>, <a href=\"http://profiles.wordpress.org/askapache\">askapache</a>, <a href=\"http://profiles.wordpress.org/atimmer\">atimmer</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/beaulebens\">Beau Lebens</a>, <a href=\"http://profiles.wordpress.org/benmoody\">ben.moody</a>, <a href=\"http://profiles.wordpress.org/bhengh\">Ben Miller</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bftrick\">BFTrick</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/bmb\">bmb</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brianhogg\">brianhogg</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/charlesclarkson\">CharlesClarkson</a>, <a href=\"http://profiles.wordpress.org/chipbennett\">Chip Bennett</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisrudzki\">Chris Rudzki</a>, <a href=\"http://profiles.wordpress.org/aeg0125\">coderaaron</a>, <a href=\"http://profiles.wordpress.org/coenjacobs\">Coen Jacobs</a>, <a href=\"http://profiles.wordpress.org/crrobi01\">Colin Robinson</a>, <a href=\"http://profiles.wordpress.org/andreasnrb\">cyonite</a>, <a href=\"http://profiles.wordpress.org/daankortenbach\">Daan Kortenbach</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/convissor\">Daniel Convissor</a>, <a href=\"http://profiles.wordpress.org/dartiss\">dartiss</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/csixty4\">Dave Ross</a>, <a href=\"http://profiles.wordpress.org/davidjlaietta\">David Laietta</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/dllh\">dllh</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dpash\">dpash</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/dzver\">dzver</a>, <a href=\"http://profiles.wordpress.org/cais\">Edward Caissie</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faishal\">faishal</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/foofy\">Foofy</a>, <a href=\"http://profiles.wordpress.org/fjarrett\">Frankie Jarrett</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/gayadesign\">Gaya Kessler</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gizburdt\">Gizburdt</a>, <a href=\"http://profiles.wordpress.org/goldenapples\">goldenapples</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">gradyetc</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/webord\">Gustavo Bordoni</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/creativeinfusion\">itinerant</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jakubtyrcha\">jakub.tyrcha</a>, <a href=\"http://profiles.wordpress.org/jamescollins\">James Collins</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/jkudish\">Joey Kudish</a>, <a href=\"http://profiles.wordpress.org/johnnyb\">John Beales</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn (johnbillion)</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/jchristopher\">Jonathan Christopher</a>, <a href=\"http://profiles.wordpress.org/desrosj\">Jonathan Desrosiers</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jonlynch\">Jon Lynch</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/josephscott\">Joseph Scott</a>, <a href=\"http://profiles.wordpress.org/betzster\">Josh Betz</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/ketwaroo\">Ketwaroo</a>, <a href=\"http://profiles.wordpress.org/kevinb\">kevinB</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/koopersmith\">koopersmith</a>, <a href=\"http://profiles.wordpress.org/kurtpayne\">Kurt Payne</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis (leewillis77)</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/layotte\">Lew Ayotte</a>, <a href=\"http://profiles.wordpress.org/lgedeon\">Luke Gedeon</a>, <a href=\"http://profiles.wordpress.org/iworks\">Marcin Pietrzak</a>, <a href=\"http://profiles.wordpress.org/cimmo\">Marco Cimmino</a>, <a href=\"http://profiles.wordpress.org/marco_teethgrinder\">Marco Galasso</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/tw2113\">Michael Beckwith</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/usermrpapa\">Mr Papa</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/naomicbush\">Naomi</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/natejacobs\">NateJacobs</a>, <a href=\"http://profiles.wordpress.org/nathanrice\">nathanrice</a>, <a href=\"http://profiles.wordpress.org/niallkennedy\">Niall Kennedy</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nickmomrik\">Nick Momrik</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/noahsilverstein\">noahsilverstein</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nukaga\">nukaga</a>, <a href=\"http://profiles.wordpress.org/nullvariable\">nullvariable</a>, <a href=\"http://profiles.wordpress.org/butuzov\">Oleg Butuzov</a>, <a href=\"http://profiles.wordpress.org/paolal\">Paolo Belcastro</a>, <a href=\"http://profiles.wordpress.org/xparham\">Parham</a>, <a href=\"http://profiles.wordpress.org/pbiron\">Paul Biron</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/peterjaap\">peterjaap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/plocha\">plocha</a>, <a href=\"http://profiles.wordpress.org/pollett\">Pollett</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/ramiy\">Rami Yushuvaev</a>, <a href=\"http://profiles.wordpress.org/rasheed\">Rasheed Bydousi</a>, <a href=\"http://profiles.wordpress.org/raybernard\">RayBernard</a>, <a href=\"http://profiles.wordpress.org/rboren\">rboren</a>, <a href=\"http://profiles.wordpress.org/greuben\">Reuben Gunday</a>, <a href=\"http://profiles.wordpress.org/rfair404\">rfair404</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/r3df\">Rick Radko</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/wpmuguru\">Ron Rennick</a>, <a href=\"http://profiles.wordpress.org/rpattillo\">rpattillo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/hotchkissconsulting\">Sam Hotchkiss</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/scottsweb\">scottsweb</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/scruffian\">scruffian</a>, <a href=\"http://profiles.wordpress.org/tenpura\">Seisuke Kuraishi (tenpura)</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sillybean\">Stephanie Leary</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar (@netweb)</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/strangerstudios\">strangerstudios</a>, <a href=\"http://profiles.wordpress.org/sweetie089\">sweetie089</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">swissspidy</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tivnet\">tivnet</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/toscho\">toscho</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/sorich87\">Ulrich Sossou</a>, <a href=\"http://profiles.wordpress.org/vericgar\">vericgar</a>, <a href=\"http://profiles.wordpress.org/vinod-dalvi\">Vinod Dalvi</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wikicms\">wikicms</a>, <a href=\"http://profiles.wordpress.org/willnorris\">Will Norris</a>, <a href=\"http://profiles.wordpress.org/wojtekszkutnik\">Wojtek Szkutnik</a>, <a href=\"http://profiles.wordpress.org/wycks\">wycks</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p>Enjoy what may be one of your last few manual updates. See you soon for version 3.8!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2013/10/basie/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.7 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 23 Oct 2013 00:05:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2729\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:417:\"The second release candidate of WordPress 3.7 is now available for testing! Those of you already testing WordPress 3.7 will be updated automatically to RC2. (Nice.) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the WordPress Beta Tester plugin (you’ll want “bleeding edge nightlies”) or download the release candidate here (zip). Please post to the Alpha/Beta [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1183:\"<p>The second release candidate of WordPress 3.7 is now available for testing!</p>\n<p>Those of you already testing WordPress 3.7 will be updated automatically to RC2. (<em>Nice.</em>) If you&#8217;d like to start testing, there&#8217;s no time like the present! Try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”) or <a href=\"http://wordpress.org/wordpress-3.7-RC2.zip\">download the release candidate here</a> (zip). Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a> if you think you&#8217;ve found a bug, and if any known issues are raised, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>Developers, please test your plugins and themes against WordPress 3.7. If there is a compatibility issue, let us know as soon as possible so we can deal with it before the final release.</p>\n<p>For more on WordPress 3.7, check out the <a href=\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\">announcement post for Release Candidate 1</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Upcoming WordCamps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 22 Oct 2013 19:25:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:9:\"Community\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"WordCamp\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2723\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:368:\"WordCamps are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Jen Mylo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3584:\"<p><a href=\"http://central.wordcamp.org/\">WordCamps</a> are casual, locally-organized conferences that celebrate everything related to WordPress, and are a great opportunity to meet other WordPress users and professionals in your community. This has been a great year for WordCamps &#8212; there have been 56 so far in more than 20 countries, and there another 15 on the calendar before the year&#8217;s over. If there&#8217;s one near you, check it out! In addition to getting to know your local WordPress community, most WordCamps attract some traveling visitors a well, giving you the chance to meet contributors to the WordPress open source project and <a href=\"http://make.wordpress.org/\">get involved</a> yourself.</p>\n<p>Here are the WordCamps on the schedule for the rest of this year.</p>\n<p>October 25-27: <strong><a href=\"http://2013.boston.wordcamp.org/\">WordCamp Boston</a></strong>, Boston, MA, USA<br />\nOctober 25-26: <strong><a href=\"http://2013.malaga.wordcamp.org/\">WordCamp Malaga</a></strong>, Spain<br />\nOctober 26: <strong><a href=\"http://2013.nepal.wordcamp.org/\">WordCamp Nepal</a></strong>, Kathmandu, Nepal<br />\nOctober 26: <strong><a href=\"http://2013.sofia.wordcamp.org/\">WordCamp Sofia</a></strong>, Bulgaria<br />\nNovember 7: <strong><a href=\"http://2013.capetown.wordcamp.org/\">WordCamp Cape Town</a></strong>, South Africa<br />\nNovember 9: <strong><a href=\"http://2013.porto.wordcamp.org/\">WordCamp Porto</a></strong>, Portugal<br />\nNovember 9-10: <strong><a href=\"http://2013.kenya.wordcamp.org/\">WordCamp Kenya</a></strong>, Nairobi, Kenya<br />\nNovember 15: <strong><a href=\"http://2013.edmonton.wordcamp.org/\">WordCamp Edmonton</a></strong>, AB, Canada<br />\nNovember 16-17: <strong><a href=\"http://2013.orlando.wordcamp.org/\">WordCamp Orlando</a></strong>, FL, USA<br />\nNovember 16: <strong><a href=\"http://2013.denver.wordcamp.org/\">WordCamp Denver</a></strong>, CO, USA<br />\nNovember 23-24: <strong><a href=\"http://2013.london.wordcamp.org/\">WordCamp London</a></strong>, UK<br />\nNovember 23-24: <strong><a href=\"http://2013.raleigh.wordcamp.org/\">WordCamp Raleigh</a></strong>, NC, USA<br />\nNovember 23: <strong><a href=\"http://2013.saopaulo.wordcamp.org/\">WordCamp São Paulo</a></strong>, Brazil<br />\nDecember 14: <strong><a href=\"http://2013.vegas.wordcamp.org/\">WordCamp Las Vegas</a></strong>, NV, USA<br />\nDecember 14-15: <strong><a href=\"http://2013.sevilla.wordcamp.org/\">WordCamp Sevilla</a></strong>, Spain</p>\n<p>No WordCamps on this list in your area? Not to worry! There are thriving <a href=\"http://wordpress.meetup.com/\">WordPress meetups</a> all over the world where you can meet like-minded people, and we maintain a library of <a href=\"http://wordpress.tv/category/wordcamptv/\">WordCamp videos</a> at <a href=\"http://wordpress.tv/\">WordPress.tv</a>.</p>\n<h3>Get Involved</h3>\n<ul>\n<li>If you&#8217;re interested in organizing a WordCamp in your area, check out our <a href=\"http://plan.wordcamp.org/\">WordCamp planning</a> site.</li>\n<li>If you&#8217;re interested in <a href=\"http://make.wordpress.org/community/meetup-interest-form/\">starting a WordPress meetup</a> in your area, let us know and we can set up a group on meetup.com for you.</li>\n<li>And speaking of WordCamp videos, we&#8217;ve recently enabled volunteer-generated subtitles/closed captioning of the videos on WordPress.tv to make them more accessible. Interested in helping? Check out the <a href=\"http://wordpress.tv/using-amara-org-to-caption-or-subtitle-a-wordpress-tv-video/\">WordPress.tv subtitling instructions</a>.</li>\n</ul>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/10/upcoming-wordcamps-4/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.7 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 18 Oct 2013 19:52:14 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2718\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:331:\"The first release candidate for WordPress 3.7 is now available! In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 next week, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2274:\"<p>The first release candidate for WordPress 3.7 is now available!</p>\n<p>In RC 1, we&#8217;ve made some adjustments to the update process to make it more reliable than ever. We hope to ship WordPress 3.7 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.7 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>WordPress 3.7 introduces <strong>automatic background updates</strong> for security and minor releases (like updating from 3.7 to 3.7.1). These are really easy to test  — RC 1 will update every 12 hours or so to the latest development version, and then email you the results. (You may get two emails: one for debugging, and one all users of 3.7 will receive.) If something went wrong, you can report it.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"http://wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"http://core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p>To test WordPress 3.7 RC1, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.7-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what&#8217;s new in WordPress 3.7, visit the awesome About screen in your dashboard (<strong><img alt=\"\" src=\"http://i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" data-recalc-dims=\"1\" /> → About</strong> in the toolbar). There, you can also see if your install is eligible for background updates. WordPress won’t automatically update, for example, if you’re using version control like Subversion or Git.</p>\n<p><strong>Developers,</strong> please test your plugins and themes against WordPress 3.7, so that if there is a compatibility issue, we can figure it out before the final release. Make sure you post any issues to the support forums.</p>\n<p><em>WordPress three seven</em><br />\n<em>A self-updating engine</em><br />\n<em>Lies beneath the hood</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2013/10/wordpress-3-7-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.7 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 10 Oct 2013 21:28:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2706\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:357:\"WordPress 3.7 Beta 2 is now available for download and testing. This is software still in development, so we don&#8217;t recommend that you run it on a production site. This has been a quiet beta period. We&#8217;re hoping to get some more testers for automatic background updates, which will occur for security and minor releases (like updating [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2108:\"<p>WordPress 3.7 Beta 2 is now available for download and testing. This is software still in development, so we don&#8217;t recommend that you run it on a production site.</p>\n<p>This has been a quiet beta period. We&#8217;re hoping to get some more testers for <strong>automatic background updates</strong>, which will occur for security and minor releases (like updating from 3.7 to 3.7.1). It&#8217;s really easy to test this, as Beta 2 will update each day to the latest development version and then email you the results. If something goes wrong, you can report it — it&#8217;s that simple. To get the beta, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you&#8217;ll want &#8220;bleeding edge nightlies&#8221;). Or you can <a href=\"http://wordpress.org/wordpress-3.7-beta2.zip\">download the beta here</a> (zip). Check out <strong>Dashboard → Updates</strong> to see if your install is eligible for background updates. WordPress won&#8217;t update if, for example, you&#8217;re using version control like SVN or Git.</p>\n<p>For more of what&#8217;s new in version 3.7, <a title=\"WordPress 3.7 Beta 1\" href=\"http://wordpress.org/news/2013/09/wordpress-3-7-beta-1/\">check out the Beta 1 blog post</a>. In Beta 2, we further increased the stability of background updates and also added about 50 bug fixes, including a fix for Internet Explorer 11 in the visual editor.</p>\n<p>If you think you’ve found a bug, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a bug report, <a href=\"http://core.trac.wordpress.org/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/report/5\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.7\">everything we’ve fixed</a>.</p>\n<p>Happy testing!</p>\n<p><em>Beta 2 released<br />\nDotting i&#8217;s and crossing t&#8217;s</em><br />\n<em>Expect RC next</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2013/10/wordpress-3-7-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 17 Dec 2013 15:46:35 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Fri, 13 Dec 2013 22:14:07 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('1634', '_transient_timeout_ye_video_M2YwNTRjY2YzNjg5NzRhYWY2ODgzOGUwYzE2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1635', '_transient_ye_video_M2YwNTRjY2YzNjg5NzRhYWY2ODgzOGUwYzE2YmM2NzI0', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/im5RzdwrhcU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Warts+at+Home%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3043', 'uninstall_plugins', 'a:3:{i:0;b:0;s:27:\"wp-pagenavi/wp-pagenavi.php\";s:14:\"__return_false\";s:26:\"secure-wordpress/index.php\";a:2:{i:0;s:10:\"SwpaPlugin\";i:1;s:9:\"uninstall\";}}', 'no');
INSERT INTO `wp_options` VALUES('4937', 'WSD-PLUGIN-CAN-RUN-TASKS', '1', 'yes');
INSERT INTO `wp_options` VALUES('4938', 'wsdplugin_settings', 'a:15:{s:17:\"fix_hideWpVersion\";a:3:{s:4:\"name\";s:17:\"fix_hideWpVersion\";s:5:\"value\";i:0;s:4:\"desc\";s:55:\"Hide WordPress version for all users but administrators\";}s:34:\"fix_removeWpMetaGeneratorsFrontend\";a:3:{s:4:\"name\";s:34:\"fix_removeWpMetaGeneratorsFrontend\";s:5:\"value\";i:0;s:4:\"desc\";s:84:\"Remove various meta tags generators from the blog\'s head tag for non-administrators.\";}s:31:\"fix_removeReallySimpleDiscovery\";a:3:{s:4:\"name\";s:31:\"fix_removeReallySimpleDiscovery\";s:5:\"value\";i:0;s:4:\"desc\";s:55:\"Remove Really Simple Discovery meta tags from front-end\";}s:27:\"fix_removeWindowsLiveWriter\";a:3:{s:4:\"name\";s:27:\"fix_removeWindowsLiveWriter\";s:5:\"value\";i:0;s:4:\"desc\";s:51:\"Remove Windows Live Writer meta tags from front-end\";}s:25:\"fix_disableErrorReporting\";a:3:{s:4:\"name\";s:25:\"fix_disableErrorReporting\";s:5:\"value\";i:0;s:4:\"desc\";s:61:\"Disable error reporting (php + db) for all but administrators\";}s:32:\"fix_removeCoreUpdateNotification\";a:3:{s:4:\"name\";s:32:\"fix_removeCoreUpdateNotification\";s:5:\"value\";i:0;s:4:\"desc\";s:73:\"Remove core update notifications from back-end for all but administrators\";}s:35:\"fix_removePluginUpdateNotifications\";a:3:{s:4:\"name\";s:35:\"fix_removePluginUpdateNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:50:\"Remove plug-ins update notifications from back-end\";}s:34:\"fix_removeThemeUpdateNotifications\";a:3:{s:4:\"name\";s:34:\"fix_removeThemeUpdateNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:48:\"Remove themes update notifications from back-end\";}s:41:\"fix_removeLoginErrorNotificationsFrontEnd\";a:3:{s:4:\"name\";s:41:\"fix_removeLoginErrorNotificationsFrontEnd\";s:5:\"value\";i:0;s:4:\"desc\";s:47:\"Remove login error notifications from front-end\";}s:26:\"fix_hideAdminNotifications\";a:3:{s:4:\"name\";s:26:\"fix_hideAdminNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:40:\"Hide admin notifications for non admins.\";}s:27:\"fix_preventDirectoryListing\";a:3:{s:4:\"name\";s:27:\"fix_preventDirectoryListing\";s:5:\"value\";i:0;s:4:\"desc\";s:153:\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\";}s:28:\"fix_removeWpVersionFromLinks\";a:3:{s:4:\"name\";s:28:\"fix_removeWpVersionFromLinks\";s:5:\"value\";i:0;s:4:\"desc\";s:38:\"Remove the version parameter from urls\";}s:27:\"fix_emptyReadmeFileFromRoot\";a:3:{s:4:\"name\";s:27:\"fix_emptyReadmeFileFromRoot\";s:5:\"value\";i:0;s:4:\"desc\";s:66:\"Empty the content of the readme.html file from the root directory.\";}s:25:\"keepNumEntriesLiveTraffic\";i:500;s:26:\"liveTrafficRefreshRateAjax\";i:10;}', 'yes');
INSERT INTO `wp_options` VALUES('1640', '_transient_timeout_ye_video_MTIxYWIwZDQ4ZmYzNDRlYmI5YmZlOGQ0YjU2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1641', '_transient_ye_video_MTIxYWIwZDQ4ZmYzNDRlYmI5YmZlOGQ0YjU2ZjY1MDFm', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/xsNOZdwWk5Q?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Plantar+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1646', '_transient_timeout_ye_video_ZTZmNDg1NmJlYmQxY2MzOWViZjgxNDQyN2Iw', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1647', '_transient_ye_video_ZTZmNDg1NmJlYmQxY2MzOWViZjgxNDQyN2IwNDFiODNh', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g1g3DzM7rz8?version=3&amp;fs=0&amp;rel=0&amp;title=How+to+Remove+a+Plantar+Wart+from+Foot+Procedure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1652', '_transient_timeout_ye_video_YTUyMWNiZjI1N2Y1NGMyYmM1MjI1MTJiMDA2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1653', '_transient_ye_video_YTUyMWNiZjI1N2Y1NGMyYmM1MjI1MTJiMDA2NDkyZmIz', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/HiooHVe2Cdw?version=3&amp;fs=0&amp;rel=0&amp;title=wart+Remove+without+pain+-+only+apple+cider+vinegar%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2023', '_transient_timeout_ye_video_MmMyMDQ4NDRmN2M2N2Q0ZDhkZGQxZWIwMThh', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('1738', '_transient_timeout_ye_video_OTIzNjJiZjQzNDZjNmE5Yzg2MjdiNDQxZjgx', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1739', '_transient_ye_video_OTIzNjJiZjQzNDZjNmE5Yzg2MjdiNDQxZjgxMmZjZjMw', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/im5RzdwrhcU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Warts+at+Home%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1744', '_transient_timeout_ye_video_MWVlMGI5MjQ3YjRiNzQxODRmYWJkMzYwYTAz', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1745', '_transient_ye_video_MWVlMGI5MjQ3YjRiNzQxODRmYWJkMzYwYTAzNmE1NzIw', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/xsNOZdwWk5Q?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Plantar+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1750', '_transient_timeout_ye_video_MzFmMWQ3M2QwMTliNmNjMmUwMjg3NzlhOTc2', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1751', '_transient_ye_video_MzFmMWQ3M2QwMTliNmNjMmUwMjg3NzlhOTc2MTllZWJj', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g1g3DzM7rz8?version=3&amp;fs=0&amp;rel=0&amp;title=How+to+Remove+a+Plantar+Wart+from+Foot+Procedure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1756', '_transient_timeout_ye_video_NjVlOTE4NTJlNjczODM1MzNhYTlhMGU0Y2Fh', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1757', '_transient_ye_video_NjVlOTE4NTJlNjczODM1MzNhYTlhMGU0Y2FhYmI3NDRk', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/HiooHVe2Cdw?version=3&amp;fs=0&amp;rel=0&amp;title=wart+Remove+without+pain+-+only+apple+cider+vinegar%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1774', 'pagenavi_options', 'a:15:{s:10:\"pages_text\";s:36:\"Page %CURRENT_PAGE% of %TOTAL_PAGES%\";s:12:\"current_text\";s:13:\"%PAGE_NUMBER%\";s:9:\"page_text\";s:13:\"%PAGE_NUMBER%\";s:10:\"first_text\";s:13:\"&laquo; First\";s:9:\"last_text\";s:12:\"Last &raquo;\";s:9:\"prev_text\";s:7:\"&laquo;\";s:9:\"next_text\";s:7:\"&raquo;\";s:12:\"dotleft_text\";s:3:\"...\";s:13:\"dotright_text\";s:3:\"...\";s:9:\"num_pages\";i:5;s:23:\"num_larger_page_numbers\";i:3;s:28:\"larger_page_numbers_multiple\";i:10;s:11:\"always_show\";b:0;s:16:\"use_pagenavi_css\";b:1;s:5:\"style\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('1789', 'woo_show_number_results', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1816', 'dd_global_config', 'a:6:{s:24:\"dd_global_twitter_option\";a:1:{s:31:\"dd_global_twitter_option_source\";s:0:\"\";}s:23:\"dd_global_buffer_option\";a:1:{s:30:\"dd_global_buffer_option_source\";s:0:\"\";}s:26:\"dd_global_tweetmeme_option\";a:3:{s:33:\"dd_global_tweetmeme_option_source\";s:0:\"\";s:34:\"dd_global_tweetmeme_option_service\";s:0:\"\";s:38:\"dd_global_tweetmeme_option_service_api\";s:0:\"\";}s:22:\"dd_global_topsy_option\";a:2:{s:29:\"dd_global_topsy_option_source\";s:0:\"\";s:28:\"dd_global_topsy_option_theme\";s:4:\"blue\";}s:25:\"dd_global_facebook_option\";a:5:{s:32:\"dd_global_facebook_option_locale\";s:5:\"en_US\";s:30:\"dd_global_facebook_option_send\";s:0:\"\";s:30:\"dd_global_facebook_option_face\";s:0:\"\";s:31:\"dd_global_facebook_option_thumb\";s:10:\"checked=on\";s:39:\"dd_global_facebook_option_default_thumb\";s:0:\"\";}s:23:\"dd_global_flattr_option\";a:1:{s:27:\"dd_global_flattr_option_uid\";s:0:\"\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1817', 'dd_normal_display_config', 'a:5:{s:14:\"display_option\";a:6:{s:19:\"display_option_home\";s:0:\"\";s:19:\"display_option_post\";s:2:\"on\";s:19:\"display_option_page\";s:0:\"\";s:18:\"display_option_cat\";s:0:\"\";s:18:\"display_option_tag\";s:0:\"\";s:22:\"display_option_archive\";s:0:\"\";}s:15:\"category_option\";a:3:{s:21:\"category_option_radio\";s:29:\"category_option_radio_include\";s:23:\"category_option_include\";s:3:\"All\";s:23:\"category_option_exclude\";s:4:\"None\";}s:10:\"dd_line_up\";a:1:{s:17:\"dd_line_up_select\";s:10:\"Horizontal\";}s:16:\"dd_status_option\";a:1:{s:24:\"dd_status_option_display\";s:2:\"on\";}s:16:\"dd_excerp_option\";a:1:{s:24:\"dd_excerp_option_display\";s:2:\"on\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1818', 'dd_normal_button', 'a:2:{s:24:\"dd_normal_button_display\";a:24:{s:14:\"dd_button_digg\";O:7:\"DD_Digg\":30:{s:12:\"buttonLayout\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:16:\"buttonLayoutLazy\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:4:\"name\";s:4:\"Digg\";s:10:\"websiteURL\";s:19:\"http://www.digg.com\";s:6:\"apiURL\";s:44:\"http://about.digg.com/downloads/button/smart\";s:7:\"baseURL\";s:383:\"<script type=\'text/javascript\'>(function() {var s = document.createElement(\'SCRIPT\'), s1 = document.getElementsByTagName(\'SCRIPT\')[0];s.type = \'text/javascript\';s.async = true;s.src = \'http://widgets.digg.com/buttons.js\';s1.parentNode.insertBefore(s, s1);})();</script> <a class=\'DiggThisButton VOTE_BUTTON_DESIGN\' href=\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\'></a>\";s:12:\"baseURL_lazy\";s:123:\"<div class=\'dd-digg-ajax-load dd-digg-POST_ID\'></div><a class=\'DiggThisButton DD_DIGG_AJAX_POST_ID VOTE_BUTTON_DESIGN\'></a>\";s:19:\"baseURL_lazy_script\";s:253:\" function loadDigg_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-digg-POST_ID\').remove();$(\'.DD_DIGG_AJAX_POST_ID\').attr(\'href\',\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\');$.getScript(\'http://widgets.digg.com/buttons.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:56:\"window.setTimeout(\'loadDigg_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:18:\"dd_digg_appendType\";s:4:\"none\";s:20:\"dd_digg_buttonDesign\";s:6:\"Normal\";s:23:\"dd_digg_ajax_left_float\";s:0:\"\";s:17:\"dd_digg_lazy_load\";s:0:\"\";s:21:\"dd_digg_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:18:\"dd_digg_appendType\";s:20:\"option_button_design\";s:20:\"dd_digg_buttonDesign\";s:20:\"option_button_weight\";s:21:\"dd_digg_button_weight\";s:22:\"option_ajax_left_float\";s:23:\"dd_digg_ajax_left_float\";s:16:\"option_lazy_load\";s:17:\"dd_digg_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_reddit\";O:9:\"DD_Reddit\":31:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:21:\"buttonLayoutLazyWidth\";a:3:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";s:4:\"Icon\";s:2:\"69\";}s:22:\"buttonLayoutLazyHeight\";a:3:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";s:4:\"Icon\";s:2:\"52\";}s:23:\"buttonLayoutWidthHeight\";a:3:{s:6:\"Normal\";s:22:\"height=\"69\" width=\"51\"\";s:7:\"Compact\";s:23:\"height=\"22\" width=\"120\"\";s:4:\"Icon\";s:22:\"height=\"52\" width=\"69\"\";}s:4:\"name\";s:6:\"Reddit\";s:10:\"websiteURL\";s:21:\"http://www.reddit.com\";s:6:\"apiURL\";s:30:\"http://www.reddit.com/buttons/\";s:7:\"baseURL\";s:165:\"<iframe src=\"http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=\'1\'\" EXTRA_VALUE scrolling=\'no\' frameborder=\'0\'></iframe>\";s:12:\"baseURL_lazy\";s:164:\"<div class=\'dd-reddit-ajax-load dd-reddit-POST_ID\'></div><iframe class=\'DD_REDDIT_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadReddit_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-reddit-POST_ID\').remove();$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'src\',\'http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=1\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadReddit_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_reddit_appendType\";s:4:\"none\";s:22:\"dd_reddit_buttonDesign\";s:6:\"Normal\";s:25:\"dd_reddit_ajax_left_float\";s:0:\"\";s:19:\"dd_reddit_lazy_load\";s:0:\"\";s:23:\"dd_reddit_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_reddit_appendType\";s:20:\"option_button_design\";s:22:\"dd_reddit_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_reddit_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_reddit_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_reddit_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_gbuzz\";O:8:\"DD_GBuzz\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:11:\"Google Buzz\";s:10:\"websiteURL\";s:26:\"http://www.google.com/buzz\";s:6:\"apiURL\";s:53:\"http://www.google.com/buzz/api/admin/configPostWidget\";s:7:\"baseURL\";s:247:\"<a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a><script type=\'text/javascript\' src=\'http://www.google.com/buzz/api/button.js\'></script>\";s:12:\"baseURL_lazy\";s:215:\"<div class=\'dd-gbuzz-ajax-load dd-gbuzz-POST_ID\'></div><a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadGBuzz_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-gbuzz-POST_ID\').remove();$.getScript(\'http://www.google.com/buzz/api/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadGBuzz_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_gbuzz_appendType\";s:4:\"none\";s:21:\"dd_gbuzz_buttonDesign\";s:6:\"Normal\";s:24:\"dd_gbuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_gbuzz_lazy_load\";s:0:\"\";s:22:\"dd_gbuzz_button_weight\";s:2:\"98\";}s:18:\"option_append_type\";s:19:\"dd_gbuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_gbuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_gbuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_gbuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_gbuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"98\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_dzone\";O:8:\"DD_DZone\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"1\' height=\'70\' width=\'50\'\";s:7:\"Compact\";s:26:\"2\' height=\'25\' width=\'155\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:1:\"1\";s:7:\"Compact\";s:1:\"2\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:3:\"155\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"70\";s:7:\"Compact\";s:2:\"25\";}s:4:\"name\";s:5:\"DZone\";s:10:\"websiteURL\";s:20:\"http://www.dzone.com\";s:6:\"apiURL\";s:38:\"http://www.dzone.com/links/buttons.jsp\";s:7:\"baseURL\";s:163:\"<iframe src=\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&amp;title=VOTE_TITLE&amp;t=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:161:\"<div class=\'dd-dzone-ajax-load dd-dzone-POST_ID\'></div><iframe class=\'DD_DZONE_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadDzone_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-dzone-POST_ID\').remove();$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'src\',\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&title=VOTE_TITLE&t=VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadDzone_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_dzone_appendType\";s:4:\"none\";s:21:\"dd_dzone_buttonDesign\";s:6:\"Normal\";s:24:\"dd_dzone_ajax_left_float\";s:0:\"\";s:18:\"dd_dzone_lazy_load\";s:0:\"\";s:22:\"dd_dzone_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:19:\"dd_dzone_appendType\";s:20:\"option_button_design\";s:21:\"dd_dzone_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_dzone_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_dzone_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_dzone_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:17:\"dd_button_fbshare\";O:10:\"DD_FbShare\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:14:\"Facebook Share\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:30:\"http://www.facebook.com/share/\";s:7:\"baseURL\";s:209:\"<a name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a><script src=\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";s:203:\"<div class=\'dd-fbshare-ajax-load dd-fbshare-POST_ID\'></div><a class=\'DD_FBSHARE_AJAX_POST_ID\' name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a>\";s:19:\"baseURL_lazy_script\";s:177:\" function loadFBShare_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshare-POST_ID\').remove(); $.getScript(\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadFBShare_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_fbshare_appendType\";s:4:\"none\";s:23:\"dd_fbshare_buttonDesign\";s:7:\"Compact\";s:26:\"dd_fbshare_ajax_left_float\";s:0:\"\";s:20:\"dd_fbshare_lazy_load\";s:0:\"\";s:24:\"dd_fbshare_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_fbshare_appendType\";s:20:\"option_button_design\";s:23:\"dd_fbshare_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_fbshare_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_fbshare_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_fbshare_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_delicious\";O:12:\"DD_Delicious\":30:{s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:4:\"name\";s:9:\"Delicious\";s:10:\"websiteURL\";s:24:\"http://www.delicious.com\";s:6:\"apiURL\";s:35:\"http://www.delicious.com/help/feeds\";s:7:\"baseURL\";s:436:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a class=\'VOTE_BUTTON_DESIGN\' href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'><div style=\'padding-top:3px\'>SAVED_COUNT</div></span></a></div>\";s:12:\"baseURL_lazy\";s:374:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'>SAVED_COUNT</span></a></div>\";s:19:\"baseURL_lazy_script\";s:428:\" function loadDelicious_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-delicious-POST_ID\').remove();$.getJSON(\'http://feeds.delicious.com/v2/json/urlinfo/data?url=VOTE_URL&amp;callback=?\',function(data) {var msg =\'\';var count = 0;if (data.length > 0) {count = data[0].total_posts;if(count ==0){msg = \'0\';}else if(count ==1){msg = \'1\';}else{msg = count}}else{msg = \'0\';}$(\'#DD_DELICIOUS_AJAX_POST_ID\').text(msg);}); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadDelicious_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_delicious_appendType\";s:4:\"none\";s:25:\"dd_delicious_buttonDesign\";s:6:\"Normal\";s:28:\"dd_delicious_ajax_left_float\";s:0:\"\";s:22:\"dd_delicious_lazy_load\";s:0:\"\";s:26:\"dd_delicious_button_weight\";s:2:\"93\";}s:18:\"option_append_type\";s:23:\"dd_delicious_appendType\";s:20:\"option_button_design\";s:25:\"dd_delicious_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_delicious_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_delicious_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_delicious_lazy_load\";s:19:\"button_weight_value\";s:2:\"93\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_fblike\";O:9:\"DD_FbLike\":31:{s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:16:\"buttonLayoutLazy\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:23:\"buttonLayoutWidthHeight\";a:6:{s:13:\"Like Standard\";s:25:\"width:500px; height:24px;\";s:17:\"Like Button Count\";s:24:\"width:92px; height:20px;\";s:14:\"Like Box Count\";s:24:\"width:50px; height:62px;\";s:18:\"Recommend Standard\";s:25:\"width:500px; height:24px;\";s:22:\"Recommend Button Count\";s:25:\"width:130px; height:20px;\";s:19:\"Recommend Box Count\";s:24:\"width:90px; height:60px;\";}s:21:\"buttonLayoutLazyWidth\";a:6:{s:13:\"Like Standard\";s:3:\"500\";s:17:\"Like Button Count\";s:2:\"92\";s:14:\"Like Box Count\";s:2:\"50\";s:18:\"Recommend Standard\";s:3:\"500\";s:22:\"Recommend Button Count\";s:3:\"130\";s:19:\"Recommend Box Count\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:6:{s:13:\"Like Standard\";s:2:\"24\";s:17:\"Like Button Count\";s:2:\"20\";s:14:\"Like Box Count\";s:2:\"62\";s:18:\"Recommend Standard\";s:2:\"24\";s:22:\"Recommend Button Count\";s:2:\"20\";s:19:\"Recommend Box Count\";s:2:\"60\";}s:4:\"name\";s:22:\"Facebook Like (IFrame)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:234:\"<iframe src=\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\' scrolling=\'no\' frameborder=\'0\' style=\'border:none; overflow:hidden; EXTRA_VALUE\' allowTransparency=\'true\'></iframe>\";s:12:\"baseURL_lazy\";s:189:\"<div class=\'dd-fblike-ajax-load dd-fblike-POST_ID\'></div><iframe class=\"DD_FBLIKE_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowTransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:408:\" function loadFBLike_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fblike-POST_ID\').remove();$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'src\',\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFBLike_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_fblike_appendType\";s:13:\"after_content\";s:22:\"dd_fblike_buttonDesign\";s:14:\"Like Box Count\";s:25:\"dd_fblike_ajax_left_float\";s:0:\"\";s:19:\"dd_fblike_lazy_load\";s:0:\"\";s:23:\"dd_fblike_button_weight\";s:3:\"106\";}s:18:\"option_append_type\";s:20:\"dd_fblike_appendType\";s:20:\"option_button_design\";s:22:\"dd_fblike_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_fblike_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_fblike_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_fblike_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_stumbleupon\";O:14:\"DD_StumbleUpon\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:1:\"5\";s:7:\"Compact\";s:1:\"1\";}s:4:\"name\";s:11:\"Stumbleupon\";s:10:\"websiteURL\";s:26:\"http://www.stumbleupon.com\";s:6:\"apiURL\";s:34:\"http://www.stumbleupon.com/badges/\";s:7:\"baseURL\";s:102:\"<script src=\'http://www.stumbleupon.com/hostedbadge.php?s=VOTE_BUTTON_DESIGN&amp;r=VOTE_URL\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:25:\"dd_stumbleupon_appendType\";s:4:\"none\";s:27:\"dd_stumbleupon_buttonDesign\";s:6:\"Normal\";s:30:\"dd_stumbleupon_ajax_left_float\";s:0:\"\";s:24:\"dd_stumbleupon_lazy_load\";s:0:\"\";s:28:\"dd_stumbleupon_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:25:\"dd_stumbleupon_appendType\";s:20:\"option_button_design\";s:27:\"dd_stumbleupon_buttonDesign\";s:20:\"option_button_weight\";s:28:\"dd_stumbleupon_button_weight\";s:22:\"option_ajax_left_float\";s:30:\"dd_stumbleupon_ajax_left_float\";s:16:\"option_lazy_load\";s:24:\"dd_stumbleupon_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_yahoobuzz\";O:8:\"DD_YBuzz\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:6:\"square\";s:7:\"Compact\";s:11:\"small-votes\";s:12:\"Compact_Text\";s:10:\"text-votes\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"Yahoo Buzz\";s:10:\"websiteURL\";s:21:\"http://buzz.yahoo.com\";s:6:\"apiURL\";s:29:\"http://buzz.yahoo.com/buttons\";s:7:\"baseURL\";s:216:\"<script type=\'text/javascript\'>yahooBuzzArticleHeadline=\"VOTE_TITLE\";yahooBuzzArticleId=\"VOTE_URL\";</script><script type=\'text/javascript\' src=\'http://d.yimg.com/ds/badge2.js\' badgetype=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_ybuzz_appendType\";s:4:\"none\";s:21:\"dd_ybuzz_buttonDesign\";s:6:\"Normal\";s:24:\"dd_ybuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_ybuzz_lazy_load\";s:0:\"\";s:22:\"dd_ybuzz_button_weight\";s:2:\"90\";}s:18:\"option_append_type\";s:19:\"dd_ybuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_ybuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_ybuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_ybuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_ybuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"90\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_fbshareme\";O:12:\"DD_FbShareMe\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"53\";s:7:\"Compact\";s:2:\"80\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"18\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"fbShare.me\";s:10:\"websiteURL\";s:21:\"http://www.fbshare.me\";s:6:\"apiURL\";s:21:\"http://www.fbshare.me\";s:7:\"baseURL\";s:142:\"<script>var fbShare = {url: \'VOTE_URL\',size: \'VOTE_BUTTON_DESIGN\',}</script><script src=\'http://widgets.fbshare.me/files/fbshare.js\'></script>\";s:12:\"baseURL_lazy\";s:198:\"<div class=\'dd-fbshareme-ajax-load dd-fbshareme-POST_ID\'></div><iframe class=\"DD_FBSHAREME_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowtransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadFBShareMe_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshareme-POST_ID\').remove();$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'src\',\'http://widgets.fbshare.me/files/fbshare.php?url=VOTE_URL&size=VOTE_BUTTON_DESIGN\');  }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadFBShareMe_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_fbshareme_appendType\";s:4:\"none\";s:25:\"dd_fbshareme_buttonDesign\";s:6:\"Normal\";s:28:\"dd_fbshareme_ajax_left_float\";s:0:\"\";s:22:\"dd_fbshareme_lazy_load\";s:0:\"\";s:26:\"dd_fbshareme_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:23:\"dd_fbshareme_appendType\";s:20:\"option_button_design\";s:25:\"dd_fbshareme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_fbshareme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_fbshareme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_fbshareme_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_blogenagage\";O:13:\"DD_BlogEngage\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:11:\"button4.php\";}s:4:\"name\";s:10:\"BlogEngage\";s:10:\"websiteURL\";s:25:\"http://www.blogengage.com\";s:6:\"apiURL\";s:43:\"http://www.blogengage.com/profile_promo.php\";s:7:\"baseURL\";s:132:\"<script type=\'text/javascript\'>submit_url = \'VOTE_URL\';</script><script src=\'http://blogengage.com/evb/VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_blogengage_appendType\";s:4:\"none\";s:26:\"dd_blogengage_buttonDesign\";s:6:\"Normal\";s:29:\"dd_blogengage_ajax_left_float\";s:0:\"\";s:23:\"dd_blogengage_lazy_load\";s:0:\"\";s:27:\"dd_blogengage_button_weight\";s:2:\"84\";}s:18:\"option_append_type\";s:24:\"dd_blogengage_appendType\";s:20:\"option_button_design\";s:26:\"dd_blogengage_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_blogengage_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_blogengage_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_blogengage_lazy_load\";s:19:\"button_weight_value\";s:2:\"84\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:21:\"dd_button_thewebblend\";O:14:\"DD_TheWebBlend\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:0:\"\";s:7:\"Compact\";s:21:\"badge_size=\'compact\';\";}s:4:\"name\";s:11:\"TheWebBlend\";s:10:\"websiteURL\";s:26:\"http://www.thewebblend.com\";s:6:\"apiURL\";s:33:\"http://thewebblend.com/tools/vote\";s:7:\"baseURL\";s:194:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; VOTE_BUTTON_DESIGN</script><script src=\'http://thewebblend.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:22:\"dd_webblend_appendType\";s:4:\"none\";s:24:\"dd_webblend_buttonDesign\";s:6:\"Normal\";s:27:\"dd_webblend_ajax_left_float\";s:0:\"\";s:21:\"dd_webblend_lazy_load\";s:0:\"\";s:25:\"dd_webblend_button_weight\";s:2:\"85\";}s:18:\"option_append_type\";s:22:\"dd_webblend_appendType\";s:20:\"option_button_design\";s:24:\"dd_webblend_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_webblend_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_webblend_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_webblend_lazy_load\";s:19:\"button_weight_value\";s:2:\"85\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:20:\"dd_button_designbump\";O:13:\"DD_DesignBump\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:10:\"DesignBump\";s:10:\"websiteURL\";s:25:\"http://www.designbump.com\";s:6:\"apiURL\";s:33:\"http://designbump.com/content/evb\";s:7:\"baseURL\";s:176:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; </script> <script src=\'http://designbump.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_designbump_appendType\";s:4:\"none\";s:26:\"dd_designbump_buttonDesign\";s:6:\"Normal\";s:29:\"dd_designbump_ajax_left_float\";s:0:\"\";s:23:\"dd_designbump_lazy_load\";s:0:\"\";s:27:\"dd_designbump_button_weight\";s:2:\"87\";}s:18:\"option_append_type\";s:24:\"dd_designbump_appendType\";s:20:\"option_button_design\";s:26:\"dd_designbump_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_designbump_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_designbump_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_designbump_lazy_load\";s:19:\"button_weight_value\";s:2:\"87\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_twitter\";O:10:\"DD_Twitter\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:7:\"Twitter\";s:10:\"websiteURL\";s:22:\"http://www.twitter.com\";s:6:\"apiURL\";s:38:\"http://twitter.com/goodies/tweetbutton\";s:7:\"baseURL\";s:252:\"<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a><script type=\"text/javascript\" src=\"http://platform.twitter.com/widgets.js\"></script>\";s:12:\"baseURL_lazy\";s:226:\"<div class=\'dd-twitter-ajax-load dd-twitter-POST_ID\'></div><a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a>\";s:19:\"baseURL_lazy_script\";s:164:\" function loadTwitter_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-twitter-POST_ID\').remove();$.getScript(\'http://platform.twitter.com/widgets.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadTwitter_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_twitter_appendType\";s:13:\"after_content\";s:23:\"dd_twitter_buttonDesign\";s:6:\"Normal\";s:26:\"dd_twitter_ajax_left_float\";s:0:\"\";s:20:\"dd_twitter_lazy_load\";s:0:\"\";s:24:\"dd_twitter_button_weight\";s:3:\"110\";}s:18:\"option_append_type\";s:21:\"dd_twitter_appendType\";s:20:\"option_button_design\";s:23:\"dd_twitter_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_twitter_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_twitter_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_twitter_lazy_load\";s:19:\"button_weight_value\";s:3:\"110\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_tweetmeme\";O:12:\"DD_TweetMeme\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:30:\"normal\' height=\'61\' width=\'50\'\";s:7:\"Compact\";s:31:\"compact\' height=\'20\' width=\'90\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"normal\";s:7:\"Compact\";s:7:\"compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"61\";s:7:\"Compact\";s:2:\"20\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:9:\"TweetMeme\";s:10:\"websiteURL\";s:25:\"http://www.tweetmeme.com/\";s:6:\"apiURL\";s:46:\"http://wordpress.org/extend/plugins/tweetmeme/\";s:7:\"baseURL\";s:200:\"<iframe src=\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API&style=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:173:\"<div class=\'dd-tweetmeme-ajax-load dd-tweetmeme-POST_ID\'></div><iframe class=\'DD_TWEETMEME_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:465:\" function loadTweetMeme_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-tweetmeme-POST_ID\').remove();$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'src\',\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&style=VOTE_BUTTON_DESIGN&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadTweetMeme_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_tweetmeme_appendType\";s:4:\"none\";s:25:\"dd_tweetmeme_buttonDesign\";s:6:\"Normal\";s:28:\"dd_tweetmeme_ajax_left_float\";s:0:\"\";s:22:\"dd_tweetmeme_lazy_load\";s:0:\"\";s:26:\"dd_tweetmeme_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:23:\"dd_tweetmeme_appendType\";s:20:\"option_button_design\";s:25:\"dd_tweetmeme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_tweetmeme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_tweetmeme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_tweetmeme_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_topsy\";O:8:\"DD_Topsy\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:3:\"big\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:5:\"Topsy\";s:10:\"websiteURL\";s:20:\"http://www.topsy.com\";s:6:\"apiURL\";s:44:\"http://labs.topsy.com/button/retweet-button/\";s:7:\"baseURL\";s:233:\"<script type=\"text/javascript\" src=\"http://cdn.topsy.com/topsy.js?init=topsyWidgetCreator\"></script><div class=\"topsy_widget_data\"><!--{\"url\":\"VOTE_URL\",\"style\":\"VOTE_BUTTON_DESIGN\",\"theme\":\"VOTE_THEME\",\"nick\":\"VOTE_SOURCE\"}--></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_topsy_appendType\";s:4:\"none\";s:21:\"dd_topsy_buttonDesign\";s:6:\"Normal\";s:24:\"dd_topsy_ajax_left_float\";s:0:\"\";s:18:\"dd_topsy_lazy_load\";s:0:\"\";s:22:\"dd_topsy_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:19:\"dd_topsy_appendType\";s:20:\"option_button_design\";s:21:\"dd_topsy_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_topsy_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_topsy_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_topsy_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_comments\";O:11:\"DD_Comments\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:8:\"Comments\";s:10:\"websiteURL\";s:11:\"http://none\";s:6:\"apiURL\";s:11:\"http://none\";s:7:\"baseURL\";s:142:\"<div id=\'dd_comments\'><a class=\'clcount\' href=VOTE_URL><span class=\'ctotal\'>COMMENTS_COUNT</span></a><a class=\'clink\' href=VOTE_URL></a></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_comments_appendType\";s:4:\"none\";s:24:\"dd_comments_buttonDesign\";s:6:\"Normal\";s:27:\"dd_comments_ajax_left_float\";s:0:\"\";s:21:\"dd_comments_lazy_load\";s:0:\"\";s:25:\"dd_comments_button_weight\";s:2:\"88\";}s:18:\"option_append_type\";s:22:\"dd_comments_appendType\";s:20:\"option_button_design\";s:24:\"dd_comments_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_comments_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_comments_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_comments_lazy_load\";s:19:\"button_weight_value\";s:2:\"88\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_linkedin\";O:11:\"DD_Linkedin\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:8:\"Linkedin\";s:10:\"websiteURL\";s:23:\"http://www.linkedin.com\";s:6:\"apiURL\";s:34:\"http://www.linkedin.com/publishers\";s:7:\"baseURL\";s:168:\"<script type=\'text/javascript\' src=\'http://platform.linkedin.com/in.js\'></script><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";s:148:\"<div class=\'dd-linkedin-ajax-load dd-linkedin-POST_ID\'></div><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadLinkedin_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-linkedin-POST_ID\').remove();$.getScript(\'http://platform.linkedin.com/in.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:60:\"window.setTimeout(\'loadLinkedin_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_linkedin_appendType\";s:13:\"after_content\";s:24:\"dd_linkedin_buttonDesign\";s:6:\"Normal\";s:27:\"dd_linkedin_ajax_left_float\";s:0:\"\";s:21:\"dd_linkedin_lazy_load\";s:0:\"\";s:25:\"dd_linkedin_button_weight\";s:3:\"108\";}s:18:\"option_append_type\";s:22:\"dd_linkedin_appendType\";s:20:\"option_button_design\";s:24:\"dd_linkedin_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_linkedin_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_linkedin_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_linkedin_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_serpd\";O:8:\"DD_Serpd\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:0:\"\";}s:4:\"name\";s:5:\"Serpd\";s:10:\"websiteURL\";s:20:\"http://www.serpd.com\";s:6:\"apiURL\";s:29:\"http://www.serpd.com/widgets/\";s:7:\"baseURL\";s:150:\"<script type=\"text/javascript\">submit_url = \"VOTE_URL\";</script><script type=\"text/javascript\" src=\"http://www.serpd.com/index.php?page=evb\"></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_serpd_appendType\";s:4:\"none\";s:21:\"dd_serpd_buttonDesign\";s:6:\"Normal\";s:24:\"dd_serpd_ajax_left_float\";s:0:\"\";s:18:\"dd_serpd_lazy_load\";s:0:\"\";s:22:\"dd_serpd_button_weight\";s:2:\"86\";}s:18:\"option_append_type\";s:19:\"dd_serpd_appendType\";s:20:\"option_button_design\";s:21:\"dd_serpd_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_serpd_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_serpd_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_serpd_lazy_load\";s:19:\"button_weight_value\";s:2:\"86\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:22:\"dd_button_fblike_xfbml\";O:15:\"DD_FbLike_XFBML\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:17:\"Like Button Count\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:19:\"islazyLoadAvailable\";b:0;s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:13:\" width=\"450\" \";s:17:\"Like Button Count\";s:34:\" layout=\"button_count\" width=\"92\" \";s:14:\"Like Box Count\";s:31:\" layout=\"box_count\" width=\"50\" \";s:18:\"Recommend Standard\";s:32:\" action=\"recommend\" width=\"400\" \";s:22:\"Recommend Button Count\";s:54:\" action=\"recommend\" layout=\"button_count\" width=\"130\" \";s:19:\"Recommend Box Count\";s:50:\" action=\"recommend\" layout=\"box_count\" width=\"90\" \";}s:4:\"name\";s:21:\"Facebook Like (XFBML)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:170:\"<script src=\"http://connect.facebook.net/FACEBOOK_LOCALE/all.js#xfbml=1\"></script><fb:like href=\"VOTE_URL\" FACEBOOK_SEND FACEBOOK_SHOW_FACE VOTE_BUTTON_DESIGN ></fb:like>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:26:\"dd_fblike_xfbml_appendType\";s:4:\"none\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:17:\"Like Button Count\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:0:\"\";s:25:\"dd_fblike_xfbml_lazy_load\";s:0:\"\";s:29:\"dd_fblike_xfbml_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:26:\"dd_fblike_xfbml_appendType\";s:20:\"option_button_design\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:20:\"option_button_weight\";s:29:\"dd_fblike_xfbml_button_weight\";s:22:\"option_ajax_left_float\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:16:\"option_lazy_load\";s:25:\"dd_fblike_xfbml_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_google1\";O:10:\"DD_Google1\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:4:\"name\";s:9:\"Google +1\";s:10:\"websiteURL\";s:32:\"http://www.google.com/+1/button/\";s:6:\"apiURL\";s:37:\"http://code.google.com/apis/+1button/\";s:7:\"baseURL\";s:149:\"<script type=\'text/javascript\' src=\'https://apis.google.com/js/plusone.js\'></script><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:12:\"baseURL_lazy\";s:124:\"<div class=\'dd-google1-ajax-load dd-google1-POST_ID\'></div><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:19:\"baseURL_lazy_script\";s:163:\" function loadGoogle1_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-google1-POST_ID\').remove();$.getScript(\'https://apis.google.com/js/plusone.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadGoogle1_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_google1_appendType\";s:13:\"after_content\";s:23:\"dd_google1_buttonDesign\";s:6:\"Normal\";s:26:\"dd_google1_ajax_left_float\";s:0:\"\";s:20:\"dd_google1_lazy_load\";s:0:\"\";s:24:\"dd_google1_button_weight\";s:3:\"109\";}s:18:\"option_append_type\";s:21:\"dd_google1_appendType\";s:20:\"option_button_design\";s:23:\"dd_google1_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_google1_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_google1_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_google1_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_buffer\";O:9:\"DD_Buffer\":30:{s:11:\"append_type\";s:13:\"after_content\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:6:\"Buffer\";s:10:\"websiteURL\";s:21:\"http://bufferapp.com/\";s:6:\"apiURL\";s:36:\"http://bufferapp.com/goodies/button/\";s:7:\"baseURL\";s:234:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a><script type=\"text/javascript\" src=\"http://static.bufferapp.com/js/button.js\"></script>\";s:12:\"baseURL_lazy\";s:147:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a>\";s:19:\"baseURL_lazy_script\";s:163:\"function loadBuffer_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-buffer-POST_ID\').remove();$.getScript(\'http://static.bufferapp.com/js/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadBuffer_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_buffer_appendType\";s:4:\"none\";s:22:\"dd_buffer_buttonDesign\";s:6:\"Normal\";s:25:\"dd_buffer_ajax_left_float\";s:0:\"\";s:19:\"dd_buffer_lazy_load\";s:0:\"\";s:23:\"dd_buffer_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_buffer_appendType\";s:20:\"option_button_design\";s:22:\"dd_buffer_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_buffer_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_buffer_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_buffer_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_pinterest\";O:12:\"DD_Pinterest\":30:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:9:\"Pinterest\";s:10:\"websiteURL\";s:20:\"http://pinterest.com\";s:6:\"apiURL\";s:55:\"http://pinterest.com/about/goodies/#button_for_websites\";s:7:\"baseURL\";s:249:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button\" count-layout=\"VOTE_BUTTON_DESIGN\"></a><script type=\"text/javascript\" src=\"http://assets.pinterest.com/js/pinit.js\"></script>\";s:12:\"baseURL_lazy\";s:207:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button dd-pinterest-ajax-load dd-pinterest-POST_ID\" count-layout=\"VOTE_BUTTON_DESIGN\"></a>\";s:19:\"baseURL_lazy_script\";s:132:\"function loadPinterest_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://assets.pinterest.com/js/pinit.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadPinterest_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_pinterest_appendType\";s:13:\"after_content\";s:25:\"dd_pinterest_buttonDesign\";s:6:\"Normal\";s:28:\"dd_pinterest_ajax_left_float\";s:0:\"\";s:22:\"dd_pinterest_lazy_load\";s:0:\"\";s:26:\"dd_pinterest_button_weight\";s:3:\"107\";}s:18:\"option_append_type\";s:23:\"dd_pinterest_appendType\";s:20:\"option_button_design\";s:25:\"dd_pinterest_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_pinterest_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_pinterest_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_pinterest_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_flattr\";O:9:\"DD_Flattr\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:6:\"Flattr\";s:10:\"websiteURL\";s:17:\"http://flattr.com\";s:6:\"apiURL\";s:36:\"http://developers.flattr.net/button/\";s:7:\"baseURL\";s:257:\"<script src=\"http://api.flattr.com/js/0.6/load.js?mode=auto\"></script><a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:12:\"baseURL_lazy\";s:187:\"<a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:19:\"baseURL_lazy_script\";s:136:\"function loadFlattr_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://api.flattr.com/js/0.6/load.js?mode=auto\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFlattr_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_flattr_appendType\";s:4:\"none\";s:22:\"dd_flattr_buttonDesign\";s:6:\"Normal\";s:25:\"dd_flattr_ajax_left_float\";s:0:\"\";s:19:\"dd_flattr_lazy_load\";s:0:\"\";s:23:\"dd_flattr_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:20:\"dd_flattr_appendType\";s:20:\"option_button_design\";s:22:\"dd_flattr_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_flattr_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_flattr_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_flattr_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}}s:22:\"dd_normal_button_final\";a:5:{s:16:\"dd_button_fblike\";r:279;s:17:\"dd_button_twitter\";r:609;s:18:\"dd_button_linkedin\";r:784;s:17:\"dd_button_google1\";r:921;s:19:\"dd_button_pinterest\";r:1015;}}', 'yes');
INSERT INTO `wp_options` VALUES('1819', 'dd_float_display_config', 'a:6:{s:14:\"display_option\";a:6:{s:19:\"display_option_home\";s:0:\"\";s:19:\"display_option_post\";s:2:\"on\";s:19:\"display_option_page\";s:0:\"\";s:18:\"display_option_cat\";s:0:\"\";s:18:\"display_option_tag\";s:0:\"\";s:22:\"display_option_archive\";s:0:\"\";}s:15:\"category_option\";a:3:{s:21:\"category_option_radio\";s:29:\"category_option_radio_include\";s:23:\"category_option_include\";s:3:\"All\";s:23:\"category_option_exclude\";s:4:\"None\";}s:16:\"dd_status_option\";a:1:{s:24:\"dd_status_option_display\";s:0:\"\";}s:15:\"dd_float_option\";a:2:{s:22:\"dd_float_option_credit\";s:2:\"on\";s:20:\"dd_float_option_left\";s:2:\"60\";}s:21:\"dd_extra_option_email\";a:2:{s:28:\"dd_extra_option_email_status\";s:0:\"\";s:31:\"dd_extra_option_email_sharethis\";s:0:\"\";}s:21:\"dd_extra_option_print\";a:1:{s:28:\"dd_extra_option_print_status\";s:0:\"\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1820', 'dd_float_button', 'a:2:{s:23:\"dd_float_button_display\";a:24:{s:14:\"dd_button_digg\";O:7:\"DD_Digg\":30:{s:12:\"buttonLayout\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:16:\"buttonLayoutLazy\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:4:\"name\";s:4:\"Digg\";s:10:\"websiteURL\";s:19:\"http://www.digg.com\";s:6:\"apiURL\";s:44:\"http://about.digg.com/downloads/button/smart\";s:7:\"baseURL\";s:383:\"<script type=\'text/javascript\'>(function() {var s = document.createElement(\'SCRIPT\'), s1 = document.getElementsByTagName(\'SCRIPT\')[0];s.type = \'text/javascript\';s.async = true;s.src = \'http://widgets.digg.com/buttons.js\';s1.parentNode.insertBefore(s, s1);})();</script> <a class=\'DiggThisButton VOTE_BUTTON_DESIGN\' href=\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\'></a>\";s:12:\"baseURL_lazy\";s:123:\"<div class=\'dd-digg-ajax-load dd-digg-POST_ID\'></div><a class=\'DiggThisButton DD_DIGG_AJAX_POST_ID VOTE_BUTTON_DESIGN\'></a>\";s:19:\"baseURL_lazy_script\";s:253:\" function loadDigg_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-digg-POST_ID\').remove();$(\'.DD_DIGG_AJAX_POST_ID\').attr(\'href\',\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\');$.getScript(\'http://widgets.digg.com/buttons.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:56:\"window.setTimeout(\'loadDigg_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:18:\"dd_digg_appendType\";s:0:\"\";s:20:\"dd_digg_buttonDesign\";s:0:\"\";s:23:\"dd_digg_ajax_left_float\";s:0:\"\";s:17:\"dd_digg_lazy_load\";s:0:\"\";s:21:\"dd_digg_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:18:\"dd_digg_appendType\";s:20:\"option_button_design\";s:20:\"dd_digg_buttonDesign\";s:20:\"option_button_weight\";s:21:\"dd_digg_button_weight\";s:22:\"option_ajax_left_float\";s:23:\"dd_digg_ajax_left_float\";s:16:\"option_lazy_load\";s:17:\"dd_digg_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_reddit\";O:9:\"DD_Reddit\":31:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:21:\"buttonLayoutLazyWidth\";a:3:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";s:4:\"Icon\";s:2:\"69\";}s:22:\"buttonLayoutLazyHeight\";a:3:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";s:4:\"Icon\";s:2:\"52\";}s:23:\"buttonLayoutWidthHeight\";a:3:{s:6:\"Normal\";s:22:\"height=\"69\" width=\"51\"\";s:7:\"Compact\";s:23:\"height=\"22\" width=\"120\"\";s:4:\"Icon\";s:22:\"height=\"52\" width=\"69\"\";}s:4:\"name\";s:6:\"Reddit\";s:10:\"websiteURL\";s:21:\"http://www.reddit.com\";s:6:\"apiURL\";s:30:\"http://www.reddit.com/buttons/\";s:7:\"baseURL\";s:165:\"<iframe src=\"http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=\'1\'\" EXTRA_VALUE scrolling=\'no\' frameborder=\'0\'></iframe>\";s:12:\"baseURL_lazy\";s:164:\"<div class=\'dd-reddit-ajax-load dd-reddit-POST_ID\'></div><iframe class=\'DD_REDDIT_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadReddit_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-reddit-POST_ID\').remove();$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'src\',\'http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=1\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadReddit_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_reddit_appendType\";s:0:\"\";s:22:\"dd_reddit_buttonDesign\";s:0:\"\";s:25:\"dd_reddit_ajax_left_float\";s:0:\"\";s:19:\"dd_reddit_lazy_load\";s:0:\"\";s:23:\"dd_reddit_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_reddit_appendType\";s:20:\"option_button_design\";s:22:\"dd_reddit_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_reddit_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_reddit_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_reddit_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_gbuzz\";O:8:\"DD_GBuzz\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:11:\"Google Buzz\";s:10:\"websiteURL\";s:26:\"http://www.google.com/buzz\";s:6:\"apiURL\";s:53:\"http://www.google.com/buzz/api/admin/configPostWidget\";s:7:\"baseURL\";s:247:\"<a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a><script type=\'text/javascript\' src=\'http://www.google.com/buzz/api/button.js\'></script>\";s:12:\"baseURL_lazy\";s:215:\"<div class=\'dd-gbuzz-ajax-load dd-gbuzz-POST_ID\'></div><a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadGBuzz_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-gbuzz-POST_ID\').remove();$.getScript(\'http://www.google.com/buzz/api/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadGBuzz_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_gbuzz_appendType\";s:0:\"\";s:21:\"dd_gbuzz_buttonDesign\";s:0:\"\";s:24:\"dd_gbuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_gbuzz_lazy_load\";s:0:\"\";s:22:\"dd_gbuzz_button_weight\";s:2:\"98\";}s:18:\"option_append_type\";s:19:\"dd_gbuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_gbuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_gbuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_gbuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_gbuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"98\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_dzone\";O:8:\"DD_DZone\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"1\' height=\'70\' width=\'50\'\";s:7:\"Compact\";s:26:\"2\' height=\'25\' width=\'155\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:1:\"1\";s:7:\"Compact\";s:1:\"2\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:3:\"155\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"70\";s:7:\"Compact\";s:2:\"25\";}s:4:\"name\";s:5:\"DZone\";s:10:\"websiteURL\";s:20:\"http://www.dzone.com\";s:6:\"apiURL\";s:38:\"http://www.dzone.com/links/buttons.jsp\";s:7:\"baseURL\";s:163:\"<iframe src=\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&amp;title=VOTE_TITLE&amp;t=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:161:\"<div class=\'dd-dzone-ajax-load dd-dzone-POST_ID\'></div><iframe class=\'DD_DZONE_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadDzone_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-dzone-POST_ID\').remove();$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'src\',\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&title=VOTE_TITLE&t=VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadDzone_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_dzone_appendType\";s:0:\"\";s:21:\"dd_dzone_buttonDesign\";s:0:\"\";s:24:\"dd_dzone_ajax_left_float\";s:0:\"\";s:18:\"dd_dzone_lazy_load\";s:0:\"\";s:22:\"dd_dzone_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:19:\"dd_dzone_appendType\";s:20:\"option_button_design\";s:21:\"dd_dzone_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_dzone_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_dzone_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_dzone_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:17:\"dd_button_fbshare\";O:10:\"DD_FbShare\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:14:\"Facebook Share\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:30:\"http://www.facebook.com/share/\";s:7:\"baseURL\";s:209:\"<a name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a><script src=\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";s:203:\"<div class=\'dd-fbshare-ajax-load dd-fbshare-POST_ID\'></div><a class=\'DD_FBSHARE_AJAX_POST_ID\' name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a>\";s:19:\"baseURL_lazy_script\";s:177:\" function loadFBShare_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshare-POST_ID\').remove(); $.getScript(\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadFBShare_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_fbshare_appendType\";s:0:\"\";s:23:\"dd_fbshare_buttonDesign\";s:0:\"\";s:26:\"dd_fbshare_ajax_left_float\";s:0:\"\";s:20:\"dd_fbshare_lazy_load\";s:0:\"\";s:24:\"dd_fbshare_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_fbshare_appendType\";s:20:\"option_button_design\";s:23:\"dd_fbshare_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_fbshare_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_fbshare_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_fbshare_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_delicious\";O:12:\"DD_Delicious\":30:{s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:4:\"name\";s:9:\"Delicious\";s:10:\"websiteURL\";s:24:\"http://www.delicious.com\";s:6:\"apiURL\";s:35:\"http://www.delicious.com/help/feeds\";s:7:\"baseURL\";s:436:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a class=\'VOTE_BUTTON_DESIGN\' href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'><div style=\'padding-top:3px\'>SAVED_COUNT</div></span></a></div>\";s:12:\"baseURL_lazy\";s:374:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'>SAVED_COUNT</span></a></div>\";s:19:\"baseURL_lazy_script\";s:428:\" function loadDelicious_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-delicious-POST_ID\').remove();$.getJSON(\'http://feeds.delicious.com/v2/json/urlinfo/data?url=VOTE_URL&amp;callback=?\',function(data) {var msg =\'\';var count = 0;if (data.length > 0) {count = data[0].total_posts;if(count ==0){msg = \'0\';}else if(count ==1){msg = \'1\';}else{msg = count}}else{msg = \'0\';}$(\'#DD_DELICIOUS_AJAX_POST_ID\').text(msg);}); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadDelicious_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_delicious_appendType\";s:0:\"\";s:25:\"dd_delicious_buttonDesign\";s:0:\"\";s:28:\"dd_delicious_ajax_left_float\";s:0:\"\";s:22:\"dd_delicious_lazy_load\";s:0:\"\";s:26:\"dd_delicious_button_weight\";s:2:\"93\";}s:18:\"option_append_type\";s:23:\"dd_delicious_appendType\";s:20:\"option_button_design\";s:25:\"dd_delicious_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_delicious_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_delicious_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_delicious_lazy_load\";s:19:\"button_weight_value\";s:2:\"93\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_fblike\";O:9:\"DD_FbLike\":31:{s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:16:\"buttonLayoutLazy\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:23:\"buttonLayoutWidthHeight\";a:6:{s:13:\"Like Standard\";s:25:\"width:500px; height:24px;\";s:17:\"Like Button Count\";s:24:\"width:92px; height:20px;\";s:14:\"Like Box Count\";s:24:\"width:50px; height:62px;\";s:18:\"Recommend Standard\";s:25:\"width:500px; height:24px;\";s:22:\"Recommend Button Count\";s:25:\"width:130px; height:20px;\";s:19:\"Recommend Box Count\";s:24:\"width:90px; height:60px;\";}s:21:\"buttonLayoutLazyWidth\";a:6:{s:13:\"Like Standard\";s:3:\"500\";s:17:\"Like Button Count\";s:2:\"92\";s:14:\"Like Box Count\";s:2:\"50\";s:18:\"Recommend Standard\";s:3:\"500\";s:22:\"Recommend Button Count\";s:3:\"130\";s:19:\"Recommend Box Count\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:6:{s:13:\"Like Standard\";s:2:\"24\";s:17:\"Like Button Count\";s:2:\"20\";s:14:\"Like Box Count\";s:2:\"62\";s:18:\"Recommend Standard\";s:2:\"24\";s:22:\"Recommend Button Count\";s:2:\"20\";s:19:\"Recommend Box Count\";s:2:\"60\";}s:4:\"name\";s:22:\"Facebook Like (IFrame)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:234:\"<iframe src=\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\' scrolling=\'no\' frameborder=\'0\' style=\'border:none; overflow:hidden; EXTRA_VALUE\' allowTransparency=\'true\'></iframe>\";s:12:\"baseURL_lazy\";s:189:\"<div class=\'dd-fblike-ajax-load dd-fblike-POST_ID\'></div><iframe class=\"DD_FBLIKE_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowTransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:408:\" function loadFBLike_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fblike-POST_ID\').remove();$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'src\',\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFBLike_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_fblike_appendType\";s:0:\"\";s:22:\"dd_fblike_buttonDesign\";s:0:\"\";s:25:\"dd_fblike_ajax_left_float\";s:2:\"on\";s:19:\"dd_fblike_lazy_load\";s:0:\"\";s:23:\"dd_fblike_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:20:\"dd_fblike_appendType\";s:20:\"option_button_design\";s:22:\"dd_fblike_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_fblike_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_fblike_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_fblike_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_stumbleupon\";O:14:\"DD_StumbleUpon\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:1:\"5\";s:7:\"Compact\";s:1:\"1\";}s:4:\"name\";s:11:\"Stumbleupon\";s:10:\"websiteURL\";s:26:\"http://www.stumbleupon.com\";s:6:\"apiURL\";s:34:\"http://www.stumbleupon.com/badges/\";s:7:\"baseURL\";s:102:\"<script src=\'http://www.stumbleupon.com/hostedbadge.php?s=VOTE_BUTTON_DESIGN&amp;r=VOTE_URL\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:25:\"dd_stumbleupon_appendType\";s:0:\"\";s:27:\"dd_stumbleupon_buttonDesign\";s:0:\"\";s:30:\"dd_stumbleupon_ajax_left_float\";s:0:\"\";s:24:\"dd_stumbleupon_lazy_load\";s:0:\"\";s:28:\"dd_stumbleupon_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:25:\"dd_stumbleupon_appendType\";s:20:\"option_button_design\";s:27:\"dd_stumbleupon_buttonDesign\";s:20:\"option_button_weight\";s:28:\"dd_stumbleupon_button_weight\";s:22:\"option_ajax_left_float\";s:30:\"dd_stumbleupon_ajax_left_float\";s:16:\"option_lazy_load\";s:24:\"dd_stumbleupon_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_yahoobuzz\";O:8:\"DD_YBuzz\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:6:\"square\";s:7:\"Compact\";s:11:\"small-votes\";s:12:\"Compact_Text\";s:10:\"text-votes\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"Yahoo Buzz\";s:10:\"websiteURL\";s:21:\"http://buzz.yahoo.com\";s:6:\"apiURL\";s:29:\"http://buzz.yahoo.com/buttons\";s:7:\"baseURL\";s:216:\"<script type=\'text/javascript\'>yahooBuzzArticleHeadline=\"VOTE_TITLE\";yahooBuzzArticleId=\"VOTE_URL\";</script><script type=\'text/javascript\' src=\'http://d.yimg.com/ds/badge2.js\' badgetype=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_ybuzz_appendType\";s:0:\"\";s:21:\"dd_ybuzz_buttonDesign\";s:0:\"\";s:24:\"dd_ybuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_ybuzz_lazy_load\";s:0:\"\";s:22:\"dd_ybuzz_button_weight\";s:2:\"90\";}s:18:\"option_append_type\";s:19:\"dd_ybuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_ybuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_ybuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_ybuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_ybuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"90\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_fbshareme\";O:12:\"DD_FbShareMe\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"53\";s:7:\"Compact\";s:2:\"80\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"18\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"fbShare.me\";s:10:\"websiteURL\";s:21:\"http://www.fbshare.me\";s:6:\"apiURL\";s:21:\"http://www.fbshare.me\";s:7:\"baseURL\";s:142:\"<script>var fbShare = {url: \'VOTE_URL\',size: \'VOTE_BUTTON_DESIGN\',}</script><script src=\'http://widgets.fbshare.me/files/fbshare.js\'></script>\";s:12:\"baseURL_lazy\";s:198:\"<div class=\'dd-fbshareme-ajax-load dd-fbshareme-POST_ID\'></div><iframe class=\"DD_FBSHAREME_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowtransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadFBShareMe_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshareme-POST_ID\').remove();$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'src\',\'http://widgets.fbshare.me/files/fbshare.php?url=VOTE_URL&size=VOTE_BUTTON_DESIGN\');  }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadFBShareMe_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_fbshareme_appendType\";s:0:\"\";s:25:\"dd_fbshareme_buttonDesign\";s:0:\"\";s:28:\"dd_fbshareme_ajax_left_float\";s:0:\"\";s:22:\"dd_fbshareme_lazy_load\";s:0:\"\";s:26:\"dd_fbshareme_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:23:\"dd_fbshareme_appendType\";s:20:\"option_button_design\";s:25:\"dd_fbshareme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_fbshareme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_fbshareme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_fbshareme_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_blogenagage\";O:13:\"DD_BlogEngage\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:11:\"button4.php\";}s:4:\"name\";s:10:\"BlogEngage\";s:10:\"websiteURL\";s:25:\"http://www.blogengage.com\";s:6:\"apiURL\";s:43:\"http://www.blogengage.com/profile_promo.php\";s:7:\"baseURL\";s:132:\"<script type=\'text/javascript\'>submit_url = \'VOTE_URL\';</script><script src=\'http://blogengage.com/evb/VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_blogengage_appendType\";s:0:\"\";s:26:\"dd_blogengage_buttonDesign\";s:0:\"\";s:29:\"dd_blogengage_ajax_left_float\";s:0:\"\";s:23:\"dd_blogengage_lazy_load\";s:0:\"\";s:27:\"dd_blogengage_button_weight\";s:2:\"84\";}s:18:\"option_append_type\";s:24:\"dd_blogengage_appendType\";s:20:\"option_button_design\";s:26:\"dd_blogengage_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_blogengage_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_blogengage_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_blogengage_lazy_load\";s:19:\"button_weight_value\";s:2:\"84\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:21:\"dd_button_thewebblend\";O:14:\"DD_TheWebBlend\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:0:\"\";s:7:\"Compact\";s:21:\"badge_size=\'compact\';\";}s:4:\"name\";s:11:\"TheWebBlend\";s:10:\"websiteURL\";s:26:\"http://www.thewebblend.com\";s:6:\"apiURL\";s:33:\"http://thewebblend.com/tools/vote\";s:7:\"baseURL\";s:194:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; VOTE_BUTTON_DESIGN</script><script src=\'http://thewebblend.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:22:\"dd_webblend_appendType\";s:0:\"\";s:24:\"dd_webblend_buttonDesign\";s:0:\"\";s:27:\"dd_webblend_ajax_left_float\";s:0:\"\";s:21:\"dd_webblend_lazy_load\";s:0:\"\";s:25:\"dd_webblend_button_weight\";s:2:\"85\";}s:18:\"option_append_type\";s:22:\"dd_webblend_appendType\";s:20:\"option_button_design\";s:24:\"dd_webblend_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_webblend_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_webblend_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_webblend_lazy_load\";s:19:\"button_weight_value\";s:2:\"85\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:20:\"dd_button_designbump\";O:13:\"DD_DesignBump\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:10:\"DesignBump\";s:10:\"websiteURL\";s:25:\"http://www.designbump.com\";s:6:\"apiURL\";s:33:\"http://designbump.com/content/evb\";s:7:\"baseURL\";s:176:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; </script> <script src=\'http://designbump.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_designbump_appendType\";s:0:\"\";s:26:\"dd_designbump_buttonDesign\";s:0:\"\";s:29:\"dd_designbump_ajax_left_float\";s:0:\"\";s:23:\"dd_designbump_lazy_load\";s:0:\"\";s:27:\"dd_designbump_button_weight\";s:2:\"87\";}s:18:\"option_append_type\";s:24:\"dd_designbump_appendType\";s:20:\"option_button_design\";s:26:\"dd_designbump_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_designbump_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_designbump_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_designbump_lazy_load\";s:19:\"button_weight_value\";s:2:\"87\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_twitter\";O:10:\"DD_Twitter\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:7:\"Twitter\";s:10:\"websiteURL\";s:22:\"http://www.twitter.com\";s:6:\"apiURL\";s:38:\"http://twitter.com/goodies/tweetbutton\";s:7:\"baseURL\";s:252:\"<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a><script type=\"text/javascript\" src=\"http://platform.twitter.com/widgets.js\"></script>\";s:12:\"baseURL_lazy\";s:226:\"<div class=\'dd-twitter-ajax-load dd-twitter-POST_ID\'></div><a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a>\";s:19:\"baseURL_lazy_script\";s:164:\" function loadTwitter_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-twitter-POST_ID\').remove();$.getScript(\'http://platform.twitter.com/widgets.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadTwitter_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_twitter_appendType\";s:0:\"\";s:23:\"dd_twitter_buttonDesign\";s:0:\"\";s:26:\"dd_twitter_ajax_left_float\";s:2:\"on\";s:20:\"dd_twitter_lazy_load\";s:0:\"\";s:24:\"dd_twitter_button_weight\";s:3:\"110\";}s:18:\"option_append_type\";s:21:\"dd_twitter_appendType\";s:20:\"option_button_design\";s:23:\"dd_twitter_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_twitter_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_twitter_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_twitter_lazy_load\";s:19:\"button_weight_value\";s:3:\"110\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_tweetmeme\";O:12:\"DD_TweetMeme\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:30:\"normal\' height=\'61\' width=\'50\'\";s:7:\"Compact\";s:31:\"compact\' height=\'20\' width=\'90\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"normal\";s:7:\"Compact\";s:7:\"compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"61\";s:7:\"Compact\";s:2:\"20\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:9:\"TweetMeme\";s:10:\"websiteURL\";s:25:\"http://www.tweetmeme.com/\";s:6:\"apiURL\";s:46:\"http://wordpress.org/extend/plugins/tweetmeme/\";s:7:\"baseURL\";s:200:\"<iframe src=\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API&style=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:173:\"<div class=\'dd-tweetmeme-ajax-load dd-tweetmeme-POST_ID\'></div><iframe class=\'DD_TWEETMEME_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:465:\" function loadTweetMeme_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-tweetmeme-POST_ID\').remove();$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'src\',\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&style=VOTE_BUTTON_DESIGN&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadTweetMeme_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_tweetmeme_appendType\";s:0:\"\";s:25:\"dd_tweetmeme_buttonDesign\";s:0:\"\";s:28:\"dd_tweetmeme_ajax_left_float\";s:0:\"\";s:22:\"dd_tweetmeme_lazy_load\";s:0:\"\";s:26:\"dd_tweetmeme_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:23:\"dd_tweetmeme_appendType\";s:20:\"option_button_design\";s:25:\"dd_tweetmeme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_tweetmeme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_tweetmeme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_tweetmeme_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_topsy\";O:8:\"DD_Topsy\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:3:\"big\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:5:\"Topsy\";s:10:\"websiteURL\";s:20:\"http://www.topsy.com\";s:6:\"apiURL\";s:44:\"http://labs.topsy.com/button/retweet-button/\";s:7:\"baseURL\";s:233:\"<script type=\"text/javascript\" src=\"http://cdn.topsy.com/topsy.js?init=topsyWidgetCreator\"></script><div class=\"topsy_widget_data\"><!--{\"url\":\"VOTE_URL\",\"style\":\"VOTE_BUTTON_DESIGN\",\"theme\":\"VOTE_THEME\",\"nick\":\"VOTE_SOURCE\"}--></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_topsy_appendType\";s:0:\"\";s:21:\"dd_topsy_buttonDesign\";s:0:\"\";s:24:\"dd_topsy_ajax_left_float\";s:0:\"\";s:18:\"dd_topsy_lazy_load\";s:0:\"\";s:22:\"dd_topsy_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:19:\"dd_topsy_appendType\";s:20:\"option_button_design\";s:21:\"dd_topsy_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_topsy_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_topsy_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_topsy_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_comments\";O:11:\"DD_Comments\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:8:\"Comments\";s:10:\"websiteURL\";s:11:\"http://none\";s:6:\"apiURL\";s:11:\"http://none\";s:7:\"baseURL\";s:142:\"<div id=\'dd_comments\'><a class=\'clcount\' href=VOTE_URL><span class=\'ctotal\'>COMMENTS_COUNT</span></a><a class=\'clink\' href=VOTE_URL></a></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_comments_appendType\";s:0:\"\";s:24:\"dd_comments_buttonDesign\";s:0:\"\";s:27:\"dd_comments_ajax_left_float\";s:0:\"\";s:21:\"dd_comments_lazy_load\";s:0:\"\";s:25:\"dd_comments_button_weight\";s:2:\"88\";}s:18:\"option_append_type\";s:22:\"dd_comments_appendType\";s:20:\"option_button_design\";s:24:\"dd_comments_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_comments_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_comments_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_comments_lazy_load\";s:19:\"button_weight_value\";s:2:\"88\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_linkedin\";O:11:\"DD_Linkedin\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:8:\"Linkedin\";s:10:\"websiteURL\";s:23:\"http://www.linkedin.com\";s:6:\"apiURL\";s:34:\"http://www.linkedin.com/publishers\";s:7:\"baseURL\";s:168:\"<script type=\'text/javascript\' src=\'http://platform.linkedin.com/in.js\'></script><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";s:148:\"<div class=\'dd-linkedin-ajax-load dd-linkedin-POST_ID\'></div><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadLinkedin_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-linkedin-POST_ID\').remove();$.getScript(\'http://platform.linkedin.com/in.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:60:\"window.setTimeout(\'loadLinkedin_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_linkedin_appendType\";s:0:\"\";s:24:\"dd_linkedin_buttonDesign\";s:0:\"\";s:27:\"dd_linkedin_ajax_left_float\";s:2:\"on\";s:21:\"dd_linkedin_lazy_load\";s:0:\"\";s:25:\"dd_linkedin_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:22:\"dd_linkedin_appendType\";s:20:\"option_button_design\";s:24:\"dd_linkedin_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_linkedin_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_linkedin_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_linkedin_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_serpd\";O:8:\"DD_Serpd\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:0:\"\";}s:4:\"name\";s:5:\"Serpd\";s:10:\"websiteURL\";s:20:\"http://www.serpd.com\";s:6:\"apiURL\";s:29:\"http://www.serpd.com/widgets/\";s:7:\"baseURL\";s:150:\"<script type=\"text/javascript\">submit_url = \"VOTE_URL\";</script><script type=\"text/javascript\" src=\"http://www.serpd.com/index.php?page=evb\"></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_serpd_appendType\";s:0:\"\";s:21:\"dd_serpd_buttonDesign\";s:0:\"\";s:24:\"dd_serpd_ajax_left_float\";s:0:\"\";s:18:\"dd_serpd_lazy_load\";s:0:\"\";s:22:\"dd_serpd_button_weight\";s:2:\"86\";}s:18:\"option_append_type\";s:19:\"dd_serpd_appendType\";s:20:\"option_button_design\";s:21:\"dd_serpd_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_serpd_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_serpd_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_serpd_lazy_load\";s:19:\"button_weight_value\";s:2:\"86\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:22:\"dd_button_fblike_xfbml\";O:15:\"DD_FbLike_XFBML\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:17:\"Like Button Count\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:19:\"islazyLoadAvailable\";b:0;s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:13:\" width=\"450\" \";s:17:\"Like Button Count\";s:34:\" layout=\"button_count\" width=\"92\" \";s:14:\"Like Box Count\";s:31:\" layout=\"box_count\" width=\"50\" \";s:18:\"Recommend Standard\";s:32:\" action=\"recommend\" width=\"400\" \";s:22:\"Recommend Button Count\";s:54:\" action=\"recommend\" layout=\"button_count\" width=\"130\" \";s:19:\"Recommend Box Count\";s:50:\" action=\"recommend\" layout=\"box_count\" width=\"90\" \";}s:4:\"name\";s:21:\"Facebook Like (XFBML)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:170:\"<script src=\"http://connect.facebook.net/FACEBOOK_LOCALE/all.js#xfbml=1\"></script><fb:like href=\"VOTE_URL\" FACEBOOK_SEND FACEBOOK_SHOW_FACE VOTE_BUTTON_DESIGN ></fb:like>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:26:\"dd_fblike_xfbml_appendType\";s:0:\"\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:0:\"\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:0:\"\";s:25:\"dd_fblike_xfbml_lazy_load\";s:0:\"\";s:29:\"dd_fblike_xfbml_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:26:\"dd_fblike_xfbml_appendType\";s:20:\"option_button_design\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:20:\"option_button_weight\";s:29:\"dd_fblike_xfbml_button_weight\";s:22:\"option_ajax_left_float\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:16:\"option_lazy_load\";s:25:\"dd_fblike_xfbml_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_google1\";O:10:\"DD_Google1\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:4:\"name\";s:9:\"Google +1\";s:10:\"websiteURL\";s:32:\"http://www.google.com/+1/button/\";s:6:\"apiURL\";s:37:\"http://code.google.com/apis/+1button/\";s:7:\"baseURL\";s:149:\"<script type=\'text/javascript\' src=\'https://apis.google.com/js/plusone.js\'></script><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:12:\"baseURL_lazy\";s:124:\"<div class=\'dd-google1-ajax-load dd-google1-POST_ID\'></div><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:19:\"baseURL_lazy_script\";s:163:\" function loadGoogle1_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-google1-POST_ID\').remove();$.getScript(\'https://apis.google.com/js/plusone.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadGoogle1_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_google1_appendType\";s:0:\"\";s:23:\"dd_google1_buttonDesign\";s:0:\"\";s:26:\"dd_google1_ajax_left_float\";s:2:\"on\";s:20:\"dd_google1_lazy_load\";s:0:\"\";s:24:\"dd_google1_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_google1_appendType\";s:20:\"option_button_design\";s:23:\"dd_google1_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_google1_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_google1_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_google1_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_buffer\";O:9:\"DD_Buffer\":30:{s:11:\"append_type\";s:13:\"after_content\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:6:\"Buffer\";s:10:\"websiteURL\";s:21:\"http://bufferapp.com/\";s:6:\"apiURL\";s:36:\"http://bufferapp.com/goodies/button/\";s:7:\"baseURL\";s:234:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a><script type=\"text/javascript\" src=\"http://static.bufferapp.com/js/button.js\"></script>\";s:12:\"baseURL_lazy\";s:147:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a>\";s:19:\"baseURL_lazy_script\";s:163:\"function loadBuffer_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-buffer-POST_ID\').remove();$.getScript(\'http://static.bufferapp.com/js/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadBuffer_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_buffer_appendType\";s:0:\"\";s:22:\"dd_buffer_buttonDesign\";s:0:\"\";s:25:\"dd_buffer_ajax_left_float\";s:0:\"\";s:19:\"dd_buffer_lazy_load\";s:0:\"\";s:23:\"dd_buffer_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_buffer_appendType\";s:20:\"option_button_design\";s:22:\"dd_buffer_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_buffer_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_buffer_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_buffer_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_pinterest\";O:12:\"DD_Pinterest\":30:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:9:\"Pinterest\";s:10:\"websiteURL\";s:20:\"http://pinterest.com\";s:6:\"apiURL\";s:55:\"http://pinterest.com/about/goodies/#button_for_websites\";s:7:\"baseURL\";s:249:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button\" count-layout=\"VOTE_BUTTON_DESIGN\"></a><script type=\"text/javascript\" src=\"http://assets.pinterest.com/js/pinit.js\"></script>\";s:12:\"baseURL_lazy\";s:207:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button dd-pinterest-ajax-load dd-pinterest-POST_ID\" count-layout=\"VOTE_BUTTON_DESIGN\"></a>\";s:19:\"baseURL_lazy_script\";s:132:\"function loadPinterest_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://assets.pinterest.com/js/pinit.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadPinterest_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_pinterest_appendType\";s:0:\"\";s:25:\"dd_pinterest_buttonDesign\";s:0:\"\";s:28:\"dd_pinterest_ajax_left_float\";s:2:\"on\";s:22:\"dd_pinterest_lazy_load\";s:0:\"\";s:26:\"dd_pinterest_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:23:\"dd_pinterest_appendType\";s:20:\"option_button_design\";s:25:\"dd_pinterest_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_pinterest_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_pinterest_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_pinterest_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_flattr\";O:9:\"DD_Flattr\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:6:\"Flattr\";s:10:\"websiteURL\";s:17:\"http://flattr.com\";s:6:\"apiURL\";s:36:\"http://developers.flattr.net/button/\";s:7:\"baseURL\";s:257:\"<script src=\"http://api.flattr.com/js/0.6/load.js?mode=auto\"></script><a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:12:\"baseURL_lazy\";s:187:\"<a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:19:\"baseURL_lazy_script\";s:136:\"function loadFlattr_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://api.flattr.com/js/0.6/load.js?mode=auto\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFlattr_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_flattr_appendType\";s:0:\"\";s:22:\"dd_flattr_buttonDesign\";s:0:\"\";s:25:\"dd_flattr_ajax_left_float\";s:0:\"\";s:19:\"dd_flattr_lazy_load\";s:0:\"\";s:23:\"dd_flattr_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:20:\"dd_flattr_appendType\";s:20:\"option_button_design\";s:22:\"dd_flattr_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_flattr_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_flattr_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_flattr_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}}s:21:\"dd_float_button_final\";a:5:{s:16:\"dd_button_fblike\";r:279;s:17:\"dd_button_twitter\";r:609;s:18:\"dd_button_linkedin\";r:784;s:17:\"dd_button_google1\";r:921;s:19:\"dd_button_pinterest\";r:1015;}}', 'yes');
INSERT INTO `wp_options` VALUES('1821', 'dd_client_version', '5', 'yes');
INSERT INTO `wp_options` VALUES('2024', '_transient_ye_video_MmMyMDQ4NDRmN2M2N2Q0ZDhkZGQxZWIwMThhMjk0N2Y2', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/1AQBZYUltq8?version=3&amp;fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Make+Acne+Scars+Disappear%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5585', '_site_transient_timeout_theme_roots', '1387266752', 'yes');
INSERT INTO `wp_options` VALUES('5586', '_site_transient_theme_roots', 'a:5:{s:18:\"headlines_enhanced\";s:7:\"/themes\";s:12:\"twentyeleven\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";s:14:\"twentythirteen\";s:7:\"/themes\";s:12:\"twentytwelve\";s:7:\"/themes\";}', 'yes');
INSERT INTO `wp_options` VALUES('1922', 'woo_disable_comments_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('2017', '_transient_timeout_ye_video_ZjcyYWZhMGI0YjIxZTE1ODg2YjgyMjFmZmQ5', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2018', '_transient_ye_video_ZjcyYWZhMGI0YjIxZTE1ODg2YjgyMjFmZmQ5OTYxN2Rl', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/uCtUI6Ot_ns?version=3&amp;fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Get+Rid+of+Acne+Scars%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2042', '_transient_ye_video_ODhhMzlhZDYwNWMyNjhhNjBjNTA2YjAxOTQ3MGU3OTRi', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g4j1BMWAGAs?version=3&amp;fs=0&amp;rel=0&amp;title=Nutritional+Supplements+%3A+Benefits+of+Vitamin+E+Oil%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3046', 'logged_in_key', 'lWrQ$2u<[7uCnwcASz~o#LP>H$}-MT1q)!k|b:G-{,SDC{,%vo,2`(PlhlnP1w/Q', 'yes');
INSERT INTO `wp_options` VALUES('3044', 'auth_key', '-NJt7|~>6L12<P@UW6O5^:2[.Y3|>72(22kd@XxA&pquGcReW:QO@Y;}&DfM$=l_', 'yes');
INSERT INTO `wp_options` VALUES('3048', 'nonce_key', 'G[n;]M-Vh>S{;P()jLOT.s j[G]dN#2S}0~W_>QKN:M{6tt*%j6?(q0q]GGXlig}', 'yes');
INSERT INTO `wp_options` VALUES('3110', '_transient_plugins_delete_result_22', '1', 'yes');
INSERT INTO `wp_options` VALUES('3142', '_transient_timeout_aye_video_NjFmMjdjMDg2YzBiNGEzOWQ0MjJmYTBiMzJ', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3130', '_transient_timeout_aye_video_ODA3NDgwODczNGE3M2NiZWQwNTc0Y2QxZmF', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3192', '_transient_timeout_aye_video_NjA2OGZmNjBjNWJhZjZjZGZkZjE3NDFjOWZ', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3136', '_transient_timeout_aye_video_MjM4MTI4MzkxMjhhZjI4NDZjMjUxYjFmZTE', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3137', '_transient_aye_video_MjM4MTI4MzkxMjhhZjI4NDZjMjUxYjFmZTE4ZjkzYmU', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/1AQBZYUltq8?fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Make+Acne+Scars+Disappear&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3131', '_transient_aye_video_ODA3NDgwODczNGE3M2NiZWQwNTc0Y2QxZmFmMzI2NWE', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/uCtUI6Ot_ns?fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Get+Rid+of+Acne+Scars&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3148', '_transient_timeout_aye_video_MjQ4YTMyZWI4NWZmZDY2NTUyNGU4NDczN2U', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3149', '_transient_aye_video_MjQ4YTMyZWI4NWZmZDY2NTUyNGU4NDczN2UwNzBhMmU', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/qiIZJJ9l5ZU?fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Make+Scars+Go+Away&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3154', '_transient_timeout_aye_video_MmRhNmZjZGM5YWQyZTkxOTVlMjVlMmMwNTY', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3155', '_transient_aye_video_MmRhNmZjZGM5YWQyZTkxOTVlMjVlMmMwNTY3YzU2NzY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g4j1BMWAGAs?fs=0&amp;rel=0&amp;title=Nutritional+Supplements+%3A+Benefits+of+Vitamin+E+Oil&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3193', '_transient_aye_video_NjA2OGZmNjBjNWJhZjZjZGZkZjE3NDFjOWZhOTdkYWY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/pGZHNqP8WnY?fs=0&amp;rel=0&amp;title=Clickbank+Tutorial&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3198', '_transient_timeout_aye_video_ZWJjNDVhMmNmOTYxYjBlMGE3Yzc2NDczNzB', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3199', '_transient_aye_video_ZWJjNDVhMmNmOTYxYjBlMGE3Yzc2NDczNzBiY2Q0NGJ', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vAMRXJj5J_A?fs=0&amp;rel=0&amp;title=ClickBank+Tutorial+2011+%7C+Use+This+To+Pick+The+Most+Profitable+Product+From+ClickBank+MarketPlace&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3204', '_transient_timeout_aye_video_MDk1YzY0YmNhZjQ2MGFjMzMwM2M3ZjQzMzd', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3205', '_transient_aye_video_MDk1YzY0YmNhZjQ2MGFjMzMwM2M3ZjQzMzdkNTBkYzY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/53Zx_n4hgK0?fs=0&amp;rel=0&amp;title=ClickBank+Tools+Tutorial+Tips+%7C+Use+This+FREE+ClickBank+Marketplace+Tool+To+Boost+Your+Commission&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3210', '_transient_timeout_aye_video_ZjY5ZTNmNzE2ZmMyZTdjZjU0Mjc0ODY5YjR', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3211', '_transient_aye_video_ZjY5ZTNmNzE2ZmMyZTdjZjU0Mjc0ODY5YjRlYmQ5MWJ', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/SAVV-ZrlWeI?fs=0&amp;rel=0&amp;title=Clickbank+Tutorial&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3216', '_transient_timeout_aye_video_MzQ2ZWY0NGFlYTgzYmE5NTI2MDNkOWNlMTg', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3217', '_transient_aye_video_MzQ2ZWY0NGFlYTgzYmE5NTI2MDNkOWNlMTgxMjQ5Njg', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/cSUiqwcHKRw?fs=0&amp;rel=0&amp;title=Youtube+Clickbank+Tutorial+-+Follow+All+Guide+in+Video+To+Make+Big+Money+in+Clickbank&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3822', 'link_manager_enabled', '1', 'yes');
INSERT INTO `wp_options` VALUES('4917', '_site_transient_update_themes', 'O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1387264952;s:7:\"checked\";a:5:{s:18:\"headlines_enhanced\";s:5:\"3.2.6\";s:12:\"twentyeleven\";s:3:\"1.7\";s:14:\"twentyfourteen\";s:3:\"1.0\";s:14:\"twentythirteen\";s:3:\"1.1\";s:12:\"twentytwelve\";s:3:\"1.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('5458', '_site_transient_update_plugins', 'O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1387264952;s:7:\"checked\";a:26:{s:26:\"secure-wordpress/index.php\";s:5:\"3.0.1\";s:35:\"ad-codez-widget/ad-codes-widget.php\";s:6:\"110709\";s:39:\"ad-squares-widget/ad-squares-widget.php\";s:6:\"110709\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:3:\"2.1\";s:27:\"backupbuddy/backupbuddy.php\";s:6:\"2.2.33\";s:39:\"bad-behavior/bad-behavior-wordpress.php\";s:6:\"2.2.14\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:3:\"3.6\";s:46:\"custom-post-template/custom-post-templates.php\";s:3:\"1.5\";s:39:\"sitemap-generator/sitemap-generator.php\";s:4:\"3.15\";s:23:\"digg-digg/digg-digg.php\";s:5:\"5.3.6\";s:43:\"easy-privacy-policy/easy-privacy-policy.php\";s:4:\"1.02\";s:36:\"google-sitemap-generator/sitemap.php\";s:3:\"3.4\";s:9:\"hello.php\";s:3:\"1.6\";s:32:\"login-lockdown/loginlockdown.php\";s:4:\"v1.5\";s:22:\"obox-mobile/mobile.php\";s:5:\"1.1.7\";s:27:\"pretty-link/pretty-link.php\";s:5:\"1.6.5\";s:31:\"quick-adsense/quick-adsense.php\";s:5:\"1.9.2\";s:35:\"simply-show-ids/simply-show-ids.php\";s:5:\"1.3.3\";s:23:\"slideshow/slideshow.php\";s:6:\"1.0.45\";s:30:\"smart-youtube/smartyoutube.php\";s:5:\"4.2.1\";s:25:\"sucuri-scanner/sucuri.php\";s:5:\"1.5.2\";s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";s:4:\"1.53\";s:31:\"youtube-embed/youtube-embed.php\";s:3:\"3.1\";s:25:\"wp-cumulus/wp-cumulus.php\";s:4:\"1.23\";s:27:\"wp-pagenavi/wp-pagenavi.php\";s:4:\"2.83\";s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";s:5:\"1.6.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('5597', '_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c', '1387338395', 'no');
INSERT INTO `wp_options` VALUES('5598', '_transient_feed_867bd5c64f85878d03a060509cd2f92c', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"WordPress.tv: Chris Van Patten: The Code Is Written: Now What?\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=26075\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.tv/2013/12/17/chris-van-patten-the-code-is-written-now-what/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:677:\"<div id=\"v-7ooEjg9X-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/26075/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/26075/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=26075&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/17/chris-van-patten-the-code-is-written-now-what/\"><img alt=\"Chris Van Patten: The Code Is Written: Now What?\" src=\"http://videos.videopress.com/7ooEjg9X/video-2229799521_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Dec 2013 14:56:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WordPress.tv: Ujwal Thapa: WordPress As A Blogging Platform\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=26761\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"http://wordpress.tv/2013/12/17/ujwal-thapa-wordpress-as-a-blogging-platform/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:673:\"<div id=\"v-wwl4y5zP-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/26761/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/26761/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=26761&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/17/ujwal-thapa-wordpress-as-a-blogging-platform/\"><img alt=\"Ujwal Thapa: WordPress As A Blogging Platform\" src=\"http://videos.videopress.com/wwl4y5zP/video-490e934315_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Dec 2013 14:51:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: BuddyPress 1.9 “Sammy” Released With New Notifications Component\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12892\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://www.wptavern.com/buddypress-1-9-sammy-released-with-new-notifications-component\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4559:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sammys.png\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sammys.png?resize=296%2C300\" alt=\"sammys\" class=\"alignright size-medium wp-image-13360\" /></a>BuddyPress 1.9 was <a href=\"http://buddypress.org/2013/12/buddypress-1-9-sammy/\" target=\"_blank\">released</a> to the world today thanks to many volunteer contributors who worked hard to make it happen. This release pays tribute to Sammy&#8217;s Pizza in Providence, Rhode Island, where lead developer John James Jacoby has enjoyed many fine pizza pies.</p>\n<p>Here&#8217;s a quick tour of the three main highlights of this release.</p>\n<h3>New Notifications Component</h3>\n<p>BuddyPress is introducing a new component for the first time in two years. The 1.9 release has moved notifications to its own component so that they&#8217;re all centralized in one place.<span id=\"more-12892\"></span></p>\n<div id=\"attachment_13294\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/notifications.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/notifications.jpg?resize=560%2C432\" alt=\"BuddyPress Notifications\" class=\"size-full wp-image-13294\" /></a><p class=\"wp-caption-text\">BuddyPress Notifications</p></div>\n<p>Notifications also have an improved API in 1.9 so that developers can easily tie their extensions into them. </p>\n<h3>Dynamic Menu Items</h3>\n<p>BuddyPress site admins will be thrilled to find that 1.9 includes <a href=\"http://www.wptavern.com/buddypress-1-9-will-include-dynamic-menu-links\" target=\"_blank\">dynamic menu links</a>. It&#8217;s now easier than ever to build menus with dynamic links such as &#8220;My Profile&#8221; or &#8220;Settings&#8221; that are specific to logged-in users. Dynamic menu items are separated into logged-in and logged-out user links. </p>\n<div id=\"attachment_9961\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/bp-menus.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/10/bp-menus.jpg?resize=560%2C547\" alt=\"Dynamic BuddyPress Menus\" class=\"size-full wp-image-9961\" /></a><p class=\"wp-caption-text\">Dynamic BuddyPress Menus</p></div>\n<p>If you previously used a plugin to generate dynamic menu items, you can now delete it and use the built-in BuddyPress links at <strong>Dashboard > Appearance > Menus</strong>.</p>\n<h3>New Widgets</h3>\n<p>BuddyPress 1.9 introduces three new core widgets to help you customize your social network:</p>\n<p><div id=\"attachment_13296\" class=\"wp-caption alignright\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/friends-widget.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/friends-widget.jpg?resize=225%2C274\" alt=\"Friends Widget\" class=\"size-full wp-image-13296\" /></a><p class=\"wp-caption-text\">Friends Widget</p></div>\n<ul>\n<li><strong>Friends Widget:</strong> A list of recently active, popular and newest friends of the displayed member.</li>\n<li><strong>Log In Widget:</strong> Adds a simple “Log In” form and/or &#8220;Log Out&#8221; link</li>\n<li><strong>Sitewide Notices Widget:</strong> Displays Sitewide Notices from the Private Messaging component.</li>\n</ul>\n<h4>Developer Goodies</h4>\n<p>BuddyPress 1.9 reinstates the bp_redirect_canonical() functionality. phpDoc inline documentation has been improved as well as compatibility with the develop.svn.wordpress.org unit-test suite. </p>\n<p>On top of all that, the <a href=\"http://www.wptavern.com/buddypress-codex-completely-revamped-with-new-design-tutorials-and-guides\" target=\"_blank\">BuddyPress Codex has been completely revamped</a> with a design refresh and loads of new tutorials and guides.</p>\n<p>The BuddyPress core team is already cooking up new ideas for the 2.0 release but will take some time off for the holidays before getting started. The team will be sending out a brief questionnaire after the beginning of the new year to get community input before setting the goals for BuddyPress 2.0. If you&#8217;re keen on shaping the future of BuddyPress, watch for that questionnaire and make sure to voice your opinion. In the meantime, enjoy all the <a href=\"http://codex.buddypress.org/developer/releases/version-1-9/\" target=\"_blank\">new goodies packaged into 1.9</a>. It&#8217;s already fully compatible with WordPress 3.8 so you&#8217;re safe to upgrade to the very latest.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Dec 2013 05:47:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"BuddyPress: BuddyPress 1.9 “Sammy”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=175601\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"http://buddypress.org/2013/12/buddypress-1-9-sammy/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:6622:\"<p>Today the BuddyPress team is excited to announce the release of BuddyPress 1.9 &#8220;Sammy&#8221;.</p>\n<h3>What&#8217;s new in 1.9</h3>\n<p><em>Notifications</em></p>\n<p>BuddyPress has always come packaged with the ability to alert members of relevant goings-on. Things like friend requests, private messages, and group invitations, have been routed through a very simple core process that alerts members via email and a bubble in the top toolbar area. In BuddyPress 1.9, Notifications graduates to a full component, complete with a user interface for seeing past notifications, an improved API for developers to interface with them, and lays the foundation for future improvements and integrations to this functionality.</p>\n<p><em>Navigation Integration</em></p>\n<p>Since WordPress 3.0, site administrators have been able to easily create and manage the navigational elements of their sites, and until now, BuddyPress&#8217;s components have been unavailable as options. In BuddyPress 1.9, we&#8217;re introducing context aware navigation menu items that are only available for either logged in or logged out users, allowing your menus to dynamically adjust for your members. We think this is really cool, and is a feature that will really help integrate BuddyPress into existing installations.</p>\n<p><em>Widgets</em></p>\n<p>We&#8217;ve added a few more widgets to help connect your community to the rest of your site:</p>\n<ul>\n<li>Friends Widget: a list of recently active, popular, and newest friends of the displayed member.</li>\n<li>Log In Widget: adds a simple “Log In” form to your site.</li>\n<li>Sitewide Notices Widget: display Sitewide Notices from the Private Messaging component.</li>\n</ul>\n<p><em>Developer Bits</em></p>\n<p>BuddyPress 1.9 includes improvements to make it easier to develop plugins and themes for BuddyPress:</p>\n<ul>\n<li>Improved inline documentation for developers that are crazy enough to go snooping through the code.</li>\n<li>Improved compatibility with develop.svn.wordpress.org unit-test suite</li>\n<li>We&#8217;ve brought back <code>bp_redirect_canonical()</code> for helping redirect to top level/default members sections.</li>\n</ul>\n<h3>Sammy&#8217;s Pizza</h3>\n<p>On the east side of Providence, Rhode Island, U.S.A, on historic Hope St. just a few blocks north of Brown University, sat Sammy&#8217;s Pizza, home to one of the most delicious pizzas I&#8217;ve ever tasted. Sammy&#8217;s was my neighborhood hangout for the 2 years I spent in Providence, and not a day went by I didn&#8217;t stop in and at least say hello. The owner expanded into the next-door property and transformed Sammy&#8217;s into a gorgeous restaurant now known as The Kitchen Bar, where Sammy still continues baking the best pies in New England (in my opinion, anyways.) BuddyPress 1.9 is named &#8220;Sammy&#8221; in honor and memory of the great times I spent with some of my favorite people, eating my favorite foods, in one of my favorite places. If you happen to be in the area, stop in and tell Sammy I say hello!</p>\n<h3>Kudos</h3>\n<p>BuddyPress wouldn&#8217;t be what it is without the continued efforts of a volunteer staff of contributors. If it&#8217;s development, design, wireframes, UI, UX, you name it, these people helped make it happen for BuddyPress 1.9:</p>\n<p><a href=\"http://profiles.wordpress.org/AliMH/\">AliMH</a>, <a href=\"http://profiles.wordpress.org/asakurayoh/\">asakurayoh</a>, <a href=\"http://profiles.wordpress.org/boonebgorges/\">boonebgorges</a>, <a href=\"http://profiles.wordpress.org/burakali/\">burakali</a>, <a href=\"http://profiles.wordpress.org/dcavins/\">dcavins</a>, <a href=\"http://profiles.wordpress.org/ddean/\">ddean</a>, <a href=\"http://profiles.wordpress.org/DennisSmolek/\">DennisSmolek</a>, <a href=\"http://profiles.wordpress.org/dimensionmedia/\">dimensionmedia</a>, <a href=\"http://profiles.wordpress.org/djpaul/\">DJPaul</a>, <a href=\"http://profiles.wordpress.org/dtc7240/\">dtc7240</a>, <a href=\"http://profiles.wordpress.org/ericlewis/\">ericlewis</a>, <a href=\"http://profiles.wordpress.org/gametako/\">gametako</a>, <a href=\"http://profiles.wordpress.org/geoffroycochard/\">geoffroycochard</a>, <a href=\"http://profiles.wordpress.org/graham-washbrook/\">graha washbrook</a>, <a href=\"http://profiles.wordpress.org/hanni/\">hanni</a>, <a href=\"http://profiles.wordpress.org/haykayltduk/\">haykayltduk</a>, <a href=\"http://profiles.wordpress.org/henrywright/\">henrywright</a>, <a href=\"http://profiles.wordpress.org/hnla/\">hnla</a>, <a href=\"http://profiles.wordpress.org/imath/\">imath</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby/\">johnjamesjacoby</a>, <a href=\"http://profiles.wordpress.org/jessjurick/\">jessjurick</a>, <a href=\"http://profiles.wordpress.org/lenasterg/\">lenasterg</a>, <a href=\"http://profiles.wordpress.org/mboynes/\">mboynes</a>, <a href=\"http://profiles.wordpress.org/megainfo/\">megainfo</a>, <a href=\"http://profiles.wordpress.org/Mike_Cowobo/\">Mike_Cowobo</a>, <a href=\"http://profiles.wordpress.org/modemlooper/\">modemlooper</a>, <a href=\"http://profiles.wordpress.org/olivM/\">olivM</a>, <a href=\"http://profiles.wordpress.org/needle/\">needle</a>, <a href=\"http://profiles.wordpress.org/netweblogic/\">netweblogic</a>, <a href=\"http://profiles.wordpress.org/r-a-y/\">r-a-y</a>, <a href=\"http://profiles.wordpress.org/ryderlewis/\">ryderlewis</a>, <a href=\"http://profiles.wordpress.org/sbrajesh/\">sbrajesh</a>, <a href=\"http://profiles.wordpress.org/sgr33n/\">sgr33n</a>, <a href=\"http://profiles.wordpress.org/sooskriszta/\">sooskriszta</a>, <a href=\"http://profiles.wordpress.org/terraling/\">terraling</a>, <a href=\"http://profiles.wordpress.org/tomdxw/\">tomdxw</a>, <a href=\"http://profiles.wordpress.org/trishasalas/\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/vhauri/\">vhauri</a>, <a href=\"http://profiles.wordpress.org/williamsba1/\">williamsba1</a>, <a href=\"http://profiles.wordpress.org/wpdennis/\">wpdennis</a></p>\n<h3>Fin</h3>\n<p>This release cycle, significant effort has gone into improving our documentation. The <a href=\"http://codex.buddypress.org\">BuddyPress Codex</a> is the place to get answers about how things work, how to extend the codebase, and to learn a bit about the history of the project. If you think you&#8217;ve found a bug, or want to help improve the software, head over to <a href=\"http://buddypress.trac.wordpress.org\">buddypress.trac.wordpress.org</a> and lend a hand.</p>\n<p>Download BuddyPress 1.9 &#8220;Sammy&#8221; today from the <a href=\"http://wordpress.org/extend/plugins/buddypress\">wordpress.org plugin repository</a>, or from your WordPress Dashboard.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Dec 2013 05:21:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"John James Jacoby\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"WPTavern: WPSessions To Give Away 12 Full Year Scholarships\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13351\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://www.wptavern.com/wpsessions-to-give-away-12-full-year-scholarships\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1946:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPSessionsLogo.png\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/06/WPSessionsLogo.png?resize=316%2C77\" alt=\"WPSessions Logo\" class=\"aligncenter size-full wp-image-7588\" /></a></p>\n<p>Brian Richards <a href=\"http://wpsessions.com/12-days/\" title=\"http://wpsessions.com/12-days/\">has announced</a> that he is giving away 12 full year scholarships. Winners will be given access to every new session published in 2014. According to Brian, that&#8217;s at least $360 in live, personal training. Winners are chosen every day at 12PM Eastern Time. To enter the drawing, you&#8217;ll need to tell Brian how the scholarship will benefit you or someone you know.<span id=\"more-13351\"></span></p>\n<blockquote><p>I want to hear about why you (or someone you know) would benefit from a full-year scholarship to WPSessions.com. What do you want to learn? How will you put this knowledge to use? What more can you do with another year of steady and continued growth under your belt? Tell me all this and more in a <a href=\"http://wpsessions.com/12-days/\" title=\"http://wpsessions.com/12-days/\">comment on this post</a>, and if I like your story you get the next 12 months of sessions for free.</p></blockquote>\n<p>WPSessions.com provides monthly, high quality presentations from experts in the WordPress community. Every presentation is broadcast live to viewers around the web and recorded for indefinite long-term viewing. Each session focuses on a single topic, bringing together 3 different presenters to discuss the topic’s many facets at an extremely low-cost per event. To learn more about Brian Richards and what WPSessions is all about, <a href=\"http://www.wptavern.com/introducing-wpsessions-by-brian-richards\" title=\"http://www.wptavern.com/introducing-wpsessions-by-brian-richards\">check out this interview</a> from June of 2013. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 23:25:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: Speed Up WordPress By Using the WordPress.com CDN for Javascript Files\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13319\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://www.wptavern.com/speed-up-wordpress-by-using-the-wordpress-com-cdn-for-javascript-files\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3969:\"<p><div id=\"attachment_13339\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/large_7608382028.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/large_7608382028.jpg?resize=560%2C186\" alt=\"speed\" class=\"size-full wp-image-13339\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/tcmorgan/7608382028/\">Tc Morgan</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-sa/2.0/\">cc</a></p></div>Here&#8217;s a quick performance tip for self-hosted WordPress sites. WordPress loads a number of scripts from its /wp-includes/ directory, depending on what you have active on your site. <a href=\"http://wordpress.org/plugins/use-wpcom-libraries/\" target=\"_blank\">Use WordPress.com Libraries</a> is a new plugin, created by Automattician and plugin developer <a href=\"https://twitter.com/benlobaugh\" target=\"_blank\">Ben Lobaugh</a>. Once installed, it automatically switches the URL on built-in WordPress Javascript files to serve them from the WordPress.com CDN instead. Rather than taxing your local server, you offload those requests to WordPress.com, thereby decreasing load time and bandwidth consumption. <span id=\"more-13319\"></span></p>\n<p>Here&#8217;s a quick sample of a site&#8217;s scripts before installing the plugin:</p>\n<pre class=\"brush: xml; title: ; notranslate\">&lt;script type=\'text/javascript\' src=\'http://example.com/wp-includes/js/jquery/jquery.js?ver=1.10.2\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://example.com/wp-includes/js/jquery/jquery-migrate.min.js?ver=1.2.1\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://example.com/wp-includes/js/jquery/ui/jquery.ui.core.min.js?ver=1.10.3\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://example.com/wp-includes/js/jquery/ui/jquery.ui.widget.min.js?ver=1.10.3\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://example.comm/wp-includes/js/jquery/ui/jquery.ui.tabs.min.js?ver=1.10.3\'&gt;&lt;/script&gt;</pre>\n<p>The plugin automatically changes the script URLs in use to call the ones hosted on WordPress.com:</p>\n<pre class=\"brush: xml; title: ; notranslate\">&lt;script type=\'text/javascript\' src=\'http://wordpress.com/wp-includes/js/jquery/jquery.js?ver=1.10.2\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://wordpress.com/wp-includes/js/jquery/jquery-migrate.min.js?ver=1.2.1\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://wordpress.com/wp-includes/js/jquery/ui/jquery.ui.core.min.js?ver=1.10.3\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://wordpress.com/wp-includes/js/jquery/ui/jquery.ui.widget.min.js?ver=1.10.3\'&gt;&lt;/script&gt;\n&lt;script type=\'text/javascript\' src=\'http://wordpress.com/wp-includes/js/jquery/ui/jquery.ui.tabs.min.js?ver=1.10.3\'&gt;&lt;/script&gt;</pre>\n<p>Don&#8217;t look for a settings panel, as it doesn&#8217;t come with any options. You simply install the plugin, activate it and you&#8217;re good to go. Everything happens automatically in the background. <strong>As a general warning, make sure to check through your site after installing this in case anything has broken.</strong> In my tests everything worked fine but if you&#8217;re running an older version of WordPress, it may not work predictably. The plugin is still in development and will likely receive updates to improve it over time.</p>\n<p>It&#8217;s tough to say how much of a performance boost you&#8217;ll get and how much bandwidth you&#8217;ll save by installing this plugin, because it depends on which scripts you have active on your website and how heavy your traffic is. However, every small bit helps, especially if you&#8217;re not already using a CDN. Install the <a href=\"http://wordpress.org/plugins/use-wpcom-libraries/\" target=\"_blank\">Use WordPress.com Libraries</a> plugin for free from the WordPress plugin directory.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 22:15:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: o2 WordPress Plugin Expected To Be Available In Early 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13244\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://www.wptavern.com/o2-wordpress-plugin-expected-to-be-available-in-early-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4134:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/o2SiteLogo.jpg\" rel=\"thumbnail\"><img class=\"aligncenter size-large wp-image-13316\" alt=\"o2 Site Logo\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/o2SiteLogo.jpg?resize=500%2C109\" /></a></p>\n<p>In 2008, Automattic created a WordPress theme entitled <a title=\"http://theme.wordpress.com/retired/prologue/\" href=\"http://theme.wordpress.com/retired/prologue/\">Prologue</a>. A year after its launch, Automattic released <a title=\"http://p2theme.com/\" href=\"http://p2theme.com/\">P2</a> to take the place of Prologue. P2 was a revolutionary theme as it enabled communication to happen in near real-time and arranged comments so that they were equally as important as blog posts. From 2009 to 2013, P2 handled <strong>80%</strong> of the communication that took place within the company. Earlier this year at WordCamp San Francisco, Beau Lebens who works at Automattic announced the successor to P2. It won&#8217;t be a theme. Instead, it will be a plugin entitled <a title=\"http://geto2.com/\" href=\"http://geto2.com/\">o2</a>. <span id=\"more-13244\"></span></p>\n<p>o2 is named after the section of the <a title=\"http://ma.tt/2011/09/automattic-creed/\" href=\"http://ma.tt/2011/09/automattic-creed/\">Automattic creed</a> that states &#8220;<em>I will communicate as much as possible, because it’s the oxygen of a distributed company</em>&#8220;. o2 was built from the ground up around the idea that communication is oxygen. In this light, the features of o2 make total sense:</p>\n<ul>\n<li>Intended to be used within a network</li>\n<li>Focused on the client side or frontend</li>\n<li>Native infinite scroll</li>\n<li>Improved real time commenting</li>\n<li>Cross-site Search (Search multiple o2 instances within a network)</li>\n<li>Cross-posting (Post on more than one o2 site at the same time)</li>\n<li>Keyword + Name Notifications</li>\n<li>Shared Tags</li>\n<li>Email Integration (Post and comment by email)</li>\n<li>Drag and drop media uploading</li>\n<li>Jetpack Integration</li>\n</ul>\n<p>While o2 is a plugin it will ship with a default theme called <strong>Breathe</strong> based on the <a title=\"http://underscores.me/\" href=\"http://underscores.me/\">Underscores starter theme</a>. o2 is being built as a platform so developers will be able to create plugins and themes to extend its capabilities.</p>\n<h3>The Progress Of o2</h3>\n<p>One of the downsides to o2 is that it will initially not contain any of the network functionality that was mentioned in <a href=\"http://wordpress.tv/2013/08/08/beau-lebens-taking-wordpress-to-the-front-end-with-o2/\" title=\"http://wordpress.tv/2013/08/08/beau-lebens-taking-wordpress-to-the-front-end-with-o2/\">Beau Lebens WordCamp</a> session. When I asked Beau to clarify, he responded:</p>\n<blockquote><p>The initial version is not using websockets, but the AJAX polling is much more efficient and reliable (and accurate) than it ever was in P2.</p>\n<p>We&#8217;ll still be playing with websockets at some point, but it hasn&#8217;t proven to be critical to making a great experience thus far, so we&#8217;ve pushed it back a bit as a priority. Instead, the commenting system will be an up to date version of P2 which gives us a better foundation to work on top of.</p></blockquote>\n<p>The initial announcement was on August 8th, 2013 but o2 has yet to be released. I reached out to Beau Lebens to get a status update on the project and asked when we might see it become available for public use. He told me that the team is very close to starting a controlled beta or alpha on WordPress.com. Testing will continue into the new year. Once the initial testing program concludes, we&#8217;ll likely see something made available for self installed WordPress users. We can expect this to happen sometime around <strong>February or March of 2014</strong>. Beau Lebens points out that these release dates are very rough estimates, and it depends largely on how things go with the initial trial group.</p>\n<h3>Watch Beau Lebens at WordCamp San Francisco 2013 Announce The o2 Plugin</h3>\n<div class=\"align center\"></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 21:35:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: PrettyPress Plugin Reinvents WordPress Post Editing With Live Preview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13267\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://www.wptavern.com/prettypress-plugin-reinvents-wordpress-post-editing-with-live-preview\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2501:\"<p>The WordPress post editing experience is one of the next major features that will be evolving to meet the needs of modern publishers. We don&#8217;t know what that&#8217;s going to look like yet, but there&#8217;s a trend emerging where everyone is taking a stab at re-imagining the post editor. <a href=\"http://www.wptavern.com/splitdown-a-free-ghost-style-markdown-editor-for-wordpress\" target=\"_blank\">Free</a> and<a href=\"http://www.wptavern.com/barley-for-wordpress-a-revolutionary-inline-content-editor\" target=\"_blank\"> commercial</a> plugins are popping up all over the place, each with a different take on improving the publishing experience.</p>\n<p><a href=\"http://wordpress.org/plugins/prettypress/\" title=\"PrettyPress\" target=\"_blank\">PrettyPress</a> is one that landed in the WordPress plugin repository over the weekend. The plugin offers a live front-end preview of your post while you&#8217;re typing. <span id=\"more-13267\"></span></p>\n<div id=\"attachment_13272\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/prettypress-live-preview.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/prettypress-live-preview.png?resize=560%2C288\" alt=\"PrettyPress Live Preview\" class=\"size-full wp-image-13272\" /></a><p class=\"wp-caption-text\">PrettyPress Live Preview</p></div>\n<p>Essentially, it&#8217;s a Ghost-style editor without the Markdown. You could, however, install another plugin to add Markdown capabilities.</p>\n<p>PrettyPress aims to streamline WordPress publishing by simplifying the editing layout. It removes the distraction of having to switch back and forth between the frontend and backend to preview post formatting. </p>\n<p>While testing the plugin, I appreciated the fact that it doesn&#8217;t completely take over the post/page editor. Instead, it places a &#8220;Launch PrettyPress&#8221; button in the sidebar of the editor so that users can select when to activate the side-by-side screen.</p>\n<p>The plugin uses Javascript and jQuery to create the side-by-side layout with live preview and the PrettyPress developer notes that larger posts may have some performance issues. This is one aspect of the plugin that they plan to improve in the future. If you like this style of editing experience and you want to test it out, download the <a href=\"http://wordpress.org/plugins/prettypress/\" target=\"_blank\">PrettyPress</a> plugin for free through your WordPress dashboard.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 18:35:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:23:\"Matt: Lean Startup Talk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43236\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"http://ma.tt/2013/12/lean-startup-talk/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:225:\"<p><span class=\"embed-youtube\"></span></p>\n<p>I spoke with Sarah Millstein at the Lean Startup Conference earlier in the week. After a bit of intro we talk about how Automattic iterates, approaches hiring, and management.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 17:03:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WordPress.tv: Chris Lema: You’re a Professional: How To Avoid Overshoot And Lost Profits\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=26701\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wordpress.tv/2013/12/16/chris-lema-youre-a-professional-how-to-avoid-overshoot-and-lost-profits/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:725:\"<div id=\"v-vb1tqaLq-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/26701/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/26701/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=26701&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/16/chris-lema-youre-a-professional-how-to-avoid-overshoot-and-lost-profits/\"><img alt=\"Chris Lema: You’re a Professional: How To Avoid Overshoot And Lost Profits\" src=\"http://videos.videopress.com/vb1tqaLq/video-ee6701ec6f_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 14:34:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"WordPress.tv: Ian Dunn: Implementing The MVC Pattern In WordPress Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27431\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wordpress.tv/2013/12/16/ian-dunn-implementing-the-mvc-pattern-in-wordpress-plugins/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:701:\"<div id=\"v-zeI66kyo-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27431/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27431/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27431&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/16/ian-dunn-implementing-the-mvc-pattern-in-wordpress-plugins/\"><img alt=\"Ian Dunn: Implementing The MVC Pattern In WordPress Plugins\" src=\"http://videos.videopress.com/zeI66kyo/video-aaaf5be89d_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 13:22:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Pippin Williamson: Encouraging Community Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27328\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://wordpress.tv/2013/12/15/pippin-williamson-encouraging-community-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:681:\"<div id=\"v-TuKqPfdp-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27328/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27328/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27328&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/15/pippin-williamson-encouraging-community-development/\"><img alt=\"Pippin Williamson: Encouraging Community Development\" src=\"http://videos.videopress.com/TuKqPfdp/video-92ed1936ca_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 16 Dec 2013 00:34:24 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Matt: Surveillance double-talk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43241\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"http://ma.tt/2013/12/surveillance-double-talk/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:588:\"<p>Another Sunday, <a href=\"http://www.nytimes.com/2013/12/15/us/officials-say-us-may-never-know-extent-of-snowdens-leaks.html?pagewanted=all&_r=0\">another round of stories from the Snowden files</a>. I hope people don&#8217;t become fatigued of these continuous revelations, and it leads to change. Another good read is from the Atlantic <a href=\"http://www.theatlantic.com/politics/archive/2013/12/how-americans-were-deceived-about-cell-phone-location-data/282239/\">How Americans Were Deceived About Cell-Phone Location Data</a>. Precise but misleading language is a dangerous tool.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 15 Dec 2013 23:03:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"WordPress.tv: Chip Bennett: Custom Layouts Without Using Page Templates\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27281\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"http://wordpress.tv/2013/12/15/chip-bennett-custom-layouts-without-using-page-templates-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:693:\"<div id=\"v-XBDSZ2P8-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27281/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27281/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27281&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/15/chip-bennett-custom-layouts-without-using-page-templates-2/\"><img alt=\"Chip Bennett: Custom Layouts Without Using Page Templates\" src=\"http://videos.videopress.com/XBDSZ2P8/video-343592a7f6_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 15 Dec 2013 13:42:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: WPWeekly Episode 131 – Talking Wordsesh With Chris Cochran\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13263\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://www.wptavern.com/wpweekly-episode-131-talking-wordsesh-with-chris-cochran\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3109:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/08/WordPressWeekly_albumart2.jpg?resize=150%2C150\" alt=\"WordPress Weekly Cover Art\" class=\"alignright size-thumbnail wp-image-8715\" /></a> This weeks episode features <a href=\"http://christophercochran.me/\" title=\"http://christophercochran.me/\">Chris Cochran</a>, co-organizer of <a href=\"http://wordsesh.org/\" title=\"http://wordsesh.org/\">Wordsesh</a>. In this episode, we discussed the inspiration behind the event, Wordsesh 2, what may be coming with Wordsesh 3, and much more. We also talked about the release of WordPress 3.8, covered all of the new features and gave our thoughts on the new default theme, TwentyFourteen. Last but not least, I challenge you to figure out whether the sound you hear in this episode is a baby, or a kitten. Leave your answer in the comments.<span id=\"more-13263\"></span></p>\n<h2>Stories Discussed:</h2>\n<p><a href=\"http://www.wptavern.com/wordpress-3-8-parker-released\" title=\"http://www.wptavern.com/wordpress-3-8-parker-released\">WordPress 3.8 Released</a><br />\n<a href=\"http://www.wptavern.com/get-more-admin-color-schemes-for-wordpress-3-8\" title=\"http://www.wptavern.com/get-more-admin-color-schemes-for-wordpress-3-8\">Get More Admin Color Schemes For WordPress 3.8</a><br />\n<a href=\"http://www.wptavern.com/coming-soon-an-issues-tracker-for-wordpress-documentation\" title=\"http://www.wptavern.com/coming-soon-an-issues-tracker-for-wordpress-documentation\">Coming Soon: An Issues Tracker for WordPress Documentation</a><br />\n<a href=\"http://www.wptavern.com/jetpack-2-7-introduces-google-publicize-support-and-adds-cloudup-oembed\" title=\"http://www.wptavern.com/jetpack-2-7-introduces-google-publicize-support-and-adds-cloudup-oembed\">Jetpack 2.7 Introduces Google+ Publicize Support and Adds Cloudup oEmbed</a><br />\n<a href=\"http://www.wptavern.com/envato-to-re-focus-on-community-after-earning-140m-in-2013\" title=\"http://www.wptavern.com/envato-to-re-focus-on-community-after-earning-140m-in-2013\">Envato To Re-Focus On Community After Lifetime Earnings Reach $140M</a><br />\n<a href=\"https://www.youtube.com/playlist?list=PL9bmvLB3RpG4DFZ0PCkAJbCMkn_Il06ns\" title=\"https://www.youtube.com/playlist?list=PL9bmvLB3RpG4DFZ0PCkAJbCMkn_Il06ns\">WordSesh 2 Video Playlist</a></p>\n<h2>WPWeekly Meta:</h2>\n<p><strong>Next Episode:</strong> Friday, December 20th 3 P.M. Eastern &#8211; Special Guest Chris Lema</p>\n<p><strong>Subscribe To WPWeekly Via Itunes: </strong><a href=\"https://itunes.apple.com/us/podcast/wordpress-weekly/id694849738\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via RSS: </strong><a href=\"http://www.wptavern.com/feed/podcast\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Subscribe To WPWeekly Via Stitcher Radio: </strong><a href=\"http://www.stitcher.com/podcast/wordpress-weekly-podcast?refid=stpr\" target=\"_blank\">Click here to subscribe</a></p>\n<p><strong>Listen To Episode #131:</strong><br />\n</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 15 Dec 2013 08:55:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:106:\"WordPress.tv: Matthew Russo: The Money Is In The Details: How I Raised $27,780 In 3 Months Using WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27238\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:120:\"http://wordpress.tv/2013/12/14/matthew-russo-the-money-is-in-the-details-how-i-raised-27780-in-3-months-using-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:758:\"<div id=\"v-NdSLTqYd-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27238/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27238/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27238&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/14/matthew-russo-the-money-is-in-the-details-how-i-raised-27780-in-3-months-using-wordpress/\"><img alt=\"Matthew Russo: The Money Is In The Details: How I Raised $27,780 In 3 Months Using WordPress\" src=\"http://videos.videopress.com/NdSLTqYd/video-9d9ef408ca_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 14 Dec 2013 18:26:29 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"WordPress.tv: Angie Meeker: WordPress For Startups\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27292\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://wordpress.tv/2013/12/14/angie-meeker-wordpress-for-startups/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:655:\"<div id=\"v-WxmHeBiv-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27292/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27292/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27292&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/14/angie-meeker-wordpress-for-startups/\"><img alt=\"Angie Meeker: WordPress For Startups\" src=\"http://videos.videopress.com/WxmHeBiv/video-f274e157bc_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 14 Dec 2013 15:53:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"BuddyPress: BuddyPress.org updated to WordPress 3.8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://buddypress.org/?p=175498\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://buddypress.org/2013/12/buddypress-org-updated-to-wordpress-3-8/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:388:\"<p>A quick note that BuddyPress.org has been updated to WordPress 3.8. Also, BuddyPress 1.8 is fully compatible with the latest and greatest version of WordPress, so you can safely update knowing that BuddyPress will cooperate completely.</p>\n<p>We&#8217;ve also updated BuddyPress.org to run what will be BuddyPress 1.9, which we&#8217;re preparing to release on Monday, December 16.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 21:13:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"John James Jacoby\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WordPress.tv: Jesse Petersen: Building Greater Profits Into Your WordPress Business\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=24105\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wordpress.tv/2013/12/13/jesse-petersen-building-greater-profits-into-your-wordpress-business/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:721:\"<div id=\"v-OYCOeZeZ-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/24105/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/24105/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=24105&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/13/jesse-petersen-building-greater-profits-into-your-wordpress-business/\"><img alt=\"Jesse Petersen: Building Greater Profits Into Your WordPress Business\" src=\"http://videos.videopress.com/OYCOeZeZ/video-169a0e013b_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 20:56:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: How to Use the British English Translation of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13247\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://www.wptavern.com/how-to-use-the-british-english-translation-of-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2392:\"<p>If you want to use WordPress in the Queen’s English, you&#8217;re in luck. There&#8217;s an <a href=\"http://en-gb.wordpress.org/\" target=\"_blank\">en-gb translation</a> and it&#8217;s been updated for WordPress 3.8. With the new admin design, British English WordPress installs will spell words like &#8220;colour&#8221; and &#8220;customise&#8221; in the proper English style.</p>\n<div id=\"attachment_13249\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/en-gb-colours.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/en-gb-colours.png?resize=466%2C303\" alt=\"en-gb Translation\" class=\"size-full wp-image-13249\" /></a><p class=\"wp-caption-text\">en_gb Translation</p></div>\n<p>The easiest way to get an installation that uses proper English is to download the full package from the <a href=\"http://en-gb.wordpress.org/\" target=\"_blank\">en_GB WordPress homepage</a>. This download offers the latest version of WordPress with the British translation files already in place and referenced in <em>wp-config.php</em>. Please note that installing this entire zip package is only useful if you&#8217;re starting from scratch.<span id=\"more-13247\"></span></p>\n<h3>How to Manually Add Translation Files for an Existing Site</h3>\n<p>If you have an existing site where you&#8217;d like to add British translation files, here&#8217;s how:</p>\n<p><strong>Step 1.</strong> Download the British English .mo language file from the en_GB homepage. You can pull this out of the /languages/ folder in the package. As a bonus, if you&#8217;re using Twenty Fourteen, you can also find a theme translation within this folder. </p>\n<p><strong>Step 2.</strong> Create a new directory under wp-content called languages:  <strong>/wp-content/languages/</strong></p>\n<p><strong>Step 3.</strong> Upload the en_GB.mo file to the languages directory.</p>\n<p><strong>Step 4.</strong> Add this line to your <em>wp-config.php</em> file in the languages section: </p>\n<pre>define(\'WPLANG\', \'en_GB\');</pre>\n<p>Save your changes to <em>wp-config.php</em> and upload it to your server. You should now have proper English displayed throughout your installation.</p>\n<p>Note that this same process applies to any other language files as well. Hopefully, this small courtesy will bring some cheer to our friends across the pond!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 19:54:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"WPTavern: Help Build CF Community: A Social Network for People with Cystic Fibrosis\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12941\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://www.wptavern.com/help-build-cf-community-a-social-network-for-people-with-cystic-fibrosis\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:13233:\"<p>Imagine being born with a genetic disease that causes your lungs to fill, making it hard, sometimes impossible, to breathe. Imagine being susceptible to lung infections and a shorter life expectancy than everyone else. Imagine coughing attacks, feeling as though you&#8217;re drowning, regular hospital stays, and the fear of an uncertain future.</p>\n<p>Now imagine that thousands of others also share this genetic disease but you won&#8217;t ever be able to meet with them in person. You won&#8217;t be able to get together to share stories, a shoulder, a helping hand, a hug, or build a community of support and encouragement.<span id=\"more-12941\"></span></p>\n<p>This is the reality for those living with cystic fibrosis. People with CF are not allowed to have contact with one another. Because of a high susceptibility to lung infections, they can easily infect each other just by hanging out. Highly resistant bacteria can be shared between those with CF that can lead to serious declines in lung function and more vicious illnesses that are harder to treat, ultimately reducing life expectancy.</p>\n<p>This is the issue being tackled by BuddyPress developer, consultant and community builder Bowe Frankema. Bowe lives with cystic fibrosis and has mounted a campaign to create a social network dedicated to bringing this community together virtually, since they cannot meet together in person. </p>\n<p></p>\n<p>We were able to catch up with Bowe and ask him some questions about this project, CFCommunity.net, what it will mean for the cystic fibrosis community, the technology behind it, and what the open source community has meant to him personally. </p>\n<p><strong>Tavern:</strong><em> When did it occur to you that BuddyPress and WordPress would be a perfect fit for the CF Community?</em></p>\n<p><strong>Bowe:</strong> The first time I visited the BuddyPress Community forums back in 2009. I already tried out BuddyPress, but wasn’t sure if it could do the job. The software was still in it’s early days and the learning curve was through the roof! I did have experience in web development and community building so I got just enough of it, to dive in deeper. </p>\n<p>I visited the support forums to ask some questions, and was blown away by the community there. <span class=\"pullquote alignleft\">Seeing this group of people working together to create software that was free for anyone to use, baffled me. Where was the catch? Why were these people doing this for free? </span></p>\n<p>BuddyPress introduced me to the concept of Open Source and working together on creating something that benefits everyone. As soon as I “got” it I never looked back and knew that I wanted to build CFCommunity on WordPress/BuddyPress. </p>\n<p><strong>Tavern:</strong> <em>Will you be building / designing the site yourself? Or will you be getting a team to help you?</em></p>\n<p><strong>Bowe:</strong> This is definitely a team effort. It’s funny that I’m able to type that with so much confidence, because it took me a long time to get to this point. I had the crazy idea that a non-profit project could be developed, managed and funded by this one guy, who also happens to have CF and can’t even work full time. It’s funny how your ambitions can make you set these unrealistic goals. As soon as I started talking about CFCommunity to my friends, they had these amazing ideas on how to make it happen. </p>\n<p>Registering as an official cause, doing a crowdfunding campaign and helping getting the word out, it’s all done with the help of the input of my friends. Especially Mason and Siobhan have been great friends and mentors! </p>\n<p>If we reach our goal we’ll be starting the development fairly soon. We’re still looking for a BuddyPress/WordPress plugin developer and someone who’s experienced with WP/BP Theme Development. </p>\n<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/registration.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/registration.jpg?resize=560%2C212\" alt=\"registration\" class=\"aligncenter size-full wp-image-13236\" /></a></p>\n<p>Besides the geek stuff there’s a lot of work we need to put in building the community. Translations, finding moderators, writing quality copy and getting the word out. It’s going to be fun :-)</p>\n<p><strong>Tavern:</strong> <em>What kinds of new plugins will you need to create to serve the CF community specifically?</em></p>\n<p><strong>Bowe:</strong> We have a few very specific plugins in mind that we’d like to develop for the community. Here’s some of them:</p>\n<p><em>I’m in the hospital :-(</em> &#8211; This is a button on your profile that you press when you’re in the hospital. You can put in your address + room number and your friends will get notified. They will then be able to quickly send you a physical get well card or an e-card. </p>\n<p><em>Memorial Profiles</em> &#8211; The world of CF can be very grim, and over the years we’ve lost some of our friends due to CF. We have created memorial pages for those we lost, where we share stories, pictures and memories. We’d like to have a place for this on CFCommunity. We have ideas for doing this in such a way that a memorial page remains private for a small group of friends connected to the person who passed away. </p>\n<p><em>Donations / Supporter Sytem</em> &#8211; A lightweight plugin that simply allows users to make recurring donations to our community. These supporters are automatically listed on a special page and have a special badge on their profile. </p>\n<p><em>Cause/Organisation Groups</em> &#8211; We’d like to give CF related causes the ability to create a group similar to a Discussion Group. The big difference is that they would be able to tell something about their cause. The biggest benefit for having these pages for CF related causes/organisations is making it very easy for our members to find places they could contact for information or support. </p>\n<p><em>Welcome Messages</em> &#8211; On CFCommunity we will have hosts who are welcoming our new members. In order to help new members we’ll automatically send them a welcome message in their native language by one of the hosts assigned to that country. </p>\n<p>These are a few unique plugins, but a ton of time is also spent on integrating and extending existing plugins that are perfect for our cause. One of the things we’re most excited about is using the <a href=\"http://wordpress.org/plugins/achievements/\" target=\"_blank\">Achievements</a> plugin to reward our members for things like taking their meds, gaining weight or exercising.</p>\n<p><strong>Tavern:</strong> <em> If you&#8217;re able to reach your funding goals, how long do you think it will take to build out the new CF Community site? And have you thought about a stretch goal?</em></p>\n<p><strong>Bowe:</strong> We’re aiming for a launch at the end of spring. The last 30% is always the hardest, and we have quite a bit of challenges to solve. It’s not just a technical thing, a lot of things are related to community building and finding the right people to lead the way. We’re planning to write about this process in more detail as the CFCommunity comes closer to launch!</p>\n<p>If we go over our funding goal one of the first things I’d like to do is create a similar plugin as Commons in a Box but then for causes. Basically it would be a plugin suite + theme that would allow anyone to quickly start a social network for their cause. I think it would be awesome to drastically lower the barrier for people to create these types of communities. I honestly believe WordPress is the perfect platform for these type of communities, so I hope we’ll get to that point after we’ve launched CFCommunity. </p>\n<p><strong>Tavern:</strong> <em>How has being involved with the WordPress and BuddyPress community changed your life?</em></p>\n<p><strong>Bowe:</strong> Story time! Average life expectancy for people with CF is around 40, I never realized how much everything I did was influenced by this. I badly wanted to leave my mark on everything I did. I was driven by an unhealthy fear of missing out on life. My entire life I had been taking shortcuts to achieve as much as possible in the shortest amount of time. </p>\n<p>This is something that I’ve heard from many of my friends with CF, we’re simply not allowing ourselves to plan a real future for ourselves. <span class=\"pullquote alignleft\">Often friends and family would praise me for being so driven and ambitious but I was driven by the fear that I was in the prime time of my life.</span> I neglected my treatments, skipped my meds and was constantly asking too much of my body. I certainly wasn’t in the best state of mind.  </p>\n<p>Things changed when I met an old friend who strongly advised me to see a different doctor. He really helped me change my perspective on life and helped me to stay motivated.</p>\n<p>I needed to start planning for the future, think long-term and manage my energy. Find things that would give meaning to my life but are actually achievable and do not have a negative impact on my health. Plan for the future. I decided that I wanted to plan a large part of my future around WordPress.</p>\n<p>WordPress has allowed me to build my career doing the things I’ve always loved doing; being creative, working with people, and give weight to my work through meaningful projects . </p>\n<p>I’ve made real friends through WordPress and most of these friends are now helping me with CFCommunity.</p>\n<p><span class=\"pullquote alignleft\">WordPress allows me to have an impact on others through my work. It has given me the chance to see the world through WordCamps and BuddyCamps.</span> It allows me to stand on my own feet and move from a small city in the Netherlands to the amazing city of Berlin. It allows me to work in my own pace and from anywhere. </p>\n<p>It’s an amazing idea that my work has impact on others across the world, and I have WordPress and it’s community to thank for it. </p>\n<p><strong>Tavern:</strong> <em>What is your ultimate hope for this community, on a heart level, where do you want it to go? In what ways do you hope that it will improve the lives of people with CF?</em></p>\n<p><strong>Bowe:</strong> When I was twelve my parents heard about these summer camps for kids with Cystic Fibrosis and thought it would be a good idea to sent me there. Those weeks have taught me more about living with CF than any doctor, family member or book could ever tell me. For seven days a year I would spent time with kids who truly understood what it was like being different. </p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/bowe.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/bowe.jpg?resize=560%2C298\" alt=\"bowe\" class=\"aligncenter size-full wp-image-13217\" /></a></p>\n<p>While I was running around on the field playing a game of soccer with the well kids, we had ill kids, those who were sick at the time, cheering for us on the side of the field with IVs in their arms. I learned to accept CF as part of me, and be grateful that I was doing so well compared to others.</p>\n<p><span class=\"pullquote alignleft\">The idea that kids who are struggling with coming to grips with their Cystic Fibrosis, would never be able to experience what it was like to be accepted and understood in such a profound way really got to me.<br />\n</span><br />\nSo my ultimate goal with CFCommunity is to create something that could help people affected by CF to go through life a little easier. Last year my cousin gave birth to a beautiful girl who sadly also has CF. She’ll never be able to meet others with CF in real life and I know one day she’d like to meet others with CF. I want to create that place for her and everyone else affected by CF. How awesome would it be if she knew it was her uncle who made that happen? Being in a position to do these things is proof that I made the right decision to make WordPress such a big part of my life :-)</p>\n<h3>Help Make the CFCommunity a Reality</h3>\n<p>The project has already garnered the backing of some serious talent, including Mason James, Siobhan McKeown, Tom Wilmot, Tammie Lister and Sarah Smit. The campaign is also offering a number of awesome WordPress perks from companies like <a href=\"https://wpremote.com/\" target=\"_blank\">WP Remote</a>, <a href=\"http://thewpvalet.com/\" target=\"_blank\">WP Valet</a>, <a href=\"http://siteground.com\" target=\"_blank\">SiteGround</a> and <a href=\"http://hmn.md/\" target=\"_blank\">Human Made</a>. </p>\n<p>Those involved in the WordPress and BuddyPress community are in a unique position to help make a difference in the lives of those impacted by cystic fibrosis, whether it&#8217;s through support, a plugin donation, getting the word out or helping to fund the project. If you want to get behind this project to build <a href=\"http://cfcommunity.net/\" target=\"_blank\">CFCommunity.net</a> and help Bowe change the world, visit their <a href=\"http://www.indiegogo.com/projects/cfcommunity-net-a-social-network-for-people-with-cystic-fibrosis\">IndieGoGo Campaign</a>. </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 17:22:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"Dougal Campbell: Presentation Video\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"http://dougal.gunters.org/?p=75377\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://dougal.gunters.org/blog/2013/12/13/presentation-video/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1433:\"<p>Back in March of 2013, I gave a presentation at WordCamp Atlanta titled &#8220;Secure All The Things&#8221;. I&#8217;ve just noticed that <a title=\"Secure All The Things!\" href=\"http://wordpress.tv/2013/10/26/dougal-campbell-secure-all-the-things/\">the video of this presentation</a> finally went up on<a href=\"http://wordpress.tv/\"> wordpress.tv</a> a few weeks ago.</p>\n<p>At the time of the WordCamp, I had been really busy at work, so I hadn&#8217;t had as much time to rehearse or revamp my slide deck as I had wanted. Despite that, I feel like the talk went off pretty well, especially about halfway in, when I started fielding questions from the audience. I was able to relax more when I was answering questions than when I was concerned about remembering which slide was coming up next.</p>\n<p>Towards the very end, I realized that we were coming up against the session&#8217;s time limit, so I hurried through the last few slide points. But overall, I felt like it went pretty well.</p>\n<p><span id=\"more-75377\"></span></p>\n<p></p>\n<p>Original Article: <a href=\"http://dougal.gunters.org/blog/2013/12/13/presentation-video/\">Presentation Video</a>\n<a href=\"http://dougal.gunters.org\">Dougal Campbell&#039;s geek ramblings - WordPress, web development, and world domination.</a></p><div class=\"yarpp-related-rss yarpp-related-none\">\n<img src=\"http://yarpp.org/pixels/5db43ee24c4f1e1d0e45d08cc91b0130\" alt=\"YARPP\" />\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 15:59:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"Dougal Campbell\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WordPress.tv: Adam Schweigert: Largo Project Case Study\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27219\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://wordpress.tv/2013/12/13/adam-schweigert-largo-project-case-study/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:659:\"<div id=\"v-YPk4kLUt-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27219/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27219/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27219&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/13/adam-schweigert-largo-project-case-study/\"><img alt=\"Adam Schweigert: Largo Project Case Study\" src=\"http://videos.videopress.com/YPk4kLUt/video-3694cb9b0d_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 14:42:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WordPress.tv: Andrey “Rarst” Savchenko: Better Site Stacks with Composer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27095\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"http://wordpress.tv/2013/12/13/andrey-rarst-savchenko-better-site-stacks-with-composer/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:765:\"<div id=\"v-shRrusog-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27095/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27095/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27095&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/13/andrey-rarst-savchenko-better-site-stacks-with-composer/\"><img alt=\"wceu-2013-Better Site Stacks with Composer-Andrey “Rarst” Savchenko\" src=\"http://videos.videopress.com/shRrusog/wceu-2013-better-site-stacks-with-composer-andrey-e2809crarste2809d-savchenko_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 11:22:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WordPress.tv: Miriam Schwab: Learn from my mistakes, don’t make them: The Business of WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27093\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://wordpress.tv/2013/12/12/miriam-schwab-learn-from-my-mistakes-dont-make-them-the-business-of-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:818:\"<div id=\"v-sYrTra0Z-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27093/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27093/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27093&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/12/miriam-schwab-learn-from-my-mistakes-dont-make-them-the-business-of-wordpress/\"><img alt=\"wceu-2013-Learn from my mistakes, don’t make them-The Business of WordPress-Miriam-Schwab\" src=\"http://videos.videopress.com/sYrTra0Z/wceu-2013-learn-from-my-mistakes-don_t-make-them-the-business-of-wordpress-miriam-schwab_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 03:19:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WordPress.tv: Introducing WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27668\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.tv/2013/12/12/introducing-wordpress-3-8-parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:636:\"<div id=\"v-XyHt0O7q-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27668/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27668/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27668&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/12/introducing-wordpress-3-8-parker/\"><img alt=\"WordPress_3.8_release\" src=\"http://videos.videopress.com/XyHt0O7q/wordpress_3-8_release_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 13 Dec 2013 01:55:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Scott Reilly (coffee2code)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WPTavern: 3 Efficient Tools for WordPress Database Migration\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13165\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://www.wptavern.com/3-efficient-tools-for-wordpress-database-migration\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4984:\"<div id=\"attachment_13210\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/medium_9626686898.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/medium_9626686898.jpg?resize=560%2C237\" alt=\"photo credit: Don McCullough - cc\" class=\"size-full wp-image-13210\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/69214385@N04/9626686898/\">Don McCullough</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc/2.0/\">cc</a></p></div>\n<p>One of the challenges of migrating a WordPress site is performing a search and replace within the database to update all of the links to the new URL. There are even more links to update on a multisite installation and you&#8217;re often working with a larger database. Today we&#8217;re going to look at a few handy tools that will make your life much easier when migrating a site. The tool you select usually depends on when you prefer to perform the search and replace.<span id=\"more-13165\"></span></p>\n<h4>Migrate DB Plugin: Requires Admin Access</h4>\n<p>If you have access to the WordPress admin, one of the easiest ways to make the changes up front is to use the Migrate DB plugin. Jeff recently <a href=\"http://www.wptavern.com/wordpress-plugin-review-wp-db-migrate\" target=\"_blank\">reviewed</a> it if you&#8217;d like to read more about how the plugin works. Essentially, you input your new URL and file path and the plugin exports an updated version of the database, which you would then import into an empty database on your new server.</p>\n<div id=\"attachment_11448\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/11/WPDBMigrateOptions.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/11/WPDBMigrateOptions.jpg?resize=560%2C417\" alt=\"WP DB Migrate Options\" class=\"size-full wp-image-11448\" /></a><p class=\"wp-caption-text\">Changing the site URL is easy!</p></div>\n<h4>Search and Replace WordPress Plugin: Requires Admin Access</h4>\n<p>In the event that you&#8217;ve already moved the site over to the new server and have already imported the database, you have a couple different options for performing your search and replace. One of them is to use phpmyadmin or a similar tool to update the home and site URLs so that you can get back into the WordPress admin. At that point you could use a plugin such as <a href=\"http://wordpress.org/plugins/search-and-replace/\" target=\"_blank\">Search and Replace</a> to update URLs, site name or anything else that&#8217;s necessary.</p>\n<p>This plugin lets you search over all or perform a more specific search in ID, post-content, GUID, titel, excerpt, meta-data, comments, comment-author, comment-e-mail, comment-url, tags/categories and categories-description.</p>\n<h4>Search and Replace DB Script: Does Not Require Admin Access</h4>\n<p>Another option that I&#8217;ve used many times is the <a href=\"http://interconnectit.com/products/search-and-replace-for-wordpress-databases/\" target=\"_blank\">Search and Replace DB</a> tool. It&#8217;s not a WordPress plugin, but it&#8217;s very easy to use. This script preserves serialized PHP strings when performing a search and replace. You upload the script to your site, scan all the tables and then input what you want to find and replace.</p>\n<div id=\"attachment_13207\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/searchreplacev2.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/searchreplacev2.jpg?resize=560%2C427\" alt=\"Scan tables\" class=\"size-full wp-image-13207\" /></a><p class=\"wp-caption-text\">Scan tables</p></div>\n<p>Although you can use this script with Drupal, Joomla or any similar CMS, it was made to work nicely with the unique requirements of WordPress migrations and includes a few key features:</p>\n<ul>\n<li>Handles multiple nested serializations (sometimes present in transient values)</li>\n<li>Handles multi-byte Unicode changes safely (important for <a href=\"http://en.wikipedia.org/wiki/Internationalized_domain_name\" target=\"_blank\">internationalized domain names</a>)</li>\n<li>Option to skip guid column for migrating sites that are already live</li>\n</ul>\n<p>The important thing to remember after using the <a href=\"http://interconnectit.com/products/search-and-replace-for-wordpress-databases/\" target=\"_blank\">Search and Replace DB script</a> is that you must remember to remove it from your website once you&#8217;re finished. Otherwise, it poses a serious security risk.</p>\n<p>Of course there are many more tools than those listed here that perform similar functions. These three above are ones that I&#8217;ve tested multiple times and found to be the easiest and most efficient for getting the job done.  Do you know of any other outstanding migration tools? Let us know in the comments below.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 21:34:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WPTavern: Get More Admin Color Schemes For WordPress 3.8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13179\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://www.wptavern.com/get-more-admin-color-schemes-for-wordpress-3-8\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2926:\"<p>One of my favorite features of the <a href=\"http://www.wptavern.com/wordpress-3-8-parker-released\" target=\"_blank\">WordPress 3.8</a> &#8216;About&#8217; page is the live admin color scheme picker. WordPress 3.8 ships with eight different color schemes.</p>\n<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/color-schemes.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/color-schemes.jpg?resize=560%2C237\" alt=\"color-schemes\" class=\"aligncenter size-full wp-image-13183\" /></a></p>\n<p>If you don&#8217;t find a favorite among the default color schemes, there are more options available using a plugin. A small group of designers have collaborated to bring WordPress users even more color schemes via <a href=\"http://wordpress.org/plugins/admin-color-schemes/\" title=\"Admin Color Schemes plugin\" target=\"_blank\">Admin Color Schemes</a>, which is receiving more interest now that 3.8 has been released. The plugin adds eight additional color schemes. If you install it, you&#8217;ll see the new colors available under your profile&#8217;s personal options in the admin.<span id=\"more-13179\"></span></p>\n<div id=\"attachment_13186\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/more-colors.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/more-colors.jpg?resize=560%2C155\" alt=\"More colors!\" class=\"size-full wp-image-13186\" /></a><p class=\"wp-caption-text\">More colors!</p></div>\n<p>You can click through the various color schemes to &#8220;try them on&#8221; instantly. These additional schemes were created by professional designers Kate Whitley, Dave Whitley, Mel Choyce, and Kelly Dwan. There&#8217;s something for everyone here, from primary colors to pastels to nature-inspired palettes. </p>\n<div id=\"attachment_13194\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/aubergine.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/aubergine.jpg?resize=560%2C349\" alt=\"Aubergine - by Kate Whitley & Kelly Dwan\" class=\"size-full wp-image-13194\" /></a><p class=\"wp-caption-text\">Aubergine &#8211; by Kate Whitley and Kelly Dwan</p></div>\n<h4>Create Your Own Color Schemes</h4>\n<p>For the more adventurous, you can check out the code of this plugin to learn how to create your own color schemes. You might be surprised to know that the backbone of the color schemes is just a handful of variables included in its scss file, defining the base, highlight, notification and action colors. You&#8217;ll need to compile your new scss file into a corresponding CSS file in order to make it work. <a href=\"http://wordpress.org/plugins/admin-color-schemes/\" title=\"Admin Color Schemes plugin\" target=\"_blank\">Admin Color Schemes</a> offers a nice model for how to do this.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 19:40:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WordPress.tv: Tammie Lister: The Life of a Theme\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27091\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"http://wordpress.tv/2013/12/12/tammie-lister-the-life-of-a-theme/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:681:\"<div id=\"v-hSBB9Vtg-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27091/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27091/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27091&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/12/tammie-lister-the-life-of-a-theme/\"><img alt=\"wceu-2013-The Life of a Theme-Tammie-Lister\" src=\"http://videos.videopress.com/hSBB9Vtg/wceu-2013-the-life-of-a-theme-tammie-lister_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 19:12:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"Ping-O-Matic: Bits of Advice on Growth and Readership\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://blog.pingomatic.com/?p=98\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://blog.pingomatic.com/2013/12/12/growth-and-readership/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3398:\"<p>In the past, we&#8217;ve shared quick optimization tips, sharing plugins, and other tools to help drive traffic to your site. Over on <a href=\"https://dailypost.wordpress.com\" target=\"_blank\"><em>The Daily Post</em></a>, we&#8217;ve published interviews with popular bloggers on growing your site and building your readership.</p>\n<p><img class=\"aligncenter size-large wp-image-99\" alt=\"statwrangling\" src=\"http://pingomatic.files.wordpress.com/2013/12/statwrangling.png?w=600&h=267\" width=\"600\" height=\"267\" /></p>\n<p>Here are snippets from <a href=\"https://dailypost.wordpress.com/2013/10/22/cristian-mihai/\" target=\"_blank\">a great Q&amp;A</a> with author <a href=\"http://cristianmihai.net/\" target=\"_blank\">Cristian Mihai</a>.</p>\n<h3>What&#8217;s your secret to building such a large following?</h3>\n<blockquote><p>The secret is to do something you’re passionate about, something you care deeply about. Because if you do so, odds are that someone else will relate to what you’re doing. If every post you write means something to you, it’ll undoubtedly mean something to other people, too.</p>\n<p>Another key aspect is consistency. It’s not all about quantity — posting every day, for instance — but also about quality. Readers should know what to expect every time they get notified that you posted something new on your blog.</p>\n<p>Blogging is not a numbers game. Yes, as you become more popular it’s easy to lose track of things; it becomes more and more difficult to realize that those numbers are actually people. Every like, comment, and follow is an action performed by another human being.</p>\n<p>Statistics only offer you a cold perspective of what’s going on with your blog, but what matters more is the level of interaction that you manage with fellow bloggers. Also, if you think too much about followers and such, you’re going to try too hard. And you’re going to fail.</p></blockquote>\n<h3>What types of posts perform better?</h3>\n<blockquote><p>It’s almost impossible to determine why some posts perform better than others. Sometimes it’s ironic, because you worked really hard on a certain piece — did a lot of research, tried to make it all come together in the most attractive way possible — and you just don’t get people to care enough to leave a comment. Other times, the exact opposite happens.</p>\n<p>Popularity simply means how many people relate to what you’re doing. Engagement means how many people care enough — whether they agree or disagree — to actually respond. The goal is to figure out what it is that makes people follow your blog. What type of posts do they enjoy reading most? That’s when your stats may prove useful. If you analyze the posts that perform better, you’ll see they’re often similar in theme, structure, and so on. That’s what readers want most.</p></blockquote>\n<p><em>Read <a href=\"https://dailypost.wordpress.com/2013/10/22/cristian-mihai/\" target=\"_blank\">this entire interview on blog growth and readership</a>.</em></p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/pingomatic.wordpress.com/98/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/pingomatic.wordpress.com/98/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.pingomatic.com&blog=68432&post=98&subd=pingomatic&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 19:07:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"Cheri Lucas Rowlands\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"WPTavern: WordPress 3.8 “Parker” Released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=11632\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://www.wptavern.com/wordpress-3-8-parker-released\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:9584:\"<p><a href=\"http://wordpress.org/news/2013/12/parker/\" title=\"http://wordpress.org/news/2013/12/parker/\">WordPress 3.8 &#8220;Parker&#8221; has been released</a>, named for jazz artist <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\" title=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>. Version 3.8 has been in the oven for 49 days. This marks the second release that contains features that started off as plugins first, a <a title=\"http://www.wptavern.com/wordpress-core-development-goes-to-warp-speed-with-features-as-plugins-model\" href=\"http://www.wptavern.com/wordpress-core-development-goes-to-warp-speed-with-features-as-plugins-model\">development practice</a> we&#8217;ve covered on WPTavern at great length. It&#8217;s important to note that after upgrading to WordPress 3.8, you are strongly encouraged to disable and remove any of the features that started off as plugins. For example, since MP6 was merged into core, it&#8217;s no longer needed and will automatically be disabled after you upgrade.</p>\n<div id=\"attachment_13047\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38About.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-13047\" alt=\"WordPress 3.8 About Page\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38About.jpg?resize=500%2C300\" /></a><p class=\"wp-caption-text\">WordPress 3.8 About Page</p></div>\n<p><span id=\"more-11632\"></span></p>\n<h3>A New Theme Experience (Formerly Known As THX)</h3>\n<div id=\"attachment_13010\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38THX.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-13010\" alt=\"WordPress 3.8 Theme Experience\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38THX.jpg?resize=500%2C259\" /></a><p class=\"wp-caption-text\">The New WordPress Theme Experience</p></div>\n<p>Browsing and switching themes from the backend of WordPress is now a much better experience thanks to a completely revamped themes page. The themes page now has larger thumbnails making it easier to browse themes at a glance. Clicking the theme details link displays a large screenshot of the theme as well as a detailed description on the right hand side.</p>\n<h3>Widgets Area Chooser (Formerly Known As The Widget Area Chooser Plugin)</h3>\n<div id=\"attachment_13015\" class=\"wp-caption alignright\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38WidgetManagement.jpg\" rel=\"thumbnail\"><img class=\"size-full wp-image-13015\" alt=\"WordPress 3.8 Widget Management\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38WidgetManagement.jpg?resize=269%2C253\" /></a><p class=\"wp-caption-text\">New Way To Manage Widgets</p></div>\n<p>The days of scrolling endlessly to manage Widgets are over. WordPress 3.8 enhances the Widget management pages in a few key areas. Sidebars now make better use of free space on wide screen monitors by adding a side-by-side display. You no longer have to drag widgets into the sidebar, although you&#8217;ll still be able to. An alternative method is to click on the widget and select the sidebar you&#8217;d like to have it displayed on. Select the sidebar location and click the add widget button. This is a huge improvement, especially for those who use a lot of widgets.</p>\n<h3>A Refined Dashboard With Widget Improvements (Formerly Known As DASH)</h3>\n<p>The WordPress 3.8 dashboard has reworked a number of widgets to make them more useful. During the development phase, the <a title=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\" href=\"http://make.wordpress.org/ui/2013/10/11/dash-update-4/\">incoming links widget was removed</a> since it routinely didn&#8217;t work. The WordPress Blog, Other WordPress News, and Plugins widgets were combined to form the new WordPress News widget. The Right Now widget has been renamed to &#8220;<em>At a Glance</em>&#8220;. This widget shows how many posts, pages and comments are on the site as well as the current version of WordPress installed. Akismet stats now make up the bottom portion of the widget.</p>\n<div id=\"attachment_13026\" class=\"wp-caption aligncenter\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38DashboardRevamp.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-13026\" alt=\"Removed, Merged, And Revamped Dashboard Widgets\" src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38DashboardRevamp.jpg?resize=500%2C240\" /></a><p class=\"wp-caption-text\">Removed, Merged, And Revamped Dashboard Widgets</p></div>\n<p>Recent Comments was merged into the new Activity widget which also shows any scheduled posts and the five most recently published posts. Last but not least, QuickPress was renamed to Quick Drafts which also houses the Recent Drafts widget. There is no longer an option to specify how many columns the dashboard has. Instead, the number of columns will automatically change based on the available screen real estate. Developers can hook into the activity widget and add additional information to it.</p>\n<h3>WordPress Backend Redesign (Formerly Known As MP6)</h3>\n<p>The most noticeable change in WordPress 3.8 is the renovated backend design. This redesign has been <a title=\"http://make.wordpress.org/ui/2013/03/09/as-a-continuation-of-the-work-begun-in/\" href=\"http://make.wordpress.org/ui/2013/03/09/as-a-continuation-of-the-work-begun-in/\">nine months in the making</a> with the creation of the MP6 plugin. The new design is aesthetically pleasing to the eyes. Typography has gotten some major improvements thanks to the use of Open Sans.</p>\n<div id=\"attachment_13027\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38AdminColorSchemes.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-13027\" alt=\"WordPress 3.8 Has Eight Different Color Schemes\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38AdminColorSchemes.jpg?resize=500%2C156\" /></a><p class=\"wp-caption-text\">WordPress 3.8 Has Eight Different Color Schemes</p></div>\n<p>If dark colors are not your style, WordPress 3.8 ships with eight different color schemes. My personal favorite is Midnight. It&#8217;s possible that in the near future, a large number of color schemes will be available via an add-on plugin.</p>\n<h3>The New Default Theme TwentyFourteen</h3>\n<div id=\"attachment_13028\" class=\"wp-caption alignright\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38TwentyFourteenDefaultThemes.jpg\" rel=\"thumbnail\"><img class=\"size-medium wp-image-13028\" alt=\"WordPress 3.8 Default Theme TwentyFourteen\" src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38TwentyFourteenDefaultThemes.jpg?resize=300%2C190\" /></a><p class=\"wp-caption-text\">WordPress 3.8 Default Theme TwentyFourteen</p></div>\n<p>TwentyFourteen marks the first time a new WordPress default theme is available for a full year. TwentyFourteen, previously known as Further, was originally created as a theme for WordPress.com. Based on Further&#8217;s success, it became an ideal candidate to be turned into the default theme. The theme is based around a magazine concept and includes up to six featured content blocks. Use the three widget areas to customize your website, and change your content’s layout with a full width page template and a contributor page to show off your authors.</p>\n<h3>Responsive Admin Design</h3>\n<div id=\"attachment_13045\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38ResponsiveDesign.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-13045\" alt=\"WordPress 3.8 Responsive Admin\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WP38ResponsiveDesign.jpg?resize=500%2C183\" /></a><p class=\"wp-caption-text\">WordPress 3.8 Backend Is Now Responsive</p></div>\n<p>The backend of WordPress 3.8 is now responsive. The WordPress backend now adapts to any device such as a smartphone, tablet, notebook, or desktop. This is incredibly helpful to those who use WordPress mobile apps on smartphones and need to access specific administrative functions in the backend of WordPress. In previous versions, navigating through the backend on a mobile device was painfully slow. Some of the increase in speed can be attributed to using vector-based icons that scale to your screen. By discarding pixels, pages load faster.</p>\n<h3>WordPress 3.8 Is The Best Release Yet</h3>\n<p><div id=\"attachment_13172\" class=\"wp-caption alignright\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/CharlieParker.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/CharlieParker.jpg?resize=217%2C300\" alt=\"WordPress 3.8 Charlie Parker\" class=\"size-medium wp-image-13172\" /></a><p class=\"wp-caption-text\">Charlie Parker</p></div>I didn&#8217;t realize how many changes are in WordPress 3.8 until I wrote this post. There are a lot of user facing features and enhancements that will take some getting used to. However, I think all of the improvements make it the best release so far. </p>\n<p>The default theme has a specific use case but I&#8217;m curious to see how the WordPress community will re-imagine TwentyFourteen using child themes. Last but not least, thank you to everyone who contributed to WordPress 3.8 either by way of submitting patches, reporting bugs, or beta testing the software. It&#8217;s your dedication that enabled 3.8 to ship on time.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"Dev Blog: WordPress 3.8 “Parker”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=2765\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://wordpress.org/news/2013/12/parker/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:17553:\"<p>Version 3.8 of WordPress, named “Parker” in honor of <a href=\"http://en.wikipedia.org/wiki/Charlie_Parker\">Charlie Parker</a>, bebop innovator, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. We hope you&#8217;ll think this is the most beautiful update yet.</p>\n<div id=\"v-6wORgoGb-1\" class=\"video-player\"></div>\n<h2 class=\"aligncenter\">Introducing a modern new design</h2>\n<p><img class=\"wp-image-2951 aligncenter\" alt=\"overview\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/overview.jpg?resize=623%2C193\" /></p>\n<p>WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. Gone are overbearing gradients and dozens of shades of grey — bring on a bigger, bolder, more colorful design!</p>\n<p><img class=\"aligncenter  wp-image-2856\" alt=\"about-modern-wordpress\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/design.png?resize=623%2C151\" /></p>\n<h3>Modern aesthetic</h3>\n<p>The new WordPress dashboard has a fresh, uncluttered design that embraces clarity and simplicity.</p>\n<h3>Clean typography</h3>\n<p>The Open Sans typeface provides simple, friendly text that is optimized for both desktop and mobile viewing. It’s even open source, just like WordPress.</p>\n<h3>Refined contrast</h3>\n<p>We think beautiful design should never sacrifice legibility. With superior contrast and large, comfortable type, the new design is easy to read and a pleasure to navigate.</p>\n<hr />\n<h2 class=\"aligncenter\">WordPress on every device</h2>\n<p><img class=\"alignright  wp-image-2984\" alt=\"responsive\" src=\"http://i2.wp.com/wpdotorg.files.wordpress.com/2013/12/responsive.jpg?resize=255%2C255\" />We all access the internet in different ways. Smartphone, tablet, notebook, desktop — no matter what you use, WordPress will adapt and you’ll feel right at home.</p>\n<h3>High definition at high speed</h3>\n<p>WordPress is sharper than ever with new vector-based icons that scale to your screen. By ditching pixels, pages load significantly faster, too.</p>\n<hr />\n<h2 class=\"aligncenter\">Admin color schemes to match your personality</h2>\n<p><img class=\"aligncenter  wp-image-2954\" alt=\"colors\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/colors.jpg?resize=623%2C339\" /></p>\n<p>WordPress just got a colorful new update. We’ve included eight new admin color schemes so you can pick the one that suits you best.</p>\n<p>Color schemes can be previewed and changed from your Profile page.</p>\n<hr />\n<h2 class=\"aligncenter\">Refined theme management</h2>\n<p><img class=\"alignright  wp-image-2967\" alt=\"themes\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/themes.jpg?resize=360%2C344\" />The new themes screen lets you survey your themes at a glance. Or want more information? Click to discover more. Then sit back and use your keyboard’s navigation arrows to flip through every theme you’ve got.</p>\n<h3>Smoother widget experience</h3>\n<p>Drag-drag-drag. Scroll-scroll-scroll. Widget management can be complicated. With the new design, we’ve worked to streamline the widgets screen.</p>\n<p>Have a large monitor? Multiple widget areas stack side-by-side to use the available space. Using a tablet? Just tap a widget to add it.</p>\n<hr />\n<h2 class=\"aligncenter\">Twenty Fourteen, a sleek new magazine theme</h2>\n<p><img class=\"aligncenter size-large wp-image-2789\" alt=\"The new Twenty Fourteen theme displayed on a laptop. tablet and phone\" src=\"http://i0.wp.com/wpdotorg.files.wordpress.com/2013/12/twentyfourteen.jpg?resize=692%2C275\" /></p>\n<h3>Turn your blog into a magazine</h3>\n<p>Create a beautiful magazine-style site with WordPress and Twenty Fourteen. Choose a grid or a slider to display featured content on your homepage. Customize your site with three widget areas or change your layout with two page templates.</p>\n<p>With a striking design that does not compromise our trademark simplicity, Twenty Fourteen is our most intrepid default theme yet.</p>\n<hr />\n<h2>Beginning of a new era</h2>\n<p>This release was led by Matt Mullenweg. This is our second release using the new plugin-first development process, with a much shorter timeframe than in the past. We think it’s been going great. You can check out the features currently in production on the <a title=\"Make WordPress Core\" href=\"http://make.wordpress.org/core/\" target=\"_blank\">make/core blog</a>.</p>\n<p>There are 188 contributors with props in this release:</p>\n<p><a href=\"http://profiles.wordpress.org/aaronholbrook\">Aaron Holbrook</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">adamsilverstein</a>, <a href=\"http://profiles.wordpress.org/admiralthrawn\">admiralthrawn</a>, <a href=\"http://profiles.wordpress.org/ahoereth\">Alexander Hoereth</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aralbald\">Andrey Kabakchiev</a>, <a href=\"http://profiles.wordpress.org/apeatling\">Andy Peatling</a>, <a href=\"http://profiles.wordpress.org/ankitgadertcampcom\">Ankit Gade</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/fliespl\">Arkadiusz Rzadkowolski</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/bananastalktome\">Billy (bananastalktome)</a>, <a href=\"http://profiles.wordpress.org/binarymoon\">binarymoon</a>, <a href=\"http://profiles.wordpress.org/bradyvercher\">Brady Vercher</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/calin\">Calin Don</a>, <a href=\"http://profiles.wordpress.org/carldanley\">Carl Danley</a>, <a href=\"http://profiles.wordpress.org/sixhours\">Caroline Moore</a>, <a href=\"http://profiles.wordpress.org/caspie\">Caspie</a>, <a href=\"http://profiles.wordpress.org/chrisbliss18\">Chris Jean</a>, <a href=\"http://profiles.wordpress.org/iblamefish\">Clinton Montague</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/dbernar1\">Dan Bernardic</a>, <a href=\"http://profiles.wordpress.org/danieldudzic\">Daniel Dudzic</a>, <a href=\"http://profiles.wordpress.org/datafeedrcom\">datafeedrcom</a>, <a href=\"http://profiles.wordpress.org/drw158\">Dave Whitley</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling (ocean90)</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/dziudek\">dziudek</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evansolomon\">Evan Solomon</a>, <a href=\"http://profiles.wordpress.org/faison\">Faison</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/gnarf37\">gnarf37</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/iandunn\">Ian Dunn</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/isaackeyet\">Isaac Keyet</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jacklenox\">Jack Lenox</a>, <a href=\"http://profiles.wordpress.org/janhenckens\">janhenckens</a>, <a href=\"http://profiles.wordpress.org/jblz\">Jeff Bowen</a>, <a href=\"http://profiles.wordpress.org/jeffr0\">Jeff Chandler</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/buffler\">Jeremy Buller</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jeherve\">Jeremy Herve</a>, <a href=\"http://profiles.wordpress.org/jpry\">Jeremy Pry</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jhned\">jhned</a>, <a href=\"http://profiles.wordpress.org/jim912\">jim912</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joen\">Joen Asmussen</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnafish\">John Fish</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/nukaga\">Junko Nukaga</a>, <a href=\"http://profiles.wordpress.org/devesine\">Justin de Vesine</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/codebykat\">Kat Hagan</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/koki4a\">Konstantin Dankov</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lessbloat\">lessbloat</a>, <a href=\"http://profiles.wordpress.org/lite3\">lite3</a>, <a href=\"http://profiles.wordpress.org/littlethingsstudio\">littlethingsstudio</a>, <a href=\"http://profiles.wordpress.org/lucp\">LucP</a>, <a href=\"http://profiles.wordpress.org/latz\">Lutz Schroer</a>, <a href=\"http://profiles.wordpress.org/mako09\">Mako</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markmcwilliams\">Mark McWilliams</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/mattwiebe\">Matt Wiebe</a>, <a href=\"http://profiles.wordpress.org/megane9988\">megane9988</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/micahwave\">micahwave</a>, <a href=\"http://profiles.wordpress.org/cainm\">Michael Cain</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel</a>, <a href=\"http://profiles.wordpress.org/chellycat\">Michelle Langston</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikelittle\">Mike Little</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinic</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mt8biz\">moto hachi</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/neil_pie\">neil_pie</a>, <a href=\"http://profiles.wordpress.org/nickdaugherty\">Nick Daugherty</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nbachiyski\">Nikolay Bachiyski</a>, <a href=\"http://profiles.wordpress.org/ninio\">ninio</a>, <a href=\"http://profiles.wordpress.org/ninnypants\">ninnypants</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nvwd\">Nowell VanHoesen</a>, <a href=\"http://profiles.wordpress.org/odysseygate\">odyssey</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/swissspidy\">Pascal Birchler</a>, <a href=\"http://profiles.wordpress.org/pauldewouters\">Paul de Wouters</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/ptahdunbar\">Ptah Dunbar</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/bamadesigner\">Rachel Carden</a>, <a href=\"http://profiles.wordpress.org/radices\">Radices</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/defries\">Remkus de Vries</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/rdall\">Robert Dall</a>, <a href=\"http://profiles.wordpress.org/wet\">Robert Wetzlmayr, PHP-Programmierer</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sanchothefat\">sanchothefat</a>, <a href=\"http://profiles.wordpress.org/sboisvert\">sboisvert</a>, <a href=\"http://profiles.wordpress.org/scottbasgaard\">Scott Basgaard</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">shaunandrews</a>, <a href=\"http://profiles.wordpress.org/designsimply\">Sheri Bigelow (designsimply)</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirbrillig\">sirbrillig</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/iamtakashi\">Takashi Irie</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tmtoy\">Takuma Morikawa</a>, <a href=\"http://profiles.wordpress.org/thomasguillot\">Thomas Guillot</a>, <a href=\"http://profiles.wordpress.org/tierra\">tierra</a>, <a href=\"http://profiles.wordpress.org/tillkruess\">Till Kruss</a>, <a href=\"http://profiles.wordpress.org/tlamedia\">TLA Media</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tommcfarlin\">tommcfarlin</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/taupecat\">Tracy Rotton</a>, <a href=\"http://profiles.wordpress.org/trishasalas\">trishasalas</a>, <a href=\"http://profiles.wordpress.org/mbmufffin\">Tyler Smith</a>, <a href=\"http://profiles.wordpress.org/grapplerulrich\">Ulrich</a>, <a href=\"http://profiles.wordpress.org/l10n\">Vladimir</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yonasy\">yonasy</a>, and <a href=\"http://profiles.wordpress.org/tollmanz\">Zack Tollman</a>. Also thanks to <a href=\"http://benmorrison.org/\">Ben Morrison</a> and <a href=\"http://christineswebb.com/\">Christine Webb</a> for help with the video.</p>\n<p>Thanks for choosing WordPress. See you soon for version 3.9!</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 17:00:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"Joseph: Giving Back to WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"https://josephscott.org/?p=9447\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"https://josephscott.org/archives/2013/12/giving-back-to-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1942:\"<p><img src=\"https://josephscott.org/wp-content/uploads/2013/12/wordpress-logo-simplified-rgb.png\" alt=\"wordpress-logo-simplified-rgb\" width=\"200\" height=\"200\" class=\"alignleft size-full wp-image-9579\" /></p>\n<p>Last month 10up announced they were sponsoring Helen Hou-Sandi to work on core WordPress full time.  This has been a very positive trend, with Bluehost and DreamHost also dedicating full time positions to core WordPress development.  At Automattic we have entire team of people working on the WordPress.org project.</p>\n<p>Not everyone is in a position to have a full time developer or designer dedicated just to the WordPress project.  There are other ways of helping though.  A good example is <a href=\"http://www.wpsitecare.com/giving-back-wordpress/\" title=\"Funny how different people get the same good idea at the same time.\">WP Site Care, who is dedicating time each week for employees to help in the WordPress support forums</a>.  Ryan Sullivan summed it up nicely at the end of his announcement:</p>\n<blockquote><p>\nI also realized that everyone has a place. We don’t employ anyone with core contributor skills here (yet), but we’re damn good at support, and that’s something we can give back in a very meaningful and effective way.</p>\n<p>So I’m proud to announce that all WP Site Care team members will be contributing time weekly to the WordPress Support Forums and Docs.\n</p></blockquote>\n<p>I like the idea of building off of your existing strengths to help out the rest of the WordPress community.  If you are looking for ways to help the WordPress project or other WordPress users check out the <a href=\"http://codex.wordpress.org/Contributing_to_WordPress\" title=\"The translation community is a big deal.\">contributing to WordPress page in the WordPress Codex</a> and your local <a href=\"http://wordpress.meetup.com/\" title=\"There are over 500 WordPress meetup groups world wide.\">WordPress meetup</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 16:19:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Joseph Scott\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"WordPress.tv: Joost de Valk: The Victory of the Commons\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27089\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"http://wordpress.tv/2013/12/12/joost-de-valk-the-victory-of-the-commons/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:702:\"<div id=\"v-6uzkORd0-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27089/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27089/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27089&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/12/joost-de-valk-the-victory-of-the-commons/\"><img alt=\"wceu-2013-The Victory of the Commons-Joost-de-Valk\" src=\"http://videos.videopress.com/6uzkORd0/wceu-2013-the-victory-of-the-commons-joost-de-valk_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 11:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"WordPress.tv: Ptah Dunbar: Unit Testing like a Pirate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27087\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"http://wordpress.tv/2013/12/11/ptah-dunbar-unit-testing-like-a-pirate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:696:\"<div id=\"v-MnmWlSBJ-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27087/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27087/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27087&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/11/ptah-dunbar-unit-testing-like-a-pirate/\"><img alt=\"wceu-2013-Unit Testing like a Pirate-ptah-dunbar\" src=\"http://videos.videopress.com/MnmWlSBJ/wceu-2013-unit-testing-like-a-pirate-ptah-dunbar_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 12 Dec 2013 01:10:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Infographic Shows WordPress Adoption Rate Is Like Wildfire\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13135\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://www.wptavern.com/infographic-shows-wordpress-adoption-rate-is-like-wildfire\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1506:\"<div id=\"attachment_13137\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WPAdoptionInfographic.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/WPAdoptionInfographic.jpg?resize=500%2C320\" alt=\"WordPress Sitting On Top Of The World\" class=\"size-large wp-image-13137\" /></a><p class=\"wp-caption-text\">WordPress Sitting On Top Of The World</p></div>\n<p>Back in June, 2013 WPEngine <a href=\"http://www.slideshare.net/photoflame42/wordcamp-chicago\" title=\"http://www.slideshare.net/photoflame42/wordcamp-chicago\">participated in a session</a> at WordCamp Chicago that was filled with WordPress statistics and trends. The results from that survey have <a href=\"http://wpengine.com/2013/12/11/measuring-wordpress-adoption-infographic/\" title=\"http://wpengine.com/2013/12/11/measuring-wordpress-adoption-infographic/\">now been published as an infographic</a>. I think the most impressive stat is that there is <strong>one WordPress site for every 101 people in the world</strong>. According to the graphic, that&#8217;s essentially the population of Shanghai, Mumbai, Moscow, Mexico City, Tokyo, New York City, London, and Los Angeles combined. <span id=\"more-13135\"></span> </p>\n<p>If you&#8217;re interested in more statistics, Matt Mullenweg conducted a survey shortly before WordCamp San Francisco 2013 and shared the results in his State Of The Word presentation. </p>\n<p><span class=\"embed-youtube\"></span></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 22:56:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"WPTavern: Envato To Re-Focus On Community After Lifetime Earnings Reach $140M\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13102\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://www.wptavern.com/envato-to-re-focus-on-community-after-earning-140m-in-2013\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3498:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/EnvatoLogo.jpg\" rel=\"thumbnail\"><img class=\"alignright size-full wp-image-13106\" alt=\"Envato Logo\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/EnvatoLogo.jpg?resize=222%2C47\" /></a>Collis Ta&#8217;eed, CEO of Envato, has <a href=\"http://inside.envato.com/2013-envato-wrap-up/\" title=\"http://inside.envato.com/2013-envato-wrap-up/\">published a wrap up</a> of what the company accomplished during 2013. Alongside some big numbers, Collis reflects on the past seven years of Envato&#8217;s existence. <em>&#8220;When I look back at the seven years of Envato&#8217;s life so far, I certainly underestimated what this company and community was capable of achieving. This in turn makes me wonder how much more we can do in the next seven.&#8221;</em> Envato is the parent company of a number of successful marketplaces such as <a title=\"http://themeforest.net/\" href=\"http://themeforest.net/\">ThemeForest</a> and <a title=\"http://codecanyon.net/\" href=\"http://codecanyon.net/\">CodeCanyon</a>. <span id=\"more-13102\"></span></p>\n<p><strong>Some of their impressive stats for 2013 include:</strong></p>\n<ul>\n<li>Their community of authors, affiliates, freelancers and instructors took their lifetime earnings with Envato past $140,000,000.</li>\n<li>There are over 720 hours of educational video content and 16,000 free tutorials and articles</li>\n<li>The company sponsored a number of community events such as WordCamps, as well as open source projects like Ghost</li>\n<li>Envato continued to give to charitable organizations with a total lifetime contribution of over half a million dollars.</li>\n</ul>\n<h3>Communities Can Turn Against You In A Flash</h3>\n<p>The marketplaces have provided a number of opportunities for developers to make money that otherwise, didn&#8217;t exist. Their community has played a large role in Envato&#8217;s success. After reading the Envato wrap up post, it&#8217;s clear that Collis and team realize this. </p>\n<blockquote><p>Now that we know who we want to be, we have to live up to it. That&#8217;s why I believe that we are now entering a new phase of Envato&#8217;s life, that I would call Community-Building.</p></blockquote>\n<p>It&#8217;s awesome to see the company embracing their community and watching it pay off for both parties. However, a word of caution: A community can be a fickle thing. Envato has proven that a community can be forgiving if large changes are discussed before their implementation. A great example is when Envato <a href=\"http://notes.envato.com/news/survey-results-about-gpl-opt-in-choice/\" title=\"http://notes.envato.com/news/survey-results-about-gpl-opt-in-choice/\">changed the licensing options</a> for theme and plugin authors on ThemeForest and CodeCanyon. While everyone didn&#8217;t agree with the decisions made, members had a chance to voice their opinions and participate in the discussion. Envato needs to continue giving their community the opportunity to decide which direction the ship travels. </p>\n<p>Collis, as acting ship captain of Envato, will continue to be faced with the challenges of making decisions that the community disagrees with. It&#8217;s at these moments Envato can see what type of community they really have surrounding them. Will they stand by the company? Or line up outside the walls with pitchforks? The one thing that helped Envato become so successful is the same thing that can destroy the company.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 22:35:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WPTavern: Jetpack 2.7 Introduces Google+ Publicize Support and Adds Cloudup oEmbed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13091\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"http://www.wptavern.com/jetpack-2-7-introduces-google-publicize-support-and-adds-cloudup-oembed\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4231:\"<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/09/jetpack.png\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/09/jetpack.png?resize=150%2C150\" alt=\"Jetpack Logo\" class=\"alignleft size-thumbnail wp-image-9209\" /></a><a href=\"http://wordpress.org/plugins/jetpack/\" target=\"_blank\">Jetpack</a> 2.7 was released today, featuring <a href=\"http://jetpack.me/2013/12/11/jetpack-2-7-publicize/\" target=\"_blank\">Google+ support for Publicize</a>, which enables you to shoot posts straight to G+ after you publish them. </p>\n<p>However, the Jetpack team has packed more into this release than they let on in the <a href=\"http://jetpack.me/2013/12/11/jetpack-2-7-publicize/\" target=\"_blank\">announcement</a>. Here&#8217;s a quick overview of the major enhancements and bug fixes included in 2.7.<span id=\"more-13091\"></span></p>\n<h4>Cloudup oEmbed Support</h4>\n<p><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/cloudup.png\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/cloudup.png?resize=150%2C150\" alt=\"cloudup\" class=\"alignright size-thumbnail wp-image-12353\" /></a>Last week we <a href=\"http://www.wptavern.com/new-plugin-adds-cloudup-oembed-support-for-wordpress\" target=\"_blank\">featured the new Cloudup oEmbed plugin</a> that allows you to simply paste a <a href=\"http://cloudup.com\" target=\"_blank\">Cloudup</a> URL on its own line to insert content.</p>\n<p>It&#8217;s convenient to have this packed into Jetpack because Cloudup usage is likely to explode after it&#8217;s out of beta. If you previously installed the plugin for Cloudup oEmbed, you can now delete it if you&#8217;re running Jetpack. If you haven&#8217;t yet tried the Cloudup file sharing service, you can <a href=\"https://cloudup.com/signup/manual?code=matt\" target=\"_blank\">use this link</a> to sign up as a beta user.</p>\n<h4>G+ Publicize for Profiles and Pages</h4>\n<p><div id=\"attachment_13122\" class=\"wp-caption alignright\"><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/publicize-settings.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/publicize-settings.jpg?resize=294%2C356\" alt=\"Publicize Settings\" class=\"size-full wp-image-13122\" /></a><p class=\"wp-caption-text\">Publicize Settings</p></div>Publicize now allows you to link up a G+ profile or page account. Once you update Jetpack to 2.7, go to the post editor to view your current Publicize linked accounts. Click on the &#8216;Settings&#8217; link to authenticate for the G+ profile/page you want to use.</p>\n<p>In order to test out the new G+ Publicize feature we linked it up to our brand new <a href=\"https://plus.google.com/106331420450854425959/\" target=\"_blank\">WP Tavern page</a> where you can follow us for all the latest WordPress news. During this process, we discovered that posts automatically share privately from the WordPress app created, unless you change the app&#8217;s privacy setting to public. Your G+ page settings should have a menu item where you can edit the privacy of posts shared.</p>\n<p>If you publish a high volume of content, then you know it&#8217;s a pain to manually share your posts on every social network. Jetpack&#8217;s new G+ Publicize Support allows you to mark one thing off your daily list.</p>\n<h4>Enhancements and Improvements for Upcoming WordPress 3.8 Release</h4>\n<p>Jetpack 2.7 includes some enhancements and fixes that will get your site ready for WordPress 3.8 and the new default theme. This release adds infinite scroll support for Twenty Fourteen. It also has some fixes for Jetpack&#8217;s <a href=\"http://jetpack.me/support/featured-content/\" target=\"_blank\">Featured Content</a> module:</p>\n<ul>\n<li>Moved Settings to Customizer, provided option to set default tag as fallback, specified all supported post-types rather than just additional ones</li>\n<li>Added compatibility with &#8216;additional_post_types&#8217; theme support argument and comment updates</li>\n</ul>\n<p>For a comprehensive list of everything that&#8217;s new and update, check out the Jetpack <a href=\"http://wordpress.org/plugins/jetpack/changelog/\" target=\"_blank\">changelog</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 22:10:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WPTavern: Coming Soon: An Issues Tracker for WordPress Documentation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13064\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:81:\"http://www.wptavern.com/coming-soon-an-issues-tracker-for-wordpress-documentation\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:5528:\"<p>WordPress documentation is about to improve by leaps and bounds.  At the moment, trying to get involved contributing to documentation can be quite confusing. Unless you know the current docs inside and out, it&#8217;s not easy to find gaps or missing pieces that need attention. That&#8217;s where an issues tracker comes into play.</p>\n<h3>What is a documentation issues tracker?</h3>\n<p>A docs issues tracker is to documentation what trac is to code. The issues tracker provides a central place where users and contributors can report and track progress on issues specific to documentation.<span id=\"more-13064\"></span></p>\n<p>The Drupal project has a <a href=\"https://drupal.org/project/issues/documentation\" target=\"_blank\">nice example</a> if you want to see one in action.</p>\n<p>The idea originated with the WordPress Docs Team. When Siobhan McKeown <a href=\"http://make.wordpress.org/docs/2013/08/15/an-issue-tracker-for-documentation/\" target=\"_blank\">outlined</a> the idea for the tracker, she cited two important problems that the issues tracker will solve:</p>\n<ul>\n<li>People want to contribute to docs but don’t have a central list of tasks that they can sit down and tackle</li>\n<li>More and more contributor days are happening and our issue tracker will be a place where organizers can find tasks for the day</li>\n</ul>\n<p>Example issues one might report include documentation that&#8217;s out of date, incomplete docs, pages that need editing, missing sections, a dead link, code examples that are broken or need updating.</p>\n<p><a href=\"http://profiles.wordpress.org/karmatosed\" target=\"_blank\">Tammie Lister</a> designed a mockup of the tracker planned for WordPress:</p>\n<div id=\"attachment_13088\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/tracker-mockup.jpg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/tracker-mockup.jpg?resize=560%2C576\" alt=\"Mockup of Documentation Issues Tracker\" class=\"size-full wp-image-13088\" /></a><p class=\"wp-caption-text\">Mockup of Documentation Issues Tracker</p></div>\n<p>As you can see, it&#8217;s simpler than trac in many ways and designed to be easy for anyone to quickly create a report on an issue.</p>\n<h3>The Docs Tracker is Now in Development</h3>\n<p><div id=\"attachment_13067\" class=\"wp-caption alignright\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sam.jpeg\" rel=\"thumbnail\"><img src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sam.jpeg?resize=150%2C150\" alt=\"Samuel Sidler\" class=\"size-thumbnail wp-image-13067\" /></a><p class=\"wp-caption-text\">Samuel Sidler</p></div>I had the chance to chat with <a href=\"http://profiles.wordpress.org/samuelsidler\" target=\"_blank\">Samuel Sidler</a>. He is helping to organize the tracker project, which is code named &#8220;Documentron&#8221;.</p>\n<p>To get an understanding of the system that contributors have been using so far, I asked him how documentation issues are currently being resolved. It seems that right now, there is no central place for everyone to jump in and work together. He replied:</p>\n<blockquote><p>Currently, documentation issues are resolved and tracked manually by individual contributors. There isn&#8217;t an easy way to report issues or request new documentation. The documentation issue tracker will allow two things: 1) anyone can report an issue with documentation and 2) the docs team can track all open issues to have a better picture of the state of documentation across the project.</p></blockquote>\n<p>Sidler believes that the new issues tracker will help open up contribution to WordPress docs in a major way. <strong>&#8220;The tracker is focused on making things easier for the docs team first and foremost. But any community member will be able to report issues to it, opening the door to participation,&#8221;</strong> he said. Besides the Docs Team, he anticipates that the Support Team will also be likely to use the tracker for the documentation they manage.</p>\n<p>The designs have been finalized and Sidler reports that Otto has happily agreed to develop the new tracker. How soon will we see it in use on WordPress.org? Sidler says, &#8220;It&#8217;s hard to say exactly how long an issue tracker will take to build, especially with the upcoming holidays, but we&#8217;re closer than we&#8217;ve ever been.&#8221; The plan is to roll it out in beta first and Sidler will be organizing users for testing. &#8220;We&#8217;ll put links on a few docs to test the reporting interface with end users before rolling it out to all documentation.&#8221;</p>\n<p>A documentation issues tracker is a must-have tool for any large open source project. Sidler is hoping that it will streamline issue management. </p>\n<blockquote><p>Ideally, more issues will get reported and then fixed with an issue tracker in place. Having an easy way for anyone to report an issue should increase the number of reported issues. Likewise, having a central place to track issues will make them easier to fix.</p></blockquote>\n<p>I&#8217;m excited to see the documentation issues tracker implemented on WordPress.org. It has the potential to exponentially increase the contribution to docs as well as collaboration among Docs Team members. If you&#8217;re eager to contribute to WordPress docs but don&#8217;t know where to get started, the tracker will help you to find a place to jump in. We&#8217;ll let you know when it&#8217;s live on WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 19:03:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WordPress.tv: Floor Drees: Working Towards Great Version Control for Content Creators\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27085\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"http://wordpress.tv/2013/12/11/floor-drees-working-towards-great-version-control-for-content-creators/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:792:\"<div id=\"v-n9bHRYyW-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27085/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27085/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27085&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/11/floor-drees-working-towards-great-version-control-for-content-creators/\"><img alt=\"wceu-2013-Working Towards Great Version Control for Content Creators-Floor-Drees\" src=\"http://videos.videopress.com/n9bHRYyW/wceu-2013-working-towards-great-version-control-for-content-creators-floor-drees_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 18:11:08 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"WordPress.tv: Mónica Guerra Leiria: Between Glorified Computer Interface and Ultimate Narcissist: delivering what the client needs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27080\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:146:\"http://wordpress.tv/2013/12/11/monica-guerra-leiria-between-glorified-computer-interface-and-ultimate-narcissist-delivering-what-the-client-needs/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:896:\"<div id=\"v-aSTjMxQU-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27080/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27080/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27080&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/11/monica-guerra-leiria-between-glorified-computer-interface-and-ultimate-narcissist-delivering-what-the-client-needs/\"><img alt=\"wceu-2013-Between Glorified Computer Interface and Ultimate Narcissist-delivering what the client needs-monica\" src=\"http://videos.videopress.com/aSTjMxQU/wceu-2013-between-glorified-computer-interface-and-ultimate-narcissist-delivering-what-the-client-needs-monica_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 08:44:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"WordPress.tv: Kirsten Schelper &amp; Elisabeth Hölzl: Developing WordPress Themes with Git\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27078\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://wordpress.tv/2013/12/10/kirsten-schelper-elisabeth-holzl-developing-wordpress-themes-with-git/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:723:\"<div id=\"v-BjSyjg3d-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27078/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27078/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27078&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/10/kirsten-schelper-elisabeth-holzl-developing-wordpress-themes-with-git/\"><img alt=\"wceu-2013-Developing WordPress Themes with Git\" src=\"http://videos.videopress.com/BjSyjg3d/wceu-2013-developing-wordpress-themes-with-git_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 03:40:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:70:\"WPTavern: WordPress StackExchange Votes On New Community Promotion Ads\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://www.wptavern.com/wordpress-stackexchange-votes-on-new-community-promotion-ads\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2103:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sharing.jpg\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/sharing.jpg?resize=560%2C230\" alt=\"sharing\" class=\"aligncenter size-full wp-image-13050\" /></a></p>\n<p>The <a href=\"http://wordpress.stackexchange.com\" target=\"_blank\">WordPress StackExchange</a> community is currently <a href=\"http://meta.wordpress.stackexchange.com/questions/3709/community-promotion-ads-2014/\" target=\"_blank\">voting</a> on ads to display in the sidebar of its forums for 2014. Every year the Community Promotion Ads are reset in December. These ads serve to promote anything that the community deems to be important. Usually, the ads are dedicated to promoting information and resources that benefit those in the community as well as potential new members who might be visiting. To be clear, these are not ads dedicated to commercial products.</p>\n<p>WordPress StackExchange lists a few examples of Community Promotion Ads, including open source plugins, power tools, events or conferences and anything that might be of genuine interest to WordPress people.<span id=\"more-12753\"></span></p>\n<h4>Cast Your Vote for the Most Useful Community Promotion Ads</h3>\n<p>Cycling the ads every year helps to keep them fresh and current. The WordPress StackExchange is a place where many WordPress users turn to for answers and it&#8217;s important for community members to vote up the ads that will be the most useful and relevant.</p>\n<p>Right now, there are only four ads up for votes, but the WordPress community has many more quality resources that could be included here. They&#8217;re still taking new submissions for Community Promotion Ads if you&#8217;d like to send in an image and URL. Voting will continue throughout December. You&#8217;ll need to create an account in order vote. Once logged in, you can <a href=\"http://meta.wordpress.stackexchange.com/questions/3709/community-promotion-ads-2014/\" target=\"_blank\">vote up</a> the resources you think will be the most useful to the WordPress community.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 02:01:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"WPTavern: Industry Night #4 – Pippin Williamson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=13031\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://www.wptavern.com/industry-night-4-pippin-williamson\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1303:\"<p><a href=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/11/IndustryNight_albumart_2d.jpg\" rel=\"thumbnail\"><img class=\"alignleft  wp-image-11945\" alt=\"Industry Night with Marcus Couch\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/11/IndustryNight_albumart_2d.jpg?resize=200%2C200\" /></a>On tonight&#8217;s show we&#8217;re engaged in conversation with <a title=\"Pippin Williamson\" href=\"http://pippinsplugins.com/\" target=\"_blank\">Pippin Willamson</a>, developer of many notable plugins including <a title=\"Easy Digital Downloads\" href=\"http://easydigitaldownloads.com\">Easy Digital Downloads</a>. Along with his co-host Brad Touesnard, Pippin produces one of my favorite WordPress Development podcasts, <a href=\"http://applyfilters.fm/\" title=\"http://applyfilters.fm/\">Apply Filters</a>. </p>\n<p>In our conversation <a title=\"Pippin Williamson on Twitter\" href=\"http://twitter.com/pippinsplugins\" target=\"_blank\">Pippin</a> discusses the development process for creating new plugins, debugging plugin <a title=\"Query Monitor\" href=\"http://wordpress.org/plugins/query-monitor/\" target=\"_blank\">Query Monitor</a>, LinkedIn usage, the podcast and general WordPress observations. So pull up a chair, grab a cold one and join me in my conversation with Pippin Williamson! </p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 11 Dec 2013 00:46:27 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Marcus Couch\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WPTavern: Admin Column View: A New Way to Organize WordPress Pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12979\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"http://www.wptavern.com/admin-column-view-a-new-way-to-organize-wordpress-pages\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3379:\"<p>Have you ever wished for a better way to navigate pages in the WordPress admin? The UI for hierarchical content makes it difficult to understand the organization of pages and custom post types at a glance.</p>\n<p>Inspired by the column view in the OS X Finder, Alex King and the team at Crowd Favorite have created a similar interface for navigating pages/hierarchical CPTs in the WordPress admin. Their new <a href=\"http://wordpress.org/plugins/admin-column-view/\" target=\"_blank\">Admin Column View</a> plugin is now available in the WordPress plugin repository.</p>\n<p>This plugin introduces a Column View menu item under the Pages menu for viewing content in a more intuitive way. </p>\n<div id=\"attachment_12999\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/pages-column-view.jpg\" rel=\"thumbnail\"><img src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/pages-column-view.jpg?resize=560%2C321\" alt=\"Column view of pages\" class=\"size-full wp-image-12999\" /></a><p class=\"wp-caption-text\">Column view of pages</p></div>\n<p>Admin Column View does more than just redesign the Pages menu UI. It also includes some features that are not easy to see in a screenshot:<span id=\"more-12979\"></span></p>\n<ul>\n<li>Use drag and drop to re-order (set the &#8220;menu_order&#8221; property) pages/custom post types.</li>\n<li>Provides a link at each level to create a new page/custom post type at that level.</li>\n<li>Colored post status indicators: ie. private, draft, etc.</li>\n<li>Support for custom post types</li>\n</ul>\n<p>This expanded view shows the new page/CPT creation link and colored post status indicators in action:</p>\n<div id=\"attachment_12993\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/admin-column-view.png\" rel=\"thumbnail\"><img src=\"http://i0.wp.com/www.wptavern.com/wp-content/uploads/2013/12/admin-column-view.png?resize=560%2C366\" alt=\"Admin Column View\" class=\"size-full wp-image-12993\" /></a><p class=\"wp-caption-text\">Admin Column View</p></div>\n<p>Admin interaction with the content is much easier to see in Alex King&#8217;s video walk-through:</p>\n<p></p>\n<h3>An Alternative Content Listing UI for WordPress as a CMS</h3>\n<p>Admin Column View is a very helpful plugin for sites using WordPress more heavily as a CMS. It provides instant context for hierarchical content, showing posts in relationship to those above and below. Plugins like this also open discussion about how the WordPress admin can be improved, although this way of arranging content may not be for everyone. </p>\n<p>Last Friday on our <a href=\"http://www.wptavern.com/wpweekly-episode-130-catching-up-with-matt-mullenweg\" target=\"_blank\">weekly podcast</a> Matt Mullenweg said, <strong>&#8220;I don&#8217;t think everyone&#8217;s WordPress should look the same.&#8221;</strong> This statement applies in this instance where sites with a large number of pages or CPTs might benefit from an alternative UI provided to organize content in the admin.</p>\n<p>The <a href=\"http://wordpress.org/plugins/admin-column-view/\" target=\"_blank\">Admin Column View</a> plugin was designed for the WordPress 3.8 admin refresh, so it won&#8217;t be outdated in a couple days when 3.8 is released. Download it for free through your admin panel or via its home on WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 22:46:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: ServerPress: A Quick and Easy Way to Create Local WordPress Installs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12983\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:91:\"http://www.wptavern.com/serverpress-a-quick-and-easy-way-to-create-local-wordpress-installs\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4244:\"<p><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/ServerPresslogo.jpg\" rel=\"thumbnail\"><img class=\"alignright size-full wp-image-12990\" alt=\"ServerPress Logo\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/ServerPresslogo.jpg?resize=191%2C53\" /></a>A few months ago, I had the privilege to attend <a title=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013\" href=\"http://www.wptavern.com/my-experience-wordcamp-grand-rapids-2013\">WordCamp Grand Rapids</a>. At the event, I obtained a <a title=\"http://serverpress.com\" href=\"http://serverpress.com\">ServerPress.com</a> branded USB stick. Little did I know that this was no ordinary USB drive. <span id=\"more-12983\"></span></p>\n<h3>Making It Easy To Setup A Local Dev Environment For WordPress</h3>\n<p>ServerPress is a company devoted to making it as easy as possible to set up a local development environment for WordPress. ServerPress has two different editions of their DesktopServer software. <a title=\"http://serverpress.com/membership-options/\" href=\"http://serverpress.com/membership-options/\">DesktopServer Premium</a> costs $99 per year and includes access to priority support, content, additional features and multisite support. The DesktopServer limited edition is free to use but only has access to a limited amount of documentation and support. The limited version is what was packaged on the USB stick. Both editions support Macintosh OS X 10.4.11-10.9.0 and Windows XP/Vista/7/8.</p>\n<h3>Automate The Configuration of New Websites With Blueprints</h3>\n<div id=\"attachment_12995\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/DesktopServerBlueprints.jpg\" rel=\"thumbnail\"><img class=\"size-full wp-image-12995\" alt=\"Desktop Server Blueprints\" src=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/DesktopServerBlueprints.jpg?resize=441%2C168\" /></a><p class=\"wp-caption-text\">Easily Install Different WordPress Versions</p></div>\n<p>The WordPress version that came with my USB drive was WordPress 3.6. We are now at 3.7.1 with 3.8 around the corner. I contacted ServerPress.com support via email and they promptly replied with an explanation on how to update the version of WordPress that&#8217;s used when creating a new test site. DesktopLimited has support for something called Blueprints. Blueprints help accelerate the development process by automating the configuration of new sites.</p>\n<p>By placing WordPress versions (<strong>zip files</strong>) inside of the Blueprints folder, you can select which version of WordPress will be installed during the creation of a new testing site. You can also place commonly used themes and plugins inside of the Blueprints folder. This technique provides a quick and easy way to test themes and plugins on multiple versions of WordPress.</p>\n<h3>DesktopServer Limited Is A Great Substitute For WAMP</h3>\n<div id=\"attachment_12998\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/www.wptavern.com/wp-content/uploads/2013/12/DesktopServerFeaturesComparisonChart.jpg\" rel=\"thumbnail\"><img class=\"size-large wp-image-12998\" alt=\"Desktop Server Features Comparison Chart\" src=\"http://i1.wp.com/www.wptavern.com/wp-content/uploads/2013/12/DesktopServerFeaturesComparisonChart.jpg?resize=500%2C247\" /></a><p class=\"wp-caption-text\">Feature Comparison Chart</p></div>\n<p><a href=\"http://www.wampserver.com/\" title=\"http://www.wampserver.com/\">WAMP</a> installs Apache, MySQL, phpMyAdmin, php 5.3, and Xdebug. DesktopServer Limited Edition has all of that plus the ability to install specific WordPress versions, domain name mapping, automated virtual hosts creation and can copy WordPress sites. If you&#8217;re going to use WAMP to setup a local environment for WordPress development, it makes sense to use DesktopServer instead as it provides everything WAMP offers and so much more. </p>\n<p>While I&#8217;ve only scratched the surface, I&#8217;ve used the software enough to justify ditching WAMP and using DesktopServer Limited from now on. I invite you to try out <a title=\"http://serverpress.com/downloads/\" href=\"http://serverpress.com/downloads/\">their free version</a> and let me know what you think.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 22:30:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Jeffro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"Alex King: Admin Column View\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=18877\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://crowdfavorite.com/blog/2013/12/admin-column-view-cms-wordpress-plugin/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:585:\"<p>We&#8217;ve made it easier to navigate and manage pages (and other hierarchical post types) in the WordPress admin.</p>\n<p></p>\n<p>If you haven&#8217;t already subscribed to the <a href=\"http://crowdfavorite.com/blog/\">Crowd Favorite blog</a>, go do it. We&#8217;re posting good stuff over there.</p>\n<p class=\"threads-post-notice\">This post is part of the project: <a href=\"http://alexking.org/project/admin-column-view\">Admin Column View</a>. View the project timeline for more context on this post.</p>\n<p><a href=\"http://alexking.org/blog/2013/12/10/admin-column-view\">#</a></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 18:11:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WordPress.tv: Boone Gorges: Herding Cats with the BuddyPress Activity Component\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27076\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://wordpress.tv/2013/12/10/boone-gorges-herding-cats-with-the-buddypress-activity-component/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:772:\"<div id=\"v-hyB5Y3VK-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27076/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27076/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27076&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/10/boone-gorges-herding-cats-with-the-buddypress-activity-component/\"><img alt=\"wceu-2013-Boon-Gorges-Herding Cats with the BuddyPress Activity Component\" src=\"http://videos.videopress.com/hyB5Y3VK/wceu-2013-boon-gorges-herding-cats-with-the-buddypress-activity-component_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 18:11:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WPTavern: New Plugin Brings Hands-Free Publishing To WordPress Via Google Glass\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"http://www.wptavern.com/?p=12947\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://www.wptavern.com/new-plugin-brings-hands-free-publishing-to-wordpress-via-google-glass\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2400:\"<p>Google Glass hasn&#8217;t even launched yet and it already has a WordPress plugin. The folks at <a href=\"http://labs.webershandwick.com/wpforglass/2013/10/27/introducing-wpforglass/\" target=\"_blank\">Weber Shandwick</a>, a PR and communications firm, have developed the first WordPress plugin that interfaces with Google Glass to publish content.</p>\n<p>wpForGlass is currently operated by touch, although the creators plan to add voice commands by the time Google Glass officially launches. The plugin makes it possible for users to take a photo or video and instantly send it to a self-hosted WordPress blog. You can also speak a caption before your media is uploaded.<span id=\"more-12947\"></span></p>\n<p></p>\n<h3>How wpForGlass Works</h3>\n<p><a href=\"https://github.com/webershandwick/wpForGlass\" target=\"_blank\">wpForGlass</a> makes use of Google’s <a href=\"https://developers.google.com/glass/\" target=\"_blank\">Mirror API</a> to transmit your data through Google server.  When setting up the plugin you&#8217;ll need to have an SSL certificate, ability to set up cron jobs and Mirror API Access in order to create an OAuth 2.0 client ID for your application. It&#8217;s important to note that the shared media is processed on Google servers and then downloaded to the WordPress site, which may take a few minutes to process. </p>\n<h3>wpForGlass Adds a New Dimension to Journalism and Live Blogging</h3>\n<p>This plugin has the potential to be revolutionary for journalism. It creates a fast lane for delivering content and news to people in a live environment. Immediacy and hands-free publishing are the real benefits of wpForGlass. Events can be recorded and transmitted in near real-time by regular people without requiring a live news station camera feed, further exploding the capacity of the blogosphere to be the real journalists on the scene. </p>\n<p>The ability to shoot and transmit images and video to a blog in a hands-free environment also opens up a new interactive capacity for bloggers, documentarians and journalists who, until now, have had their hands shackled to a notepad, a phone or a camera while attempting to observe and report.</p>\n<p>The <a href=\"https://github.com/webershandwick/wpForGlass\" target=\"_blank\">wpForGlass</a> code is open source so Glass Explorers can take advantage of it right now and developers can fork it or contribute to improve the plugin.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 17:39:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WordPress.tv: Scott Basgaard: Help Yourself by Helping Others\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=27074\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://wordpress.tv/2013/12/10/scott-basgaard-help-yourself-by-helping-others-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:722:\"<div id=\"v-rIGcL9AB-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/27074/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/27074/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=27074&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2013/12/10/scott-basgaard-help-yourself-by-helping-others-2/\"><img alt=\"wceu-2013-Help Yourself by Helping Others-Scott Basgaard\" src=\"http://videos.videopress.com/rIGcL9AB/wceu-2013-help-yourself-by-helping-others-scott-basgaard_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 10 Dec 2013 08:31:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 17 Dec 2013 15:46:35 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"173255\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Tue, 17 Dec 2013 15:30:16 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('5603', '_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109', '1387338396', 'no');
INSERT INTO `wp_options` VALUES('5604', '_transient_feed_mod_b9388c83948825c1edaef0d856b7b109', '1387295196', 'no');
INSERT INTO `wp_options` VALUES('5601', '_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109', '1387338396', 'no');
INSERT INTO `wp_options` VALUES('5602', '_transient_feed_b9388c83948825c1edaef0d856b7b109', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 17 Dec 2013 15:43:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"Arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your Wordpress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Better WP Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"The easiest, most effective way to secure WordPress. Improve the security of any WordPress site in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"TinyMCE Advanced\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/tinymce-advanced/#post-2082\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Jun 2007 15:00:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2082@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Andrew Ozz\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5468@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"Create a slick mobile WordPress website with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 7.5 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Wordfence Security is a free enterprise class security plugin that includes a firewall, virus scanning, real-time traffic with geolocation and more.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Captcha\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/captcha/#post-26129\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 27 Apr 2011 05:53:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"26129@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"This plugin allows you to implement super security captcha form into web forms.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:11:\"bestwebsoft\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Fast Secure Contact Form\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"http://wordpress.org/plugins/si-contact-form/#post-12636\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 27 Aug 2009 01:20:04 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"12636@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"An easy and powerful form builder that lets your visitors send you email. Blocks all automated spammers. No templates to mess with.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Mike Challis\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Tue, 17 Dec 2013 15:46:36 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 02 Aug 2007 12:45:03 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 250\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('5605', '_transient_timeout_plugin_slugs', '1387381596', 'no');
INSERT INTO `wp_options` VALUES('5606', '_transient_plugin_slugs', 'a:26:{i:0;s:26:\"secure-wordpress/index.php\";i:1;s:35:\"ad-codez-widget/ad-codes-widget.php\";i:2;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:3;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:4;s:27:\"backupbuddy/backupbuddy.php\";i:5;s:39:\"bad-behavior/bad-behavior-wordpress.php\";i:6;s:36:\"contact-form-7/wp-contact-form-7.php\";i:7;s:46:\"custom-post-template/custom-post-templates.php\";i:8;s:39:\"sitemap-generator/sitemap-generator.php\";i:9;s:23:\"digg-digg/digg-digg.php\";i:10;s:43:\"easy-privacy-policy/easy-privacy-policy.php\";i:11;s:36:\"google-sitemap-generator/sitemap.php\";i:12;s:9:\"hello.php\";i:13;s:32:\"login-lockdown/loginlockdown.php\";i:14;s:22:\"obox-mobile/mobile.php\";i:15;s:27:\"pretty-link/pretty-link.php\";i:16;s:31:\"quick-adsense/quick-adsense.php\";i:17;s:35:\"simply-show-ids/simply-show-ids.php\";i:18;s:23:\"slideshow/slideshow.php\";i:19;s:30:\"smart-youtube/smartyoutube.php\";i:20;s:25:\"sucuri-scanner/sucuri.php\";i:21;s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";i:22;s:31:\"youtube-embed/youtube-embed.php\";i:23;s:25:\"wp-cumulus/wp-cumulus.php\";i:24;s:27:\"wp-pagenavi/wp-pagenavi.php\";i:25;s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";}', 'no');
INSERT INTO `wp_options` VALUES('5551', '_transient_vye_type_NnPobSrR3zM', 'v', 'no');
INSERT INTO `wp_options` VALUES('5550', '_transient_timeout_vye_type_NnPobSrR3zM', '1387331249', 'no');
INSERT INTO `wp_options` VALUES('5611', '_transient_timeout_vye_video_ebdc327876821c0c593c56a482883cbb', '1387298827', 'no');
INSERT INTO `wp_options` VALUES('5612', '_transient_vye_video_ebdc327876821c0c593c56a482883cbb', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/NnPobSrR3zM?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5556', '_transient_timeout_vye_type_AHKcHV6iMjk', '1387331250', 'no');
INSERT INTO `wp_options` VALUES('5557', '_transient_vye_type_AHKcHV6iMjk', 'v', 'no');
INSERT INTO `wp_options` VALUES('5558', '_transient_timeout_vye_title_AHKcHV6iMjk', '1387331250', 'no');
INSERT INTO `wp_options` VALUES('5559', '_transient_vye_title_AHKcHV6iMjk', 'Law Enforcement Jobs : How to Join the Police Department', 'no');
INSERT INTO `wp_options` VALUES('5613', '_transient_timeout_vye_video_693275bdf2580a7da28c885857965859', '1387298827', 'no');
INSERT INTO `wp_options` VALUES('5614', '_transient_vye_video_693275bdf2580a7da28c885857965859', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/AHKcHV6iMjk?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5562', '_transient_timeout_vye_type_UVMgePqZhVM', '1387331250', 'no');
INSERT INTO `wp_options` VALUES('5563', '_transient_vye_type_UVMgePqZhVM', 'v', 'no');
INSERT INTO `wp_options` VALUES('5564', '_transient_timeout_vye_title_UVMgePqZhVM', '1387331250', 'no');
INSERT INTO `wp_options` VALUES('5565', '_transient_vye_title_UVMgePqZhVM', 'Police Written Exam Golden Nugget', 'no');
INSERT INTO `wp_options` VALUES('5615', '_transient_timeout_vye_video_dec19ea113bc39562a3858b64761d911', '1387298827', 'no');
INSERT INTO `wp_options` VALUES('5616', '_transient_vye_video_dec19ea113bc39562a3858b64761d911', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/UVMgePqZhVM?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5599', '_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1387338395', 'no');
INSERT INTO `wp_options` VALUES('5600', '_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1387295195', 'no');
INSERT INTO `wp_options` VALUES('5607', '_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51', '1387338396', 'no');
INSERT INTO `wp_options` VALUES('5608', '_transient_dash_4077549d03da2e451c8b5f002294ff51', '<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2013/12/parker/\' title=\'Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you’ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. […]\'>WordPress 3.8 “Parker”</a> <span class=\"rss-date\">December 12, 2013</span><div class=\'rssSummary\'>Version 3.8 of WordPress, named “Parker” in honor of Charlie Parker, bebop innovator, is available for download or update in your WordPress dashboard. We hope you’ll think this is the most beautiful update yet. Introducing a modern new design WordPress has gotten a facelift. 3.8 brings a fresh new look to the entire admin dashboard. […]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/12/17/chris-van-patten-the-code-is-written-now-what/\' title=\'    \'>WordPress.tv: Chris Van Patten: The Code Is Written: Now What?</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2013/12/17/ujwal-thapa-wordpress-as-a-blogging-platform/\' title=\'    \'>WordPress.tv: Ujwal Thapa: WordPress As A Blogging Platform</a></li><li><a class=\'rsswidget\' href=\'http://www.wptavern.com/buddypress-1-9-sammy-released-with-new-notifications-component\' title=\'BuddyPress 1.9 was released to the world today thanks to many volunteer contributors who worked hard to make it happen. This release pays tribute to Sammy’s Pizza in Providence, Rhode Island, where lead developer John James Jacoby has enjoyed many fine pizza pies. Here’s a quick tour of the three main highlights of this release. New Notifications Component BuddyPress is introducing a new component for the first time in two years. The 1.9 release has moved notifications to its own component so that they’re all centralized in one place. BuddyPress Notifications Notifications also have an improved API in 1.9 so that developers can easily tie their extensions into them.  Dynamic Menu Items BuddyPress site admins will be thrilled to find that 1.9 includes dynamic menu links. It’s now easier than ever to build menus with dynamic links such as “My Profile” or “Settings” that are specific to logged-in users. Dynamic menu items are separated into logged-in and logged-out user links.  Dynamic BuddyPress Menus If you previously used a plugin to generate dynamic menu items, you can now delete it and use the built-in BuddyPress links at Dashboard &gt; Appearance &gt; Menus. New Widgets BuddyPress 1.9 introduces three new core widgets to help you customize your social network: Friends Widget  Friends Widget: A list of recently active, popular and newest friends of the displayed member. Log In Widget: Adds a simple “Log In” form and/or “Log Out” link Sitewide Notices Widget: Displays Sitewide Notices from the Private Messaging component.  Developer Goodies BuddyPress 1.9 reinstates the bp_redirect_canonical() functionality. phpDoc inline documentation has been improved as well as compatibility with the develop.svn.wordpress.org unit-test suite.  On top of all that, the BuddyPress Codex has been completely revamped with a design refresh and loads of new tutorials and guides. The BuddyPress core team is already cooking up new ideas for the 2.0 release but will take some time off for the holidays before getting started. The team will be sending out a brief questionnaire after the beginning of the new year to get community input before setting the goals for BuddyPress 2.0. If you’re keen on shaping the future of BuddyPress, watch for that questionnaire and make sure to voice your opinion. In the meantime, enjoy all the new goodies packaged into 1.9. It’s already fully compatible with WordPress 3.8 so you’re safe to upgrade to the very latest.\'>WPTavern: BuddyPress 1.9 “Sammy” Released With New Notifications Component</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'http://wordpress.org/plugins/better-wp-security/\' class=\'dashboard-news-plugin-link\'>Better WP Security</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=better-wp-security&amp;_wpnonce=876c44ed86&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Better WP Security\'>Install</a>)</span></li></ul></div>', 'no');
INSERT INTO `wp_options` VALUES('5619', '_transient_vye_type_eQU7p52El4k', 'v', 'no');
INSERT INTO `wp_options` VALUES('5620', '_transient_timeout_vye_title_eQU7p52El4k', '1387381741', 'no');
INSERT INTO `wp_options` VALUES('5621', '_transient_vye_title_eQU7p52El4k', 'How to Do the Magic Trick of Taking Money Out of Your Ear : Magic 101', 'no');
INSERT INTO `wp_options` VALUES('5622', '_transient_timeout_vye_video_38f44e46fca7c47fc7fc166466689ffd', '1387298941', 'no');
INSERT INTO `wp_options` VALUES('5623', '_transient_vye_video_38f44e46fca7c47fc7fc166466689ffd', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eQU7p52El4k?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5624', '_transient_timeout_vye_type_88AWZwleTns', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5625', '_transient_vye_type_88AWZwleTns', 'v', 'no');
INSERT INTO `wp_options` VALUES('5626', '_transient_timeout_vye_title_88AWZwleTns', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5627', '_transient_vye_title_88AWZwleTns', 'Magic Tricks for the Dinner Table : A Routine Idea for Dinner Table Magic', 'no');
INSERT INTO `wp_options` VALUES('5628', '_transient_timeout_vye_video_8a2a81754260ba7fe84d80831074404a', '1387298942', 'no');
INSERT INTO `wp_options` VALUES('5629', '_transient_vye_video_8a2a81754260ba7fe84d80831074404a', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/88AWZwleTns?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5630', '_transient_timeout_vye_type_E6VWi7IaroA', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5631', '_transient_vye_type_E6VWi7IaroA', 'v', 'no');
INSERT INTO `wp_options` VALUES('5632', '_transient_timeout_vye_title_E6VWi7IaroA', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5633', '_transient_vye_title_E6VWi7IaroA', 'Magic Tricks Revealed : Learn Popular Illusions Free : The Coin Fold Illusion Magic Trick Revealed', 'no');
INSERT INTO `wp_options` VALUES('5634', '_transient_timeout_vye_video_06da34ac3d41a0f7846f130d6f85b7fe', '1387298942', 'no');
INSERT INTO `wp_options` VALUES('5635', '_transient_vye_video_06da34ac3d41a0f7846f130d6f85b7fe', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/E6VWi7IaroA?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5636', '_transient_timeout_vye_type_xEaspKUrMco', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5637', '_transient_vye_type_xEaspKUrMco', 'v', 'no');
INSERT INTO `wp_options` VALUES('5638', '_transient_timeout_vye_title_xEaspKUrMco', '1387381742', 'no');
INSERT INTO `wp_options` VALUES('5639', '_transient_vye_title_xEaspKUrMco', 'YT - Magic Card Tricks : Earn Money With Card Tricks', 'no');
INSERT INTO `wp_options` VALUES('5640', '_transient_timeout_vye_video_e7826030076bed0956059b80e46410ee', '1387298942', 'no');
INSERT INTO `wp_options` VALUES('5641', '_transient_vye_video_e7826030076bed0956059b80e46410ee', '\n<!-- Vixy YouTube Embed v3.1 -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/xEaspKUrMco?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('5644', '_transient_doing_cron', '1387295936.0000000000000000000000', 'yes');
CREATE TABLE `wp_postmeta` (  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`meta_id`),  KEY `post_id` (`post_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM AUTO_INCREMENT=1542 DEFAULT CHARSET=utf8;
INSERT INTO `wp_postmeta` VALUES('1', '2', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('657', '4', '_mail', 'a:7:{s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:26:\"[your-name] <[your-email]>\";s:4:\"body\";s:185:\"From: [your-name] <[your-email]>\r\nSubject: [your-subject]\r\n\r\nMessage Body:\r\n[your-message]\r\n\r\n--\r\nThis mail is sent via contact form on Blood Pressure Help http://www.plrblogs.com/magic\";s:9:\"recipient\";s:23:\"youremail@youremail.com\";s:18:\"additional_headers\";s:0:\"\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";s:0:\"\";}');
INSERT INTO `wp_postmeta` VALUES('658', '4', '_mail_2', 'a:8:{s:6:\"active\";s:0:\"\";s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:26:\"[your-name] <[your-email]>\";s:4:\"body\";s:124:\"Message body:\r\n[your-message]\r\n\r\n--\r\nThis mail is sent via contact form on Blood Pressure Help http://www.plrblogs.com/magic\";s:9:\"recipient\";s:12:\"[your-email]\";s:18:\"additional_headers\";s:0:\"\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";s:0:\"\";}');
INSERT INTO `wp_postmeta` VALUES('659', '4', '_messages', 'a:13:{s:12:\"mail_sent_ok\";s:43:\"Your message was sent successfully. Thanks.\";s:12:\"mail_sent_ng\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:16:\"validation_error\";s:74:\"Validation errors occurred. Please confirm the fields and submit it again.\";s:12:\"accept_terms\";s:35:\"Please accept the terms to proceed.\";s:13:\"invalid_email\";s:28:\"Email address seems invalid.\";s:16:\"invalid_required\";s:31:\"Please fill the required field.\";s:17:\"akismet_says_spam\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:17:\"captcha_not_match\";s:31:\"Your entered code is incorrect.\";s:13:\"upload_failed\";s:22:\"Failed to upload file.\";s:24:\"upload_file_type_invalid\";s:30:\"This file type is not allowed.\";s:21:\"upload_file_too_large\";s:23:\"This file is too large.\";s:23:\"upload_failed_php_error\";s:38:\"Failed to upload file. Error occurred.\";s:23:\"quiz_answer_not_correct\";s:27:\"Your answer is not correct.\";}');
INSERT INTO `wp_postmeta` VALUES('660', '4', '_additional_settings', '');
INSERT INTO `wp_postmeta` VALUES('7', '2', '_edit_lock', '1353922025:24');
INSERT INTO `wp_postmeta` VALUES('8', '2', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('9', '2', 'image', '');
INSERT INTO `wp_postmeta` VALUES('10', '2', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('11', '2', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('12', '16', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('13', '16', '_edit_lock', '1353922037:24');
INSERT INTO `wp_postmeta` VALUES('14', '16', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('15', '16', 'image', '');
INSERT INTO `wp_postmeta` VALUES('16', '16', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('17', '16', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('18', '19', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('19', '19', '_edit_lock', '1353922065:24');
INSERT INTO `wp_postmeta` VALUES('20', '19', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('21', '19', 'image', '');
INSERT INTO `wp_postmeta` VALUES('22', '19', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('23', '19', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('24', '21', '_edit_last', '27');
INSERT INTO `wp_postmeta` VALUES('25', '21', '_edit_lock', '1387295315:27');
INSERT INTO `wp_postmeta` VALUES('26', '21', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('27', '21', 'image', '');
INSERT INTO `wp_postmeta` VALUES('28', '21', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('29', '21', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('500', '388', 'image', '');
INSERT INTO `wp_postmeta` VALUES('498', '388', '_edit_lock', '1353922044:24');
INSERT INTO `wp_postmeta` VALUES('162', '194', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:26:\"2011/12/banner-example.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:26:\"banner-example-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('161', '194', '_wp_attached_file', '2011/12/banner-example.jpg');
INSERT INTO `wp_postmeta` VALUES('158', '189', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:27:\"2011/12/banner-example2.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:27:\"banner-example2-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('140', '83', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('139', '83', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('138', '83', 'image', '');
INSERT INTO `wp_postmeta` VALUES('135', '83', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('136', '83', '_edit_lock', '1353922058:24');
INSERT INTO `wp_postmeta` VALUES('137', '83', '_wp_page_template', 'sales-page-no-header.php');
INSERT INTO `wp_postmeta` VALUES('157', '189', '_wp_attached_file', '2011/12/banner-example2.jpg');
INSERT INTO `wp_postmeta` VALUES('159', '190', '_wp_attached_file', '2011/12/banner-example3.jpg');
INSERT INTO `wp_postmeta` VALUES('160', '190', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:27:\"2011/12/banner-example3.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:27:\"banner-example3-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('502', '388', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('501', '388', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('499', '388', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('497', '388', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('778', '18', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('779', '18', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('780', '18', '_edit_lock', '1353922050:24');
INSERT INTO `wp_postmeta` VALUES('656', '4', '_form', '<p>Your Name (required)<br />\r\n    [text* your-name] </p>\r\n\r\n<p>Your Email (required)<br />\r\n    [email* your-email] </p>\r\n\r\n<p>Subject<br />\r\n    [text your-subject] </p>\r\n\r\n<p>Your Message<br />\r\n    [textarea your-message] </p>\r\n\r\n<p>[submit \"Send\"]</p>');
INSERT INTO `wp_postmeta` VALUES('1435', '879', '_edit_lock', '1384315346:26');
INSERT INTO `wp_postmeta` VALUES('1437', '878', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1432', '880', '_edit_lock', '1384315343:26');
INSERT INTO `wp_postmeta` VALUES('1433', '879', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1429', '881', '_edit_lock', '1387165473:26');
INSERT INTO `wp_postmeta` VALUES('1430', '880', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1427', '881', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1440', '877', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1439', '878', '_edit_lock', '1387165474:26');
INSERT INTO `wp_postmeta` VALUES('1443', '876', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1442', '877', '_edit_lock', '1387165476:26');
INSERT INTO `wp_postmeta` VALUES('1447', '875', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1445', '876', '_edit_lock', '1387163738:26');
INSERT INTO `wp_postmeta` VALUES('1450', '874', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1449', '875', '_edit_lock', '1387165478:26');
INSERT INTO `wp_postmeta` VALUES('1453', '873', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1452', '874', '_edit_lock', '1387165479:26');
INSERT INTO `wp_postmeta` VALUES('1456', '872', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1455', '873', '_edit_lock', '1384315352:26');
INSERT INTO `wp_postmeta` VALUES('1458', '872', '_edit_lock', '1384315354:26');
INSERT INTO `wp_postmeta` VALUES('1460', '881', 'image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb1.jpg');
INSERT INTO `wp_postmeta` VALUES('1461', '881', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1462', '881', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1464', '880', 'image', '');
INSERT INTO `wp_postmeta` VALUES('1465', '880', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1466', '880', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1468', '879', 'image', '');
INSERT INTO `wp_postmeta` VALUES('1469', '879', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1470', '879', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1472', '878', 'image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb2.jpg');
INSERT INTO `wp_postmeta` VALUES('1473', '878', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1474', '878', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1476', '877', 'image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb3.jpg');
INSERT INTO `wp_postmeta` VALUES('1477', '877', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1478', '877', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1480', '876', 'image', '');
INSERT INTO `wp_postmeta` VALUES('1481', '876', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1482', '876', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1484', '873', 'image', '');
INSERT INTO `wp_postmeta` VALUES('1485', '873', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1486', '873', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1488', '872', 'image', '');
INSERT INTO `wp_postmeta` VALUES('1489', '872', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1490', '872', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1491', '892', '_wp_attached_file', '2013/11/learn-easy-magic-300x250.jpg');
INSERT INTO `wp_postmeta` VALUES('1492', '892', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:300;s:6:\"height\";i:250;s:4:\"file\";s:36:\"2013/11/learn-easy-magic-300x250.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:36:\"learn-easy-magic-300x250-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1493', '893', '_wp_attached_file', '2013/11/professional-magic-tricks-300x250.jpg');
INSERT INTO `wp_postmeta` VALUES('1494', '893', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:300;s:6:\"height\";i:250;s:4:\"file\";s:45:\"2013/11/professional-magic-tricks-300x250.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:45:\"professional-magic-tricks-300x250-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1495', '894', '_wp_attached_file', '2013/11/125x125-Mind-Blowing2.jpg');
INSERT INTO `wp_postmeta` VALUES('1496', '894', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:125;s:6:\"height\";i:125;s:4:\"file\";s:33:\"2013/11/125x125-Mind-Blowing2.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1497', '895', '_wp_attached_file', '2013/11/468x60.jpg');
INSERT INTO `wp_postmeta` VALUES('1498', '895', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:468;s:6:\"height\";i:60;s:4:\"file\";s:18:\"2013/11/468x60.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:17:\"468x60-150x60.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:60;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:17:\"468x60-300x38.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1499', '892', '_edit_lock', '1384604065:26');
INSERT INTO `wp_postmeta` VALUES('1500', '895', '_edit_lock', '1384604065:26');
INSERT INTO `wp_postmeta` VALUES('1501', '893', '_edit_lock', '1384604066:26');
INSERT INTO `wp_postmeta` VALUES('1502', '894', '_edit_lock', '1384604067:26');
INSERT INTO `wp_postmeta` VALUES('1505', '896', '_wp_attached_file', '2013/12/magic-silder1.jpg');
INSERT INTO `wp_postmeta` VALUES('1506', '896', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:580;s:6:\"height\";i:300;s:4:\"file\";s:25:\"2013/12/magic-silder1.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"magic-silder1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"magic-silder1-300x155.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1540', '903', '_wp_attachment_image_alt', 'Learn All The Classic Magic Tricks Today!');
INSERT INTO `wp_postmeta` VALUES('1539', '903', '_edit_lock', '1387165829:26');
INSERT INTO `wp_postmeta` VALUES('1509', '898', '_wp_attached_file', '2013/12/magic-thumb1.jpg');
INSERT INTO `wp_postmeta` VALUES('1510', '898', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:24:\"2013/12/magic-thumb1.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1511', '899', '_wp_attached_file', '2013/12/magic-thumb2.jpg');
INSERT INTO `wp_postmeta` VALUES('1512', '899', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:24:\"2013/12/magic-thumb2.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1513', '900', '_wp_attached_file', '2013/12/magic-thumb3.jpg');
INSERT INTO `wp_postmeta` VALUES('1514', '900', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:24:\"2013/12/magic-thumb3.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1515', '901', '_wp_attached_file', '2013/12/magic-thumb4.jpg');
INSERT INTO `wp_postmeta` VALUES('1516', '901', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:24:\"2013/12/magic-thumb4.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1517', '902', '_wp_attached_file', '2013/12/magic-thumb5.jpg');
INSERT INTO `wp_postmeta` VALUES('1518', '902', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:24:\"2013/12/magic-thumb5.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1519', '896', '_edit_lock', '1387165626:26');
INSERT INTO `wp_postmeta` VALUES('1521', '898', '_edit_lock', '1387165497:26');
INSERT INTO `wp_postmeta` VALUES('1533', '896', '_wp_attachment_image_alt', 'Impress Friends And Family With Easy To Learn Magic Tricks!');
INSERT INTO `wp_postmeta` VALUES('1526', '875', 'image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb4.jpg');
INSERT INTO `wp_postmeta` VALUES('1527', '875', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1528', '875', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1530', '874', 'image', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb5.jpg');
INSERT INTO `wp_postmeta` VALUES('1531', '874', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1532', '874', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1534', '896', '_edit_last', '26');
INSERT INTO `wp_postmeta` VALUES('1538', '903', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:580;s:6:\"height\";i:300;s:4:\"file\";s:25:\"2013/12/magic-silder2.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:25:\"magic-silder2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:25:\"magic-silder2-300x155.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1537', '903', '_wp_attached_file', '2013/12/magic-silder2.jpg');
INSERT INTO `wp_postmeta` VALUES('1541', '903', '_edit_last', '26');
CREATE TABLE `wp_posts` (  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_content` longtext NOT NULL,  `post_title` text NOT NULL,  `post_excerpt` text NOT NULL,  `post_status` varchar(20) NOT NULL DEFAULT 'publish',  `comment_status` varchar(20) NOT NULL DEFAULT 'open',  `ping_status` varchar(20) NOT NULL DEFAULT 'open',  `post_password` varchar(20) NOT NULL DEFAULT '',  `post_name` varchar(200) NOT NULL DEFAULT '',  `to_ping` text NOT NULL,  `pinged` text NOT NULL,  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_content_filtered` longtext NOT NULL,  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `guid` varchar(255) NOT NULL DEFAULT '',  `menu_order` int(11) NOT NULL DEFAULT '0',  `post_type` varchar(20) NOT NULL DEFAULT 'post',  `post_mime_type` varchar(100) NOT NULL DEFAULT '',  `comment_count` bigint(20) NOT NULL DEFAULT '0',  PRIMARY KEY (`ID`),  KEY `post_name` (`post_name`),  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),  KEY `post_parent` (`post_parent`),  KEY `post_author` (`post_author`)) ENGINE=MyISAM AUTO_INCREMENT=908 DEFAULT CHARSET=utf8;
INSERT INTO `wp_posts` VALUES('2', '28', '2012-11-08 04:18:50', '2012-11-08 04:18:50', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'publish', 'open', 'closed', '', 'about', '', '', '2012-11-26 09:27:05', '2012-11-26 09:27:05', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=2', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('16', '28', '2012-11-08 21:22:43', '2012-11-08 21:22:43', '[contact-form-7 id=\"4\" title=\"Contact form 1\"]', 'Contact', '', 'publish', 'open', 'closed', '', 'contact', '', '', '2012-11-26 09:27:17', '2012-11-26 09:27:17', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=16', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('17', '28', '2011-12-08 21:22:38', '2011-12-08 21:22:38', '', 'Contact', '', 'inherit', 'open', 'open', '', '16-revision', '', '', '2011-12-08 21:22:38', '2011-12-08 21:22:38', '', '16', 'http://www.plrblogs.com/bloodpressure/uncategorized/16-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('18', '28', '2012-11-08 21:23:31', '2012-11-08 21:23:31', '<strong>Your Privacy</strong><br/>Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.<p/><strong>Google Adsense and the DoubleClick DART Cookie</strong><br/>Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url <a href=\"http://www.google.com/privacy_ads.html\">http://www.google.com/privacy_ads.html</a> Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies,  has no access or control over these cookies that may be used by third party advertisers.<p/><strong>Collection of Personal Information</strong><br/>When visiting , the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n<p/><strong>Links to third party Websites</strong><br/>We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n<p/><strong>Changes to this Privacy Statement</strong><br/>The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of  then you may contact us at <p/>', 'Privacy Policy', '', 'publish', 'closed', 'closed', '', 'privacy-policy', '', '', '2012-11-26 09:27:30', '2012-11-26 09:27:30', '', '0', 'http://www.plrblogs.com/bloodpressure/privacy-policy', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('4', '28', '2011-12-08 20:59:30', '2011-12-08 20:59:30', '', 'Contact form 1', '', 'publish', 'closed', 'open', '', 'contact-form-1', '', '', '2011-12-08 20:59:30', '2011-12-08 20:59:30', '', '0', 'http://www.plrblogs.com/bloodpressure/?wpcf7_contact_form=contact-form-1', '0', 'wpcf7_contact_form', '', '0');
INSERT INTO `wp_posts` VALUES('5', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Logo', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_logo', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=5', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('6', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Custom Favicon', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_custom_favicon', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=6', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('7', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 1', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_1', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=7', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('8', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 2', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_2', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=8', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('9', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 3', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_3', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=9', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('10', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 1', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_1', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=10', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('11', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 2', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_2', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=11', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('12', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 3', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_3', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=12', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('13', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Ad Top Image', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_ad_top_image', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=13', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('14', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Ad Content Image', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_ad_content_image', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=14', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('15', '28', '2011-12-08 04:18:50', '2011-12-08 04:18:50', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://www.plrblogs.com/magic/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'inherit', 'open', 'open', '', '2-revision', '', '', '2011-12-08 04:18:50', '2011-12-08 04:18:50', '', '2', 'http://www.plrblogs.com/bloodpressure/?p=15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('19', '28', '2012-11-08 21:24:17', '2012-11-08 21:24:17', '<!-- ddsitemapgen -->', 'Sitemap', '', 'publish', 'open', 'closed', '', 'sitemap', '', '', '2012-11-26 09:27:45', '2012-11-26 09:27:45', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=19', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('20', '28', '2011-12-08 21:23:55', '2011-12-08 21:23:55', '', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-revision', '', '', '2011-12-08 21:23:55', '2011-12-08 21:23:55', '', '19', 'http://www.plrblogs.com/bloodpressure/uncategorized/19-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('21', '28', '2013-10-08 21:25:50', '2013-10-08 21:25:50', '[youtube width=570 height=390]eQU7p52El4k[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]88AWZwleTns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]E6VWi7IaroA[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xEaspKUrMco[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Magic Videos', '', 'publish', 'open', 'closed', '', 'magic-videos', '', '', '2013-12-17 15:48:34', '2013-12-17 15:48:34', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=21', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('869', '28', '2013-11-11 20:49:16', '2013-11-11 20:49:16', '<ul>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-11 20:49:16', '2013-11-11 20:49:16', '', '21', 'http://www.plrblogs.com/aviarybirdhouseplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('22', '28', '2011-12-08 21:25:20', '2011-12-08 21:25:20', '', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:25:20', '2011-12-08 21:25:20', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('23', '28', '2011-12-08 21:25:50', '2011-12-08 21:25:50', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]J2C_7QLwsnc[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]IBbEBFsfheU[/youtube]</span>[youtube width=270 height=200]I3BxvHhz4XQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]h_FZMRZ1_Xg[/youtube]</span>[youtube width=270 height=200]UFSc3rrAYLQ[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:25:50', '2011-12-08 21:25:50', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('24', '28', '2011-12-08 21:26:50', '2011-12-08 21:26:50', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=270 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=270 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:26:50', '2011-12-08 21:26:50', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('25', '28', '2011-12-08 21:27:16', '2011-12-08 21:27:16', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=260 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=260 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=260 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=260 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:27:16', '2011-12-08 21:27:16', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('26', '28', '2011-12-08 21:27:38', '2011-12-08 21:27:38', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=250 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:27:38', '2011-12-08 21:27:38', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('27', '28', '2011-12-08 21:29:07', '2011-12-08 21:29:07', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:29:07', '2011-12-08 21:29:07', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-6', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('28', '28', '2011-12-08 21:45:04', '2011-12-08 21:45:04', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:45:04', '2011-12-08 21:45:04', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-7', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('29', '28', '2013-11-13 02:43:06', '2013-11-13 02:43:06', '[youtube width=570 height=390][/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\n[youtube width=570 height=390][/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\n[youtube width=570 height=390][/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\n[youtube width=570 height=390][/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Magic Videos', '', 'inherit', 'open', 'open', '', '21-autosave-v1', '', '', '2013-11-13 02:43:06', '2013-11-13 02:43:06', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('743', '28', '2013-07-05 13:31:56', '2013-07-05 13:31:56', 'Beer Brewing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]Kw8wV5NkOf4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]otxFTHi1bKY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]Ay2_RpC7JRw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]5WGHkNPqCS8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]6f1jJ_K8hhk[/youtube]', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 13:31:56', '2013-07-05 13:31:56', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-26', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('82', '28', '2011-12-09 06:10:24', '2011-12-09 06:10:24', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-autosave', '', '', '2011-12-09 06:10:24', '2011-12-09 06:10:24', '', '2', 'http://www.plrblogs.com/bloodpressure/uncategorized/2-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('30', '28', '2011-12-08 21:45:41', '2011-12-08 21:45:41', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]</span>\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]</span>', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:45:41', '2011-12-08 21:45:41', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-8', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('31', '28', '2011-12-08 21:47:28', '2011-12-08 21:47:28', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ONytpf8Rihs[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]vWK6vWGeSMQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:47:28', '2011-12-08 21:47:28', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-9', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('385', '28', '2012-04-24 08:57:26', '2012-04-24 08:57:26', 'Acne Scar Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 08:57:26', '2012-04-24 08:57:26', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-16', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('389', '28', '2012-04-25 12:31:06', '2012-04-25 12:31:06', '', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision', '', '', '2012-04-25 12:31:06', '2012-04-25 12:31:06', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('294', '28', '2011-12-08 21:49:13', '2011-12-08 21:49:13', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ONytpf8Rihs[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]vWK6vWGeSMQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:49:13', '2011-12-08 21:49:13', '', '21', 'http://www.plrblogs.com/wartremoval/uncategorized/21-revision-10', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('380', '28', '2012-02-16 14:50:50', '2012-02-16 14:50:50', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Wart Removal Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-02-16 14:50:50', '2012-02-16 14:50:50', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-11', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('381', '28', '2012-04-24 05:59:17', '2012-04-24 05:59:17', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:17', '2012-04-24 05:59:17', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-12', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('382', '28', '2012-04-24 05:59:24', '2012-04-24 05:59:24', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:24', '2012-04-24 05:59:24', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-13', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('383', '28', '2012-04-24 05:59:30', '2012-04-24 05:59:30', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:30', '2012-04-24 05:59:30', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-14', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('384', '28', '2012-04-24 08:56:28', '2012-04-24 08:56:28', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 08:56:28', '2012-04-24 08:56:28', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('194', '28', '2011-12-11 20:36:21', '2011-12-11 20:36:21', '', 'banner-example', '', 'inherit', 'open', 'open', '', 'banner-example', '', '', '2011-12-11 20:36:21', '2011-12-11 20:36:21', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('392', '28', '2012-04-25 12:41:42', '2012-04-25 12:41:42', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-4', '', '', '2012-04-25 12:41:42', '2012-04-25 12:41:42', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('460', '28', '2012-04-24 09:12:53', '2012-04-24 09:12:53', 'Acne Scar Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 09:12:53', '2012-04-24 09:12:53', '', '21', 'http://www.plrblogs.com/clickbank/uncategorized/21-revision-17', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('77', '28', '2011-12-09 03:04:10', '2011-12-09 03:04:10', '', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-autosave', '', '', '2011-12-09 03:04:10', '2011-12-09 03:04:10', '', '19', 'http://www.plrblogs.com/bloodpressure/uncategorized/19-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('83', '28', '2012-10-09 13:33:36', '2012-10-09 13:33:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'draft', 'open', 'closed', '', 'sample-sales-page', '', '', '2012-11-26 09:27:38', '2012-11-26 09:27:38', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=83', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('142', '28', '2011-12-09 18:41:51', '2011-12-09 18:41:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-58', '', '', '2011-12-09 18:41:51', '2011-12-09 18:41:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-58', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('126', '28', '2011-12-09 16:13:49', '2011-12-09 16:13:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-42', '', '', '2011-12-09 16:13:49', '2011-12-09 16:13:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-42', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('85', '28', '2011-12-09 13:33:36', '2011-12-09 13:33:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-2', '', '', '2011-12-09 13:33:36', '2011-12-09 13:33:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('84', '28', '2011-12-09 13:32:38', '2011-12-09 13:32:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\n\nAdd Feature/Benefit Bullet Points Here!\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n<li class=\"bullet\">Control background color, border color, and even border radius!</li>\n<li class=\"bullet\">Control width of page, padding (spacing) of inside page area!</li>\n<li class=\"bullet\">Comes with the FREE version of WP Graphix Magic, my newest plugin!</li>\n<li class=\"bullet\">Highlight text, add colored buttons, add badges, bullets, Buy Now Buttons!</li>\n<li class=\"bullet\">and much more!</li>\n</ul>\n[/wpgfxm_bullets]\n[/wpgfxm_contentbox]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\n\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\n\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\n\nHere is some text you can enter\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n<li class=\"bullet\">Enter List Info Enter List Info Enter List Info Enter List Info</li>\n<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\n<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\n\n[/wpgfxm_salesboxes]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_bullets bullet=\"green-tick-3\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-1\" ]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_divider divider_image=\"css\" ]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\n\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\n\n&nbsp;\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\n\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision', '', '', '2011-12-09 13:32:38', '2011-12-09 13:32:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('86', '28', '2011-12-09 13:35:48', '2011-12-09 13:35:48', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-3', '', '', '2011-12-09 13:35:48', '2011-12-09 13:35:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('87', '28', '2011-12-09 13:36:25', '2011-12-09 13:36:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-4', '', '', '2011-12-09 13:36:25', '2011-12-09 13:36:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('88', '28', '2011-12-12 01:25:47', '2011-12-12 01:25:47', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\n\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\n\n&nbsp;\n\nFrom the desk of: John Smith\n\n<strong>Dear site visitor,</strong>\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\nAdd Feature/Benefit Bullet Points Here!\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n</ul>\n[/wpgfxm_bullets]\n[/wpgfxm_contentbox]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\n\nHere you mention about your superb money back, 100% satisfaction guarantee!\n\n&nbsp;\n\n[/wpgfxm_contentbox]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_divider divider_image=\"divider-1\"]\n\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\n\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\nHere is some text you can enter\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\n\n[/wpgfxm_salesboxes]\n\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-autosave', '', '', '2011-12-12 01:25:47', '2011-12-12 01:25:47', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('125', '28', '2011-12-09 15:51:08', '2011-12-09 15:51:08', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-41', '', '', '2011-12-09 15:51:08', '2011-12-09 15:51:08', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-41', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('90', '28', '2011-12-09 13:46:33', '2011-12-09 13:46:33', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-6', '', '', '2011-12-09 13:46:33', '2011-12-09 13:46:33', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-6', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('89', '28', '2011-12-09 13:37:00', '2011-12-09 13:37:00', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-5', '', '', '2011-12-09 13:37:00', '2011-12-09 13:37:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('91', '28', '2011-12-09 13:47:41', '2011-12-09 13:47:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\nIt\'s never been easier to create custom sales pages like this, all within seconds!\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-7', '', '', '2011-12-09 13:47:41', '2011-12-09 13:47:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-7', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('124', '28', '2011-12-09 15:50:36', '2011-12-09 15:50:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-40', '', '', '2011-12-09 15:50:36', '2011-12-09 15:50:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-40', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('92', '28', '2011-12-09 13:48:28', '2011-12-09 13:48:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-8', '', '', '2011-12-09 13:48:28', '2011-12-09 13:48:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-8', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('98', '28', '2011-12-09 13:51:01', '2011-12-09 13:51:01', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-14', '', '', '2011-12-09 13:51:01', '2011-12-09 13:51:01', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-14', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('93', '28', '2011-12-09 13:48:52', '2011-12-09 13:48:52', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-9', '', '', '2011-12-09 13:48:52', '2011-12-09 13:48:52', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-9', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('94', '28', '2011-12-09 13:49:07', '2011-12-09 13:49:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"150%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-10', '', '', '2011-12-09 13:49:07', '2011-12-09 13:49:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-10', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('95', '28', '2011-12-09 13:49:28', '2011-12-09 13:49:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-11', '', '', '2011-12-09 13:49:28', '2011-12-09 13:49:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-11', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('96', '28', '2011-12-09 13:49:39', '2011-12-09 13:49:39', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-12', '', '', '2011-12-09 13:49:39', '2011-12-09 13:49:39', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-12', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('97', '28', '2011-12-09 13:50:15', '2011-12-09 13:50:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-13', '', '', '2011-12-09 13:50:15', '2011-12-09 13:50:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-13', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('99', '28', '2011-12-09 13:51:25', '2011-12-09 13:51:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-15', '', '', '2011-12-09 13:51:25', '2011-12-09 13:51:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('100', '28', '2011-12-09 13:51:42', '2011-12-09 13:51:42', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-16', '', '', '2011-12-09 13:51:42', '2011-12-09 13:51:42', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-16', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('101', '28', '2011-12-09 13:52:05', '2011-12-09 13:52:05', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-17', '', '', '2011-12-09 13:52:05', '2011-12-09 13:52:05', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-17', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('102', '28', '2011-12-09 13:57:02', '2011-12-09 13:57:02', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"90%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-18', '', '', '2011-12-09 13:57:02', '2011-12-09 13:57:02', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-18', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('103', '28', '2011-12-09 13:57:18', '2011-12-09 13:57:18', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-19', '', '', '2011-12-09 13:57:18', '2011-12-09 13:57:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-19', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('105', '28', '2011-12-09 14:26:38', '2011-12-09 14:26:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-21', '', '', '2011-12-09 14:26:38', '2011-12-09 14:26:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-21', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('123', '28', '2011-12-09 15:07:02', '2011-12-09 15:07:02', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-39', '', '', '2011-12-09 15:07:02', '2011-12-09 15:07:02', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-39', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('104', '28', '2011-12-09 14:24:27', '2011-12-09 14:24:27', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-20', '', '', '2011-12-09 14:24:27', '2011-12-09 14:24:27', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-20', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('106', '28', '2011-12-09 14:27:07', '2011-12-09 14:27:07', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-22', '', '', '2011-12-09 14:27:07', '2011-12-09 14:27:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-22', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('107', '28', '2011-12-09 14:27:20', '2011-12-09 14:27:20', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"70%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-23', '', '', '2011-12-09 14:27:20', '2011-12-09 14:27:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-23', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('108', '28', '2011-12-09 14:27:31', '2011-12-09 14:27:31', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"80%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-24', '', '', '2011-12-09 14:27:31', '2011-12-09 14:27:31', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-24', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('109', '28', '2011-12-09 14:27:43', '2011-12-09 14:27:43', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"90%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-25', '', '', '2011-12-09 14:27:43', '2011-12-09 14:27:43', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-25', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('113', '28', '2011-12-09 14:41:17', '2011-12-09 14:41:17', '&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-29', '', '', '2011-12-09 14:41:17', '2011-12-09 14:41:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-29', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('110', '28', '2011-12-09 14:28:00', '2011-12-09 14:28:00', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-26', '', '', '2011-12-09 14:28:00', '2011-12-09 14:28:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-26', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('111', '28', '2011-12-09 14:28:21', '2011-12-09 14:28:21', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"200%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-27', '', '', '2011-12-09 14:28:21', '2011-12-09 14:28:21', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-27', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('112', '28', '2011-12-09 14:40:55', '2011-12-09 14:40:55', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-28', '', '', '2011-12-09 14:40:55', '2011-12-09 14:40:55', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-28', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('114', '28', '2011-12-09 14:41:38', '2011-12-09 14:41:38', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-30', '', '', '2011-12-09 14:41:38', '2011-12-09 14:41:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-30', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('115', '28', '2011-12-09 14:48:38', '2011-12-09 14:48:38', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"20%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-31', '', '', '2011-12-09 14:48:38', '2011-12-09 14:48:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-31', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('117', '28', '2011-12-09 15:01:46', '2011-12-09 15:01:46', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-33', '', '', '2011-12-09 15:01:46', '2011-12-09 15:01:46', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-33', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('116', '28', '2011-12-09 15:00:09', '2011-12-09 15:00:09', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-32', '', '', '2011-12-09 15:00:09', '2011-12-09 15:00:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-32', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('118', '28', '2011-12-09 15:02:06', '2011-12-09 15:02:06', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"30%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-34', '', '', '2011-12-09 15:02:06', '2011-12-09 15:02:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-34', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('119', '28', '2011-12-09 15:02:19', '2011-12-09 15:02:19', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"40%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-35', '', '', '2011-12-09 15:02:19', '2011-12-09 15:02:19', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-35', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('120', '28', '2011-12-09 15:02:48', '2011-12-09 15:02:48', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"60%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-36', '', '', '2011-12-09 15:02:48', '2011-12-09 15:02:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-36', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('121', '28', '2011-12-09 15:03:03', '2011-12-09 15:03:03', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"10%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-37', '', '', '2011-12-09 15:03:03', '2011-12-09 15:03:03', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-37', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('122', '28', '2011-12-09 15:03:15', '2011-12-09 15:03:15', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"20%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-38', '', '', '2011-12-09 15:03:15', '2011-12-09 15:03:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-38', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('127', '28', '2011-12-09 16:14:18', '2011-12-09 16:14:18', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-43', '', '', '2011-12-09 16:14:18', '2011-12-09 16:14:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-43', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('128', '28', '2011-12-09 16:15:00', '2011-12-09 16:15:00', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-44', '', '', '2011-12-09 16:15:00', '2011-12-09 16:15:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-44', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('129', '28', '2011-12-09 16:21:20', '2011-12-09 16:21:20', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-45', '', '', '2011-12-09 16:21:20', '2011-12-09 16:21:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-45', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('132', '28', '2011-12-09 16:51:39', '2011-12-09 16:51:39', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Your 30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-48', '', '', '2011-12-09 16:51:39', '2011-12-09 16:51:39', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-48', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('131', '28', '2011-12-09 16:27:16', '2011-12-09 16:27:16', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-47', '', '', '2011-12-09 16:27:16', '2011-12-09 16:27:16', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-47', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('130', '28', '2011-12-09 16:24:15', '2011-12-09 16:24:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-46', '', '', '2011-12-09 16:24:15', '2011-12-09 16:24:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-46', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('141', '28', '2011-12-09 18:40:58', '2011-12-09 18:40:58', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-57', '', '', '2011-12-09 18:40:58', '2011-12-09 18:40:58', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-57', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('133', '28', '2011-12-09 16:52:25', '2011-12-09 16:52:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-49', '', '', '2011-12-09 16:52:25', '2011-12-09 16:52:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-49', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('135', '28', '2011-12-09 16:56:41', '2011-12-09 16:56:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-51', '', '', '2011-12-09 16:56:41', '2011-12-09 16:56:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-51', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('134', '28', '2011-12-09 16:52:47', '2011-12-09 16:52:47', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-50', '', '', '2011-12-09 16:52:47', '2011-12-09 16:52:47', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-50', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('136', '28', '2011-12-09 16:57:17', '2011-12-09 16:57:17', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-52', '', '', '2011-12-09 16:57:17', '2011-12-09 16:57:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-52', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('137', '28', '2011-12-09 16:57:56', '2011-12-09 16:57:56', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-53', '', '', '2011-12-09 16:57:56', '2011-12-09 16:57:56', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-53', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('138', '28', '2011-12-09 16:58:22', '2011-12-09 16:58:22', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-54', '', '', '2011-12-09 16:58:22', '2011-12-09 16:58:22', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-54', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('140', '28', '2011-12-09 17:04:28', '2011-12-09 17:04:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-56', '', '', '2011-12-09 17:04:28', '2011-12-09 17:04:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-56', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('139', '28', '2011-12-09 16:58:51', '2011-12-09 16:58:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-55', '', '', '2011-12-09 16:58:51', '2011-12-09 16:58:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-55', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('143', '28', '2011-12-09 18:42:09', '2011-12-09 18:42:09', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-59', '', '', '2011-12-09 18:42:09', '2011-12-09 18:42:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-59', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('144', '28', '2011-12-09 18:44:06', '2011-12-09 18:44:06', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-60', '', '', '2011-12-09 18:44:06', '2011-12-09 18:44:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-60', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('145', '28', '2011-12-09 18:44:59', '2011-12-09 18:44:59', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=570 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-61', '', '', '2011-12-09 18:44:59', '2011-12-09 18:44:59', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-61', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('146', '28', '2011-12-09 18:45:15', '2011-12-09 18:45:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-62', '', '', '2011-12-09 18:45:15', '2011-12-09 18:45:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-62', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('147', '28', '2011-12-09 18:46:07', '2011-12-09 18:46:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-63', '', '', '2011-12-09 18:46:07', '2011-12-09 18:46:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-63', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('148', '28', '2011-12-09 18:46:29', '2011-12-09 18:46:29', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-64', '', '', '2011-12-09 18:46:29', '2011-12-09 18:46:29', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-64', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('149', '28', '2011-12-09 18:46:54', '2011-12-09 18:46:54', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-65', '', '', '2011-12-09 18:46:54', '2011-12-09 18:46:54', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-65', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('150', '28', '2011-12-09 18:47:25', '2011-12-09 18:47:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-66', '', '', '2011-12-09 18:47:25', '2011-12-09 18:47:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-66', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('152', '28', '2011-12-09 18:48:37', '2011-12-09 18:48:37', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-68', '', '', '2011-12-09 18:48:37', '2011-12-09 18:48:37', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-68', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('151', '28', '2011-12-09 18:48:07', '2011-12-09 18:48:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"16px\" color=\"#000000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Dear site visitor,[/wpgfxm_headlines]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-67', '', '', '2011-12-09 18:48:07', '2011-12-09 18:48:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-67', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('154', '28', '2011-12-09 18:49:41', '2011-12-09 18:49:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-70', '', '', '2011-12-09 18:49:41', '2011-12-09 18:49:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-70', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('153', '28', '2011-12-09 18:49:15', '2011-12-09 18:49:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-69', '', '', '2011-12-09 18:49:15', '2011-12-09 18:49:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-69', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('159', '28', '2011-12-09 19:03:38', '2011-12-09 19:03:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-75', '', '', '2011-12-09 19:03:38', '2011-12-09 19:03:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-75', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('155', '28', '2011-12-09 18:58:49', '2011-12-09 18:58:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-71', '', '', '2011-12-09 18:58:49', '2011-12-09 18:58:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-71', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('156', '28', '2011-12-09 19:00:13', '2011-12-09 19:00:13', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-72', '', '', '2011-12-09 19:00:13', '2011-12-09 19:00:13', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-72', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('160', '28', '2011-12-09 19:06:23', '2011-12-09 19:06:23', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\nMaybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want!\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-76', '', '', '2011-12-09 19:06:23', '2011-12-09 19:06:23', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-76', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('157', '28', '2011-12-09 19:02:13', '2011-12-09 19:02:13', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-73', '', '', '2011-12-09 19:02:13', '2011-12-09 19:02:13', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-73', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('158', '28', '2011-12-09 19:02:40', '2011-12-09 19:02:40', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-74', '', '', '2011-12-09 19:02:40', '2011-12-09 19:02:40', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-74', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('164', '28', '2011-12-09 19:14:49', '2011-12-09 19:14:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-80', '', '', '2011-12-09 19:14:49', '2011-12-09 19:14:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-80', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('163', '28', '2011-12-09 19:10:40', '2011-12-09 19:10:40', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"80%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-79', '', '', '2011-12-09 19:10:40', '2011-12-09 19:10:40', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-79', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('161', '28', '2011-12-09 19:07:35', '2011-12-09 19:07:35', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"800%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-77', '', '', '2011-12-09 19:07:35', '2011-12-09 19:07:35', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-77', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('162', '28', '2011-12-09 19:08:51', '2011-12-09 19:08:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"80%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-78', '', '', '2011-12-09 19:08:51', '2011-12-09 19:08:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-78', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('169', '28', '2011-12-09 19:17:36', '2011-12-09 19:17:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-85', '', '', '2011-12-09 19:17:36', '2011-12-09 19:17:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-85', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('165', '28', '2011-12-09 19:15:17', '2011-12-09 19:15:17', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#000000\" ]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-81', '', '', '2011-12-09 19:15:17', '2011-12-09 19:15:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-81', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('166', '28', '2011-12-09 19:15:46', '2011-12-09 19:15:46', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-82', '', '', '2011-12-09 19:15:46', '2011-12-09 19:15:46', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-82', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('167', '28', '2011-12-09 19:16:15', '2011-12-09 19:16:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-83', '', '', '2011-12-09 19:16:15', '2011-12-09 19:16:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-83', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('168', '28', '2011-12-09 19:16:33', '2011-12-09 19:16:33', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-84', '', '', '2011-12-09 19:16:33', '2011-12-09 19:16:33', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-84', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('170', '28', '2011-12-09 19:21:28', '2011-12-09 19:21:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-86', '', '', '2011-12-09 19:21:28', '2011-12-09 19:21:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-86', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('171', '28', '2011-12-09 19:21:48', '2011-12-09 19:21:48', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-87', '', '', '2011-12-09 19:21:48', '2011-12-09 19:21:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-87', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('172', '28', '2011-12-09 19:22:11', '2011-12-09 19:22:11', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-88', '', '', '2011-12-09 19:22:11', '2011-12-09 19:22:11', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-88', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('173', '28', '2011-12-09 20:13:12', '2011-12-09 20:13:12', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-89', '', '', '2011-12-09 20:13:12', '2011-12-09 20:13:12', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-89', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('174', '28', '2011-12-09 20:13:30', '2011-12-09 20:13:30', '[wpgfxm_headlines font=\"Impact\" size=\"50px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-90', '', '', '2011-12-09 20:13:30', '2011-12-09 20:13:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-90', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('175', '28', '2011-12-09 20:14:05', '2011-12-09 20:14:05', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-91', '', '', '2011-12-09 20:14:05', '2011-12-09 20:14:05', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-91', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('176', '28', '2011-12-09 20:16:09', '2011-12-09 20:16:09', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]GRmDGvdkg8E[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-92', '', '', '2011-12-09 20:16:09', '2011-12-09 20:16:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-92', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('177', '28', '2011-12-09 20:22:59', '2011-12-09 20:22:59', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-93', '', '', '2011-12-09 20:22:59', '2011-12-09 20:22:59', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-93', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('178', '28', '2011-12-09 20:23:54', '2011-12-09 20:23:54', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-94', '', '', '2011-12-09 20:23:54', '2011-12-09 20:23:54', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-94', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('189', '28', '2011-12-10 01:34:25', '2011-12-10 01:34:25', '', 'banner-example2', '', 'inherit', 'open', 'open', '', 'banner-example2', '', '', '2011-12-10 01:34:25', '2011-12-10 01:34:25', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('190', '28', '2011-12-10 01:34:26', '2011-12-10 01:34:26', '', 'banner-example3', '', 'inherit', 'open', 'open', '', 'banner-example3', '', '', '2011-12-10 01:34:26', '2011-12-10 01:34:26', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example3.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('183', '28', '2011-12-09 20:24:26', '2011-12-09 20:24:26', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-95', '', '', '2011-12-09 20:24:26', '2011-12-09 20:24:26', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-95', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('184', '28', '2011-12-09 22:11:20', '2011-12-09 22:11:20', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-96', '', '', '2011-12-09 22:11:20', '2011-12-09 22:11:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-96', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('192', '28', '2011-12-09 23:40:18', '2011-12-09 23:40:18', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-97', '', '', '2011-12-09 23:40:18', '2011-12-09 23:40:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-97', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('196', '28', '2011-12-11 19:38:17', '2011-12-11 19:38:17', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-98', '', '', '2011-12-11 19:38:17', '2011-12-11 19:38:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-98', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('197', '28', '2011-12-12 00:56:08', '2011-12-12 00:56:08', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-99', '', '', '2011-12-12 00:56:08', '2011-12-12 00:56:08', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-99', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('198', '28', '2011-12-12 01:00:24', '2011-12-12 01:00:24', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-100', '', '', '2011-12-12 01:00:24', '2011-12-12 01:00:24', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-100', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('199', '28', '2011-12-12 01:06:19', '2011-12-12 01:06:19', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-101', '', '', '2011-12-12 01:06:19', '2011-12-12 01:06:19', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-101', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('201', '28', '2011-12-12 01:07:45', '2011-12-12 01:07:45', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-103', '', '', '2011-12-12 01:07:45', '2011-12-12 01:07:45', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-103', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('200', '28', '2011-12-12 01:07:30', '2011-12-12 01:07:30', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-102', '', '', '2011-12-12 01:07:30', '2011-12-12 01:07:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-102', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('202', '28', '2011-12-12 01:08:36', '2011-12-12 01:08:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-104', '', '', '2011-12-12 01:08:36', '2011-12-12 01:08:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-104', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('205', '28', '2011-12-12 01:09:30', '2011-12-12 01:09:30', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-107', '', '', '2011-12-12 01:09:30', '2011-12-12 01:09:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-107', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('203', '28', '2011-12-12 01:08:55', '2011-12-12 01:08:55', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-105', '', '', '2011-12-12 01:08:55', '2011-12-12 01:08:55', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-105', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('204', '28', '2011-12-12 01:09:06', '2011-12-12 01:09:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-106', '', '', '2011-12-12 01:09:06', '2011-12-12 01:09:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-106', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('207', '28', '2011-12-12 01:10:06', '2011-12-12 01:10:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-109', '', '', '2011-12-12 01:10:06', '2011-12-12 01:10:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-109', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('206', '28', '2011-12-12 01:09:45', '2011-12-12 01:09:45', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-108', '', '', '2011-12-12 01:09:45', '2011-12-12 01:09:45', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-108', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('208', '28', '2011-12-12 01:10:36', '2011-12-12 01:10:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-110', '', '', '2011-12-12 01:10:36', '2011-12-12 01:10:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-110', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('209', '28', '2011-12-12 01:23:32', '2011-12-12 01:23:32', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-111', '', '', '2011-12-12 01:23:32', '2011-12-12 01:23:32', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-111', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('233', '28', '2011-12-12 01:24:41', '2011-12-12 01:24:41', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-112', '', '', '2011-12-12 01:24:41', '2011-12-12 01:24:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-112', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('235', '28', '2011-12-12 05:08:06', '2011-12-12 05:08:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n \r\n\r\nFrom the desk of: John Smith\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n \r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n \r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]Disclaimer: Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-114', '', '', '2011-12-12 05:08:06', '2011-12-12 05:08:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-114', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('234', '28', '2011-12-12 05:07:28', '2011-12-12 05:07:28', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere are just a few of the options available:\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Control background color, border color, and even border radius!</li>\r\n	<li class=\"bullet\">Control width of page, padding (spacing) of inside page area!</li>\r\n	<li class=\"bullet\">Comes with the FREE version of WP Graphix Magic, my newest plugin!</li>\r\n	<li class=\"bullet\">Highlight text, add colored buttons, add badges, bullets, Buy Now Buttons!</li>\r\n	<li class=\"bullet\">and much more!</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info Enter List Info Enter List Info Enter List Info</li>\r\n	<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\r\n	<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-113', '', '', '2011-12-12 05:07:28', '2011-12-12 05:07:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-113', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('244', '28', '2011-12-12 05:10:01', '2011-12-12 05:10:01', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-115', '', '', '2011-12-12 05:10:01', '2011-12-12 05:10:01', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-115', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('247', '28', '2011-12-12 09:17:27', '2011-12-12 09:17:27', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-116', '', '', '2011-12-12 09:17:27', '2011-12-12 09:17:27', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-116', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('248', '28', '2011-12-13 00:49:07', '2011-12-13 00:49:07', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-117', '', '', '2011-12-13 00:49:07', '2011-12-13 00:49:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-117', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('249', '28', '2011-12-13 00:49:36', '2011-12-13 00:49:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-118', '', '', '2011-12-13 00:49:36', '2011-12-13 00:49:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-118', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('250', '28', '2011-12-13 01:12:23', '2011-12-13 01:12:23', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-119', '', '', '2011-12-13 01:12:23', '2011-12-13 01:12:23', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-119', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('388', '28', '2012-10-25 12:31:11', '2012-10-25 12:31:11', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'publish', 'open', 'closed', '', 'disclosure-policy', '', '', '2012-11-26 09:27:24', '2012-11-26 09:27:24', '', '0', 'http://www.plrblogs.com/acnescars/?page_id=388', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('255', '28', '2011-12-13 01:12:48', '2011-12-13 01:12:48', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-120', '', '', '2011-12-13 01:12:48', '2011-12-13 01:12:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-120', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('256', '28', '2011-12-15 04:05:00', '2011-12-15 04:05:00', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-121', '', '', '2011-12-15 04:05:00', '2011-12-15 04:05:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-121', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('390', '28', '2012-04-25 12:31:11', '2012-04-25 12:31:11', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers’ website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-2', '', '', '2012-04-25 12:31:11', '2012-04-25 12:31:11', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('391', '28', '2012-04-25 12:37:55', '2012-04-25 12:37:55', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-3', '', '', '2012-04-25 12:37:55', '2012-04-25 12:37:55', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('536', '28', '2012-06-28 17:56:59', '2012-06-28 17:56:59', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Clickbank Marketing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-06-28 17:56:59', '2012-06-28 17:56:59', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-19', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('537', '28', '2012-11-22 19:51:35', '2012-11-22 19:51:35', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-22 19:51:35', '2012-11-22 19:51:35', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-20', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('538', '28', '2011-12-08 21:20:39', '2011-12-08 21:20:39', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-2', '', '', '2011-12-08 21:20:39', '2011-12-08 21:20:39', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('539', '28', '2012-11-25 21:44:55', '2012-11-25 21:44:55', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-3', '', '', '2012-11-25 21:44:55', '2012-11-25 21:44:55', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('404', '28', '2012-06-17 02:21:03', '2012-06-17 02:21:03', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\n\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\n\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\n\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\n\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\n\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\n\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\n\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\n\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-autosave', '', '', '2012-06-17 02:21:03', '2012-06-17 02:21:03', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('550', '28', '2012-11-25 21:45:02', '2012-11-25 21:45:02', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-4', '', '', '2012-11-25 21:45:02', '2012-11-25 21:45:02', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('551', '28', '2012-11-22 19:52:32', '2012-11-22 19:52:32', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-22 19:52:32', '2012-11-22 19:52:32', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-21', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('552', '28', '2011-12-08 21:22:43', '2011-12-08 21:22:43', '[contact-form-7 id=\"4\" title=\"Contact form 1\"]', 'Contact', '', 'inherit', 'open', 'open', '', '16-revision-2', '', '', '2011-12-08 21:22:43', '2011-12-08 21:22:43', '', '16', 'http://www.plrblogs.com/badbreath/uncategorized/16-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('553', '28', '2012-04-25 12:42:08', '2012-04-25 12:42:08', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-5', '', '', '2012-04-25 12:42:08', '2012-04-25 12:42:08', '', '388', 'http://www.plrblogs.com/badbreath/uncategorized/388-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('554', '28', '2011-12-08 21:23:31', '2011-12-08 21:23:31', '<strong>Your Privacy</strong><br/>Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.<p/><strong>Google Adsense and the DoubleClick DART Cookie</strong><br/>Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url <a href=\"http://www.google.com/privacy_ads.html\">http://www.google.com/privacy_ads.html</a> Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies,  has no access or control over these cookies that may be used by third party advertisers.<p/><strong>Collection of Personal Information</strong><br/>When visiting , the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n<p/><strong>Links to third party Websites</strong><br/>We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n<p/><strong>Changes to this Privacy Statement</strong><br/>The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of  then you may contact us at <p/>', 'Privacy Policy', '', 'inherit', 'open', 'open', '', '18-revision', '', '', '2011-12-08 21:23:31', '2011-12-08 21:23:31', '', '18', 'http://www.plrblogs.com/badbreath/uncategorized/18-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('555', '28', '2012-07-01 03:19:53', '2012-07-01 03:19:53', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-124', '', '', '2012-07-01 03:19:53', '2012-07-01 03:19:53', '', '83', 'http://www.plrblogs.com/badbreath/uncategorized/83-revision-124', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('556', '28', '2011-12-08 21:24:17', '2011-12-08 21:24:17', '<!-- ddsitemapgen -->', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-revision-2', '', '', '2011-12-08 21:24:17', '2011-12-08 21:24:17', '', '19', 'http://www.plrblogs.com/badbreath/uncategorized/19-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('480', '28', '2012-06-26 01:00:52', '2012-06-26 01:00:52', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Clickbank Marketing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-06-26 01:00:52', '2012-06-26 01:00:52', '', '21', 'http://www.plrblogs.com/clickbank/uncategorized/21-revision-18', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('483', '28', '2011-12-15 04:07:56', '2011-12-15 04:07:56', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-122', '', '', '2011-12-15 04:07:56', '2011-12-15 04:07:56', '', '83', 'http://www.plrblogs.com/clickbank/uncategorized/83-revision-122', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('484', '28', '2012-07-01 03:17:54', '2012-07-01 03:17:54', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-123', '', '', '2012-07-01 03:17:54', '2012-07-01 03:17:54', '', '83', 'http://www.plrblogs.com/clickbank/uncategorized/83-revision-123', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('651', '28', '2013-01-10 21:22:55', '2013-01-10 21:22:55', 'Kindle Publishing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]V-T12_6HYGk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xKE5fIfY2Lc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ASEwXjEr2Oc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]2fVCKGP9lHk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]usNuEVGGZ10[/youtube]', 'Kindle Publishing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-01-10 21:22:55', '2013-01-10 21:22:55', '', '21', 'http://www.plrblogs.com/beerbrewing/uncategorized/21-revision-24', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('822', '28', '2013-07-25 13:05:55', '2013-07-25 13:05:55', '[youtube width=570 height=390]1pnotCDM4KU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]B3YK9qDCLjQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-25 13:05:55', '2013-07-25 13:05:55', '', '21', 'http://www.plrblogs.com/airtravel/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('573', '28', '2012-11-26 09:27:10', '2012-11-26 09:27:10', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-26 09:27:10', '2012-11-26 09:27:10', '', '21', 'http://www.plrblogs.com/kindle/uncategorized/21-revision-22', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('574', '28', '2013-01-10 21:09:44', '2013-01-10 21:09:44', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Kindle Publishing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-01-10 21:09:44', '2013-01-10 21:09:44', '', '21', 'http://www.plrblogs.com/kindle/uncategorized/21-revision-23', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('742', '28', '2013-05-18 09:11:02', '2013-05-18 09:11:02', 'Beer Brewing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]Kw8wV5NkOf4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]otxFTHi1bKY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]Ay2_RpC7JRw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]5WGHkNPqCS8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]6f1jJ_K8hhk[/youtube]', 'Beer Brewing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-05-18 09:11:02', '2013-05-18 09:11:02', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-25', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('744', '28', '2013-07-05 13:34:11', '2013-07-05 13:34:11', '[youtube width=570 height=390]fn-OZW4X8Sc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lNnQtyV_w94[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 13:34:11', '2013-07-05 13:34:11', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-27', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('808', '28', '2013-07-05 15:33:30', '2013-07-05 15:33:30', '[youtube width=570 height=390]1pnotCDM4KU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]B3YK9qDCLjQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 15:33:30', '2013-07-05 15:33:30', '', '21', 'http://www.plrblogs.com/nailfungus/uncategorized/21-revision-28', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('823', '28', '2013-08-10 12:26:32', '2013-08-10 12:26:32', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-08-10 12:26:32', '2013-08-10 12:26:32', '', '21', 'http://www.plrblogs.com/conversationconfidence/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('824', '28', '2013-08-11 01:01:46', '2013-08-11 01:01:46', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Conversation Help Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-08-11 01:01:46', '2013-08-11 01:01:46', '', '21', 'http://www.plrblogs.com/conversationconfidence/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('868', '28', '2013-11-11 20:48:44', '2013-11-11 20:48:44', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-11 20:48:44', '2013-11-11 20:48:44', '', '21', 'http://www.plrblogs.com/aviarybirdhouseplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('896', '28', '2013-12-16 03:44:28', '2013-12-16 03:44:28', '', 'Impress Friends And Family With Easy To Learn Magic Tricks!', 'Impress Friends And Family With Easy To Learn Magic Tricks!', 'inherit', 'open', 'open', '', 'magic-silder1', '', '', '2013-12-16 03:44:28', '2013-12-16 03:44:28', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-silder1.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('871', '28', '2013-11-13 02:46:23', '2013-11-13 02:46:23', '[youtube width=570 height=390]ClA1lUeXMTc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]NnPobSrR3zM[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]AHKcHV6iMjk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]UVMgePqZhVM[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Magic Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-13 02:46:23', '2013-11-13 02:46:23', '', '21', 'http://www.plrblogs.com/magic/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('872', '28', '2013-10-02 09:48:00', '2013-10-02 09:48:00', 'One of the easiest forms of magic, Card Tricks have been around for as long as people can remember. These tricks have in fact grown in popularity with each year that has passed. Street performances by skilled magicians such as David Blaine and the introduction of large gaming facilities, such as the casinos of Los Vegas have contributed to the increased popularity of card tricks.\r\n\r\nMany amateur magicians specialise in card tricks due to their versatility. They are small, easy to handle and extremely cheap. They also do not require any special props or abilities, other than a fair amount of practice and a good routine, to make them work.\r\n\r\nMost professional magicians guard their secrets jealously. There are the occasional performers who hold sessions and seminars that introduce youngsters and amateur magic enthusiasts to the wonders and intricacies that surround the performance of card tricks. \r\n\r\nThese educational gatherings, together with the many hundreds of booklets, videos and websites are available to the public. These many items now reveal the secrets behind such astounding card tricks. Elevating cards into the air, card vanishing, but ever popular, tearing a card and restoring it to its original shape. \r\n\r\nSleight of hand, card marking, trick decks and a variety of other ploys are used in performing card tricks. Good sleight of hand card tricks are never easy and improve only with time and practice. Card marking which is also popular with many magicians is often undetectable to the audience or person watching the trick.\r\n\r\nThere are many ways of marking cards. Juice marking and pin pricks are the most popular methods amongst beginners. However, more sophisticated techniques such as tinting the uniform back of cards and using luminous marked cards (that can only be detected through specially made sunglasses) are also used. \r\n\r\nThe gamblers riffle test (which entails the rapid flipping of the pack to see if there is any change in the outer design of the cards) and shining light off the card to detect punctures or other markings; are just some methods through which marked cards can be detected. \r\n\r\nHowever, all card tricks, no matter how complicated they may seem, are based upon a few basic principles that are then developed to produce an entirely new trick. Professional card manipulators have swelled the ranks of magicians in recent years, and include the talents of such skilled performers as Richard Pitchford (Cardini), Ed Marlo and Allan Ackerman as well as other veterans of the art.', 'Card Tricks', '', 'publish', 'open', 'open', '', 'card-tricks', '', '', '2013-11-13 04:04:13', '2013-11-13 04:04:13', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/card-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('873', '28', '2013-10-06 07:22:17', '2013-10-06 07:22:17', 'Coin tricks have been around almost from the time coins first came into being. They have been a popular fairground attraction for the last two or three hundred years. Nowadays, coin tricks have become a favorite with professional magicians around the world. \r\n\r\nModern coin tricks have evolved into a fascinating act. Street magicians and performers of magic can baffle entire audiences with a variety of tricks. These are tricks such as making coins multiply, vanish and subsequently reappear by plucking them from the air.\r\n\r\nCoin tricks are also known as coin flourishing or coin manipulating. They require sleight of hand and a fair amount of practice to improve dexterity. A polished act for presentation will make the coin trick very believable. \r\n\r\nCoins come in a variety of sizes. Large shiny coins are more visible against your hand and are ideal for show purposes. Coins with broad or rough edges offer an advantage over other types of coins as they are easier to grip and maneuver. \r\n\r\nIt is said that practice makes perfect, and that is certainly true when performing coin tricks. Practice enables magicians to identify their personal preferences. The coins most suited to perform particular tricks are the ones which fit to the contours of their palms. These allow coin tricks to be performed deftly without being detected by the audience. \r\n\r\nThere are books, videos, TV programs, websites and even seminars that are dedicated to showing the many behind the scene magic tricks. These for the most part, focus on simple magic routines. These will help to initiate beginners to the world of magic. \r\n\r\nMore sophisticated and complicated coin tricks can be gradually developed. There are also seminars at which the magical community gather to show off their skill and occasionally. If youre lucky you will get an opportunity to share their knowledge on how certain of their more baffling tricks are performed. \r\n\r\nSome of the easiest coin tricks, though vastly entertaining, require no special skill or ability on the part of the magician. A certain amount of convincing patter can often transform what would otherwise be a very ordinary trick into a gasp evoking performance. \r\n\r\nOne such case in point, especially where coin tricks are concerned, would be the Penny Prediction. Here a member of the audience is asked to select a coin from a hat, pass it around the room. Everyone except the magician sees the coin. It is then put back into the hat. The magician then proceeds to read the minds of the people, or commune with spirits and produce the correct coin.\r\n\r\nCoin tricks such as this are very impressive. True. However, they are often very simple and easily explained. Like the Penny Prediction where the coin passed around the room. It absorbs the body heat of those handling the coin and grows warmer. When the coin is put back into the hat, the magician is able to identify it from the rest of the coins immediately.', 'Coin Tricks', '', 'publish', 'open', 'open', '', 'coin-tricks', '', '', '2013-11-13 04:04:06', '2013-11-13 04:04:06', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/coin-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('874', '28', '2013-10-10 02:58:16', '2013-10-10 02:58:16', 'We have all been fascinated by watching various people playing card tricks. Some of us have even attempted at one time or another to perform these card tricks ourselves with varying degrees of success. Of the many card tricks out there you will find some really cool card tricks. These are the card tricks that have people looking on in total bafflement as they try to figure out what happened to the cards.\r\n\r\nThese cool card tricks are for the most part performed by magicians or individuals who perform card tricks. You however also have the ability of performing these types of fantastic card tricks too. The main items that you will need to perform these numerous cool card tricks is that of a deck of cards, patience and some books that show you the behind the scene details of these tricks.\r\n\r\nNow before you say that you can do these tricks in no time at all there is an art form you will need to master. You might feel that the art form is just a way of diverting the attention of the audience from the trick and you have no need for this trickery. This however is not the case. \r\n\r\nThis art form of performing cool card tricks must be performed smoothly as you are doing the routine otherwise the card trick will look unpolished and incomplete. Also the audience will not be impressed with your card trick. For this reason as you are perfecting your cool card tricks you should also master the art of presenting the tricks.   \r\n\r\nJust to make the life of the audience more interesting your cool card tricks can have indications of psychic talents. By doing a card trick which has these elements to the trick you will definitely have the audience eager to see what else you can do. Just to whet your appetite for the sheer number of cool card tricks here are a few that you can try out. The torn and restored card trick is one of the most well known cool card tricks to be performed.\r\n\r\nThis is a cool card trick to try out. In this trick you seemingly tear the card in front of the audiences eyes. Then by a few magic words and /or magic gestures you restore the card back to its original shape. The best thing about this trick is that there will not be any visible tear marks on the torn card. Another interesting and yet very cool trick is called the Jack Robbers.\r\n\r\nThis card trick uses the four Jacks to perform the trick. As you are performing the trick of how these four Jack cards stole from a bank (read card deck here) you will see the wonder and amazement as the finale of the card trick is seen before their eyes.\r\n\r\nThe world of magic and card tricks is closely connected. When you use cool card tricks you bring the audience straight into a magical world.', 'Cool Card Tricks', '', 'publish', 'open', 'open', '', 'cool-card-tricks', '', '', '2013-12-16 03:46:17', '2013-12-16 03:46:17', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/cool-card-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('875', '28', '2013-10-14 10:55:13', '2013-10-14 10:55:13', 'The desire to perform different kinds of tricks is one that we have all felt. As children we tried coin tricks, shell games, different card tricks. We have all at one time or another desired to be magicians and perform many wonderful magic tricks. The best way to start out with these magic tricks is to see the various easy magic tricks that you can try out.\r\n\r\nThere are various magic trick books that we can consult to help us do these tricks. You should first look at the contents of these books to see if there are any tricks that appeal to you. Having found these books you should gather all the magic tools you will need. The next step is to read one of the easy magic tricks in the book fully and make sure that you understand these tricks.\r\n\r\nHaving looked at these tricks you will need to start out slowly. Make sure that you follow the directions for the easy magic tricks. As you become more confident of your skill you can make the tricks flow faster and smoother. The first stage is to become proficient at performing the tricks without any signs of hesitation. \r\n\r\nOnce you are sure that you can perform your range of easy magic tricks without difficulty you may want to see how the trick looks in front of a mirror. There are a host of great magic tricks which can be performed by anyone. The main thing with all of these many different tricks is to have the steps of the trick well practiced so that it flows naturally.\r\n\r\nYou may want to try out some ring and card tricks for your first tricks. As there are many different variations you should select one or two to become well practiced in. While the temptation to work lots of different easy magic tricks is strong it is best to know a few really fantastic ones rather than lots of weak and unimpressive tricks. \r\n\r\nTo make these easy magic tricks look fantastic to the eyes of the audience you will need to have some interesting stories and gestures to use. You should also make sure that the audience does not feel that you are conning them. If they feel that you are just playing a bad trick on them your entire magic repertoire will fail.\r\n\r\nThe key items to perform any type of magic trick are confidence in your skill, patience to get the spell right, and continued practice so that the spell flows effortlessly. Combine these with the right amount of flair and magical display and you will have your audience coming back for more of your easy magic tricks.', 'Easy Magic Tricks', '', 'publish', 'open', 'open', '', 'easy-magic-tricks', '', '', '2013-12-16 03:46:13', '2013-12-16 03:46:13', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/easy-magic-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('876', '28', '2013-10-17 09:05:23', '2013-10-17 09:05:23', 'Card tricks are a staple part of every magicians repertoire. These are the first tricks that aspiring magicians learn to do. You can find a vast range of free card tricks in library books and sometimes on websites that are devoted to free magic tricks. The different card tricks that you can try will range from easy to do tricks to the more complicated tricks.\r\n\r\nBy looking at these different free card tricks you will be able to see which ones you want to try out. Having chosen the different card tricks that you like, the ability of practicing these will be possible. You should contain your excitement however until you have mastered these different card tricks one at a time.\r\n\r\nThe first step to becoming perfect at performing great card tricks is to find the manuals or books that show you the various steps in the many card tricks that can be performed. With these items you will need to read and understand the steps in a trick while you are doing the trick. This actual practice session is vital as you need to see how the trick works while you are doing it. \r\n\r\nOnce you have read through the free card tricks you have chosen you can start to improve the way you present these tricks. The flair and presentation is also vital as you need to have the audiences attention on you and not focused on your trick. Some of the free cards tricks that many magicians use can be found on the internet. \r\n\r\nTo get these free card tricks performed well you will need to spend some time practicing not just the trick but also the art of presenting the trick. For instance one of these free card tricks involves the use of four Jack cards and three other normal cards. These seven cards are placed on the top of the card deck. The Jack cards are placed beneath the 3 normal cards. \r\n\r\nOnce you have arranged all of these cards you can start the trick. You should let the audience know the background story about the trick. You will need to present the trick in the manner of a story. In this particular card trick the four Jacks are supposed to rob a bank  which is shown as being the deck of cards- and before the police arrive the Jack cards make their grand escape.\r\n\r\nFor this trick it is vital that the audience see only what you want them to see. As you begin the trick show the Jack cards to the audience very quickly  they need to see that you are holding only four Jack cards and then place them on the deck. To make the trick work you need the audience believe that the four Jack cards are placed in random order in the card deck. You should finish the story and the trick by making it seem as if you pulled the Jacks from the top of the card deck.', 'Free Card Tricks', '', 'publish', 'open', 'open', '', 'free-card-tricks', '', '', '2013-12-16 03:15:38', '2013-12-16 03:15:38', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/free-card-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('877', '28', '2013-10-20 12:02:02', '2013-10-20 12:02:02', 'Cards, coins, flying doves, jumping rabbits are all part of magic. These many items are used as tools for a magic act. While most of the items that are used in magic acts are beyond the scope of new magicians there are others that can be used. For the new magician free magic tricks are especially useful to have in your selection of magic.\r\n\r\nThese different types of free magic tricks are one that anyone who is interested in doing magic can try. The tools of the trade will be basic items that you can easily find and buy. You may want to try your hand at the very easy magic tricks to begin with. These free magic tricks will be the ones that you can perform with cards and coins.\r\n\r\nTo perform one of these many different free magic tricks the first step you will need to follow is to know the magic trick you will be trying out. The best way to accomplish this task is to find a book of magic tricks. These books are available at your local library, at various book stores and you can even find some on the internet. \r\n\r\nOnce you have found what steps are required to perform the tricks you should practice at least one until you can execute the trick flawlessly. To make these different free magic tricks that you are working on look fabulous there are various atmospheric tricks that you can use.\r\n\r\nThese are part of the showmanship that captures the interest of people. Once their interest has been caught you will leave them wondering how you performed your trick. The best types of free magic tricks will show you all of the hidden secrets that need to be done for the trick to work successfully. \r\n\r\nSome of these tricks are well know card tricks that many magicians have done. If you can pull these tricks off without your guests knowing what has happened then you can call the trick successful.\r\n\r\nThe many different free magic spells that you can try does not have to be contained only to the sphere of magic acts. These free magic tricks can be ones that you do for reason of personal well being. As magic can be used in different ways the magic tricks can be used in these ways too.\r\n\r\nMagic is one aspect of life that we thoroughly enjoy. The many different spells and magic tricks that are known to have been used throughout history keeps magic alive in our minds. For people who dont have any gift in magic free magic tricks are great ways to experience the wonder of magic.', 'Free Magic Tricks', '', 'publish', 'open', 'open', '', 'free-magic-tricks', '', '', '2013-12-16 03:46:07', '2013-12-16 03:46:07', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/free-magic-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('878', '28', '2013-10-23 02:21:00', '2013-10-23 02:21:00', 'There are many different forms of magic that exists in the world. One form is the wonderful magic illusions that magicians use to stun us. These magical illusions are complicated as they are magical in feel. The way to know if such illusions have worked is by seeing the wonder and bafflement on the faces of people as they try to figure out how you made something or someone disappear.\r\n\r\nWhile there are many magicians who specialize in these marvelous magic illusions, for the beginner of magic the most sensible approach to magic illusions is to try something very simple. You have probably seen the magic tricks where there are some metal rings that are interlocked. Your task is to remove these rings without breaking the circle. \r\n\r\nNow as this is a magic illusion you will need to discover where the splitting point of these rings is located. Of course there are many of us who manage to work these rings loose but can you tell us how you managed to do this trick. This is where the magic illusion part comes into play.\r\n\r\nOnce you have found the art of performing magic illusions you can move on to the more challenging tricks. These magic illusions will prove to be more difficult as you need to practice these quite thoroughly. While you are practicing your magical illusions you should realize that to become really good you have to practice for a long time. \r\n\r\nMany of the worlds greatest magicians use magic illusions to add some zest to their performances. These artists of magic are people like David Copperfield and even Houdini. These many different magicians have used various types of illusions to make people enjoy their shows. \r\n\r\nAs a result of this enormous interest there are books, articles, DVDs, videos and even classes where a person can learn the art of magic illusions. Now even though these are very exciting avenues to look into you must have an idea of the ways that magic is performed. \r\n\r\nThere is one aspect of these illusions that you might want to work on. This is of course the atmosphere of excitement and mystery that will need to heighten the sense of your watching audience.\r\n\r\nAs with many different forms of magic you should draw your audience into believing in the impossible. This is after all what magic illusions are all about. Without these illusions there would be no drama for the audience to appreciate. They would only feel the magic of your performance in a small way. \r\n\r\nWhether you are an aspiring magician or just interested in magic you will soon learn of the wonders that lie behind magic illusions. The ways of magic are brought to life right before our eyes with magic illusions.', 'Magic Illusions', '', 'publish', 'open', 'open', '', 'magic-illusions', '', '', '2013-12-16 03:46:02', '2013-12-16 03:46:02', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/magic-illusions', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('879', '28', '2013-10-26 02:44:06', '2013-10-26 02:44:06', 'Buying different products is always easy if you buy them from places that sell these items exclusively. For magical goods the best place to find all of these items is magic shops. These shops will for the most part be small stores where you will find lots of different items. The various items that you can find will not be confined to one branch of magic or even magic from one country.\r\n\r\nInstead you will find paraphernalia for a host of magical tricks. These magical items are great for any level spell caster to try their hands at. For the beginner or the person who is just interested there will be simple spell and magical trick books to be look at. The history of various forms of magic can also be found in these magic shops.\r\n\r\nAt this point since we are talking about magic and magic shops you have probable seen items like wands, crystal wands, magic boxes  the kind where a person walks in and then disappears, you will also get trick flower bouquets and a host of other special effects.\r\n\r\nWhile most people who come to these stores regard these magic objects as curios, there are practitioners of these arcane arts who come to these magic shops to buy their supplies. The many people who buy their magical supplies are not just confined to witches, warlocks or even the Wicca. \r\n\r\nYou will find that sometimes these magic shops have celebrity magicians who come. These people look for unusual magical items that they can use. In some cases they will purchase well known magical tricks so they will have the opportunity of making these old tricks come alive in a new version.\r\n\r\nMagic shops are great places for any one who is interested in magic. From the many items that are for sale in these shops the magic user can increase their knowledge and skill of magic. Sometimes the magic shops will have been originally opened by great magicians themselves. For instance the Houdini Magic Shop was one that Harry Houdini was supposed to have founded and opened.\r\n\r\nAs you look at these many different magic shops you will begin to understand why people have a continuing fascination with magic. The many interesting and magical objects that you can find in these shops are a testament to the popularity of magic. \r\n\r\nFor anyone who is interested in casting or showing magic these magic shops are the places to go. From here you can buy the many items that you will need to start a life that is well mixed with magic. Enjoy the journey into another world that is truly magical.', 'Magic Shops', '', 'publish', 'open', 'open', '', 'magic-shops', '', '', '2013-11-13 04:02:48', '2013-11-13 04:02:48', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/magic-shops', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('880', '28', '2013-10-29 08:40:56', '2013-10-29 08:40:56', 'Magic shows include many diverse art forms including illusion, sleight of hand and misdirection. In fact, anything and everything that cannot be explained, generally falls under the heading Its magic. \r\n\r\nScientifically of course, there is no such thing as unexplainable magic. Logicians make it a point to scoff at all things magic. They maintain that magic shows featuring dazzling, mystifying acts all have some logical reasoning or mechanism behind it. \r\n\r\nThis point of view is accepted by the majority of cynical adult audiences around the world today. TV, web sites and other methods by which many of the simpler tricks have been explained have dissipated much of the mysterious aura that previously surrounded such amazing feats as pulling flowers out of the air, rabbits out of a hat and sawing people in half. \r\n\r\nThis has resulted in conjurors foraging deeper into advanced technology and modern science to help them develop tricks that are spectacular enough to impress, amaze and entertain a more sophisticated crowd. This is not easy as most adults know the simpler tricks of the trade and always look for a logical reason behind every trick in a magicians repertoire. \r\n\r\nIllusions that are commonly used in magic shows fall into several different categories. These include such forms of illusion as teleportation, vanishing and levitation.   \r\n\r\nThere is also production where something is produced from thin air. Transformation (turning something into a totally different type of object) and penetration where solid objects pass through other solid objects (rings being intertwined, apples passing through boxes etc.) are part of the acts that you will see in magic shows.\r\n\r\nMagic shows themselves can be categorized by class, as close up to the magic with the audience close to a seated performer. Cabaret magic where magicians perform on the same floor level as the audience. Bizarre magic using horror and shock like swallowing swords, boring holes through arms and skin etc. can also be seen.\r\n \r\nThere is also platform or stage magic, telepathic magic, childrens magic and street magic. Here the magicians give impromptu performances in front of pedestrians. However, all classes of magic have their own particular audiences. These magic shows attract large crowds for all the magic shows. \r\n\r\nOf the hundreds of accomplished magicians currently performing on their own or in magic shows throughout the world, some names stand out. This is due to the sheer magnificence and skill of their performances. Performers like David Copperfield, Siegfried & Roy, David Blaine, Max Maven and Chris Angel to name a few of the great magicians of today. \r\n\r\nIt is evident, that no matter how advanced society may be that the thrill of magic will never die. In fact it would be safe to say that magic is here to stay. The many magic shows that we see are a testament to that.', 'Magic Shows', '', 'publish', 'open', 'open', '', 'magic-shows', '', '', '2013-11-13 04:02:35', '2013-11-13 04:02:35', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/magic-shows', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('881', '28', '2013-11-01 04:23:35', '2013-11-01 04:23:35', 'Magicians, especially professional magicians, tend to guard their secrets jealously. It is rare indeed to find a performer who would reveal the secrets of their art to the uninitiated or to colleagues. Very few of these individuals would indeed reveal the magic tricks they have developed on their own for love or money.\r\n\r\nNowadays books, videos, leaflets and other items available at bookstores and on the internet (even whole websites devoted to magic) have gone a long way towards explaining simple magic tricks. Amateur magic enthusiasts can even find the occasional magic convention to show them how to perform some of the more complicated magic tricks. All these things however are recent developments.\r\n\r\nRight up till the end of the 19th century there were very few books or teachers of magic. Outsiders wishing to break into the art found it an uphill and often frustrating task. The magic community itself was a closely knit group where magic was concerned, and made it a point of honour to collectively close ranks against all would be new comers.\r\n\r\nDiscoveries of magic by Reginald Scott, which was printed in 1584, is one of the first books ever printed that gave an insight into magic. Today, even with the existence of such organizations as the International Brotherhood of Magicians, there are still some organizations which make it a condition of membership to NOT divulge their art to non magicians.\r\n\r\nMagic tricks themselves can range over a diverse arena that includes everything from the old pulling a rabbit out of a hat trick and mind reading to more complicated forms of magic. These will involve levitation, using handcuffs and replacing your assistant with a Bengal tiger.  \r\n\r\nBe that as it may, coin and card tricks are still performed in every magicians act. They are some of the easiest and simplest tricks to perform. They require nothing more ingenious than a sleight of hand and a good routine to pull off a creditable performance. \r\n\r\nPopular modern magicians include such names as David Copperfield, David Blaine, Siegfried and Roy, Chris Angel and a host of others. These magicians have become household names due to their fantastic, unexplainable and often mind boggling magical performances. \r\n\r\nHowever, the most famous of all magicians is Harry Houdini (1805 - 1871), the son of a Hungarian rabbi who started out as a watch maker. He then went on to become one of the greatest magicians in the world. Houdini is best known for his escapology  the ability to escape from any form of restraints - tricks.\r\n\r\nAs you see there are many different tricks that are employed by magicians. These magic tricks are what makes these magicians so fascinating to us. The many different magic tricks you will find are part of the atmosphere of magic.', 'Magic Tricks', '', 'publish', 'open', 'open', '', 'magic-tricks', '', '', '2013-12-16 03:45:56', '2013-12-16 03:45:56', '', '0', 'http://www.plrblogs.com/magic/magic-trickery/magic-tricks', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('882', '28', '2013-11-13 03:59:32', '2013-11-13 03:59:32', 'Magicians, especially professional magicians, tend to guard their secrets jealously. It is rare indeed to find a performer who would reveal the secrets of their art to the uninitiated or to colleagues. Very few of these individuals would indeed reveal the magic tricks they have developed on their own for love or money.\r\n\r\nNowadays books, videos, leaflets and other items available at bookstores and on the internet (even whole websites devoted to magic) have gone a long way towards explaining simple magic tricks. Amateur magic enthusiasts can even find the occasional magic convention to show them how to perform some of the more complicated magic tricks. All these things however are recent developments.\r\n\r\nRight up till the end of the 19th century there were very few books or teachers of magic. Outsiders wishing to break into the art found it an uphill and often frustrating task. The magic community itself was a closely knit group where magic was concerned, and made it a point of honour to collectively close ranks against all would be new comers.\r\n\r\nDiscoveries of magic by Reginald Scott, which was printed in 1584, is one of the first books ever printed that gave an insight into magic. Today, even with the existence of such organizations as the International Brotherhood of Magicians, there are still some organizations which make it a condition of membership to NOT divulge their art to non magicians.\r\n\r\nMagic tricks themselves can range over a diverse arena that includes everything from the old pulling a rabbit out of a hat trick and mind reading to more complicated forms of magic. These will involve levitation, using handcuffs and replacing your assistant with a Bengal tiger.  \r\n\r\nBe that as it may, coin and card tricks are still performed in every magicians act. They are some of the easiest and simplest tricks to perform. They require nothing more ingenious than a sleight of hand and a good routine to pull off a creditable performance. \r\n\r\nPopular modern magicians include such names as David Copperfield, David Blaine, Siegfried and Roy, Chris Angel and a host of others. These magicians have become household names due to their fantastic, unexplainable and often mind boggling magical performances. \r\n\r\nHowever, the most famous of all magicians is Harry Houdini (1805 - 1871), the son of a Hungarian rabbi who started out as a watch maker. He then went on to become one of the greatest magicians in the world. Houdini is best known for his escapology  the ability to escape from any form of restraints - tricks.\r\n\r\nAs you see there are many different tricks that are employed by magicians. These magic tricks are what makes these magicians so fascinating to us. The many different magic tricks you will find are part of the atmosphere of magic.', 'Magic Tricks', '', 'inherit', 'open', 'open', '', '881-revision-v1', '', '', '2013-11-13 03:59:32', '2013-11-13 03:59:32', '', '881', 'http://www.plrblogs.com/magic/uncategorized/881-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('883', '28', '2013-11-13 03:59:39', '2013-11-13 03:59:39', 'Magic shows include many diverse art forms including illusion, sleight of hand and misdirection. In fact, anything and everything that cannot be explained, generally falls under the heading Its magic. \r\n\r\nScientifically of course, there is no such thing as unexplainable magic. Logicians make it a point to scoff at all things magic. They maintain that magic shows featuring dazzling, mystifying acts all have some logical reasoning or mechanism behind it. \r\n\r\nThis point of view is accepted by the majority of cynical adult audiences around the world today. TV, web sites and other methods by which many of the simpler tricks have been explained have dissipated much of the mysterious aura that previously surrounded such amazing feats as pulling flowers out of the air, rabbits out of a hat and sawing people in half. \r\n\r\nThis has resulted in conjurors foraging deeper into advanced technology and modern science to help them develop tricks that are spectacular enough to impress, amaze and entertain a more sophisticated crowd. This is not easy as most adults know the simpler tricks of the trade and always look for a logical reason behind every trick in a magicians repertoire. \r\n\r\nIllusions that are commonly used in magic shows fall into several different categories. These include such forms of illusion as teleportation, vanishing and levitation.   \r\n\r\nThere is also production where something is produced from thin air. Transformation (turning something into a totally different type of object) and penetration where solid objects pass through other solid objects (rings being intertwined, apples passing through boxes etc.) are part of the acts that you will see in magic shows.\r\n\r\nMagic shows themselves can be categorized by class, as close up to the magic with the audience close to a seated performer. Cabaret magic where magicians perform on the same floor level as the audience. Bizarre magic using horror and shock like swallowing swords, boring holes through arms and skin etc. can also be seen.\r\n \r\nThere is also platform or stage magic, telepathic magic, childrens magic and street magic. Here the magicians give impromptu performances in front of pedestrians. However, all classes of magic have their own particular audiences. These magic shows attract large crowds for all the magic shows. \r\n\r\nOf the hundreds of accomplished magicians currently performing on their own or in magic shows throughout the world, some names stand out. This is due to the sheer magnificence and skill of their performances. Performers like David Copperfield, Siegfried & Roy, David Blaine, Max Maven and Chris Angel to name a few of the great magicians of today. \r\n\r\nIt is evident, that no matter how advanced society may be that the thrill of magic will never die. In fact it would be safe to say that magic is here to stay. The many magic shows that we see are a testament to that.\r\n\r\n', 'Magic Shows', '', 'inherit', 'open', 'open', '', '880-revision-v1', '', '', '2013-11-13 03:59:39', '2013-11-13 03:59:39', '', '880', 'http://www.plrblogs.com/magic/uncategorized/880-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('884', '28', '2013-11-13 04:00:09', '2013-11-13 04:00:09', 'Buying different products is always easy if you buy them from places that sell these items exclusively. For magical goods the best place to find all of these items is magic shops. These shops will for the most part be small stores where you will find lots of different items. The various items that you can find will not be confined to one branch of magic or even magic from one country.\r\n\r\nInstead you will find paraphernalia for a host of magical tricks. These magical items are great for any level spell caster to try their hands at. For the beginner or the person who is just interested there will be simple spell and magical trick books to be look at. The history of various forms of magic can also be found in these magic shops.\r\n\r\nAt this point since we are talking about magic and magic shops you have probable seen items like wands, crystal wands, magic boxes  the kind where a person walks in and then disappears, you will also get trick flower bouquets and a host of other special effects.\r\n\r\nWhile most people who come to these stores regard these magic objects as curios, there are practitioners of these arcane arts who come to these magic shops to buy their supplies. The many people who buy their magical supplies are not just confined to witches, warlocks or even the Wicca. \r\n\r\nYou will find that sometimes these magic shops have celebrity magicians who come. These people look for unusual magical items that they can use. In some cases they will purchase well known magical tricks so they will have the opportunity of making these old tricks come alive in a new version.\r\n\r\nMagic shops are great places for any one who is interested in magic. From the many items that are for sale in these shops the magic user can increase their knowledge and skill of magic. Sometimes the magic shops will have been originally opened by great magicians themselves. For instance the Houdini Magic Shop was one that Harry Houdini was supposed to have founded and opened.\r\n\r\nAs you look at these many different magic shops you will begin to understand why people have a continuing fascination with magic. The many interesting and magical objects that you can find in these shops are a testament to the popularity of magic. \r\n\r\nFor anyone who is interested in casting or showing magic these magic shops are the places to go. From here you can buy the many items that you will need to start a life that is well mixed with magic. Enjoy the journey into another world that is truly magical.', 'Magic Shops', '', 'inherit', 'open', 'open', '', '879-revision-v1', '', '', '2013-11-13 04:00:09', '2013-11-13 04:00:09', '', '879', 'http://www.plrblogs.com/magic/uncategorized/879-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('885', '28', '2013-11-13 04:00:29', '2013-11-13 04:00:29', 'There are many different forms of magic that exists in the world. One form is the wonderful magic illusions that magicians use to stun us. These magical illusions are complicated as they are magical in feel. The way to know if such illusions have worked is by seeing the wonder and bafflement on the faces of people as they try to figure out how you made something or someone disappear.\r\n\r\nWhile there are many magicians who specialize in these marvelous magic illusions, for the beginner of magic the most sensible approach to magic illusions is to try something very simple. You have probably seen the magic tricks where there are some metal rings that are interlocked. Your task is to remove these rings without breaking the circle. \r\n\r\nNow as this is a magic illusion you will need to discover where the splitting point of these rings is located. Of course there are many of us who manage to work these rings loose but can you tell us how you managed to do this trick. This is where the magic illusion part comes into play.\r\n\r\nOnce you have found the art of performing magic illusions you can move on to the more challenging tricks. These magic illusions will prove to be more difficult as you need to practice these quite thoroughly. While you are practicing your magical illusions you should realize that to become really good you have to practice for a long time. \r\n\r\nMany of the worlds greatest magicians use magic illusions to add some zest to their performances. These artists of magic are people like David Copperfield and even Houdini. These many different magicians have used various types of illusions to make people enjoy their shows. \r\n\r\nAs a result of this enormous interest there are books, articles, DVDs, videos and even classes where a person can learn the art of magic illusions. Now even though these are very exciting avenues to look into you must have an idea of the ways that magic is performed. \r\n\r\nThere is one aspect of these illusions that you might want to work on. This is of course the atmosphere of excitement and mystery that will need to heighten the sense of your watching audience.\r\n\r\nAs with many different forms of magic you should draw your audience into believing in the impossible. This is after all what magic illusions are all about. Without these illusions there would be no drama for the audience to appreciate. They would only feel the magic of your performance in a small way. \r\n\r\nWhether you are an aspiring magician or just interested in magic you will soon learn of the wonders that lie behind magic illusions. The ways of magic are brought to life right before our eyes with magic illusions.', 'Magic Illusions', '', 'inherit', 'open', 'open', '', '878-revision-v1', '', '', '2013-11-13 04:00:29', '2013-11-13 04:00:29', '', '878', 'http://www.plrblogs.com/magic/uncategorized/878-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('886', '28', '2013-11-13 04:00:38', '2013-11-13 04:00:38', 'Cards, coins, flying doves, jumping rabbits are all part of magic. These many items are used as tools for a magic act. While most of the items that are used in magic acts are beyond the scope of new magicians there are others that can be used. For the new magician free magic tricks are especially useful to have in your selection of magic.\r\n\r\nThese different types of free magic tricks are one that anyone who is interested in doing magic can try. The tools of the trade will be basic items that you can easily find and buy. You may want to try your hand at the very easy magic tricks to begin with. These free magic tricks will be the ones that you can perform with cards and coins.\r\n\r\nTo perform one of these many different free magic tricks the first step you will need to follow is to know the magic trick you will be trying out. The best way to accomplish this task is to find a book of magic tricks. These books are available at your local library, at various book stores and you can even find some on the internet. \r\n\r\nOnce you have found what steps are required to perform the tricks you should practice at least one until you can execute the trick flawlessly. To make these different free magic tricks that you are working on look fabulous there are various atmospheric tricks that you can use.\r\n\r\nThese are part of the showmanship that captures the interest of people. Once their interest has been caught you will leave them wondering how you performed your trick. The best types of free magic tricks will show you all of the hidden secrets that need to be done for the trick to work successfully. \r\n\r\nSome of these tricks are well know card tricks that many magicians have done. If you can pull these tricks off without your guests knowing what has happened then you can call the trick successful.\r\n\r\nThe many different free magic spells that you can try does not have to be contained only to the sphere of magic acts. These free magic tricks can be ones that you do for reason of personal well being. As magic can be used in different ways the magic tricks can be used in these ways too.\r\n\r\nMagic is one aspect of life that we thoroughly enjoy. The many different spells and magic tricks that are known to have been used throughout history keeps magic alive in our minds. For people who dont have any gift in magic free magic tricks are great ways to experience the wonder of magic.', 'Free Magic Tricks', '', 'inherit', 'open', 'open', '', '877-revision-v1', '', '', '2013-11-13 04:00:38', '2013-11-13 04:00:38', '', '877', 'http://www.plrblogs.com/magic/uncategorized/877-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('887', '28', '2013-11-13 04:00:45', '2013-11-13 04:00:45', 'Card tricks are a staple part of every magicians repertoire. These are the first tricks that aspiring magicians learn to do. You can find a vast range of free card tricks in library books and sometimes on websites that are devoted to free magic tricks. The different card tricks that you can try will range from easy to do tricks to the more complicated tricks.\r\n\r\nBy looking at these different free card tricks you will be able to see which ones you want to try out. Having chosen the different card tricks that you like, the ability of practicing these will be possible. You should contain your excitement however until you have mastered these different card tricks one at a time.\r\n\r\nThe first step to becoming perfect at performing great card tricks is to find the manuals or books that show you the various steps in the many card tricks that can be performed. With these items you will need to read and understand the steps in a trick while you are doing the trick. This actual practice session is vital as you need to see how the trick works while you are doing it. \r\n\r\nOnce you have read through the free card tricks you have chosen you can start to improve the way you present these tricks. The flair and presentation is also vital as you need to have the audiences attention on you and not focused on your trick. Some of the free cards tricks that many magicians use can be found on the internet. \r\n\r\nTo get these free card tricks performed well you will need to spend some time practicing not just the trick but also the art of presenting the trick. For instance one of these free card tricks involves the use of four Jack cards and three other normal cards. These seven cards are placed on the top of the card deck. The Jack cards are placed beneath the 3 normal cards. \r\n\r\nOnce you have arranged all of these cards you can start the trick. You should let the audience know the background story about the trick. You will need to present the trick in the manner of a story. In this particular card trick the four Jacks are supposed to rob a bank  which is shown as being the deck of cards- and before the police arrive the Jack cards make their grand escape.\r\n\r\nFor this trick it is vital that the audience see only what you want them to see. As you begin the trick show the Jack cards to the audience very quickly  they need to see that you are holding only four Jack cards and then place them on the deck. To make the trick work you need the audience believe that the four Jack cards are placed in random order in the card deck. You should finish the story and the trick by making it seem as if you pulled the Jacks from the top of the card deck.', 'Free Card Tricks', '', 'inherit', 'open', 'open', '', '876-revision-v1', '', '', '2013-11-13 04:00:45', '2013-11-13 04:00:45', '', '876', 'http://www.plrblogs.com/magic/uncategorized/876-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('888', '28', '2013-11-13 04:01:00', '2013-11-13 04:01:00', 'The desire to perform different kinds of tricks is one that we have all felt. As children we tried coin tricks, shell games, different card tricks. We have all at one time or another desired to be magicians and perform many wonderful magic tricks. The best way to start out with these magic tricks is to see the various easy magic tricks that you can try out.\r\n\r\nThere are various magic trick books that we can consult to help us do these tricks. You should first look at the contents of these books to see if there are any tricks that appeal to you. Having found these books you should gather all the magic tools you will need. The next step is to read one of the easy magic tricks in the book fully and make sure that you understand these tricks.\r\n\r\nHaving looked at these tricks you will need to start out slowly. Make sure that you follow the directions for the easy magic tricks. As you become more confident of your skill you can make the tricks flow faster and smoother. The first stage is to become proficient at performing the tricks without any signs of hesitation. \r\n\r\nOnce you are sure that you can perform your range of easy magic tricks without difficulty you may want to see how the trick looks in front of a mirror. There are a host of great magic tricks which can be performed by anyone. The main thing with all of these many different tricks is to have the steps of the trick well practiced so that it flows naturally.\r\n\r\nYou may want to try out some ring and card tricks for your first tricks. As there are many different variations you should select one or two to become well practiced in. While the temptation to work lots of different easy magic tricks is strong it is best to know a few really fantastic ones rather than lots of weak and unimpressive tricks. \r\n\r\nTo make these easy magic tricks look fantastic to the eyes of the audience you will need to have some interesting stories and gestures to use. You should also make sure that the audience does not feel that you are conning them. If they feel that you are just playing a bad trick on them your entire magic repertoire will fail.\r\n\r\nThe key items to perform any type of magic trick are confidence in your skill, patience to get the spell right, and continued practice so that the spell flows effortlessly. Combine these with the right amount of flair and magical display and you will have your audience coming back for more of your easy magic tricks.', 'Easy Magic Tricks', '', 'inherit', 'open', 'open', '', '875-revision-v1', '', '', '2013-11-13 04:01:00', '2013-11-13 04:01:00', '', '875', 'http://www.plrblogs.com/magic/uncategorized/875-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('889', '28', '2013-11-13 04:01:17', '2013-11-13 04:01:17', 'We have all been fascinated by watching various people playing card tricks. Some of us have even attempted at one time or another to perform these card tricks ourselves with varying degrees of success. Of the many card tricks out there you will find some really cool card tricks. These are the card tricks that have people looking on in total bafflement as they try to figure out what happened to the cards.\r\n\r\nThese cool card tricks are for the most part performed by magicians or individuals who perform card tricks. You however also have the ability of performing these types of fantastic card tricks too. The main items that you will need to perform these numerous cool card tricks is that of a deck of cards, patience and some books that show you the behind the scene details of these tricks.\r\n\r\nNow before you say that you can do these tricks in no time at all there is an art form you will need to master. You might feel that the art form is just a way of diverting the attention of the audience from the trick and you have no need for this trickery. This however is not the case. \r\n\r\nThis art form of performing cool card tricks must be performed smoothly as you are doing the routine otherwise the card trick will look unpolished and incomplete. Also the audience will not be impressed with your card trick. For this reason as you are perfecting your cool card tricks you should also master the art of presenting the tricks.   \r\n\r\nJust to make the life of the audience more interesting your cool card tricks can have indications of psychic talents. By doing a card trick which has these elements to the trick you will definitely have the audience eager to see what else you can do. Just to whet your appetite for the sheer number of cool card tricks here are a few that you can try out. The torn and restored card trick is one of the most well known cool card tricks to be performed.\r\n\r\nThis is a cool card trick to try out. In this trick you seemingly tear the card in front of the audiences eyes. Then by a few magic words and /or magic gestures you restore the card back to its original shape. The best thing about this trick is that there will not be any visible tear marks on the torn card. Another interesting and yet very cool trick is called the Jack Robbers.\r\n\r\nThis card trick uses the four Jacks to perform the trick. As you are performing the trick of how these four Jack cards stole from a bank (read card deck here) you will see the wonder and amazement as the finale of the card trick is seen before their eyes.\r\n\r\nThe world of magic and card tricks is closely connected. When you use cool card tricks you bring the audience straight into a magical world.', 'Cool Card Tricks', '', 'inherit', 'open', 'open', '', '874-revision-v1', '', '', '2013-11-13 04:01:17', '2013-11-13 04:01:17', '', '874', 'http://www.plrblogs.com/magic/uncategorized/874-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('890', '28', '2013-11-13 04:01:26', '2013-11-13 04:01:26', 'Coin tricks have been around almost from the time coins first came into being. They have been a popular fairground attraction for the last two or three hundred years. Nowadays, coin tricks have become a favorite with professional magicians around the world. \r\n\r\nModern coin tricks have evolved into a fascinating act. Street magicians and performers of magic can baffle entire audiences with a variety of tricks. These are tricks such as making coins multiply, vanish and subsequently reappear by plucking them from the air.\r\n\r\nCoin tricks are also known as coin flourishing or coin manipulating. They require sleight of hand and a fair amount of practice to improve dexterity. A polished act for presentation will make the coin trick very believable. \r\n\r\nCoins come in a variety of sizes. Large shiny coins are more visible against your hand and are ideal for show purposes. Coins with broad or rough edges offer an advantage over other types of coins as they are easier to grip and maneuver. \r\n\r\nIt is said that practice makes perfect, and that is certainly true when performing coin tricks. Practice enables magicians to identify their personal preferences. The coins most suited to perform particular tricks are the ones which fit to the contours of their palms. These allow coin tricks to be performed deftly without being detected by the audience. \r\n\r\nThere are books, videos, TV programs, websites and even seminars that are dedicated to showing the many behind the scene magic tricks. These for the most part, focus on simple magic routines. These will help to initiate beginners to the world of magic. \r\n\r\nMore sophisticated and complicated coin tricks can be gradually developed. There are also seminars at which the magical community gather to show off their skill and occasionally. If youre lucky you will get an opportunity to share their knowledge on how certain of their more baffling tricks are performed. \r\n\r\nSome of the easiest coin tricks, though vastly entertaining, require no special skill or ability on the part of the magician. A certain amount of convincing patter can often transform what would otherwise be a very ordinary trick into a gasp evoking performance. \r\n\r\nOne such case in point, especially where coin tricks are concerned, would be the Penny Prediction. Here a member of the audience is asked to select a coin from a hat, pass it around the room. Everyone except the magician sees the coin. It is then put back into the hat. The magician then proceeds to read the minds of the people, or commune with spirits and produce the correct coin.\r\n\r\nCoin tricks such as this are very impressive. True. However, they are often very simple and easily explained. Like the Penny Prediction where the coin passed around the room. It absorbs the body heat of those handling the coin and grows warmer. When the coin is put back into the hat, the magician is able to identify it from the rest of the coins immediately.', 'Coin Tricks', '', 'inherit', 'open', 'open', '', '873-revision-v1', '', '', '2013-11-13 04:01:26', '2013-11-13 04:01:26', '', '873', 'http://www.plrblogs.com/magic/uncategorized/873-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('891', '28', '2013-11-13 04:01:36', '2013-11-13 04:01:36', 'One of the easiest forms of magic, Card Tricks have been around for as long as people can remember. These tricks have in fact grown in popularity with each year that has passed. Street performances by skilled magicians such as David Blaine and the introduction of large gaming facilities, such as the casinos of Los Vegas have contributed to the increased popularity of card tricks.\r\n\r\nMany amateur magicians specialise in card tricks due to their versatility. They are small, easy to handle and extremely cheap. They also do not require any special props or abilities, other than a fair amount of practice and a good routine, to make them work.\r\n\r\nMost professional magicians guard their secrets jealously. There are the occasional performers who hold sessions and seminars that introduce youngsters and amateur magic enthusiasts to the wonders and intricacies that surround the performance of card tricks. \r\n\r\nThese educational gatherings, together with the many hundreds of booklets, videos and websites are available to the public. These many items now reveal the secrets behind such astounding card tricks. Elevating cards into the air, card vanishing, but ever popular, tearing a card and restoring it to its original shape. \r\n\r\nSleight of hand, card marking, trick decks and a variety of other ploys are used in performing card tricks. Good sleight of hand card tricks are never easy and improve only with time and practice. Card marking which is also popular with many magicians is often undetectable to the audience or person watching the trick.\r\n\r\nThere are many ways of marking cards. Juice marking and pin pricks are the most popular methods amongst beginners. However, more sophisticated techniques such as tinting the uniform back of cards and using luminous marked cards (that can only be detected through specially made sunglasses) are also used. \r\n\r\nThe gamblers riffle test (which entails the rapid flipping of the pack to see if there is any change in the outer design of the cards) and shining light off the card to detect punctures or other markings; are just some methods through which marked cards can be detected. \r\n\r\nHowever, all card tricks, no matter how complicated they may seem, are based upon a few basic principles that are then developed to produce an entirely new trick. Professional card manipulators have swelled the ranks of magicians in recent years, and include the talents of such skilled performers as Richard Pitchford (Cardini), Ed Marlo and Allan Ackerman as well as other veterans of the art.', 'Card Tricks', '', 'inherit', 'open', 'open', '', '872-revision-v1', '', '', '2013-11-13 04:01:36', '2013-11-13 04:01:36', '', '872', 'http://www.plrblogs.com/magic/uncategorized/872-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('892', '28', '2013-11-16 12:14:12', '2013-11-16 12:14:12', '', 'learn-easy-magic-300x250', '', 'inherit', 'open', 'open', '', 'learn-easy-magic-300x250', '', '', '2013-11-16 12:14:12', '2013-11-16 12:14:12', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/learn-easy-magic-300x250.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('893', '28', '2013-11-16 12:14:14', '2013-11-16 12:14:14', '', 'professional-magic-tricks-300x250', '', 'inherit', 'open', 'open', '', 'professional-magic-tricks-300x250', '', '', '2013-11-16 12:14:14', '2013-11-16 12:14:14', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/professional-magic-tricks-300x250.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('894', '28', '2013-11-16 12:14:15', '2013-11-16 12:14:15', '', '125x125-Mind-Blowing2', '', 'inherit', 'open', 'open', '', '125x125-mind-blowing2', '', '', '2013-11-16 12:14:15', '2013-11-16 12:14:15', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/125x125-Mind-Blowing2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('895', '28', '2013-11-16 12:14:16', '2013-11-16 12:14:16', '', '468x60', '', 'inherit', 'open', 'open', '', '468x60', '', '', '2013-11-16 12:14:16', '2013-11-16 12:14:16', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/11/468x60.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('904', '28', '2013-12-16 04:11:12', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2013-12-16 04:11:12', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/magic/?p=904', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('905', '28', '2013-12-16 04:15:00', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2013-12-16 04:15:00', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/magic/?p=905', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('898', '28', '2013-12-16 03:44:31', '2013-12-16 03:44:31', '', 'magic-thumb1', '', 'inherit', 'open', 'open', '', 'magic-thumb1', '', '', '2013-12-16 03:44:31', '2013-12-16 03:44:31', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb1.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('899', '28', '2013-12-16 03:44:33', '2013-12-16 03:44:33', '', 'magic-thumb2', '', 'inherit', 'open', 'open', '', 'magic-thumb2', '', '', '2013-12-16 03:44:33', '2013-12-16 03:44:33', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('900', '28', '2013-12-16 03:44:34', '2013-12-16 03:44:34', '', 'magic-thumb3', '', 'inherit', 'open', 'open', '', 'magic-thumb3', '', '', '2013-12-16 03:44:34', '2013-12-16 03:44:34', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb3.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('901', '28', '2013-12-16 03:44:36', '2013-12-16 03:44:36', '', 'magic-thumb4', '', 'inherit', 'open', 'open', '', 'magic-thumb4', '', '', '2013-12-16 03:44:36', '2013-12-16 03:44:36', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb4.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('902', '28', '2013-12-16 03:44:41', '2013-12-16 03:44:41', '', 'magic-thumb5', '', 'inherit', 'open', 'open', '', 'magic-thumb5', '', '', '2013-12-16 03:44:41', '2013-12-16 03:44:41', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-thumb5.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('903', '28', '2013-12-16 03:50:14', '2013-12-16 03:50:14', '', 'Learn All The Classic Magic Tricks Today!', 'Learn All The Classic Magic Tricks Today!', 'inherit', 'open', 'open', '', 'magic-silder2', '', '', '2013-12-16 03:50:14', '2013-12-16 03:50:14', '', '0', 'http://www.plrblogs.com/magic/wp-content/uploads/2013/12/magic-silder2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('906', '28', '2013-12-17 15:48:34', '2013-12-17 15:48:34', '[youtube width=570 height=390]eQU7p52El4k[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]88AWZwleTns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]E6VWi7IaroA[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xEaspKUrMco[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Magic Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-12-17 15:48:34', '2013-12-17 15:48:34', '', '21', 'http://www.plrblogs.com/magic/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('907', '28', '2013-12-17 15:50:56', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2013-12-17 15:50:56', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/magic/?p=907', '0', 'post', '', '0');
CREATE TABLE `wp_prli_clicks` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `ip` varchar(255) DEFAULT NULL,  `browser` varchar(255) DEFAULT NULL,  `btype` varchar(255) DEFAULT NULL,  `bversion` varchar(255) DEFAULT NULL,  `os` varchar(255) DEFAULT NULL,  `referer` varchar(255) DEFAULT NULL,  `host` varchar(255) DEFAULT NULL,  `uri` varchar(255) DEFAULT NULL,  `robot` tinyint(4) DEFAULT '0',  `first_click` tinyint(4) DEFAULT '0',  `created_at` datetime NOT NULL,  `link_id` int(11) DEFAULT NULL,  `vuid` varchar(25) DEFAULT NULL,  PRIMARY KEY (`id`),  KEY `link_id` (`link_id`),  KEY `ip` (`ip`),  KEY `browser` (`browser`),  KEY `btype` (`btype`),  KEY `bversion` (`bversion`),  KEY `os` (`os`),  KEY `referer` (`referer`),  KEY `host` (`host`),  KEY `uri` (`uri`),  KEY `robot` (`robot`),  KEY `first_click` (`first_click`),  KEY `vuid` (`vuid`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_groups` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `name` varchar(255) DEFAULT NULL,  `description` text,  `created_at` datetime NOT NULL,  PRIMARY KEY (`id`),  KEY `name` (`name`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_link_metas` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  `link_id` int(11) NOT NULL,  `created_at` datetime NOT NULL,  PRIMARY KEY (`id`),  KEY `meta_key` (`meta_key`),  KEY `link_id` (`link_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_links` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `name` varchar(255) DEFAULT NULL,  `description` text,  `url` text,  `slug` varchar(255) DEFAULT NULL,  `nofollow` tinyint(1) DEFAULT '0',  `track_me` tinyint(1) DEFAULT '1',  `param_forwarding` varchar(255) DEFAULT NULL,  `param_struct` varchar(255) DEFAULT NULL,  `redirect_type` varchar(255) DEFAULT '307',  `created_at` datetime NOT NULL,  `group_id` int(11) DEFAULT NULL,  PRIMARY KEY (`id`),  KEY `group_id` (`group_id`),  KEY `name` (`name`),  KEY `nofollow` (`nofollow`),  KEY `track_me` (`track_me`),  KEY `param_forwarding` (`param_forwarding`),  KEY `param_struct` (`param_struct`),  KEY `redirect_type` (`redirect_type`),  KEY `slug` (`slug`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_term_relationships` (  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `term_order` int(11) NOT NULL DEFAULT '0',  PRIMARY KEY (`object_id`,`term_taxonomy_id`),  KEY `term_taxonomy_id` (`term_taxonomy_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `wp_term_relationships` VALUES('1', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('2', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('3', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('4', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('5', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('6', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('7', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('872', '325', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '317', '0');
INSERT INTO `wp_term_relationships` VALUES('874', '317', '0');
INSERT INTO `wp_term_relationships` VALUES('875', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('876', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('877', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('878', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('879', '317', '0');
INSERT INTO `wp_term_relationships` VALUES('880', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('881', '317', '0');
INSERT INTO `wp_term_relationships` VALUES('881', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('881', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('880', '318', '0');
INSERT INTO `wp_term_relationships` VALUES('880', '321', '0');
INSERT INTO `wp_term_relationships` VALUES('879', '319', '0');
INSERT INTO `wp_term_relationships` VALUES('879', '322', '0');
INSERT INTO `wp_term_relationships` VALUES('878', '316', '0');
INSERT INTO `wp_term_relationships` VALUES('878', '323', '0');
INSERT INTO `wp_term_relationships` VALUES('877', '318', '0');
INSERT INTO `wp_term_relationships` VALUES('877', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('877', '324', '0');
INSERT INTO `wp_term_relationships` VALUES('876', '316', '0');
INSERT INTO `wp_term_relationships` VALUES('876', '325', '0');
INSERT INTO `wp_term_relationships` VALUES('876', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('875', '318', '0');
INSERT INTO `wp_term_relationships` VALUES('875', '326', '0');
INSERT INTO `wp_term_relationships` VALUES('875', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('874', '327', '0');
INSERT INTO `wp_term_relationships` VALUES('874', '325', '0');
INSERT INTO `wp_term_relationships` VALUES('874', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '328', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('872', '316', '0');
INSERT INTO `wp_term_relationships` VALUES('872', '320', '0');
INSERT INTO `wp_term_relationships` VALUES('881', '329', '0');
INSERT INTO `wp_term_relationships` VALUES('880', '330', '0');
INSERT INTO `wp_term_relationships` VALUES('880', '331', '0');
INSERT INTO `wp_term_relationships` VALUES('879', '332', '0');
INSERT INTO `wp_term_relationships` VALUES('878', '333', '0');
INSERT INTO `wp_term_relationships` VALUES('878', '334', '0');
INSERT INTO `wp_term_relationships` VALUES('877', '335', '0');
INSERT INTO `wp_term_relationships` VALUES('876', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '337', '0');
INSERT INTO `wp_term_relationships` VALUES('873', '338', '0');
INSERT INTO `wp_term_relationships` VALUES('872', '336', '0');
CREATE TABLE `wp_term_taxonomy` (  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `taxonomy` varchar(32) NOT NULL DEFAULT '',  `description` longtext NOT NULL,  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `count` bigint(20) NOT NULL DEFAULT '0',  PRIMARY KEY (`term_taxonomy_id`),  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),  KEY `taxonomy` (`taxonomy`)) ENGINE=MyISAM AUTO_INCREMENT=339 DEFAULT CHARSET=utf8;
INSERT INTO `wp_term_taxonomy` VALUES('1', '1', 'category', '', '0', '0');
INSERT INTO `wp_term_taxonomy` VALUES('2', '2', 'link_category', '', '0', '7');
INSERT INTO `wp_term_taxonomy` VALUES('316', '316', 'category', '', '0', '3');
INSERT INTO `wp_term_taxonomy` VALUES('317', '317', 'category', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('318', '318', 'category', '', '0', '3');
INSERT INTO `wp_term_taxonomy` VALUES('319', '319', 'post_tag', '', '0', '7');
INSERT INTO `wp_term_taxonomy` VALUES('320', '320', 'post_tag', '', '0', '7');
INSERT INTO `wp_term_taxonomy` VALUES('321', '321', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('322', '322', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('323', '323', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('324', '324', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('325', '325', 'post_tag', '', '0', '3');
INSERT INTO `wp_term_taxonomy` VALUES('326', '326', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('327', '327', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('328', '328', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('329', '329', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('330', '330', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('331', '331', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('332', '332', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('333', '333', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('334', '334', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('335', '335', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('336', '336', 'post_tag', '', '0', '3');
INSERT INTO `wp_term_taxonomy` VALUES('337', '337', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('338', '338', 'post_tag', '', '0', '1');
CREATE TABLE `wp_terms` (  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `name` varchar(200) NOT NULL DEFAULT '',  `slug` varchar(200) NOT NULL DEFAULT '',  `term_group` bigint(10) NOT NULL DEFAULT '0',  PRIMARY KEY (`term_id`),  UNIQUE KEY `slug` (`slug`),  KEY `name` (`name`)) ENGINE=MyISAM AUTO_INCREMENT=339 DEFAULT CHARSET=utf8;
INSERT INTO `wp_terms` VALUES('1', 'Uncategorized', 'uncategorized', '0');
INSERT INTO `wp_terms` VALUES('2', 'Blogroll', 'blogroll', '0');
INSERT INTO `wp_terms` VALUES('316', 'The Art Of Magic', 'the-art-of-magic', '0');
INSERT INTO `wp_terms` VALUES('317', 'Magic Trickery', 'magic-trickery', '0');
INSERT INTO `wp_terms` VALUES('318', 'Tips On Performing Magic', 'tips-on-performing-magic', '0');
INSERT INTO `wp_terms` VALUES('319', 'magic', 'magic', '0');
INSERT INTO `wp_terms` VALUES('320', 'tricks', 'tricks', '0');
INSERT INTO `wp_terms` VALUES('321', 'shows', 'shows', '0');
INSERT INTO `wp_terms` VALUES('322', 'shops', 'shops', '0');
INSERT INTO `wp_terms` VALUES('323', 'illusions', 'illusions', '0');
INSERT INTO `wp_terms` VALUES('324', 'free', 'free', '0');
INSERT INTO `wp_terms` VALUES('325', 'card', 'card', '0');
INSERT INTO `wp_terms` VALUES('326', 'easy', 'easy', '0');
INSERT INTO `wp_terms` VALUES('327', 'cool', 'cool', '0');
INSERT INTO `wp_terms` VALUES('328', 'coin', 'coin', '0');
INSERT INTO `wp_terms` VALUES('329', 'performer', 'performer', '0');
INSERT INTO `wp_terms` VALUES('330', 'art', 'art', '0');
INSERT INTO `wp_terms` VALUES('331', 'sleight of hand', 'sleight-of-hand', '0');
INSERT INTO `wp_terms` VALUES('332', 'stores', 'stores', '0');
INSERT INTO `wp_terms` VALUES('333', 'wonderful', 'wonderful', '0');
INSERT INTO `wp_terms` VALUES('334', 'magical', 'magical', '0');
INSERT INTO `wp_terms` VALUES('335', 'act', 'act', '0');
INSERT INTO `wp_terms` VALUES('336', 'magicians', 'magicians', '0');
INSERT INTO `wp_terms` VALUES('337', 'baffle', 'baffle', '0');
INSERT INTO `wp_terms` VALUES('338', 'audiences', 'audiences', '0');
CREATE TABLE `wp_usermeta` (  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`umeta_id`),  KEY `user_id` (`user_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM AUTO_INCREMENT=571 DEFAULT CHARSET=utf8;
INSERT INTO `wp_usermeta` VALUES('566', '28', 'metaboxhidden_dashboard', 'a:5:{i:0;s:19:\"dashboard_right_now\";i:1;s:21:\"prli_dashboard_widget\";i:2;s:18:\"dashboard_activity\";i:3;s:14:\"pb_backupbuddy\";i:4;s:21:\"dashboard_quick_press\";}');
INSERT INTO `wp_usermeta` VALUES('565', '28', 'closedpostboxes_dashboard', 'a:0:{}');
INSERT INTO `wp_usermeta` VALUES('564', '28', 'wp_dashboard_quick_press_last_post_id', '907');
INSERT INTO `wp_usermeta` VALUES('563', '28', 'dismissed_wp_pointers', 'wp330_toolbar,wp330_saving_widgets,wp340_choose_image_from_library,wp340_customize_current_theme_link,wp350_media,wp360_revisions,wp360_locks,aioseop_menu_210');
INSERT INTO `wp_usermeta` VALUES('562', '28', 'wp_user_level', '10');
INSERT INTO `wp_usermeta` VALUES('561', '28', 'wp_capabilities', 'a:1:{s:13:\"administrator\";b:1;}');
INSERT INTO `wp_usermeta` VALUES('560', '28', 'show_admin_bar_front', 'false');
INSERT INTO `wp_usermeta` VALUES('559', '28', 'use_ssl', '0');
INSERT INTO `wp_usermeta` VALUES('558', '28', 'admin_color', 'fresh');
INSERT INTO `wp_usermeta` VALUES('554', '28', 'nickname', 'admin');
INSERT INTO `wp_usermeta` VALUES('555', '28', 'description', '');
INSERT INTO `wp_usermeta` VALUES('556', '28', 'rich_editing', 'true');
INSERT INTO `wp_usermeta` VALUES('557', '28', 'comment_shortcuts', 'false');
INSERT INTO `wp_usermeta` VALUES('552', '28', 'first_name', '');
INSERT INTO `wp_usermeta` VALUES('553', '28', 'last_name', '');
INSERT INTO `wp_usermeta` VALUES('569', '28', 'jabber', '');
INSERT INTO `wp_usermeta` VALUES('570', '28', 'googleplus', '');
INSERT INTO `wp_usermeta` VALUES('567', '28', 'aim', '');
INSERT INTO `wp_usermeta` VALUES('568', '28', 'yim', '');
CREATE TABLE `wp_users` (  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `user_login` varchar(60) NOT NULL DEFAULT '',  `user_pass` varchar(64) NOT NULL DEFAULT '',  `user_nicename` varchar(50) NOT NULL DEFAULT '',  `user_email` varchar(100) NOT NULL DEFAULT '',  `user_url` varchar(100) NOT NULL DEFAULT '',  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `user_activation_key` varchar(60) NOT NULL DEFAULT '',  `user_status` int(11) NOT NULL DEFAULT '0',  `display_name` varchar(250) NOT NULL DEFAULT '',  PRIMARY KEY (`ID`),  KEY `user_login_key` (`user_login`),  KEY `user_nicename` (`user_nicename`)) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
INSERT INTO `wp_users` VALUES('28', 'admin', '$P$B6qCetJfny64Rc1C7Px//Z0SOR4OY90', 'admin', 'youremail@youremail.com', '', '2013-12-17 15:50:31', '', '0', 'admin');
